angular.module('quipsphere.msngr.controllers', [])

.controller('MsngrCtrl', function($scope, $ionicConfig, $window) {
    //$scope.setbackground = {};
    //$scope.setbackground.size = $window.innerHeight+"px";
})

.controller('ChatHomeCtrl', 
    function($scope, $rootScope, $state, $stateParams, $ionicActionSheet, Constant, API,
            $ionicLoading, $ionicPopup, $timeout, $interval, $compile, socket, $ionicHistory) 
    {
    //Initialize me values
    //$scope.me_socketid = '';
    $scope.me = JSON.parse(window.localStorage['user_data'] );
    $scope.me_quipperid = window.localStorage['quipper_id']  ;            
    $scope.me_name = $scope.me.fname + ' ' + $scope.me.lname;  

    imageURI = Constant.QUIPSHERE_API_HOST+ '/quipper/getprofilepic?quipperid=' +$scope.me_quipperid ;
    
    $scope.me_avatar_url = imageURI; 

    $scope.showLoading = true;
    $scope.showChats = true;

    $scope.chat_followers = [];

    $scope.$on('$stateChangeSuccess', function(event, toState, privacyChange){             
        if(toState.name == 'app.chathome'){    
                $rootScope.countNewChatMsgs = 0;
                $rootScope.showchatbadge = false;
                 $timeout(function() {
                    socket.emit('fetchrecent', $scope.me_quipperid ); 
                }, 1500);
           
        }
    });

    window.localStorage.removeItem('unreadmsg');
    
    $rootScope.showchatbadge = false;
    

    socket.on('recentchats', function(data) { 
            //console.log(data);
            $scope.showLoading = false;
            datam = JSON.parse(data);

            if(datam.Data.followers.length == 0){
                $scope.showNoMessage = true;
                return;
            }
            if(datam.Result == 1){                    
              window.localStorage['chat_followers'] = JSON.stringify(datam.Data.followers);
            }

            $scope.chat_followers = JSON.parse(window.localStorage['chat_followers']);
    });       

    socket.on('rcvmsg', function(objid, from_quipperid, from_name, from_handle, from_avatarurl, rcvr_socketid,  sentmsg) { 
        //console.log(sentmsg);
         socket.emit('fetchrecent', $scope.me_quipperid ); 
         /* $scope.chat_followers.push( 
                JSON.parse(
                    {"name": from_name,
                    "quipper_id": from_quipperid,
                    "handle": from_handle,
                    "sentmsg": sentmsg,
                    "read_flag":true,
                    "avatar": from_avatarurl,
                    "isFollower":true}) );*/
    });        

})

.controller('ChatListCtrl', function($scope, $rootScope, $ionicPopover, $ionicHistory, $state, 
    $ionicLoading, API) {

    $scope.$on('$stateChangeSuccess', function(event, toState, privacyChange, quippers){

        $scope.showLoading = true;
        $scope.chatlistloadmore = true;
        $scope.showChats = true;
        $scope.chat_followers = [];
        if(toState.name == 'msngr.list'){ 
            var offsetf = 0;
            if($scope.chat_followers.length > 0){
                offsetf = $scope.chat_followers.length
            }
            API.getFollowers({
                offset:offsetf,
                quipper_id: $rootScope.user_data.quipper_id,
                target_quipper_id: $rootScope.user_data.quipper_id,
                limit: 20
            },function(data){
                if(data.Result == 1){
                  $scope.chatlistloadmore = false;
                }else{
                    $scope.chatlistloadmore = true;
                }      
                $scope.chat_followers = data.Data.followers;
                window.localStorage['chat_followers'] = JSON.stringify($scope.chat_followers);
                $ionicLoading.hide();

            },function(err){
                console.log(err);
            });
        }
    })

    var delaysearch = (function () {
        var timer = 0;
        return function (callback, ms) {
            clearTimeout(timer);
            timer = setTimeout(callback, ms);
        };
    })();

    //search from list of followers
    $scope.searchFollowersByName = function(member_name){  
        $scope.stoploading = true;    
        $scope.showLoading = true;
        $scope.chat_followers = [];
        delaysearch(function () {
            API.getFollowers({
                offset:0,
                quipper_id: $rootScope.user_data.quipper_id,
                target_quipper_id: $rootScope.user_data.quipper_id,
                member_name: member_name,
                limit: 10
                },
                function(data){
                    //console.log(data);
                    $scope.showLoading = false;
                    if(data.Result == 1){
                        window.localStorage['chat_followers'] = JSON.stringify(data.Data.followers);
                        $scope.chat_followers = JSON.parse(window.localStorage['chat_followers']);
                        $scope.showLoading = true;
                    }else{
                        $scope.showLoading = false;
                    }        
                    
                },
                function(err){
                    $scope.showLoading = false;
                    //console.log(err);
                }
            ); 
        }, 1);      
    }

    $scope.loadmorecfollower = function(){
        //console.log("hahaha");
        if($scope.chatlistloadmore == false){
            $scope.chatlistloadmore = true;
            document.querySelector(".loadingbar").classList.add("showloading");
            if($scope.chat_followers.length > 0){
                offsetf = $scope.chat_followers.length
            }
            API.getFollowers({
                offset:offsetf,
                quipper_id: $rootScope.user_data.quipper_id,
                target_quipper_id: $rootScope.user_data.quipper_id,
            },function(data){ 
                if(data.Data.followers.length > 0){
                    $scope.chatlistloadmore = false;
                    for(var i = 0;i < data.Data.followers.length; i++ ){
                        $scope.chat_followers.push(data.Data.followers[i]);
                    }
                    window.localStorage['chat_followers'] = JSON.stringify($scope.chat_followers);
                }else{
                    $scope.chatlistloadmore = true;
                }
                document.querySelector(".loadingbar").classList.remove("showloading");

            },function(err){
                $rootScope.showloading = false;
                console.log(err);
            });
        }
    }
})


.controller('PrivateChatCtrl', 
    function($scope, $rootScope, $state, $stateParams, MockService,
             $ionicActionSheet, Constant, $ionicLoading, $cordovaFile, 
             $filter, $ionicPopup, $ionicScrollDelegate, $timeout, $interval, $compile, socket, $ionicHistory) {

        //Initialize the required variables

        //$scope.me_socketid = '';
        $scope.me = JSON.parse(window.localStorage['user_data'] );
        $scope.me_quipperid = window.localStorage['quipper_id']  ;            
        $scope.me_name = $scope.me.fname + ' ' + $scope.me.lname;    
        $scope.chatto_quipper = $stateParams.quipperid;
        $scope.chatto_name = $stateParams.chatter;
        $scope.tohandle = $stateParams.chatterhandle;
        $scope.tohandle = $scope.chatto_name;

       //for getting the profile avatar    
       //imageURI = Constant.QUIPSHERE_API_HOST+ '/GetImage.php?pictype=profile&file=' +$scope.me_quipperid+'.jpg?'+ new Date().getTime();
       imageURI = Constant.QUIPSHERE_API_HOST+ '/quipper/getprofilepic?quipperid=' +$scope.me_quipperid ;
       $scope.me_avatar_url = imageURI;

       mageURI_to = Constant.QUIPSHERE_API_HOST+ '/quipper/getprofilepic?quipperid=' +$scope.chatto_quipper ;
       $scope.me_avatar_url_to = mageURI_to;

        //get initial messages
        $scope.messages = [];     

        /*socket.on('hellochatter', function(name, msg, me_socketid) {                  
            $scope.me_socketid = me_socketid;
        });    */   

        $scope.$on('$stateChangeSuccess', function(event, toState, privacyChange, quippers){
               /* $scope.messages = [];
                if(toState.name == 'msngr.prv_msg'){                     
                    $scope.messages = [];
                     $scope.lastSide = '';
                    socket.emit('getLastMessages', $scope.me_quipperid, $scope.chatto_quipper );   
                }*/
        });

        $scope.$on('$ionicView.beforeEnter', function() {
            $scope.messages = [];
        }); 

        $scope.$on('$ionicView.beforeLeave', function() {            
                $scope.messages = [];
        });

         //initialize messages container
        $scope.onceFlag = 0;
        $scope.messages = [];
        $scope.lastSide = '';
        console.log('firing again');
        socket.emit('getLastMessages', $scope.me_quipperid, $scope.chatto_quipper );   

         //Get recent threads
        socket.on('gotLastMessages', function(countMsgs, data) {                   
            //console.log(countMsgs); console.log(data);      
            //console.log(JSON.parse(data));     
            
            if ($scope.onceFlag == 0){
                $scope.onceFlag = 1;
            }else{
                return;
            }

            delayTime = 0;

            var cdata = JSON.parse(data);
            for(chatrecds in cdata){                
                var chatrcd = cdata[chatrecds];

                //if message is an image
                var sentmsg = chatrcd.sentmsg;
                if ( sentmsg.indexOf('image|') >= 0){
                    var imgParams = sentmsg.split('|');
                    var imgURL = imgParams[1];
                    sentmsg = '<img class="chatimgcont" src="'+imgURL+'"/>';
                    delayTime += 50;
                }

                //console.log(chatrcd.datetime);
                var timestamp =  new Date(chatrcd.datetime);
                //console.log(timestamp);
                //timestamp = timestamp.setDate(timestamp.getDate());
                var datadate = timestamp.getMonth()+","+timestamp.getDate()+","+timestamp.getFullYear();

                var a = new Date();
                a.setDate(a.getDate() - 1);
                var dateyesterday = a.getMonth()+","+a.getDate()+","+a.getFullYear();

                var b = new Date();
                var todaydate = b.getMonth()+","+b.getDate()+","+b.getFullYear();

                var timedsp = "";
                var aa  = $filter('date')(new Date(timestamp), 'h:mma');
                if(datadate == dateyesterday){
                    timedsp = "Yesterday "+aa;
                }else{
                    if(todaydate == datadate){
                        timedsp = aa;
                    }else{
                        timedsp = $filter('date')(new Date(timestamp),'MM/dd/yyyy h:mma');
                    }
                }

                if($scope.me_quipperid == chatrcd.from_quipper){
                    if ($scope.lastSide == 'right'){              
                        var last = $scope.messages[$scope.messages.length - 1];                
                        last.msgs.push({ message: sentmsg , time: timedsp });
                    }else{
                        //Right - Me
                        $scope.lastSide ='right';
                        $scope.lastRightTag =  $scope.me_quipperid + Date.now();

                        $scope.messages.push({
                            class:'right',
                            msgid: $scope.lastRightTag,
                            img: $scope.me_avatar_url, 
                            name: $scope.me_name,                     
                            userid: $scope.me_quipperid ,
                            msgs: [{ message: sentmsg , time: timedsp } ]
                        });

                        //var _d = 1000*60*60*24;


                        // $scope.msgdate = $filter('date')(new Date(chatrcd.datetime).getTime(),'yyyy-MM-dd');
                        // console.log($scope.msgdate);
                        // $scope.curdate = $filter('date')(new Date(),'yyyy-MM-dd');
                        // console.log($scope.curdate);
                        // $scope.yesterday = $filter('date')(new Date(new Date().getTime()-_d),'yyyy-MM-dd');
                        // console.log($scope.yesterday);

                        /*if($scope.msgdate == $scope.curdate) {
                            $scope.yesterday = 1;
                        } else if($scope.msgdate == $scope.yday) {
                            $scope.yesterday = 2;
                        } else {
                            $scope.yesterday = 0;
                        }*/
                    }
                                
                }else{
                     if ($scope.lastSide == 'left'){              
                        var last = $scope.messages[$scope.messages.length - 1];                
                        last.msgs.push({ message: sentmsg, time: timedsp });
                    }else{
                        $scope.lastSide ='left';
                        //Left - Other
                        $scope.lastLeftTag =  $scope.me_quipperid + Date.now();
                        //var OtherImageURI = Constant.QUIPSHERE_API_HOST+ '/GetImage.php?pictype=profile&file=' + chatrcd.from_quipper +'.jpg';
                        var OtherImageURI = Constant.QUIPSHERE_API_HOST+ '/quipper/getprofilepic?quipperid=' + chatrcd.from_quipper ;

                        $scope.messages.push({
                            class:'left',
                            msgid: $scope.lastLeftTag,
                            img: OtherImageURI, 
                            name: '',                     
                            userid: $scope.from_quipper ,
                            msgs: [{ message: sentmsg, time: timedsp } ]
                        });             
                    }
                }
                socket.emit('readflag',  chatrcd._id, true); 
            }
            
            var viewScroll = $ionicScrollDelegate.$getByHandle('userMessageScroll');
            viewScroll.scrollBottom(true);
            
            $timeout(function() {
                var viewScroll = $ionicScrollDelegate.$getByHandle('userMessageScroll');
                viewScroll.scrollBottom(true);
            }, delayTime);
            
        });    
        
        //Function receiving messages
        $scope.lastLeftTag = '';
        $scope.altflag = 0;
        socket.on('rcvmsg', function(objid, from_quipperid, from_name, from_handle, from_avatarurl, rcvr_socketid,  sentmsg) { 

            if($stateParams.quipperid == from_quipperid){    
                console.log(sentmsg);
                delayTime = 1000;

                //if message is an image
                if ( sentmsg.indexOf('image|') >= 0){
                    var imgParams = sentmsg.split('|');
                    var imgURL = imgParams[1];
                    sentmsg = '<img class="chatimgcont" src="'+imgURL+'"/>';
                    delayTime = 2000;
                }            

                var newtime  = $filter('date')(new Date(), 'h:mma');
                if ($scope.lastSide == 'left'){              
                        var last = $scope.messages[$scope.messages.length - 1];                
                        last.msgs.push({ message: sentmsg, time: newtime });
                }else{
                    $scope.lastSide = 'left'; // to determine which side is last
                    $scope.lastLeftTag =  $scope.me_quipperid + Date.now();

                    $scope.messages.push({
                        class:'left',
                        msgid: $scope.lastLeftTag,
                        img: from_avatarurl, 
                        name: from_name,                     
                        userid: from_quipperid ,
                        msgs: [{ message: sentmsg, time: newtime } ]
                    });               
                }            

                 $timeout(function() {
                    var viewScroll = $ionicScrollDelegate.$getByHandle('userMessageScroll');
                    viewScroll.scrollBottom(true);
                }, delayTime);


                /*if ($scope.altflag  == 1){
                    var audio = new Audio('sounds/glass_ting.mp3');
                    $scope.altflag  = 0;
                }else{
                    $scope.altflag  = 1;
                    var audio = new Audio('sounds/fireworks.mp3');
                }*/
                if ($rootScope.currentstate == "msngr.prv_msg"){
                    var audio = new Audio('sounds/glass_ting.mp3');      
                    //var audio = new Audio('sounds/received.mp3');            
                    audio.play();  

                    socket.emit('readflag',  objid, true);
                }
            }
        });        

        //Custom functions
        $scope.inputmsg = '';
        $scope.sendDisabled = true;
        $scope.lastSide = '';

        $scope.paste = function (event) {
          var item = event.clipboardData.items[0];
          item.getAsString(function (data) {
            console.log(data);
          });
        };

        $scope.keyDown = function (e) {
            $scope.updateTyping();
            /*var audio = new Audio('sounds/typing.mp3');
            audio.play(); */      
            if ( $scope.inputmsg.length ){
                chars = $scope.inputmsg.length - 1;
                if(chars > 0){
                    //make send icon enabled
                    flagSendDisabled(false);
                }else{
                    flagSendDisabled(true);
                }                
            }
        }

        $scope.onHold = function (){
            if($scope.keyboardShow == true)
            $ionicScrollDelegate.freezeAllScrolls(true);
        }

        $scope.onRelease = function (){
            $ionicScrollDelegate.freezeAllScrolls(false);
        }

        $scope.keyUp = function (e) {
            //var length = $scope.sentence.split(/\s+/g); //Split by space
            
            if ( $scope.inputmsg ){
                if($scope.inputmsg.length > 0){
                    //make send icon enabled
                    flagSendDisabled(false);
                }else{
                    flagSendDisabled(true);
                }                
            }
        }

        //Is Typing
        $scope.typing = false;
        var TYPING_TIMER_LENGTH = 400;

        $scope.updateTyping = function(e){
            from_quipperid = $scope.me_quipperid ;
            from_handle = $scope.me.handle;
            to_quipperid = $stateParams.quipperid ;            

            
            $timeout(function () {
                socket.emit('istyping',  from_quipperid, from_handle, to_quipperid);
            }, 400);
            
            var lastTypingTime = (new Date()).getTime();
            
           /* $timeout(function () {
                var typingTimer = (new Date()).getTime();
                var timeDiff = typingTimer - lastTypingTime;
                if (timeDiff >= TYPING_TIMER_LENGTH && $scope.typing) {
                  socket.emit('stoptyping',  from_quipperid, from_handle, to_quipperid);
                  $scope.typing = false;
                }
            }, TYPING_TIMER_LENGTH);*/

        }
        $scope.istypingfrom = "";
        $scope.waitingtyping = false;

        socket.on('waittyping', function(  from_quipperid, from_handle){
            if($stateParams.quipperid == from_quipperid){ 
                if (!$scope.waitingtyping) {
                    $scope.waitingtyping = true;
                    var el = document.getElementById('istyping');
                    el.style.display = "inline-block";

                    $timeout(function () {
                        $scope.waitingtyping = false;
                        el.style.display = "none";
                    }, 1000);   
                }
            }
        });

        socket.on('stoppedtyping', function(  from_quipperid, from_handle){
            var el = document.getElementById('istyping');
            el.style.display = "none";
            
        });

        

        //End is typing

        flagSendDisabled = function(flag){
            $scope.sendDisabled = flag;
        }

        //Send a chat message
        $scope.lastRightTag = '';
        $scope.chatAthing = function(ifImageUri){

            //var audio = new Audio('sounds/checkout_beep.mp3');     
            var sendaudio = new Audio('sounds/send.mp3');            
            sendaudio.play();
            
            if (ifImageUri){
                // var testimg = '<img class="chatimgcont" src="http://blog.teamtreehouse.com/wp-content/uploads/2015/05/ionic.jpg"/>';
                var tempimg = '<img class="chatimgcont" src="' + ifImageUri + '"/>';
                chatmsg = tempimg;    
            }else{
                chatmsg = $scope.inputmsg;    
            }

            //chatmsg = chatmsg.replace(/</g, "").replace(/>/g, "");
            //chatmsg.replace(/<(?:.|\n)*?>/gm, '');
            
            //load from preset values
            from_quipperid = $scope.me_quipperid ;
            from_handle = $scope.me.handle;
            to_quipperid = $stateParams.quipperid ;
            to_name = $stateParams.chatter;
            to_handle = $stateParams.chatterhandle;
            from_name = $scope.me_name;
            from_avatarurl = $scope.me_avatar_url;
            var newtime  = $filter('date')(new Date(), 'h:mma');
            if ($scope.lastSide == 'right'){              
                var last = $scope.messages[$scope.messages.length - 1];                
                last.msgs.push({ message: chatmsg, time: newtime });
            }else{

                $scope.lastSide = 'right';// to determine which side is last
                $scope.lastRightTag =  $scope.me_quipperid + Date.now();
                

                $scope.messages.push({
                    class:'right',
                    msgid: $scope.lastRightTag,
                    img: from_avatarurl, 
                    name: from_name,                     
                    userid: from_quipperid ,
                    msgs: [{ message: chatmsg, time: newtime } ]
                });               
            }
            
            $timeout(function() {
                var viewScroll = $ionicScrollDelegate.$getByHandle('userMessageScroll');
                viewScroll.scrollBottom(true);
            },1000);

            $scope.inputmsg = ''; // set input box to nothing  
            $scope.sendDisabled = true;     
            
             if (ifImageUri){
                 //Upload image to server
                $scope.sendChatPhoto(ifImageUri, from_quipperid, from_name, from_handle, from_avatarurl, to_quipperid, to_name, to_handle);
             }else{
                socket.emit('sendmsg',  from_quipperid, from_name, from_handle, from_avatarurl, to_quipperid, to_name, to_handle, chatmsg);
             }

        }

        //Send Photo
        $scope.sendPhoto = function(){
            //$ionicLoading.show();
                
            navigator.camera.getPicture(onSuccessFromGallery, onFailFromGallery, {
                targetWidth: 720,
                targetHeight: 720,
                quality: 72,
                allowEdit: false,
                correctOrientation: true,
                saveToPhotoAlbum: true,
                destinationType: Camera.DestinationType.FILE_URI,
                sourceType: navigator.camera.PictureSourceType.SAVEDPHOTOALBUM
            });

        };

        $scope.newQpFile = '';

        function onSuccessFromGallery(imageData) {
            // format url and filename
            var qp = imageData.split('/').pop(); var qpFile = qp.split('?'); // get the file
            var qpUrlArr = imageData.split('/'); 
            qpUrlArr.splice(-1,1); 
            var qpUrl = qpUrlArr.join('/')+'/'; // get the folder
            var newQpFile = 'chatimg_' + $rootScope.user_data.quipper_id + '_' + new Date().getTime()+'.jpg';
            $scope.newQpFile = newQpFile;
            
            // copy the file in quipsphere folder
            $cordovaFile.copyFile(qpUrl, qpFile[0], cordova.file.externalRootDirectory+'quipsphere/', newQpFile)
                .then(function (success) {
                    // display in form
                    var imageSource = cordova.file.externalRootDirectory+'quipsphere/'+newQpFile;                  
                    $scope.chatAthing(imageSource);
                   

                }, function (error) {
                    console.log('error: '+ error);
                });
        }

        $scope.sendChatPhoto = function(imageURI, from_quipperid, from_name, from_handle, from_avatarurl, to_quipperid, to_name, to_handle){
            $timeout(function() {

                 var argsP = new Array();
                    argsP[0] = '';
                    argsP[1] = ".jpg";
                    argsP[2] = "chatphoto";
                    var fileinput = imageURI.replace("file:", "");
                    QuipsApi.uploadChatPic( fileinput, argsP,  uploadCallBack );

                    //Upload File
                    function uploadCallBack(result){
                          // $ionicLoading.hide();
                          //emit msg to end user
                          var chatmsg = 'image|' + Constant.S3URL_CHATPICS +  $scope.newQpFile;
                          socket.emit('sendmsg',  from_quipperid, from_name, from_handle, from_avatarurl, to_quipperid, to_name, to_handle, chatmsg);
                    }
                
            },500);
        }
        
        function onFailFromGallery(message) {
           // $ionicLoading.hide();            
        }

        
       

        //Special Functions
         function ImageExist(url) 
        {
           var img = new Image();
           img.src = url;
           return img.height != 0;
        }

     }
     
)
