angular.module('quipsphere.profile.controllers', [])

.controller('ProfileCtrl', function($scope, $ionicPopover, $ionicHistory, $rootScope, $state, CameraService, API, $log,
    $ionicLoading, $timeout, $ionicSlideBoxDelegate, $ionicScrollDelegate, deviceType, socket, Constant) {
        $ionicHistory.clearCache();
        $scope.mprating = 0;
        $scope.quippers = [];
        $scope.delete_quip_unique_id = 0;
        $scope.unplayedprv = "";
        $scope.dsp_rate = false;

        
        // .fromTemplateUrl() method
        $ionicPopover.fromTemplateUrl('quipdelete.html', {
            scope: $scope
        }).then(function(popover) {
            $scope.quipdelete = popover;
        });

        $scope.openQuipPopover = function($event) {
            $scope.quipdelete.show($event);
        };

        $scope.closeQuipPopover = function() {
            $scope.quipdelete.hide();
        };

        //--- media variables
        var playedicon = 'img/quip_play_icon.png';
        var pausedicon = 'img/quip_pause_icon.png';
        var loadingicon = 'img/quip_loading_icon.gif';
        $rootScope.media = document.getElementById('quip_audio_src');
        $rootScope.mediaPausedFlag = 0;
        $rootScope.currentMediaId = '';
        var mediaLoadedFlag = 0;
        //--- media variables

        //--- parent function

        function MyProfileEvent(e) {

            if (e.target !== e.currentTarget) {

                var classtarget = e.target.classList;
                  for(var i = 0; i < classtarget.length; i++){
                    splitedclass = classtarget[i].split("_");
                    if(splitedclass[0] == 'global'){
                        switch(splitedclass[1]){
                            case "viewtopic":
                            $rootScope.goto('app.home-topics',{id:splitedclass[2]});
                            break;
                            case 'viewprofile':
                            $rootScope.goto('app.view-profile',{id:splitedclass[2]});
                            break;
                            case "viewsphere":
                            $rootScope.goto('app.sphere',{id:splitedclass[2]});
                            break;
                            default:break;
                        }
                    }else if(splitedclass[0] == 'viewlink'){
                        var a = classtarget[1];
                        var b = a.replace("viewlink_","");
                        window.open(b, '_system', 'location=yes');
                    }
                }

                var checktarget = e.target.id;
                splited = checktarget.split("_");
                //console.log(splited);
                switch(splited[0]){
                    case "options":
                        console.log(splited[1]);
                        $scope.delete_quip_unique_id = splited[1];
                        $scope.openQuipPopover(e);
                    break;
                    case "deletequip":
                        console.log("#container_"+splited[1]);
                        document.querySelector("#container_"+splited[1]).remove();
                    break;
                    case "requip":
                        $rootScope.globalEventHandler(e,function(s){
                            for(var i = 0; i < $scope.quippers.length; i++){
                                if($scope.quippers[i].unique_id == s[3]){
                                    $scope.quippers[i].is_requipped = true;
                                }
                            }
                        });
                    break;
                    case "undorequip":
                        $rootScope.globalEventHandler(e,function(s){
                            for(var i = 0; i < $scope.quippers.length; i++){
                                if($scope.quippers[i].unique_id == s[3]){
                                    $scope.quippers[i].is_requipped = false;
                                }
                            }
                        });
                    break;
                    case "profileimgslide":
                        for(var i = 0; i < $scope.quippers.length; i++){
                                if($scope.quippers[i].unique_id == splited[1]){
                                    var imgs = $scope.quippers[i].quip_images;
                                }
                            }
                        $scope.showImages(imgs);
                        break;
                    case "thread":
                        for(var i = 0; i < $scope.quippers.length; i++){
                            if($scope.quippers[i].unique_id == splited[1]){
                                $rootScope.threadParentUniqueId = splited[1];
                                $scope.openTopicThreadModal(splited[1]);
                                $rootScope.reRoute('go','reply thread');
                                return;
                            }
                        }
                        break;
                    case "player":
                        //insert here
                        break;
                    case "quipmedia":
                        if($rootScope.currentMediaId == e.target.className){
                            if($rootScope.mediaPausedFlag == 0){
                                e.target.src = playedicon;
                                $rootScope.media.pause();
                            }else{
                                e.target.src = pausedicon;
                                $rootScope.media.play();
                            }
                        }else{
                            e.target.src = loadingicon;
                            if($rootScope.currentMediaId == '' || $rootScope.currentMediaId == null){
                            }else{
                                var currentPlayerImage = document.querySelectorAll("."+$rootScope.currentMediaId);
                                for(var i=0;i<currentPlayerImage.length;i++){
                                    currentPlayerImage[i].setAttribute('src',playedicon);
                                }
                            }
                            $rootScope.currentMediaId = e.target.className;
                            $rootScope.media = document.getElementById('quip_audio_src');
                            $rootScope.media.pause();
                            $rootScope.media.src = e.target.name;
                            $rootScope.media.load();
                            $rootScope.quipPlayerItem = e.target; // assign the object to play
                        }
                        break;
                    case "sharequip":
                        var uid = splited[2];
                        console.log(uid);
                        window.plugins.socialsharing.share('Listen to this!', "Listen to this!", null, 'http://quipsphere.com/quip/quipshare.php?quipid=' + uid);
                        break;
                    default:break;
                }
            }
            e.stopPropagation();
        }
        $scope.$on('$ionicView.beforeEnter', function() {
            var parentelement = document.querySelector("#profcon");
            parentelement.addEventListener("click", MyProfileEvent, false);
        }); 
        $scope.$on('$ionicView.beforeLeave', function() {
            var parentelement = document.querySelector("#profcon");
            parentelement.removeEventListener("click", MyProfileEvent, false);
        });

        function ImageExist(url) 
        {
           var img = new Image();
           img.src = url;
           return img.height != 0;
        }

        $rootScope.quippers = [];
        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams, doLogout) {
            /*if(toState.name == 'app.myprofile'){
                $rootScope.reRoute('go','my profile');
            }*/

            $ionicHistory.clearCache();
            $scope.stoploadingmyquip = true;
            $scope.profile_main_picture = 'img/no_pic.png?'+ new Date().getTime();
            
            if (window.localStorage['quipper_profilepic']){
                //imageURI = 'file:///storage/sdcard0/quipsphere/'+$rootScope.user_data.quipper_id+'.jpg';
                imageURI = window.localStorage['quipper_profilepic'];

                if (ImageExist(imageURI)){
                    var image = document.getElementById('smallImage');    
                    //$scope.profile_main_picture = 'http://api.quipsphere.com/uploads/profilepic/'+$rootScope.user_data.quipper_id+'.jpg?'+ new Date().getTime();
                    $scope.profile_main_picture = imageURI;
                }else{
                    //imageURI = 'http://api.quipsphere.com/GetImage.php?pictype=profile&file='+$rootScope.user_data.quipper_id+'.jpg?'+ new Date().getTime();
                    imageURI = Constant.QUIPSHERE_API_HOST + '/quipper/getprofilepic?quipperid=' +$rootScope.user_data.quipper_id ;
                    $scope.profile_main_picture = imageURI;
                }
                //image.src = '#';
                
                //$scope.profile_main_picture = null;
                //$scope.profile_main_picture = imageURI; $scope.profile_main_picture.$apply;
                //$scope.profile_picture = window.localStorage['quipper_profilepic'];
            }else{
                    //imageURI = 'http://api.quipsphere.com/GetImage.php?pictype=profile&file='+$rootScope.user_data.quipper_id+'.jpg?'+ new Date().getTime();
                    imageURI = Constant.QUIPSHERE_API_HOST + '/quipper/getprofilepic?quipperid=' +$rootScope.user_data.quipper_id ;
                    $scope.profile_main_picture = imageURI;
                    /*if (ImageExist(imageURI)){
                        http://api.quipsphere.com/GetImage.php?pictype=profile&file=abcd1234.jpg
                        $scope.profile_main_picture = imageURI;
                    }*/
            }                

            $scope.filepath = '';

            // .fromTemplate() method
            var template = '';
            $scope.capturePhotoWithFile = function(){
                var cam = new CameraService();
                $scope.popoverphoto.hide();
                cam.start(function(imageData) {
                    var img_src = "data:image/jpeg;base64," + imageData;
                    $scope.profile_picture = img_src;
                    var blob = dataURItoBlob(img_src);
                    //$scope.profile_picture = imageData;
                    setTimeout(function(){
                        var data = {
                            'quipper_id':localStorage['quipper_id'],
                            'profile_pic':blob
                        };
                        API.changePhoto(data, function(data){
                            alert(JSON.stringify(data));
                            }, function(data){
                                alert(JSON.stringify(data));
                        });
                        },300)
                    }, function(err) {
                        // error
                });
            }

            function dataURItoBlob(dataURI)
            {
                var byteString = atob(dataURI.split(',')[1]);

                var mimeString = dataURI.split(',')[0].split(':')[1].split(';')[0]

                var ab = new ArrayBuffer(byteString.length);
                var ia = new Uint8Array(ab);
                for (var i = 0; i < byteString.length; i++)
                {
                    ia[i] = byteString.charCodeAt(i);
                }

                var bb = new Blob([ab], { "type": mimeString });
                return bb;
            }

            $scope.popover = $ionicPopover.fromTemplate(template, {
                scope: $scope
            });

            // .fromTemplateUrl() method
            $ionicPopover.fromTemplateUrl('my-popover.html', {
                scope: $scope
            }).then(function(popover) {
                $scope.popover = popover;
            });

            // UPDATE PHOTO
            $ionicPopover.fromTemplateUrl('my-popoverphoto', {
                scope: $scope
            }).then(function(popoverphoto) {
                $scope.popoverphoto = popoverphoto;
            });

            $scope.editProfile = function(){
                $scope.popover.hide();
                $state.go('app.editprofile');
            };
            $scope.deleteQuip = function(){
                console.log($scope.delete_quip_unique_id);
                API.deleteQuip({
                    unique_id : $scope.delete_quip_unique_id
                },function(data){

                },function(err){

                });
                $scope.closeQuipPopover();
                //document.querySelector("#container_"+$scope.delete_quip_unique_id).remove();
                document.getElementById("container_"+$scope.delete_quip_unique_id).style.display = "none";

            }

            $scope.changePassword = function(){
                $scope.popover.hide();
                $state.go('app.changepassword');
            };

            $scope.editAvatar = function(){
                //$state.go('app.editavatar');
                $rootScope.goto('misc.editavatar',{});
            };

            $scope.achievements = function(){
                $scope.popover.hide();
                $state.go('app.myachievements');
            };
            $scope.doLogout = function(){
                // window.localStorage['user_data'] = null;
                // window.localStorage['auth_key'] = null;
                // window.localStorage['quipper_id'] = null;
                $scope.popover.hide();

                $rootScope.Mservice.stopWorker();
                if (deviceType.isAny()) {
                    facebookConnectPlugin.logout(function(){
                    });
                }
                window.localStorage.clear();
                $ionicHistory.clearCache();
                $scope.popover.hide();
                $scope.quippers = [];
                $state.go('auth.walkthrough');
                
                //socket.disconnect();                

            };

            $scope.openPopover = function($event) {
                $scope.popover.show($event);
            };
            $scope.openPopoverPhoto = function($event) {
                $scope.popoverphoto.show($event);
            };
            $scope.closePopover = function() {
                $scope.popover.hide();
            };
            //Cleanup the popover when we're done with it!
            $scope.$on('$destroy', function() {
                $scope.popover.remove();
            });

            // Execute action on hide popover
            $scope.$on('popover.hidden', function() {
                // Execute action
            });
            // Execute action on remove popover
            $scope.$on('popover.removed', function() {
                // Execute action
            });

            API.myProfile({}, function(data){
                // console.log(data);
                if(data.Result==1){
                    window.localStorage['myProfile'] = JSON.stringify(data.Data);
                    $rootScope.myprofile = data.Data;
                    $scope.mprating = data.Data.total_rate_average;
                    $scope.dsp_rate = true;
                }
                }, function(data){
                    // console.log(data);
            })

            if(toState.name == 'app.myprofile'){
                $scope.getunread();
                if(window.localStorage['myProfile'] == undefined){
                    $rootScope.myprofile = {};
                }else{
                    $rootScope.myprofile = JSON.parse(window.localStorage['myProfile']);
                }

                function abbrNum(number, decPlaces) {
                    // 2 decimal places => 100, 3 => 1000, etc
                    decPlaces = Math.pow(10,decPlaces);

                    // Enumerate number abbreviations
                    var abbrev = [ "K", "M", "B", "T" ];

                    // Go through the array backwards, so we do the largest first
                    for (var i=abbrev.length-1; i>=0; i--) {

                        // Convert array index to "1000", "1000000", etc
                        var size = Math.pow(10,(i+1)*3);

                        // If the number is bigger or equal do the abbreviation
                        if(size <= number) {
                             // Here, we multiply by decPlaces, round, and then divide by decPlaces.
                             // This gives us nice rounding to a particular decimal place.
                             number = Math.round(number*decPlaces/size)/decPlaces;

                             // Handle special case where we round up to the next abbreviation
                             if((number == 1000) && (i < abbrev.length - 1)) {
                               number = 1;
                               i++;
                           }

                             // Add the letter for the abbreviation
                             number += abbrev[i];

                             // We are done... stop
                             break;
                         }
                     }

                     return number;
                 }
                $scope.followers = {};

                $scope.followers['count_follower'] = abbrNum($rootScope.myprofile.count_follower, 2);


                $scope.showloadingpr = true;

                if($rootScope.quippers.length === 0){
                    myQuipsdata();
                    $timeout(function(){
                        $scope.showloadingpr = false;
                        //$ionicSlideBoxDelegate.$getByHandle('profileslideX').update();
                        // if($rootScope.quippers.length > 0){
                        //     $scope.stoploadingmyquip = false;
                        // }
                        MyQuipsPullToRefresh.init({
                            contentEl:"pr-content",
                            ptrEl:"pr-ptr",
                            limittrigger:'pr-container',
                            bodyId:'pr-bodycontainer',
                            loadingFunction: myQuipsdata
                        });
                        },3000);
                }
                else{
                    $scope.showloadingpr = false;
                    $scope.stoploadingmyquip = false;
                    
                    MyQuipsPullToRefresh.init({
                        contentEl:"pr-content",
                        ptrEl:"pr-ptr",
                        limittrigger:'pr-container',
                        bodyId:'pr-bodycontainer',
                        loadingFunction: myQuipsdata
                    });
                }

                function myQuipsdata(){
                    return new Promise( function( resolve, reject ) {
                        if (true) {
                            resolve();
                            if($scope.quippers.length > 0){
                                var start = $scope.quippers[0].quipid;
                            }
                            else{
                                var start = 0;
                            }

                            API.getThread({
                                quipper_id : $rootScope.user_data.quipper_id,
                                start : start,
                                action : "refresh"

                                }, function(data){
                                    $timeout(function(){
                                        $scope.quippers = data.Data.concat($scope.quippers);
                                        $scope.quippers.$apply;
                                        $scope.stoploadingmyquip = false;

                                        //$ionicSlideBoxDelegate.$getByHandle('profileslideX').update();
                                        //quippersRs = data.Data;
                                        /*if(quippersRs) {
                                            for(var i = quippersRs.length; i--; ) {
                                                if (quippersRs.hasOwnProperty(i)) {
                                                    //$log.info(quippersRs[i].quipper_img);
                                                    quippersRs[i].quipper_img = 'http://api.quipsphere.com/uploads/profilepic/'+
                                                    $rootScope.user_data.quipper_id+'.jpg?'+
                                                    new Date().getTime();
                                                }
                                            }
                                        }*/
                                        },0);
                                }, function(data){
                                    $log.error(data);
                            }); 
                        } else {
                            reject();
                        }
                    } );
                }
                $scope.loadmoreMyQuip = function(){
                    if($scope.stoploadingmyquip === false){
                        $scope.stoploadingmyquip = true;
                        var end = $scope.quippers[$scope.quippers.length - 1].quipid;
                        API.getThread({
                            quipper_id : $rootScope.user_data.quipper_id,
                            end : end,
                            action : "showmore"
                            }, function(data){

                                if(data.Data.length > 0){
                                    for(i = 0; i < data.Data.length; i++){
                                        $scope.quippers.push(data.Data[i]);
                                    }
                                    $scope.stoploadingmyquip = false;
                                }else{
                                    $scope.stoploadingmyquip = true;
                                }
                                
                                $scope.$broadcast('scroll.infiniteScrollComplete');
                            }, function(data){
                                $scope.$broadcast('scroll.infiniteScrollComplete');
                        }); 

                        //var loadinginficon = document.getElementsByClassName("loading-inf");
                        //loadinginficon[0].innerHTML = '<div class="ptrloading" style="display:block"><span id="l1"></span><span id="l2"></span><span id="l3"></span></div>';
                    }
                }

                angular.element(document.getElementsByClassName('quipmedia'))
                .on('click',function(e){
                    $log.info('x');
                    /*var a = document.getElementsByClassName('btn-circle');
                    for(i =0; i < a.length; i++){
                    a[i].className = "btn-circle";
                    //a[i].setAttribute();
                    switch(a[i].getAttribute('index')){
                    case 'Inspirational': a[i].classList.add("turn-green"); break;
                    case 'Qoutes': a[i].classList.add("turn-blue"); break;
                    case 'Status': a[i].classList.add("turn-red"); break;
                    default:break;
                    }
                    }
                    this.classList.add("turn-active");
                    $log.debug(this.getAttribute('index'));
                    $scope.category = this.getAttribute('index');*/
                    }
                );
            }
        });

    $scope.getunread = function(){
        API.privatequipGetunplayed({
            quipper_id : $rootScope.user_data.quipper_id
            }, function(data){
                console.log(data);
                if(data.Data){
                   $scope.unplayedprv = data.Data.count; 
                }else{
                    $scope.unplayedprv = "";
                }
            }, function(data){
        }); 
    }

})

.controller('ProfileEditAvatarCtrl', function($scope, $rootScope, $ionicPopover, $timeout, $ionicActionSheet, $ionicHistory, 
    $state, CameraService, API, $ionicLoading, $log, Constant, $cordovaFile, $cordovaFileTransfer, $timeout, QUIPSHERE_API_HOST ) {

        function ImageExist(url) 
        {
           var img = new Image();
           img.src = url;
           return img.height != 0;
        }


        $scope.profile_picture = 'img/no_pic.png?'+ new Date().getTime();
        if (window.localStorage['quipper_profilepic']){
            //imageURI = 'file:///storage/sdcard0/quipsphere/'+$rootScope.user_data.quipper_id+'.jpg';
            //imageURI = Constant.QUIPSHERE_API_HOST+'/uploads/profilepic/'+$rootScope.user_data.quipper_id+'.jpg?'+new Date().getTime();
            imageURI =  window.localStorage['quipper_profilepic'];
            var image = document.getElementById('avatar-picture');    
            
            if (ImageExist(imageURI)){                
                $scope.profile_picture = imageURI;
                image.src = $scope.profile_picture;
            }else{
                //$scope.profile_picture = 'http://api.quipsphere.com/GetImage.php?pictype=profile&file='+$rootScope.user_data.quipper_id+'.jpg?'+ new Date().getTime();
                $scope.profile_picture = Constant.QUIPSHERE_API_HOST + '/quipper/getprofilepic?quipperid=' +$rootScope.user_data.quipper_id ;
                
                image.src = $scope.profile_picture;
            }
        }

        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){
            if(toState.name == 'misc.editavatar'){
                //$scope.profile_picture = 'img/quip_loading_icon.gif';                
                //imageURI = Constant.QUIPSHERE_API_HOST+'/uploads/profilepic/'+$rootScope.user_data.quipper_id+'.jpg?'+new Date().getTime();
                //$scope.profile_picture = Constant.QUIPSHERE_API_HOST+'/uploads/profilepic/'+$rootScope.user_data.quipper_id+'.jpg?'+new Date().getTime();
                imageURI =  window.localStorage['quipper_profilepic'];
                var image = document.getElementById('avatar-picture');    
                $scope.profile_picture = 'img/no_pic.png?'+ new Date().getTime();
                image.src = $scope.profile_picture;
                 if (ImageExist(imageURI)){                        
                        //$scope.profile_picture = 'file:///storage/sdcard0/quipsphere/'+$rootScope.user_data.quipper_id+'.jpg';
                        $scope.profile_picture = imageURI;
                        image.src = $scope.profile_picture;
                }else{
                    //$scope.profile_picture = 'http://api.quipsphere.com/GetImage.php?pictype=profile&file='+$rootScope.user_data.quipper_id+'.jpg?'+ new Date().getTime();
                    $scope.profile_picture = QUIPSHERE_API_HOST + '/quipper/getprofilepic?quipperid=' +$rootScope.user_data.quipper_id ;
                    image.src = $scope.profile_picture;
                }
                //$scope.profile_picture = Constant.QUIPSHERE_API_HOST+'/uploads/profilepic/'+$rootScope.user_data.quipper_id+'.jpg?'+new Date().getTime();
                submitbtn = document.getElementById('avatar-submit-container');
                submitbtn.style.display = "none";
            }
        });
        $scope.updatePicture = function(){
            var hideSheet = $ionicActionSheet.show({
                buttons: [
                    { text: '&nbsp;&nbsp;&nbsp;Take Picture' },
                    { text: '&nbsp;&nbsp;&nbsp;Upload Picture' }
                ],
                cancelText: 'Cancel',
                cancel: function() { /*add cancel code..*/ },
                buttonClicked: function(index) {
                    if (index == 0){ updatePicTake(); }
                    if (index == 1){ updatePicUpload(); }
                    return true;
                }
            });
            $timeout(function() {
                hideSheet();
            }, 3000);
            function updatePicTake(){
                var args = new Array();
                args[0] = window.localStorage['quipper_id'] ;
                QuipsApi.photoShoot(args, onSuccessUpdatePicTake);
            }
            function onSuccessUpdatePicTake(imageURI) {
                var image = document.getElementById('avatar-picture');
                image.src = imageURI;
                window.localStorage['quipper_profilepic'] = imageURI;
                $scope.profile_picture =  imageURI;
                submitbtn =  document.getElementById('avatar-submit-container');
                submitbtn.style.display = "block";     
            }
            function onFailUpdatePicTake(message) {
                alert('Failed because: ' + message);
            }
            function updatePicUpload(){
                $ionicLoading.show();
                navigator.camera.getPicture(onSuccessUpdatePicUpload, onFailUpdatePicUpload, {
                    targetWidth: 720,
                    targetHeight: 720,
                    quality: 72,
                    allowEdit: false,
                    correctOrientation: true,
                    saveToPhotoAlbum: true,
                    destinationType: Camera.DestinationType.FILE_URI,
                    sourceType: navigator.camera.PictureSourceType.SAVEDPHOTOALBUM
                });
            }
            function onSuccessUpdatePicUpload(imageData) {
                var qp = imageData.split('/').pop(); var qpFile = qp.split('?'); // get the file
                var qpUrlArr = imageData.split('/'); qpUrlArr.splice(-1,1); var qpUrl = qpUrlArr.join('/')+'/'; // get the folder
                var newQpFile = "avatar_"+new Date().getTime()+'.jpg';
                // copy the file in quipsphere folder
                $cordovaFile.copyFile(qpUrl, qpFile[0], cordova.file.externalRootDirectory+'Quipsphere/', newQpFile)
                .then(function (success) {
                    var imageSource = cordova.file.externalRootDirectory+'Quipsphere/'+newQpFile;
                    $scope.profile_picture = imageSource;
                    window.localStorage['quipper_profilepic'] = imageSource;
                    submitbtn = document.getElementById('avatar-submit-container');
                    submitbtn.style.display = "block";
                    $timeout(function(){
                        $ionicLoading.hide();
                    },700);
                }, function (error) {
                    $log.error('error: '+error);
                    $ionicLoading.hide();
                });
            }
            function onFailUpdatePicUpload(message) {
                $ionicLoading.hide();
                $log.error('Failed because: ' + message);
            }
        };

        $scope.goBack = function() {
            $ionicHistory.goBack();
        }
        $scope.submitPhoto = function(){
            var imgEl = document.getElementById('avatar-picture');
            fileURL = imgEl.src;
            var fileinput = fileURL.replace("file:", "");
            submitbtn =  document.getElementById('avatar-submit-container');
            submitbtn.style.display = "none";
            function uploadCallBack(result){
                var imgEl = document.getElementById('avatar-picture');
                fileURL = imgEl.src;
                window.localStorage['quipper_profilepic']  = fileURL;

                submitbtn =  document.getElementById('avatar-submit-container');
                submitbtn.style.display = "block";    

                $rootScope.goto('app.myprofile',{});
            }

            var args = new Array();
            args[0] = window.localStorage['quipper_id'] ;
            args[1] = ".jpg";

            QuipsApi.uploadFile(fileinput, args, uploadCallBack);
        };
})

.controller('EditprofileCtrl', function($scope, $rootScope, $ionicPopover, $ionicHistory, $state, $cordovaDatePicker, 
    $ionicLoading,  DatePicker, API) {

        $ionicHistory.clearCache();
        $scope.$on('$ionicView.beforeEnter', function() {
            window.plugins.nativepagetransitions.slide({
                "direction": "left"
            });
        }); 
        $scope.$on('$ionicView.beforeLeave', function() {        
            window.plugins.nativepagetransitions.slide({
                "direction": "left"
            });
        });


        $scope.$on('$stateChangeSuccess', function(event, toState, privacyChange, quippers, API, myProfile, cb_success2){


            if(toState.name == 'app.editprofile'){ 

                $scope.editprofileinitloading = true;
                $scope.editprofilehaserror = false;
                $scope.editprofile = {}; 
                $scope.editprofile["fname"] = "";  
                $scope.editprofile["lname"] = "";  
                $scope.editprofile["mname"] = ""; 
                $scope.editprofile["bdate"] = "";
                $scope.editprofile["privacy"] = "";
                $scope.editprofile["gender"] = "";     
                $scope.editprofile["email"] = "";
                $scope.editprofile["email_orig"] = "";  
                $scope.editprofile["mobile"] = "";
                $scope.editprofile["about_me"] = "";
                $scope.editprofile["StartDate"] = ""; 
                $scope.myProfile();    
            }
        });

         $scope.goBack = function() {
            $ionicHistory.goBack();
        }


        $scope.myProfile = function(){ 
            $scope.editprofileinitloading = true;
            var data = {};
            API.myProfile(data, cb_success2,function(err){
                $scope.editprofileinitloading = false;
                $scope.editprofilehaserror = true;
                console.log(err);
            });
        }
        function cb_success2(data){
            $scope.editprofileinitloading = false;
            if(data.Result == 1 ){
                console.log(data.Data);
                //success
                $scope.editprofile["StartDate"] = ""; 
                $scope.editprofile["fname"] = data.Data.fname;  
                $scope.editprofile["lname"] = data.Data.lname;  
                $scope.editprofile["mname"] = data.Data.mname; 
                $scope.editprofile["bdate"] = data.Data.birthdate;
                $scope.editprofile["privacy"] = data.Data.profile_private;
                $scope.editprofile["gender"] = data.Data.gender;     
                $scope.editprofile["email"] = data.Data.email;
                $scope.editprofile["email_orig"] = data.Data.email;  
                $scope.editprofile["mobile"] = data.Data.mobile_no;
                $scope.editprofile["about_me"] = data.Data.about_me;
                $scope.editprofile["country"] = data.Data.country;
                $scope.editprofile["city"] = data.Data.city;
                // console.log(data.Data)

            }else{
                //error
                $scope.editprofilehaserror = true;
                var msg = data.Message.join("<br/>");
                create_failed(msg);
            }
        }

        $scope.log = function(x){ //Private of Public
            // console.log(x)
        }

        $scope.updateProfile = function(){ //SAVING *
            console.log($scope);

            if($scope.editprofile.fname == "" ){
                create_failed("First Name is required");
            }else if($scope.editprofile.lname == ""){
                create_failed("Last Name is required");
            }
            //else if($scope.editprofile.mname == ""){
            //     create_failed("Middle Name is required");
            // }
            else if($scope.editprofile.bdate == ""){
                create_failed("Birthday is required");
            //}else if($scope.editprofile.mobile ==""){

            }else if($scope.editprofile.email == ""){
                create_failed("Email is required");
            }else if($scope.editprofile.email_orig == ""){
                create_failed("Email is required");
            }else if($scope.editprofile.gender == ""){
                create_failed("Please select a gender");
            }else{
                $ionicLoading.show();
                var data = {
                    fname: $scope.editprofile.fname,
                    lname: $scope.editprofile.lname,
                    mname: $scope.editprofile.mname,
                    bdate: $scope.editprofile.bdate,
                    mobile: $scope.editprofile.mobile,
                    email:  $scope.editprofile.email,
                    email_orig:  $scope.editprofile.email_orig,
                    gender: $scope.editprofile.gender,
                    privacy: $scope.editprofile.privacy,
                    about_me: $scope.editprofile.about_me,
                    country: $scope.editprofile.country,
                    city: $scope.editprofile.city
                };
                console.log(data);
                API.updateProfile(data, cb_success, cb_error);
            }
        }
        function cb_success(data){
            $ionicLoading.hide();
            if(data.Result == 1 ){
                //success
                create_success(data.Message[0]);
                $rootScope.goto('app.myprofile');
            }else{
                //error
                var msg = data.Message.join("<br/>");
                console.log(data.Message)
                create_failed(msg);
            }
            // console.log(data);
        }
        function cb_error(data){
            $ionicLoading.hide();
            // console.log("cb_error");
            // console.log(data);
            create_failed("Something went wrong please try again");
        }
        function create_failed(msg){
            var status = "e";
            var ontap_callback = function(e){
                // console.log(e);
            }
            title = 'Update Profile';
            btn_text = 'Try again';
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }
        function create_success(msg){
            var status = "s";
            var ontap_callback = function(e){
                // console.log(e);
            }
            title = 'Update Profile Success';
            btn_text = 'OK';
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }

        var dp = new DatePicker();
        dp.datepickerObject.from = new Date("January 1, 1907");
        dp.datepickerObject.callback = function (val) {
            if (typeof(val) === 'undefined') {
                // console.log('No date selected');
            } else {
                $scope.datepickerObject.inputDate = val;
                // console.log('Selected date is : ', val)
                $scope.editprofile.bdate = dp.dateFormat(val);
            }
        }; 
        $scope.datepickerObject = dp.datepickerObject;
})

.controller('ChangepasswordCtrl', function($scope, $rootScope, $state, $ionicHistory,  $ionicLoading, API)
    {
    $ionicHistory.clearCache();
    $scope.changepassword = {};
    $scope.back = function() {
        $ionicHistory.goBack();
    }
    $scope.$on('$ionicView.beforeEnter', function() {
        document.getElementsByTagName("ion-header-bar")[0].style.display = "none";
        document.getElementsByTagName("ion-footer-bar")[0].style.display = "none";
        window.plugins.nativepagetransitions.slide({
            "direction": "left"
        });
    }); 
    $scope.$on('$ionicView.beforeLeave', function() {
        document.getElementsByTagName("ion-header-bar")[0].style.display = "block";
        document.getElementsByTagName("ion-footer-bar")[0].style.display = "block";
        window.plugins.nativepagetransitions.slide({
            "direction": "right"
        });
    });

    $scope.changePassword = function(){ //SAVING *
        $ionicLoading.show();
        var data = {
            new_password: $scope.changepassword.new_password,
            quipper_id: $rootScope.user_data.quipper_id,
            retypenewpass: $scope.changepassword.retypenewpass
        };
        API.changePassword(data, cb_success, cb_error);
    }
    function cb_success(data){
        $ionicLoading.hide();
        if(data.Result == 1 ){
            //success
            create_success(data.Message[0]);
        }else{
            //error
            var msg = data.Message.join("<br/>");
            create_failed(msg);
        }
        // console.log(data);
    }
    function cb_error(data){
        $ionicLoading.hide();
        // console.log("cb_error");
        // console.log(data);
        create_failed("Something went wrong please try again");
    }
    function create_failed(msg){
        var status = "e";
        var ontap_callback = function(e){
            // console.log(e);
        }
        title = 'Change Password';
        btn_text = 'Try again';
        $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
    }
    function create_success(msg){
        var status = "s";
        var ontap_callback = function(e){
            $rootScope.goto('app.myprofile');
        }
        title = 'Change Password';
        btn_text = 'OK';
        $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
    }
})

.controller('ViewProfileCtrl',function($scope, $ionicPopover, $ionicHistory, $rootScope, $state, CameraService, API, $log,
    $ionicLoading, $timeout, $ionicSlideBoxDelegate, $ionicScrollDelegate, $stateParams){
        $scope.stoploadingquippers = true;
        $scope.showloadingquippers = false;
        $scope.vprating = 0;

        $scope.$on('$ionicView.beforeEnter', function() {
            if($rootScope.hastopicsearch){
                $rootScope.closeTopicModal();
            }
            var a = document.querySelectorAll("#viewprofilecon");
            for(var i = 0; i < a.length; i++){
                a[i].addEventListener("click", MyProfileEvent, false);
            }
            // var parentelement = document.querySelector("#viewprofilecon");
            // parentelement.addEventListener("click", MyProfileEvent, false);


            //--- media variables
            var playedicon = 'img/quip_play_icon.png';
            var pausedicon = 'img/quip_pause_icon.png';
            var loadingicon = 'img/quip_loading_icon.gif';
            $rootScope.media = document.getElementById('quip_audio_src');
            $rootScope.mediaPausedFlag = 0;
            $rootScope.currentMediaId = '';
            var mediaLoadedFlag = 0;
            //--- media variables

            //--- parent function

            function MyProfileEvent(e) {

                if (e.target !== e.currentTarget) {

                    var classtarget = e.target.classList;
                      for(var i = 0; i < classtarget.length; i++){
                        splitedclass = classtarget[i].split("_");
                        if(splitedclass[0] == 'global'){
                            switch(splitedclass[1]){
                                case "viewtopic":
                                $rootScope.goto('app.home-topics',{id:splitedclass[2]});
                                break;
                                case 'viewprofile':
                                $rootScope.goto('app.view-profile',{id:splitedclass[2]});
                                break;
                                case "viewsphere":
                                $rootScope.goto('app.sphere',{id:splitedclass[2]});
                                break;
                                default:break;
                            }
                        }else if(splitedclass[0] == 'viewlink'){
                            var a = classtarget[1];
                            var b = a.replace("viewlink_","");
                            window.open(b, '_system', 'location=yes');
                        }
                    }

                    var checktarget = e.target.id;
                    splited = checktarget.split("_");
                    console.log(splited);
                    switch(splited[0]){
                        case "unfollow":
                            $rootScope.globalFollowEvent(e);
                            break;
                        case "follow":
                            $rootScope.globalFollowEvent(e);
                            break;
                        case "requip":
                            $rootScope.globalEventHandler(e,function(s){
                                console.log(s)
                            });
                        break;
                        case "undorequip":
                            $rootScope.globalEventHandler(e,function(s){
                                console.log(s)
                            });
                        break;
                        case "profileimgslide":
                            for(var i = 0; i < $scope.quippers.length; i++){
                                if($scope.quippers[i].unique_id == splited[1]){
                                    var imgs = $scope.quippers[i].quip_images;
                                }
                            }
                            $scope.showImages(imgs);
                            break;
                        case "thread":
                            for(var i = 0; i < $scope.quippers.length; i++){
                                if($scope.quippers[i].unique_id == splited[2]){
                                    $rootScope.selectedtopics.handler = $scope.quippers[i].quipper_name;
                                }
                            }
                            $rootScope.threadParentUniqueId = splited[1];
                            $scope.openTopicThreadModal(splited[1]);
                            $rootScope.reRoute('go','reply thread');
                            break;
                        case "player":
                            //insert here
                            break;
                        case "replythread":
                            for(var i = 0; i < $scope.quippers.length; i++){
                                if($scope.quippers[i].unique_id == splited[2]){
                                    $rootScope.selectedtopics.handler = $scope.quippers[i].quipper_name;
                                }
                            }
                            $rootScope.fromWhatMain = 'profile';
                            $rootScope.fromWhatModal = 'profile';
                            $rootScope.threadParentUniqueId = splited[1];
                            $rootScope.openRecorderModal();
                            break;
                        case 'replytopicthread':
                            for(var i = 0; i < $scope.quippers.length; i++){
                                if($scope.quippers[i].unique_id == splited[2]){
                                    $rootScope.selectedtopics.handler = $scope.quippers[i].quipper_name;
                                }
                            }
                            $rootScope.threadParentUniqueId = splited[1];
                            $rootScope.openRecorderModal();
                            $rootScope.reRoute('go','recorder',1);
                            break;
                        case "quipmedia":
                            if($rootScope.currentMediaId == e.target.className){
                                $rootScope.currentMediaId = e.target.className;
                                if($rootScope.mediaPausedFlag == 0){
                                    e.target.src = playedicon;
                                    $rootScope.media.pause();
                                }else{
                                    e.target.src = pausedicon;
                                    $rootScope.media.play();
                                }
                            }else{
                                e.target.src = loadingicon;
                                if($rootScope.currentMediaId == '' || $rootScope.currentMediaId == null){
                                }else{
                                    var currentPlayerImage = document.querySelectorAll("."+$rootScope.currentMediaId);
                                    for(var i=0;i<currentPlayerImage.length;i++){
                                        currentPlayerImage[i].setAttribute('src',playedicon);
                                    }
                                }
                                $rootScope.currentMediaId = e.target.className;
                                $rootScope.media = document.getElementById('quip_audio_src');
                                $rootScope.media.pause();
                                $rootScope.media.src = e.target.name;
                                $rootScope.media.load();
                                $rootScope.quipPlayerItem = e.target; // assign the object to play
                            }
                            case 'ratequip':
                                for(var i = 0; i < $scope.quippers.length; i++){
                                    if($scope.quippers[i].unique_id == splited[1]){
                                        $rootScope.ratedata.selecteddata = $scope.quippers[i];
                                        $rootScope.openPopoverRate(e,splited[1],splited[2]);
                                    }
                                }
                            break;
                            case "sharequip":
                            var uid = splited[2];
                            console.log(uid);
                            window.plugins.socialsharing.share('Listen to this!', "Listen to this", null, 'http://quipsphere.com/quip/quipshare.php?quipid=' + uid);
                            break;
                        default:break;
                    }
                }
                e.stopPropagation();
            }
            var followelement = document.querySelector("#viewProfileFollow");

            if (!followelement){
                return;
            }


            followelement.addEventListener("click", followEvent, false);
            function followEvent(e){
                $rootScope.globalFollowEvent(e);
            }
          });
          $scope.$on('$ionicView.beforeLeave', function() {
            if($rootScope.hastopicsearch){
                $rootScope.openTopicModal($rootScope.hastopicsearch);
                $rootScope.hastopicsearch = "";

            }
             var a = document.querySelectorAll("#viewprofilecon");
            for(var i = 0; i < a.length; i++){
                a[i].removeEventListener("click", MyProfileEvent, false);
            }
              // var parentelement = document.querySelector("#viewprofilecon");
              // if (parentelement){
              //   parentelement.removeEventListener("click", MyProfileEvent, false);
              // }


            var followelement = document.querySelector("#viewProfileFollow");
            if (followelement){
                followelement.removeEventListener("click", followEvent, false);
            }


            function MyProfileEvent(e) {}
            function followEvent(e) {}

          });

         $scope.quipperAchievements = function(){

            $rootScope.goto('app.quipperachievements',{id:$stateParams.id});
        };

        $scope.quippers = [];

        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams, doLogout) {

            if(toState.name == 'app.view-profile'){

                $scope.showloadingquippers = true;
                $scope.stoploadingquippers = true;
                // if(window.localStorage['viewProfile'] == undefined || window.localStorage['viewProfile'] == 'undefined' ){
                //     $scope.view_profile = {};
                // }else{
                //     $scope.view_profile = JSON.parse(window.localStorage['viewProfile']);
                // }



                API.viewProfille({
                quipper_id:$rootScope.user_data.quipper_id,
                target_quipper_id: $stateParams.id
                }, function(data){
                    if(data.Result==1){
                            //window.localStorage['viewProfile'] = JSON.stringify(data.Data);
                            $scope.view_profile = data.Data;
                            $rootScope.selectedtopics.handler = $scope.view_profile.handle;

                            if(data.favorites_sum == 0){
                                $scope.vprating = -1;
                            }else{
                                $scope.vprating = data.rate_average;
                            }

                            console.log($scope.view_profile);
                            $scope.view_profile.count_follower = abbrNum($scope.view_profile.count_follower, 2);
                            $scope.view_profile.count_favorites = abbrNum($scope.view_profile.count_favorites, 2);
                            $scope.view_profile.count_following = abbrNum($scope.view_profile.count_following, 2);

                        }
                    }, function(data){
                         console.log(data);
                })



                function abbrNum(number, decPlaces) {
                    // 2 decimal places => 100, 3 => 1000, etc
                    decPlaces = Math.pow(10,decPlaces);

                    // Enumerate number abbreviations
                    var abbrev = [ "K", "M", "B", "T" ];

                    // Go through the array backwards, so we do the largest first
                    for (var i=abbrev.length-1; i>=0; i--) {

                        // Convert array index to "1000", "1000000", etc
                        var size = Math.pow(10,(i+1)*3);

                        // If the number is bigger or equal do the abbreviation
                        if(size <= number) {
                             // Here, we multiply by decPlaces, round, and then divide by decPlaces.
                             // This gives us nice rounding to a particular decimal place.
                             number = Math.round(number*decPlaces/size)/decPlaces;

                             // Handle special case where we round up to the next abbreviation
                             if((number == 1000) && (i < abbrev.length - 1)) {
                               number = 1;
                               i++;
                           }

                             // Add the letter for the abbreviation
                             number += abbrev[i];

                             // We are done... stop
                             break;
                         }
                     }

                     return number;
                 }

                if($scope.quippers.length === 0){
                    Quipsdata();
                    $timeout(function(){
                        $scope.showloadingquippers = false;
                        if($scope.quippers.length > 0){
                            $scope.stoploadingquippers = false;
                        }

                        PullToRefresh.init({
                            contentEl:"pr-content",
                            ptrEl:"pr-ptr",
                            limittrigger:'pr-container',
                            bodyId:'pr-bodycontainer',
                            loadingFunction: Quipsdata
                        });
                    },3000);
                }

                function Quipsdata(){
                    return new Promise( function( resolve, reject ) {
                        if (true) {
                            resolve();
                            if($scope.quippers.length > 0){
                                var start = $scope.quippers[0].quipid;
                            }
                            else{
                                var start = 0;
                            }

                            API.getThread({
                                quipper_id : $stateParams.id,
                                start : start,
                                action : "refresh"

                                }, function(data){
                                    $scope.quippers = data.Data.concat($scope.quippers);
                                    
                                }, function(data){
                                    $log.error(data);
                            });
                        } else {
                            reject();
                        }
                    } );
                }

                $scope.loadmoreMyQuip = function(){
                    if($scope.stoploadingquippers === false){
                        $scope.stoploadingquippers = true;
                        var end = $scope.quippers[$scope.quippers.length - 1].quipid;
                        API.getThread({
                            quipper_id : $stateParams.id,
                            end : end,
                            action : "showmore"
                            }, function(data){

                                if(data.Data.length > 0){
                                    for(i = 0; i < data.Data.length; i++){
                                        $scope.quippers.push(data.Data[i]);
                                    }
                                    $scope.stoploadingquippers = false;
                                }else{
                                    $scope.stoploadingquippers = true;
                                }

                                //$scope.$broadcast('scroll.infiniteScrollComplete');
                            }, function(data){
                                //$scope.$broadcast('scroll.infiniteScrollComplete');
                        });

                        //var loadinginficon = document.getElementsByClassName("loading-inf");
                        //loadinginficon[0].innerHTML = '<div class="ptrloading" style="display:block"><span id="l1"></span><span id="l2"></span><span id="l3"></span></div>';
                    }
                }

                // //--- media variables
                // var playedicon = 'img/quip_play_icon.png';
                // var pausedicon = 'img/quip_pause_icon.png';
                // var loadingicon = 'img/quip_loading_icon.gif';
                // var media = null; var mediaPausedFlag = 0;
                // $rootScope.currentMediaId = ''; var mediaLoadedFlag = 0;
                // //--- media variables

                // //--- parent function
                // var parentelement = document.querySelector("#pr-container");
                // parentelement.addEventListener("click", MyProfileEvent, false);
                // // var followelement = document.querySelector("#viewProfileFollow");
                // // followelement.addEventListener("click", followEvent, false)
                // function followEvent(e){
                //     $rootScope.globalFollowEvent(e);
                // }

                angular.element(document.getElementsByClassName('quipmedia'))
                .on('click',function(e){
                    $log.info('x');
                    }
                );
            }
        });

    $scope.prvquip = function(){
        $ionicLoading.show();
        API.privatequipGetquipper({'quipper_id':$stateParams.id}, function(data){
            if(data.Result == 1){
                $ionicLoading.hide();
                $rootScope.threadPrvParentUniqueId = data.Data.parentunique;
                $rootScope.prv_to_quipperid = $stateParams.id;
                $rootScope.openRecorderModal('1');
                $rootScope.isprivate = 1;
                $rootScope.reRoute('go','privatequip thread');
            }
            }, function(data){

        });

    }


     $scope.$on('updaterequipvp', function(event, args) {
            var unique_id = args.unique_id;
            var id_val = args.id_val;
            for(var i =0; i < $scope.quippers.length; i++){
                if($scope.quippers[i].unique_id == unique_id){
                    if(id_val == "requip_"){
                        $scope.quippers[i].is_requipped_img = "img/done-requip-icon.png";
                        $scope.quippers[i].quip_count = $scope.quippers[i].quip_count + 1;
                        $scope.quippers[i].is_requipped_id = 'undorequip_'+unique_id;
                    }else{
                        $scope.quippers[i].is_requipped_img = "img/quip-icon.png";
                        $scope.quippers[i].quip_count = $scope.quippers[i].quip_count - 1;
                        $scope.quippers[i].is_requipped_id = 'requip_'+unique_id;
                    }
                }
            }
        });

        $scope.$on('updateratevp', function(event, args) {
            var unique_id = args.unique_id;
            var counted = args.counted;
            var rating = args.rating;
            for(var i =0; i < $scope.quippers.length; i++){
                if($scope.quippers[i].unique_id == unique_id){
                    $scope.quippers[i].is_favorited = 1;
                    var currentave = $scope.quippers[i].average_stars;
                    var ratedvalue = rating;
                    if(currentave == 0){
                        var countdev = 1;
                    }else{
                        var countdev = 2;
                    }
                    var latest_ave = (currentave + ratedvalue) / countdev;
                    $scope.quippers[i].average_stars = Math.round(latest_ave);
                    $scope.quippers[i].is_favorited_img = "img/star-quiped.png";
                }
            }
        });
})

.controller('MyAchievementsCtrl',function($scope, $ionicHistory, $rootScope, $state, API,  $ionicLoading, $stateParams){
//console.log($rootScope.myprofile.quipper_id);

$scope.myachievements = {}; 
$scope.badges = {};
$ionicLoading.show();
API.Myachievements({
    id:$rootScope.myprofile.quipper_id,
}, function(data){
//success
$scope.myachievements = data.Data;

$scope.badges = [
    {
        badge_code:"green_apple",
        tounlock:"Starter badge.",
        img:"img/badges/apple.png",
        title:"Green Apple",
        wear : false,
        badgepercentage: 0,
        is_default : 0,
        unlocked: 0
    },

    {
        badge_code:"boss",
        tounlock:"500 followers to get this badge.",
        img:"img/badges/boss.png",
        title:"The Boss",
        wear : false,
        badgepercentage: 0,
        is_default : 0,
        unlocked: 0
    },

    {
        badge_code:"chief",
        tounlock:"1,000 followers to get this badge.",
        img:"img/badges/chief.png",
        title:"The Chief",
        wear : false,
        badgepercentage: 0,
        is_default : 0,
        unlocked: 0
    },
    {
        badge_code:"captain",
        tounlock:"5,000 followers to get this badge.",
        img:"img/badges/captain.png",
        title:"The Captain",
        wear : false,
        badgepercentage: 0,
        is_default : 0,
        unlocked: 0
    },

    {
        badge_code:"commander",
        tounlock:"10,000 followers to get this badge.",
        img:"img/badges/commander.png",
        title:"The Commander",
        wear : false,
        badgepercentage: 0,
        is_default : 0,
        unlocked: 0
    },

    {
        badge_code:"governor",
        tounlock:"100K followers to get this badge.",
        img:"img/badges/governor.png",
        title:"The Governor",
        wear : false,
        badgepercentage: 0,
        is_default : 0,
        unlocked: 0
    },

    {
        badge_code:"president",
        tounlock:"500K followers to get this badge.",
        img:"img/badges/president.png",
        title:"The President",
        wear : false,
        badgepercentage: 0,
        is_default : 0,
        unlocked: 0
    },

    {
        badge_code:"master",
        tounlock:"1M followers to get this badge.",
        img:"img/badges/master.png",
        title:"The Master",
        wear : false,
        badgepercentage: 0,
        is_default : 0,
        unlocked: 0
    },
    {
        badge_code:"dictator",
        tounlock:"5M followers to get this badge.",
        img:"img/badges/dictator.png",
        title:"The Dictator",
        wear : false,
        badgepercentage: 0,
        is_default : 0,
        unlocked: 0
    },

    {
        badge_code:"emperor",
        tounlock:"10M followers to get this badge.",
        img:"img/badges/emperor.png",
        title:"The Emperor",
        wear : false,
        badgepercentage: 0,
        is_default : 0,
        unlocked: 0
    }
]; 

for(var i = 0; i < $scope.badges.length; i++){
    for (var f = 0; f < $scope.myachievements.length; f++){
        if($scope.badges[i].badge_code == $scope.myachievements[f].badge_code){

            switch ($scope.myachievements[f].badge_code) {

                case 'green_apple':
                    $scope.badges[i].badgepercentage = 100;
                    $scope.badges[i].unlocked = 1;
                    $scope.badges[i].wear = true;
                break;

                case 'boss':
                    if($scope.myachievements[f].unlocked  == 1){
                        $scope.badges[i].badgepercentage = 100;
                        $scope.badges[i].unlocked = 1;
                        $scope.badges[i].wear = true;
                    }else{
                        $scope.badges[i].img = "img/badges/lockedbadge.png";
                        $scope.badges[i].badgepercentage = ($scope.myachievements[f].count_follower / 500) * 100;
                        if($scope.badges[i].badgepercentage >= 100){
                            $scope.badges[i].wear = true;                            
                        } 
                    }
                break;

                case 'chief':
                    if($scope.myachievements[f].unlocked  == 1){
                        $scope.badges[i].badgepercentage = 100;
                        $scope.badges[i].unlocked = 1;
                        $scope.badges[i].wear = true;
                    }else{
                        $scope.badges[i].img = "img/badges/lockedbadge.png";
                        $scope.badges[i].badgepercentage = ($scope.myachievements[f].count_follower / 1000) * 100;
                        if($scope.badges[i].badgepercentage >= 100){
                            $scope.badges[i].wear = true;
                        } 
                    }
                break;

                case 'captain':
                    if($scope.myachievements[f].unlocked  == 1){
                        $scope.badges[i].badgepercentage = 100;
                        $scope.badges[i].unlocked = 1;
                        $scope.badges[i].wear = true;
                    }else{
                        $scope.badges[i].img = "img/badges/lockedbadge.png";
                        $scope.badges[i].badgepercentage = ($scope.myachievements[f].count_follower / 5000) * 100;
                        if($scope.badges[i].badgepercentage >= 100){
                            $scope.badges[i].wear = true;
                        } 
                    }
                break;

                case 'commander':
                    if($scope.myachievements[f].unlocked  == 1){
                        $scope.badges[i].badgepercentage = 100;
                        $scope.badges[i].unlocked = 1;
                        $scope.badges[i].wear = true;
                    }else{
                        $scope.badges[i].img = "img/badges/lockedbadge.png";
                        $scope.badges[i].badgepercentage = ($scope.myachievements[f].count_follower / 10000) * 100; 
                        if($scope.badges[i].badgepercentage >= 100){
                            $scope.badges[i].wear = true;
                        }
                    }
                break;

                case 'governor':
                    if($scope.myachievements[f].unlocked  == 1){
                        $scope.badges[i].badgepercentage = 100;
                        $scope.badges[i].unlocked = 1;
                        $scope.badges[i].wear = true;
                    }else{
                        $scope.badges[i].img = "img/badges/lockedbadge.png";
                        $scope.badges[i].badgepercentage = ($scope.myachievements[f].count_follower / 100000) * 100;
                        if($scope.badges[i].badgepercentage >= 100){
                            $scope.badges[i].wear = true;
                        } 
                    }
                break;

                case 'president':
                    if($scope.myachievements[f].unlocked  == 1){
                        $scope.badges[i].badgepercentage = 100;
                        $scope.badges[i].unlocked = 1;
                        $scope.badges[i].wear = true;
                    }else{
                        $scope.badges[i].img = "img/badges/lockedbadge.png";
                        $scope.badges[i].badgepercentage = ($scope.myachievements[f].count_follower / 500000) * 100;
                        if($scope.badges[i].badgepercentage >= 100){
                            $scope.badges[i].wear = true;
                        } 
                    }
                break;

                case 'master':
                    if($scope.myachievements[f].unlocked  == 1){
                        $scope.badges[i].badgepercentage = 100;
                        $scope.badges[i].unlocked = 1;
                        $scope.badges[i].wear = true;
                    }else{
                        $scope.badges[i].img = "img/badges/lockedbadge.png";
                        $scope.badges[i].badgepercentage = ($scope.myachievements[f].count_follower / 1000000) * 100; 
                        if($scope.badges[i].badgepercentage >= 100){
                            $scope.badges[i].wear = true;
                        }

                    }
                break;

                case 'dictator':
                    if($scope.myachievements[f].unlocked  == 1){
                        $scope.badges[i].badgepercentage = 100;
                        $scope.badges[i].unlocked = 1;
                        $scope.badges[i].wear = true;
                    }else{
                        $scope.badges[i].img = "img/badges/lockedbadge.png";
                        $scope.badges[i].badgepercentage = ($scope.myachievements[f].count_follower / 5000000) * 100;
                        if($scope.badges[i].badgepercentage >= 100){
                            $scope.badges[i].wear = true;
                        } 

                    }
                break;

                case 'emperor':
                    if($scope.myachievements[f].unlocked  == 1){
                        $scope.badges[i].badgepercentage = 100;
                        $scope.badges[i].unlocked = 1;
                        $scope.badges[i].wear = true;
                    }else{
                        $scope.badges[i].img = "img/badges/lockedbadge.png";
                        $scope.badges[i].badgepercentage = ($scope.myachievements[f].count_follower / 10000000) * 100; 
                        if($scope.badges[i].badgepercentage >= 100){
                            $scope.badges[i].wear = true;
                        }

                    }
                break;
            }

            if($scope.myachievements[f].is_default == 1){
                $scope.badges[i].is_default = 1;
            }

        }
    }
}

$ionicLoading.hide();
}, function(err){
    $ionicLoading.hide();   
    console.log(err);
});


$scope.changeBadge = function(badgecode){

    $scope.badgecode = badgecode;

    if($scope.badgecode == ""){
        create_failed("Badge Code not found.");
    }else{
        $ionicLoading.show();
        var data = {
            badgecode:$scope.badgecode,
            quipper_id:$rootScope.myprofile.quipper_id
        };
//console.log(data);
$ionicLoading.show();
API.changeBadge(data, cb_success, cb_error);
console.log(data);
}

}


function cb_success(data){
    $ionicLoading.hide();
    if(data.Result == 1 ){
//success
create_success(data.Message[0]);
}else{
//error
var msg = data.Message.join("<br/>");
console.log(data.Message)
create_failed(msg);
}
// console.log(data);
}
function cb_error(data){
    $ionicLoading.hide();
// console.log("cb_error");
// console.log(data);
create_failed("Something went wrong please try again");
}

function create_failed(msg){
    var status = "e";
    var ontap_callback = function(e){
// console.log(e);
}
title = 'Change Badge';
btn_text = 'Try again';
$rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
}

function create_success(msg){
    var status = "s";
    var ontap_callback = function(e){
//console.log(e);

//$rootScope.reRoute('go','app.myprofile', 0, {id:$stateParams.id,collectionid:$scope.colid, handler:$rootScope.routeParams.handler});
$rootScope.goto('app.myprofile');
}
title = 'Change Badge';
btn_text = 'OK';
$rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
}

$scope.badgeInfo = function(badgecode){
    $stateParams.badgecode = badgecode;
    $rootScope.goto('app.badges', {badgecode:$stateParams.badgecode});
}

})


.controller('QuipperAchievementsCtrl',function($scope, $ionicHistory, $rootScope, $state, API,  $ionicLoading, $stateParams){

    //console.log($stateParams.id);
    $scope.quipperachievements = {}; 
    $scope.quipperbadges = {};
    API.quipperAchievements({
     id:$stateParams.id,
 }, function(data){
                //success
                $scope.quipperachievements = data.Data;
                $scope.quipperbadges = [
                {
                    badge_code:"green_apple",
                    tounlock:"Badge for Newbies",
                    img:"img/badges/apple.png",
                    title:"Green Apple",
                    badge_wapp : false,
                    unlocked: 0,
                    
                },

                {
                 badge_code:"boss",
                 tounlock:"Followers to unlock: 500",
                 img:"img/badges/boss.png",
                 title:"The Boss",
                 badge_wapp : false,
                 unlocked: 0,
                 
             },

             {
                 badge_code:"chief",
                 tounlock:"Followers to unlock: 1000",
                 img:"img/badges/chief.png",
                 title:"The Chief",
                 badge_wapp : false,
                 unlocked: 0,
                 
             },
             {
                 badge_code:"captain",
                 tounlock:"Followers to unlock: 5K",
                 img:"img/badges/captain.png",
                 title:"The Captain",
                 badge_wapp : false,
                 unlocked: 0,
                 
             },

             {
              badge_code:"commander",
              tounlock:"Followers to unlock: 10K",
              img:"img/badges/commander.png",
              title:"The Commander",
              badge_wapp : false,
              unlocked: 0,
              
          },

          {
             badge_code:"governor",
             tounlock:"Followers to unlock: 100K",
             img:"img/badges/governor.png",
             title:"The Governor",
             badge_wapp : false,
             unlocked: 0,
             
         },

         {
             badge_code:"president",
             tounlock:"Followers to unlock: 500K",
             img:"img/badges/president.png",
             title:"The President",
             badge_wapp : false,
             unlocked: 0,
             
         },

         {
             badge_code:"master",
             tounlock:"Followers to unlock: 1M",
             img:"img/badges/master.png",
             title:"The Master",
             badge_wapp : false,
             unlocked: 0,
             
         },

         {
          badge_code:"dictator",
          tounlock:"Followers to unlock: 5M",
          img:"img/badges/dictator.png",
          title:"The Dictator",
          badge_wapp : false,
          unlocked: 0,
          
      },

      {
         badge_code:"emperor",
         tounlock:"Followers to unlock: 10M",
         img:"img/badges/emperor.png",
         title:"The Emperor",
         badge_wapp : false,
         unlocked: 0,
         
     }
     
     ]; 

     for(var i = 0; i < $scope.quipperbadges.length; i++){
        for (var f = 0; f < $scope.quipperachievements.length; f++){
            if($scope.quipperbadges[i].badge_code == $scope.quipperachievements[f].badge_code){
                $scope.quipperbadges[i].badge_wapp = true;

            }
        }
    }
}, function(err){
 console.log(err);
});

$scope.badgeInfo = function(badgecode){
    $stateParams.badgecode = badgecode;
    $rootScope.goto('app.badges', {badgecode:$stateParams.badgecode});
}

})


.controller('BadgesInfoCtrl',function($scope, $ionicHistory, $rootScope, $state, API,  $ionicLoading, $stateParams){

    $scope.badgesinfo = {};

    switch ($stateParams.badgecode) {
        case 'green_apple':
        $scope.badgesinfo = {
            badge_code:"green_apple",
            img:"img/badges/apple2.png",
            title:"Green Apple",
            info:" ",
        };

        break;
        case 'boss':
        $scope.badgesinfo = {
            badge_code:"boss",
            tounlock:"Followers to unlock: 500",
            img:"img/badges/boss3.png",
            title:"The Boss",
            info:" ",
        };

        break;
        case 'chief':
        $scope.badgesinfo = {
            badge_code:"chief",
            tounlock:"Followers to unlock: 1000",
            img:"img/badges/chief2.png",
            title:"The Chief",
            info:" ",
        };

        break;
        case 'captain':
        $scope.badgesinfo = {
            badge_code:"captain",
            tounlock:"Followers to unlock: 5K",
            img:"img/badges/captain2.png",
            title:"The Captain",
            info:" ",
        };

        break;
        case 'commander':
        $scope.badgesinfo = {
            badge_code:"commander",
            tounlock:"Followers to unlock: 10K",
            img:"img/badges/commander2.png",
            title:"The Commander",
            info:" ",
        };

        break;
        case 'governor':
        $scope.badgesinfo = {
         badge_code:"governor",
         tounlock:"Followers to unlock: 100K",
         img:"img/badges/governor2.png",
         title:"The Governor",
         info:" ",
     };

     break;
     case 'president':
     $scope.badgesinfo = {
         badge_code:"president",
         tounlock:"Followers to unlock: 500K",
         img:"img/badges/president2.png",
         title:"The President",
         info:" ",
        };
         break;
         case 'master':
         $scope.badgesinfo = {
             badge_code:"master",
             tounlock:"Followers to unlock: 1M",
             img:"img/badges/master2.png",
             title:"The Master",
             info:" ",
         };

         break;
         case 'dictator':
         $scope.badgesinfo = {
          badge_code:"dictator",
          tounlock:"Followers to unlock: 5M",
          img:"img/badges/dictator2.png",
          title:"The Dictator",
          info:" ",
      };

      break;
      case 'emperor':
      $scope.badgesinfo = {
        badge_code:"emperor",
        tounlock:"Followers to unlock: 10M",
        img:"img/badges/emperor2.png",
        title:"The Emperor",
        info:" ",
    };

    break;

}


   

})


.directive('myMaxlengthx', ['$compile', '$log', function($compile, $log, $scope) {
    return {
        restrict: 'A',
        require: 'ngModel',
        link: function (scope, elem, attrs, ctrl) {
            attrs.$set("ngTrim", "false");
            var maxlength = parseInt(attrs.myMaxlengthx, 10);
            ctrl.$parsers.push(function (value) {
                document.getElementById('bioTextCount').innerHTML = MaxCaptionCount - value.length;
                if (value.length > maxlength)
                {
                    value = value.substr(0, maxlength);
                    ctrl.$setViewValue(value);
                    ctrl.$render();
                }
                return value;
            });
        }
    };
}])
.directive('imageonload', function() {
    return {
        restrict: 'A',
        link: function(scope, element, attrs) {
            element.bind('load', function() {
                console.log('image is loaded');
            });
            element.bind('error', function(){
                scope.profile_picture = "img/no_pic.png";
            });
        }
    };
})


;