angular.module('quipsphere.record.controllers', [])

// RECORDING
.controller('RecordCtrl', function($scope, $state) {
    //alert();
})

.controller('RecordStartCtrl', function($ionicHistory,$scope, $state, ClockSrv, Arc, FillText, $ionicPopup, $rootScope, $cordovaMedia,
    Toast, $timeout, $log, $ionicModal, $cordovaFile, $cordovaFileTransfer ) {

    $rootScope.quipDuration = 0;
    var audio = new Audio('sounds/beep.wav');

    $scope.$on('record-modal.shown', function() {

        $scope.quipsphere_app_version = window.localStorage['quipsphere_app_version'];

        // compute for toast level
        $log.debug(window.screen.height);
        var toastVerticalPosition = 0;
        if(window.screen.height < 640){
            toastVerticalPosition = -150;
        }else{
            //toastVerticalPosition = (Math.round(window.screen.height/2)-20)*(-1);
            toastVerticalPosition = -300;
        }

        $timeout(function() {
            if($rootScope.dontToast == 1){
            }else{
                if(quipDebug == 0){
                    Toast.show("PRESS & HOLD RECORD BUTTON TO START RECORDING","short","bottom",toastVerticalPosition,function(success){
                    },function(error){});
                }
                $rootScope.dontToast = 0;
            }
        }, 1000);
        $scope.pressed = false;
        $scope.msg = "";

        var clock = new ClockSrv();
        var myArc = new Arc();
        myArc.x = 100;
        myArc.y = 100;
        myArc.r = 87;
        myArc.sAngle = -90;
        myArc.eAngle = 270;
        var myText = new FillText();
        myText.text = "0";
        myText.x = 97;
        myText.y = 125;
        myText.font = "90px digital, Arial";
        var maxSeconds = 12.1;
        var multiplier = 360/maxSeconds;
        var clickDate = new Date().getTime();

        var canvas = document.createElement("canvas");
        canvas.height = "200";
        canvas.width = "200";
        var ctx = canvas.getContext('2d');
        ctx.strokeStyle = "rgba(255, 4, 4, 0.5)";
        ctx.lineWidth = 25;
        ctx.lineCap = 'butt';
        //ctx.lineCap = 'square';
        var img = document.getElementById('record-timer-img');
        img.onload = function(){
            myArc.eAngle = -90;
            renderCanvas();
        }
        window.onload = function(){
            myArc.eAngle = -90;
            renderCanvas();
        }
        setTimeout(function(){
            myArc.eAngle = -90;
            renderCanvas();
        },100)

        setTimeout(function(){
            myArc.eAngle = -90;
            renderCanvas();
        },500)

        function createCanvas(){

            ctx.drawImage(img,0,0,200,200);
            ctx.beginPath();
            ctx.arc(myArc.x, myArc.y, myArc.r, myArc.startingAngle(), myArc.endingAngle());
            ctx.stroke();

            //Date
            ctx.textAlign="center";
            ctx.fillStyle = "#ffffff";
            ctx.font=myText.font;
            ctx.fillText(myText.text,myText.x,myText.y);

            var dataURL = canvas.toDataURL();
            for(i = 0; i < document.getElementsByClassName('record-timer').length; i++){
                document.getElementsByClassName('record-timer')[i].src = dataURL;
            }

        }


        function degToRad(degree){
            var factor = Math.PI/180;
            return degree * factor;
        }

        function renderCanvas(){
            ctx.clearRect(0,0, canvas.width, canvas.height);
            createCanvas();
        }

        $scope.startRecording = function(){
            console.log('start record');
            audio.play();

            // initialize file recording then record
            quipDateTime = new Date().getTime();
            var quipFolder = '';
            if(quipDebug == 0){
                quipFolder = cordova.file.externalRootDirectory;
            }
            $cordovaFile.createDir(quipFolder,'Quipsphere', false).then(function (success) {}, function (error) {});
            quipFileName = quipFolder+'Quipsphere/'+$rootScope.user_data.quipper_id+'_'+quipDateTime+'.m4a';
            //var quipFolder = cordova.file.applicationStorageDirectory;
            //quipFileName = quipFolder+'Quipsphere/tempquip.m4a';
            //$log.info(quipFileName);

            $scope.msg = "Touch";
            $scope.pressed = true;

            $timeout(function(){
                if($scope.pressed == true){

                    clickDate = new Date().getTime();
                    clock.startClock(function(){
                        var milliseconds = new Date().getTime() - clickDate;
                        var seconds = milliseconds/1000;
                        var percent = (seconds)*multiplier - 90;
                        myText.text = parseInt(seconds);
                        myArc.eAngle = percent;
                        $rootScope.quipDuration = milliseconds;
                        console.log(seconds+' & '+maxSeconds);
                        if(seconds >= maxSeconds){
                            myText.text = "0";
                            renderCanvas();
                            $scope.stopRecording();
                        }
                        renderCanvas();
                    },50);
                    window.localStorage['quip_filename'] = quipFileName;

                    $rootScope.tempAudioFile = quipFileName;
                    if(quipDebug == 0){
                        G_qsm = $cordovaMedia.newMedia(quipFileName);
                        G_qsm.startRecord();
                    }

                }else{

                    /*console.log('error but proceed');
                    $scope.openEditQuipModal();
                    $timeout(function(){
                        $rootScope.closeRecorderModal('editquip');
                    },500);*/

                }
            },500);
        }

        $scope.stopRecording = function(){
            $scope.pressed = false;
            if(quipDebug == 0){
                if(G_qsm){
                    G_qsm.stopRecord();
                }
            }
            clock.stopClock();
            myArc.eAngle = -90;
            myText.text = "0";
            renderCanvas();
            $scope.openEditQuipModal();
            $timeout(function(){
                $rootScope.closeRecorderModal('editquip');
            },300);
        }
    });

})





