angular.module('quipsphere.sphere.controllers', [])
.controller('MysphereCtrl', function($rootScope, $scope, $state, $ionicModal, $timeout,
    $ionicSlideBoxDelegate, $ionicPopover,API, $ionicLoading, MysphereService, ClockSrv) {
        var mysphereElement = document.querySelector("#mysphere");
        $scope.mysphereClockService = new ClockSrv();
        $scope.checkUnheard = function(){
            console.log("checkUnheard");
            if(window.localStorage['mysphere_service']){
                var sphere_service_data = JSON.parse(window.localStorage['mysphere_service']);
                //console.log(sphere_service_data);
                for(var i = 0; i < document.querySelectorAll(".red-check-reset").length; i++){
                    if(document.querySelectorAll(".red-check-reset")[i] != null){
                        document.querySelectorAll(".red-check-reset")[i].style.visibility = "hidden";
                    }
                }
                for(var i = 0; i < sphere_service_data.length; i++){
                    if(document.querySelector(".red-check-"+sphere_service_data[i]) != null){
                        document.querySelector(".red-check-"+sphere_service_data[i]).style.visibility = "visible";
                    }
                }
                $ionicSlideBoxDelegate.$getByHandle('mysphere-slide').update();
                $ionicSlideBoxDelegate.$getByHandle('sphere-event-slide').update();
            }
        };
        $scope.$on('$ionicView.beforeEnter', function() {
            console.log("adding event listener mySphereEvent")
            mysphereElement.addEventListener("click", mySphereEvent, false);
            $rootScope.selectedtopics.handler = "";
            $rootScope.threadParentUniqueId = "";
            $ionicSlideBoxDelegate.$getByHandle('sphere-event-slide').update();
            $ionicSlideBoxDelegate.$getByHandle('mysphere-slide').update();
            $scope.sphereHasUnheard = [];
            $scope.sphereService = new MysphereService();
            $scope.sphereService.params.callParams.quipper_id = $rootScope.user_data.quipper_id;
            $scope.sphereService.params.callParams.root_quipper_id = $rootScope.user_data.quipper_id;
            $scope.sphereService.params.callHeaders.devtoken = $rootScope.global.devtoken;
            $scope.sphereService.params.callHeaders.userlang = $rootScope.global.userlang;
            $scope.sphereService.doWork($scope.sphereService.params);
            console.log('commanding mysphereClockService.startClock()');
            $scope.mysphereClockService.startClock(function(){
                $scope.checkUnheard();
            },1000)
        }); 

        $scope.$on('$ionicView.beforeLeave', function() {
            console.log("removing event listener mySphereEvent")
            mysphereElement.removeEventListener("click", mySphereEvent, false);
            $scope.sphereService.stopWorker();
            $scope.mysphereClockService.stopClock();
        });
        $scope.$on('$ionicView.afterLeave', function() {
            //$rootScope.canQuip = true;
        });

        function mySphereEvent(e){
            if (e.target !== e.currentTarget) {
                var checktarget = e.target.classList;
                console.log(checktarget);
                for(var i = 0; i < checktarget.length; i++){
                    splited = checktarget[i].split("_");
                    if(splited[0] == "mysphere"){
                        switch(splited[1]){
                            case "view":
                                $rootScope.threadParentUniqueId = splited[2];
                                $rootScope.reRoute('go','app.sphere', 0, {id:splited[2], handler: splited[3]});
                                $rootScope.goto('app.sphere',{id:splited[2]});
                                break;
                            case "viewevents":
                                $rootScope.threadParentUniqueId = splited[2];
                                $rootScope.reRoute('go','app.sphere-events', 0, {id:splited[2], handler: splited[3]});
                                $rootScope.goto('app.sphere-events',{id:splited[2]});
                                break;
                            default:
                                break;
                        }
                    }
                }

            }
        }


        $scope.myspheres = [];
        $scope.mysphere_array = [];
        $scope.mysphere_events = [];
        $scope.mysphere_events_array = [];
        $scope.h = window.innerHeight;
        $scope.w = window.innerWidth;
        $scope.show_mysphere_slider = false;
        $scope.show_mysphere_events_slider = false;
        var event_slider_hide = document.querySelector("#sphere_event_slider_loading_hide");
        var event_slider_show = document.querySelector("#sphere_event_slider_loading_show");
        var sphere_slider_hide = document.querySelector("#sphere_slider_loading_hide");
        var sphere_slider_show = document.querySelector("#sphere_slider_loading_show");
        $scope.getMysphere = function(){
            sphere_slider_show.style.display = "none";
            sphere_slider_hide.style.display = "block";
            $scope.mysphere_array = [];
            API.getSpheres({limit:100},
                function(data){
                    if(data.Result == 1){
                        window.localStorage['myspheres'] = JSON.stringify(data.Data);
                        $scope.myspheres = JSON.parse(window.localStorage['myspheres']);
                        //console.log($scope.myspheres.length);
                        var x = 0;
                        var y = [];
                        for(var i = 0; i < data.Data.length; i++){
                            x++;
                            y.push(data.Data[i]);
                            if(x == 9){
                                $scope.mysphere_array.push(y);
                                x = 0;
                                y = [];
                            }else{
                                if(i+1 == data.Data.length){
                                    $scope.mysphere_array.push(y);
                                    x = 0;
                                    y = [];
                                }
                            }
                            //console.log(i);
                        }
                        //console.log($scope.mysphere_array);
                        $ionicSlideBoxDelegate.$getByHandle('mysphere-slide').update();
                        sphere_slider_hide.style.display = 'none';
                        if($scope.mysphere_array.length != 0){
                            sphere_slider_show.style.display = 'block';
                        }
                    }
                },function(err){
                    sphere_slider_hide.style.display = 'none';
            }); 
        }
        $scope.getMysphereEvents = function(){
            event_slider_show.style.display = "none";
            event_slider_hide.style.display = "block";
            $scope.mysphere_events_array = [];
            API.sphereEvents({limit:100},
                function(data){
                    //console.log(data);
                    if(data.Result == 1){
                        window.localStorage['myspheres_events'] = JSON.stringify(data.Data);
                        $scope.mysphere_events = JSON.parse(window.localStorage['myspheres_events']);
                        //console.log($scope.mysphere_events.length);
                        var x = 0;
                        var y = [];
                        for(var i = 0; i < data.Data.length; i++){
                            x++;
                            y.push(data.Data[i]);
                            if(x == 3){
                                $scope.mysphere_events_array.push(y);
                                x = 0;
                                y = [];
                            }else{
                                if(i+1 == data.Data.length){
                                    $scope.mysphere_events_array.push(y);
                                    x = 0;
                                    y = [];
                                }
                            }
                            //console.log(i);
                        }
                        $ionicSlideBoxDelegate.$getByHandle('sphere-event-slide').update();
                        if($scope.mysphere_events_array.length != 0){
                            event_slider_show.style.display = "block";
                        }
                        event_slider_hide.style.display = "none";
                    }
                    setTimeout(function(){
                        $scope.$broadcast('getMySphere');
                    },100)
                },function(err){
                    event_slider_hide.style.display = "none";
                    setTimeout(function(){
                        $scope.$broadcast('getMySphere');
                    },100)
            }); 
        }
        $scope.$on('getMySphere', function(){
            $scope.getMysphere();
        })
        $scope.$on('getMySphereEvents', function(){
            $scope.getMysphereEvents();
        })
        $scope.castGetMySphere = function(){
            $scope.$broadcast('getMySphereEvents');
            $scope.$broadcast('scroll.refreshComplete');
        }
        $scope.castGetMySphere();

        

        function getSpheresData(){
            return new Promise( function( resolve, reject ) {
                if (true) {
                    resolve();
                    $scope.castGetMySphere();
                } else {
                    reject();
                }
            } );
        }
        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){
            if(toState.name == 'app.mysphere'){
                SpherePullToRefresh.init({
                    contentEl:"sphere-content",
                    ptrEl:"sphere-ptr",
                    limittrigger:'sphere-container',
                    bodyId:'sphere-bodycontainer',
                    loadingFunction: getSpheresData
                });
            }
        });

        // .fromTemplateUrl() method
        $ionicPopover.fromTemplateUrl('mysphere-popover.html', {
            scope: $scope
        }).then(function(popover) {
            $scope.myspherepopover = popover;
        });

        $scope.openMyspherePopover = function($event) {
            $scope.myspherepopover.show($event);
        };
        $scope.closeMyspherePopover = function() {
            $scope.myspherepopover.hide();
        };
        //Cleanup the popover when we're done with it!
        $scope.$on('$destroy', function() {
            $scope.myspherepopover.remove();
        });
        // Execute action on hide popover
        $scope.$on('myspherepopover.hidden', function() {
            // Execute action
        });
        // Execute action on remove popover
        $scope.$on('myspherepopover.removed', function() {
            // Execute action
        });
})
.controller('SphereCtrl', function($rootScope, $scope, $state, ClockSrv, $ionicScrollDelegate, 
    $ionicSlideBoxDelegate,$ionicLoading,$ionicPopup,
    $stateParams,$ionicPopover, API) {
        $scope.currentsphere = {};
        $scope.sphere = {};
        $scope.sphere.sphere_id = $stateParams.id;
        $scope.newsfeed_spheres = [];
        $scope.sphere_collection_array = [];
        $scope.show_new_count = false;
        $scope.new_count = '';
        $scope.current_playing = '';
        $rootScope.canQuip = false;
        var sphereElement = document.querySelector("#sphere");
        var sphere_puller = new ClockSrv();
        var newsfeed_spheres_temp = [];
        $scope.sphere_last_played_id = "";
        var playedicon = 'img/newsfeed/quip_play_icon_1.png';
        var pausedicon = 'img/newsfeed/quip_pause_icon_1.png';
        var loadingicon = 'img/quip_loading_icon.gif';
        $rootScope.mediaPausedFlag = 0;
        $rootScope.currentMediaId = '';
        var mediaLoadedFlag = 0;
        var template = 
        '<ion-popover-view class="sphere-delete-quip" style="width:100px; text-align: center;">'+
        '<div>'+
        '<div class="profile-popover-li" on-tap="" >'+
        '<span>Delete</span><br>'+
        '</div>'+
        '</div>'+
        '</ion-popover-view>';
        $scope.sending_flag = true;
        $scope.active_autofetch = false;

        $scope.$on('$ionicView.beforeEnter', function() {
            $rootScope.canQuip = false;
            console.log("adding event listener sphereEvent")
            sphereElement.addEventListener("click", sphereEvent, false);
        }); 
        $scope.$on('$ionicView.afterEnter', function() {
            console.log('start clock for fetching');
            sphere_puller.startClock(function(){
                console.log('fetching');
                if($scope.active_autofetch){
                    if($scope.sending_flag){
                        $scope.sending_flag = false;
                        if($scope.newsfeed_spheres.length != 0){
                            API.getSphereQuipsThread({
                                unique_id : $stateParams.id,
                                limit:10,
                                action:'pull',
                                end: $scope.newsfeed_spheres[0].uniqid
                                },function(data){
                                    console.log(data);
                                    if(data.Result == 1){
                                        data.Data = clearArray(data.Data, $scope.newsfeed_spheres);
                                        if(data.Data.length != 0){
                                            $scope.new_count = (data.Data.length <= 1)?data.Data.length+" new quip":data.Data.length+" new quips";
                                            if($ionicScrollDelegate.$getByHandle('sphereScroll').getScrollPosition().top <= 0){
                                                for(var i = 0; i < data.Data.length; i++){
                                                    console.log(data.Data[i].quipper_id)
                                                    console.log($rootScope.user_data.quipper_id)
                                                    if(data.Data[i].quipper_id != $rootScope.user_data.quipper_id){
                                                        document.querySelector("#show_sphere_new_quips").style.display="block";
                                                        document.querySelector("#show_sphere_new_quips").classList.remove("animate-hide-timer");
                                                        document.querySelector("#show_sphere_new_quips").classList.remove("animate-slide-down");
                                                        setTimeout(function(){
                                                            document.querySelector("#show_sphere_new_quips").classList.add("animate-hide-timer");
                                                            document.querySelector("#show_sphere_new_quips").classList.add("animate-slide-down");
                                                        },300);
                                                    }
                                                }
                                                window.localStorage['newsfeed_sphere'] = JSON.stringify(data.Data.concat($scope.newsfeed_spheres));
                                                $scope.newsfeed_spheres = data.Data.concat($scope.newsfeed_spheres);
                                            }else{
                                                for(var i = 0; i < data.Data.length; i++){
                                                    if(data.Data[i].quipper_id != $rootScope.user_data.quipper_id){
                                                        document.querySelector("#show_sphere_new_quips").style.display="block";
                                                        document.querySelector("#show_sphere_new_quips").classList.remove("animate-hide-timer");
                                                        document.querySelector("#show_sphere_new_quips").classList.remove("animate-slide-down");
                                                        setTimeout(function(){
                                                            document.querySelector("#show_sphere_new_quips").classList.add("animate-hide-timer");
                                                            document.querySelector("#show_sphere_new_quips").classList.add("animate-slide-down");
                                                        },300);
                                                    }
                                                }
                                                window.localStorage['newsfeed_sphere'] = JSON.stringify(data.Data.concat($scope.newsfeed_spheres));
                                                $scope.newsfeed_spheres = data.Data.concat($scope.newsfeed_spheres);
                                            }
                                            var y = data.Data.length-1;
                                            if($rootScope.user_data.quipper_id != data.Data[y].quipper_id){
                                                setTimeout(function(){
                                                    if($scope.current_playing == ''){
                                                        if(data.Data[y].is_played == 0){
                                                            $scope.quipHeard(data.Data[y].uniqid);
                                                        }
                                                        data.Data[y].is_played = 1;
                                                        var quip_media_class = 'auto_play_'+data.Data[y].unique_id;
                                                        var elems = document.querySelectorAll("."+quip_media_class);
                                                        var e = {};
                                                        for(var i = 0; i < elems.length; i++){
                                                            e.target = elems[i];
                                                        }
                                                        $scope.current_playing = e.target;

                                                        if($rootScope.currentMediaId == data.Data[y].unique_id){
                                                            if($rootScope.mediaPausedFlag == 0){
                                                                e.target.src = playedicon;
                                                                $rootScope.media.pause();
                                                            }else{
                                                                e.target.src = pausedicon;
                                                                $rootScope.media.play();
                                                            }
                                                        }else{
                                                            e.target.src = loadingicon;
                                                            e.target.classList.remove('play_0');
                                                            e.target.classList.add('play_1');
                                                            $rootScope.currentMediaId = data.Data[y].unique_id;
                                                            $rootScope.media = document.getElementById('quip_audio_src');
                                                            $rootScope.media.pause();
                                                            $rootScope.media.src = e.target.name;
                                                            $rootScope.media.load();
                                                            $rootScope.quipPlayerItem = e.target; // assign the object to play
                                                            $rootScope.sphereQuipUniqueId = data.Data[y].unique_id;
                                                            $scope.sphere_last_played_id = data.Data[y].unique_id;
                                                        }
                                                    }
                                                },250);
                                            }

                                            $scope.reScroll();
                                        }
                                    }else{
                                    }
                                    $scope.sending_flag = true;
                                },function(err){
                                    $scope.sending_flag = true;
                            });
                        }else{
                            API.getSphereQuipsThread({
                                unique_id : $stateParams.id,
                                limit:10,
                                },function(data){
                                    console.log(data);
                                    if(data.Result == 1){
                                        data.Data = clearArray(data.Data, data.Data);
                                        if(data.Data.length != 0){
                                            $scope.new_count = (data.Data.length <= 1)?data.Data.length+" new quip":data.Data.length+" new quips";
                                            if($ionicScrollDelegate.$getByHandle('sphereScroll').getScrollPosition().top <= 0){

                                                for(var i = 0; i < data.Data.length; i++){
                                                    if(data.Data[i].quipper_id != $rootScope.user_data.quipper_id){
                                                        document.querySelector("#show_sphere_new_quips").style.display="block";
                                                        document.querySelector("#show_sphere_new_quips").classList.remove("animate-hide-timer");
                                                        document.querySelector("#show_sphere_new_quips").classList.remove("animate-slide-down");
                                                        setTimeout(function(){
                                                            document.querySelector("#show_sphere_new_quips").classList.add("animate-hide-timer");
                                                            document.querySelector("#show_sphere_new_quips").classList.add("animate-slide-down");
                                                        },300);
                                                    }
                                                }
                                                window.localStorage['newsfeed_sphere'] = JSON.stringify(data.Data.concat($scope.newsfeed_spheres));
                                                $scope.newsfeed_spheres = JSON.parse(window.localStorage['newsfeed_sphere']);
                                            }else{
                                                for(var i = 0; i < data.Data.length; i++){
                                                    if(data.Data[i].quipper_id != $rootScope.user_data.quipper_id){
                                                        document.querySelector("#show_sphere_new_quips").style.display="block";
                                                        document.querySelector("#show_sphere_new_quips").classList.remove("animate-hide-timer");
                                                        document.querySelector("#show_sphere_new_quips").classList.remove("animate-slide-down");
                                                        setTimeout(function(){
                                                            document.querySelector("#show_sphere_new_quips").classList.add("animate-hide-timer");
                                                            document.querySelector("#show_sphere_new_quips").classList.add("animate-slide-down");
                                                        },300);
                                                    }
                                                }
                                                window.localStorage['newsfeed_sphere'] = JSON.stringify(data.Data.concat($scope.newsfeed_spheres));
                                                $scope.newsfeed_spheres = JSON.parse(window.localStorage['newsfeed_sphere']);
                                            }
                                            var y = data.Data.length-1;
                                            if($rootScope.user_data.quipper_id != data.Data[y].quipper_id){
                                                setTimeout(function(){
                                                    if($scope.current_playing == ''){
                                                        if(data.Data[y].is_played == 0){
                                                            $scope.quipHeard(data.Data[y].uniqid);
                                                        }
                                                        data.Data[y].is_played = 1;
                                                        var quip_media_class = 'auto_play_'+data.Data[y].unique_id;
                                                        var elems = document.querySelectorAll("."+quip_media_class);
                                                        var e = {};
                                                        console.log(data.Data[y].is_played);
                                                        for(var i = 0; i < elems.length; i++){
                                                            e.target = elems[i];
                                                        }
                                                        $scope.current_playing = e.target;

                                                        if($rootScope.currentMediaId == data.Data[y].unique_id){
                                                            if($rootScope.mediaPausedFlag == 0){
                                                                e.target.src = playedicon;
                                                                $rootScope.media.pause();
                                                            }else{
                                                                e.target.src = pausedicon;
                                                                $rootScope.media.play();
                                                            }
                                                        }else{
                                                            e.target.src = loadingicon;
                                                            e.target.classList.remove('play_0');
                                                            e.target.classList.add('play_1');
                                                            $rootScope.currentMediaId = data.Data[y].unique_id;
                                                            $rootScope.media = document.getElementById('quip_audio_src');
                                                            $rootScope.media.pause();
                                                            $rootScope.media.src = e.target.name;
                                                            $rootScope.media.load();
                                                            $rootScope.quipPlayerItem = e.target; // assign the object to play
                                                            $rootScope.sphereQuipUniqueId = data.Data[y].unique_id;
                                                            $scope.sphere_last_played_id = data.Data[y].unique_id;
                                                        }
                                                    }
                                                },250);
                                            }
                                            $scope.reScroll();
                                        }
                                    }else{
                                    }
                                $scope.sending_flag = true;
                                },function(err){
                                $scope.sending_flag = true;
                            });
                        }
                    }
                }
            },2000);
        }); 
        $scope.$on('$ionicView.beforeLeave', function() {
            console.log('stop clock for fetching');
            sphere_puller.stopClock();

            console.log("adding event listener sphereEvent")
            sphereElement.removeEventListener("click", sphereEvent, false);
        });
        $scope.$on('$ionicView.afterLeave', function() {
            $rootScope.canQuip = true;
        });

        $scope.$on('getSphereThreads', function(){
            // console.log('on getSphereThreads');
            // $scope.sphereScrollToTop();
        })

        $scope.$on('sphereRunQueueEnded',function(){
            console.log("sphere_last_played_id");
            console.log($scope.sphere_last_played_id);
            if($scope.current_playing != ''){
                $scope.current_playing.src = playedicon;
            }
            $scope.current_playing = '';
            //lastplayed
            if($scope.sphere_last_played_id != ""){
                for(var i = 0; i < $scope.newsfeed_spheres.length; i++){
                    if($scope.newsfeed_spheres[i].unique_id == $scope.sphere_last_played_id){
                        //autoplay
                        var f = i - 1;
                        //$scope.newsfeed_spheres[i].is_played = 1;
                        if($scope.newsfeed_spheres[f]){
                            if($scope.newsfeed_spheres[f].is_played == 0){

                                var quip_media_class = 'auto_play_'+$scope.newsfeed_spheres[f].unique_id;
                                if($scope.newsfeed_spheres[f].is_played == 0){
                                    $scope.quipHeard($scope.newsfeed_spheres[f].uniqid);
                                }
                                $scope.newsfeed_spheres[f].is_played = 1;
                                var elems = document.querySelectorAll("."+quip_media_class);
                                var e = {};
                                for(var i = 0; i < elems.length; i++){
                                    e.target = elems[i];
                                }
                                $scope.current_playing = e.target;

                                var rect = e.target.getBoundingClientRect();
                                var scroll_top = $ionicScrollDelegate.$getByHandle('sphereScroll').getScrollPosition().top;
                                $ionicScrollDelegate.$getByHandle('sphereScroll').scrollTo(0, (scroll_top + rect.top) - 100, true);

                                setTimeout(function(){
                                    if($rootScope.currentMediaId == $scope.newsfeed_spheres[f].unique_id){
                                        if($rootScope.mediaPausedFlag == 0){
                                            e.target.src = playedicon;
                                            $rootScope.media.pause();
                                        }else{
                                            e.target.src = pausedicon;
                                            $rootScope.media.play();
                                        }
                                    }else{
                                        e.target.src = loadingicon;
                                        e.target.classList.remove('play_0');
                                        e.target.classList.add('play_1');
                                        $rootScope.currentMediaId = $scope.newsfeed_spheres[f].unique_id;
                                        $rootScope.media = document.getElementById('quip_audio_src');
                                        $rootScope.media.pause();
                                        $rootScope.media.src = e.target.name;
                                        $rootScope.media.load();
                                        //e.target.src = pausedicon;
                                        $rootScope.quipPlayerItem = e.target; // assign the object to play
                                        // update
                                        $rootScope.sphereQuipUniqueId = $scope.newsfeed_spheres[f].unique_id;
                                        $scope.sphere_last_played_id = $scope.newsfeed_spheres[f].unique_id;
                                    }
                                },100);
                                return;
                            }
                        }
                        return;
                    }
                }
            }
        })
        $scope.$on('sphereRunQueuePaused',function(){
            console.log("sphere_last_played_id");
            console.log($scope.sphere_last_played_id);
            if($scope.current_playing != ''){
                $scope.current_playing.src = playedicon;
            }
            $scope.current_playing = '';
            //lastplayed
            if($scope.sphere_last_played_id != ""){
                for(var i = 0; i < $scope.newsfeed_spheres.length; i++){
                    if($scope.newsfeed_spheres[i].unique_id == $scope.sphere_last_played_id){
                        //autoplay
                        $scope.newsfeed_spheres[i].is_played = 1;
                    }
                }
            }
        })
        $scope.reScroll = function(){
            setTimeout(function(){
                if($scope.current_playing != ''){
                    var rect = $scope.current_playing.getBoundingClientRect();
                    var scroll_top = $ionicScrollDelegate.$getByHandle('sphereScroll').getScrollPosition().top;
                    $ionicScrollDelegate.$getByHandle('sphereScroll').scrollTo(0, (scroll_top + rect.top) - 100, true);
                }
            },250)
        }
        $scope.spherePopover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });
        console.log('$rootScope.routeStack');
        console.log($rootScope.routeStack);
        function sphereEvent(e){
            if (e.target !== e.currentTarget) {
                var checktarget = e.target.classList;
                for(var i = 0; i < checktarget.length; i++){
                    splited = checktarget[i].split("_");
                    console.log(splited);
                    if(splited[0] == "sphere"){
                        switch(splited[1]){

                            case "sharequip":
                                var uid = splited[3];
                                console.log(uid);
                                window.plugins.socialsharing.share('Listen to this!', "Listen to this!", null, 'http://quipsphere.com/quip/quipshare.php?quipid=' + uid);
                                break;
                            case "viewoptions":
                                var template = 
                                '<ion-popover-view class="sphere-delete-quip" style="width:100px; text-align: center;">'+
                                '<div>'+
                                '<div class="profile-popover-li" on-tap="deleteQuip(\''+splited[2]+'\')" >'+
                                '<span>Delete</span><br>'+
                                '</div>'+
                                '</div>'+
                                '</ion-popover-view>';

                                $scope.spherePopover = $ionicPopover.fromTemplate(template, {
                                    scope: $scope
                                });
                                $scope.spherePopover.show(e);
                            break;
                            case "imgslider":
                                var imgs = $scope.newsfeed_spheres[splited[2]].quip_images;
                                $rootScope.showImages(imgs);
                            break;
                            case "viewquipper":
                                //console.log(splited[2]);
                                $rootScope.reRoute('go','view profile', 0, {id:splited[2], handler:$scope.currentsphere.handle});
                                $rootScope.goto('app.view-profile',{id:splited[2]});
                            break;
                            case "viewcollection":
                                //console.log(splited[2]);
                                $rootScope.reRoute('go','app.collectionitems', 0, {id:$stateParams.id,collectionid:splited[2], handler:$rootScope.routeParams.handler});
                                $rootScope.goto('app.collectionitems',{id:$stateParams.id,collectionid:splited[2]});
                            break;
                            case "quipmedia":
                                //stop autoplay
                                if($scope.current_playing != ''){
                                    $scope.current_playing.src = playedicon;
                                }

                                for(var i = 0; i < $scope.newsfeed_spheres.length; i++){
                                    if($scope.newsfeed_spheres[i].unique_id == splited[2]){
                                        var quip_media_class = 'auto_play_'+splited[2];
                                        var elems = document.querySelectorAll("."+quip_media_class);
                                        $scope.current_playing = '';

                                        if($scope.newsfeed_spheres[i].is_played == 0){
                                            $scope.quipHeard($scope.newsfeed_spheres[i].uniqid);
                                        }
                                        $scope.newsfeed_spheres[i].is_played = 1;
                                        for(var i = 0; i < elems.length; i++){
                                            e.target = elems[i];
                                        }
                                        if($rootScope.currentMediaId == splited[2]){
                                            if($rootScope.mediaPausedFlag == 0){
                                                e.target.src = playedicon;
                                                $rootScope.media.pause();
                                            }else{
                                                e.target.src = pausedicon;
                                                $rootScope.media.play();
                                            }
                                        }else{
                                            e.target.src = loadingicon;
                                            e.target.classList.remove('play_0');
                                            e.target.classList.add('play_1');
                                            $rootScope.currentMediaId = splited[2];
                                            $rootScope.media = document.getElementById('quip_audio_src');
                                            $rootScope.media.pause();
                                            $rootScope.media.src = e.target.name;
                                            $rootScope.media.load();
                                            $rootScope.quipPlayerItem = e.target;
                                            $rootScope.sphereQuipUniqueId = splited[2];
                                            $scope.sphere_last_played_id = splited[2];
                                            $scope.current_playing = e.target;
                                        }
                                        return;
                                    }
                                }
                            break;
                            case "thread":
                                $rootScope.reRoute('go','app.sphere-reply', 0, $rootScope.routeParams);
                                $rootScope.selectedtopics.handler = $scope.currentsphere.handle + " " +splited[4];
                                $rootScope.threadParentUniqueId = splited[2];
                                $rootScope.postBackRoute = 'app.sphere-reply';
                                $rootScope.routeParams.id = splited[3];
                                $rootScope.routeParams.handler = $scope.currentsphere.handle;
                                $rootScope.routeParams.quipper_handler = splited[4];
                                $rootScope.goto('app.sphere-reply',{sphere_id:$rootScope.routeParams.id, quip_id:splited[2]});
                            break;
                            case "replythread":
                                if($scope.currentsphere.enable_reply != 1){
                                    var status = "e";
                                    var ontap_callback = function(e){
                                        // console.log(e);
                                    }
                                    var title = 'Cannot Reply';
                                    var btn_text = 'Okay';
                                    var msg = 'Reply Option is disabled'; 
                                    $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                                    return;
                                }
                                if($rootScope.canQuip == false){
                                    $rootScope.CannotQuip();
                                }else{
                                    $rootScope.reRoute('go','recorder');
                                    $rootScope.selectedtopics.handler = $scope.currentsphere.handle + " " +splited[4];
                                    $rootScope.threadParentUniqueId = splited[2];
                                    $rootScope.postBackRoute = 'app.sphere-reply';
                                    $rootScope.routeParams.id = splited[3];
                                    $rootScope.routeParams.handler = $scope.currentsphere.handle;
                                    $rootScope.routeParams.quipper_handler = splited[4];
                                    $rootScope.openRecorderModal();
                                }
                            break;
                            default:
                            break;
                        }
                    }
                    if(splited[0] == "global"){
                        switch(splited[1]){
                            case "viewtopic":
                                    $rootScope.goto('app.home-topics',{id:splited[2]});
                                    break;
                            case 'viewprofile':
                                    $rootScope.goto('app.view-profile',{id:splited[2]});
                                    break;
                            case "viewsphere":
                                    $rootScope.goto('app.sphere',{id:splited[2]});
                                    break;
                            default:break;
                        }
                    }
                    if(splited[0] == 'viewlink'){
                        var a = checktarget[i];
                        var b = a.replace("viewlink_","");
                        window.open(b, '_system', 'location=yes');
                    }
                }

            }
        }
        function mysphereDelete(){
            var msg  = "Are you sure you want to delete this Sphere?";
            var status = "e";     
            var title = "Delete this Sphere";   
            $rootScope.popUp(msg, status, title,  function(e){
                console.log("Delete");
                API.deleteSphere({
                    'unique_id' : $scope.sphere.sphere_id
                    },function(data){
                        if(data.Result == 1){
                            setTimeout(function(){
                                $rootScope.$broadcast('getMySphereEvents');
                            },250);
                            $rootScope.goback();
                        }else{
                            $rootScope.popAlert(
                                'Failed to delete sphere', 
                                'OK',
                                function() {
                            });
                        }   
                    },function(err){
                        $rootScope.popAlert(
                            'Failed to delete sphere', 
                            'OK',
                            function() {
                        });
                })
            });
        }
        function mysphereLeave(){
            var msg  = "Are you sure you want to leave this Sphere?";
            var status = "e";
            var title = "Leave this Sphere";
            $rootScope.popUp(msg, status, title,  function(e){
                console.log("Leave");
            })
        }
        $scope.deleteQuip = function(unique_id){
            document.getElementById("sphere-quip-"+unique_id).remove();
            var sphere_arr = [];
            for(var i = 0; i < $scope.newsfeed_spheres.length; i++){
                if($scope.newsfeed_spheres[i].unique_id == unique_id){

                }else{
                    sphere_arr.push($scope.newsfeed_spheres[i]);
                }
            }
            $scope.newsfeed_spheres = sphere_arr;
            API.deleteQuip({
                unique_id : unique_id
                },function(data){
                    console.log(data)
                },function(err){

            });
            $scope.spherePopover.hide();
        }
        $scope.quipHeard = function(uniqid){
            API.sphereQuipPlayed({
                uniqid : uniqid
                },function(data){
                    console.log(data);
                },function(err){
            });
        }
        $scope.sphereScrollToTop = function(){
            document.querySelector("#show_sphere_new_quips").style.display="none";
            $ionicScrollDelegate.$getByHandle('sphereScroll').scrollTop(true);
            $scope.getLatestSphereThreads();
        }
        $scope.sphereScrollPosition = function(){
            var ssp = $ionicScrollDelegate.$getByHandle('sphereScroll').getScrollPosition().top;
            // if(ssp <= 0){
            //     document.querySelector("#show_sphere_new_quips").style.display="none";
            //     //$scope.getLatestSphereThreads();
            // }else{
            //     if(newsfeed_spheres_temp.length != 0){
            //         document.querySelector("#show_sphere_new_quips").style.display="block";
            //         document.querySelector("#show_sphere_new_quips").classList.remove("animate-slide-down");
            //         document.querySelector("#show_sphere_new_quips").classList.add("animate-slide-down");
            //     }
            // }
        }
        $scope.pressSphereAction = function(action){
            console.log(action);
            if(action == "DELETE"){
                mysphereDelete();
            }else{
                mysphereLeave();
            }
        }
        $scope.followSphere = function(){
            $scope.currentsphere.followers = parseInt($scope.currentsphere.followers) + 1;
            API.sphereFollowSphere({
                unique_id : $scope.sphere.sphere_id
                },function(data){
                    $scope.getLatestSphereThreads();
                },function(err){});
            $scope.currentsphere.member_type = 'FOLLOWER';
        }
        $scope.unfollowSphere = function(){
            $scope.currentsphere.followers = parseInt($scope.currentsphere.followers) - 1;
            API.sphereUnfollowSphere({
                unique_id : $scope.sphere.sphere_id
                },function(data){},function(err){});
            $scope.currentsphere.member_type = '';
            $scope.newsfeed_spheres = [];
        }
        $scope.leaveSphere = function(){
            API.sphereUnfollowSphere({
                unique_id : $scope.sphere.sphere_id
                },function(data){
                    $rootScope.goback();
                },function(err){
                    $rootScope.goback();
            });
            $scope.newsfeed_spheres = [];
        }

        function clearArray(r1, r2){
            console.log(r1);
            var temp_array = [];
            for(var i = 0; i < r1.length; i++){
                var not_duplicated = true;
                for(var o = 0; o < r2.length; o++){
                    if(i != o){
                        if(r1[i].unique_id == r2[o].unique_id){
                            console.log(r1[i].unique_id +"=="+ r2[o].unique_id);
                            not_duplicated = false;
                        }
                    }
                }
                if(not_duplicated){
                    temp_array.push(r1[i]);
                }
            }
            return temp_array;
        }
        $scope.getSphereThreads = function(){
            if($scope.sending_flag){
                $scope.sending_flag = false;
                API.getSphereQuipsThread({
                    limit:10,
                    unique_id : $stateParams.id
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            data.Data = clearArray(data.Data, data.Data);
                            window.localStorage['newsfeed_sphere'] = JSON.stringify(data.Data);
                            $scope.newsfeed_spheres = JSON.parse(window.localStorage['newsfeed_sphere']);
                            $scope.stoploadingsphere = false;
                        }else{
                        }
                        $scope.active_autofetch = true;
                        $scope.sending_flag = true;
                    },function(err){
                        $scope.active_autofetch = true;
                        $scope.sending_flag = true;
                });
            }
        }
        $scope.selectsphere = function(){
            console.log($stateParams.id);
            $rootScope.reRoute('go','app.sphereaddcollection', 0, {id:$stateParams.id,collectionid:splited[2], handler:$rootScope.routeParams.handler});
            $rootScope.goto('app.sphereaddcollection',{id:$stateParams.id});
        }
        $scope.getLatestSphereThreads =function(){
            console.log("getLatestSphereThreads");
            if($scope.newsfeed_spheres.length != 0){
                if($scope.sending_flag){
                    $scope.sending_flag = false;
                    API.getSphereQuipsThread({
                        unique_id : $stateParams.id,
                        limit:10,
                        action:'pull',
                        end: $scope.newsfeed_spheres[0].uniqid
                        },function(data){
                            console.log(data);
                            if(data.Result == 1){
                                if(data.Data.length != 0){
                                    data.Data = clearArray(data.Data, $scope.newsfeed_spheres);
                                    window.localStorage['newsfeed_sphere'] = JSON.stringify(data.Data.concat($scope.newsfeed_spheres));
                                    $scope.newsfeed_spheres = JSON.parse(window.localStorage['newsfeed_sphere']);
                                }
                            }
                            $scope.sending_flag = true;
                        },function(err){
                            $scope.sending_flag = true;
                    });
                }
            }else{
                $scope.getSphereThreads();
            }
        }
        $scope.loadmoreSphere = function(){
            if($scope.stoploadingsphere === false){
                $scope.stoploadingsphere = true;
                if($scope.newsfeed_spheres.length){
                    document.getElementById("sphere-loading").style.display = "block";
                    var endnfid = $scope.newsfeed_spheres[$scope.newsfeed_spheres.length - 1].uniqid;
                    console.log(endnfid);
                    console.log($scope.newsfeed_spheres);
                    API.getSphereQuipsThread({
                        unique_id : $stateParams.id,
                        quipper_id:$rootScope.user_data.quipper_id, 
                        action: "showmore", 
                        end: endnfid
                    }, function(data){
                        if(data.Data.length > 0){
                            data.Data = clearArray(data.Data, $scope.newsfeed_spheres);
                            for(i = 0; i < data.Data.length; i++){
                                $scope.newsfeed_spheres.push(data.Data[i]);
                                $scope.stoploadingsphere = false;
                            }
                        }else{
                            
                        }
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        document.getElementById("sphere-loading").style.display = "none"
                        
                    }, function(err){
                        $scope.stoploadingsphere = false;
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        document.getElementById("sphere-loading").style.display = "none"
                    });

                    var loadinginficon = document.getElementsByClassName("loading-inf");
                    loadinginficon[0].innerHTML = '<div class="ptrloading" style="display:block"><span id="l1"></span><span id="l2"></span><span id="l3"></span></div>';
                }else{
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    document.getElementById("sphere-loading").style.display = "none"
                }
            }
        }
        function getSphereData(){
            return new Promise( function( resolve, reject ) {
                if (true) {
                    resolve();
                    $scope.getLatestSphereThreads();
                } else {
                    reject();
                }
            } );
        }
        $scope.showPopup3 = function(ontap_callback) {
          $scope.data = {}
        
          // Custom popup
          var myPopup = $ionicPopup.show({
             template: '<input type = "number" ng-model = "data.model" style="text-align:center; background-color:#eee;">',
             title: 'Enter Passcode',
             subTitle: '',
             scope: $scope,
                
             buttons: [
                { text: 'Cancel' }, {
                   text: '<b>Enter</b>',
                   type: 'button-positive',
                      onTap: function(e) {
                            
                         if (!$scope.data.model) {
                            //don't allow the user to close unless he enters model...
                               e.preventDefault();
                         } else {
                            return $scope.data.model;
                         }
                      }
                }
             ]
          });

          return myPopup;
        };

        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){ 
            if(toState.name == 'app.sphere'){
                $scope.sphere_rating = 5;
                $scope.sphere = {};
                $scope.sphere.sphere_id = $stateParams.id;
                $scope.newsfeed_spheres = [];
                document.querySelector("#sp-ptr").style.display = "block";
                document.querySelector("#sp-ptr .ptrloading").style.display = "block";
                document.querySelector("#sp-content").style.display = "none";
                //get sphere
                API.getSphere({
                    unique_id : $stateParams.id
                    },function(data){
                        SpherePullToRefresh.init({
                            contentEl:"sp-content",
                            ptrEl:"sp-ptr",
                            limittrigger:'sp-container',
                            bodyId:'sp-bodycontainer',
                            loadingFunction: getSphereData
                        });
                        document.querySelector("#sp-content").style.display = "block"; 
                        if(data.Result == 1){
                            $scope.currentsphere =  data.Data;
                            $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                            $rootScope.routeParams.id = $stateParams.id;
                            $rootScope.routeParams.handler = $scope.currentsphere.handle;
                            $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            if(data.Data.member_type=='OWNER'){
                                $rootScope.canQuip = true;
                                // .fromTemplateUrl() method
                                $ionicPopover.fromTemplateUrl('sphere-popover-owner.html', {
                                    scope: $scope
                                }).then(function(popover) {
                                    $scope.spherepopover = popover;
                                });
                            }else if(data.Data.member_type=='MEMBER'){
                                $rootScope.canQuip = true;
                                $ionicPopover.fromTemplateUrl('sphere-popover-member.html', {
                                    scope: $scope
                                }).then(function(popover) {
                                    $scope.spherepopover = popover;
                                });
                            }else{
                                $rootScope.canQuip = false;
                                if(window.localStorage['sphere_'+$stateParams.id] == $scope.currentsphere.passcode){
                                    $rootScope.canQuip = true;
                                }
                                $ionicPopover.fromTemplateUrl('sphere-popover-follower.html', {
                                    scope: $scope
                                }).then(function(popover) {
                                    $scope.spherepopover = popover;
                                });
                                $scope.$on('checkCanQuip', function(){
                                    if(data.Data.member_type=='FOLLOWER'){
                                        if($scope.currentsphere.everyone_may_quip=='N'){
                                            var status = "e";
                                            var ontap_callback = function(e){
                                                // console.log(e);
                                            }
                                            var title = 'Cannot Quip';
                                            var btn_text = 'Okay';
                                            var msg = 'You cannot quip because you\'re just a follower'; 
                                            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                                        }else{
                                            if($scope.currentsphere.passcode != ""){
                                                $scope.showPopup3().then(function(res) {
                                                    console.log('Tapped!', res);
                                                    if(res != undefined){
                                                        if($scope.currentsphere.passcode == res){
                                                            window.localStorage['sphere_'+$stateParams.id] = res;
                                                            $rootScope.canQuip = true;
                                                            var status = "e";
                                                            var ontap_callback = function(e){
                                                                // console.log(e);
                                                                // setTimeout(function(){
                                                                //     $rootScope.reRoute('go','recorder');
                                                                //     $rootScope.openRecorderModal();
                                                                // },250)
                                                            }
                                                            var title = 'Passcode Valid!';
                                                            var btn_text = 'Okay';
                                                            var msg = 'You may now post quips to this sphere!'; 
                                                            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                                                        }else{
                                                            var status = "e";
                                                            var ontap_callback = function(e){
                                                                // console.log(e);
                                                            }
                                                            var title = 'Invalid Passcode';
                                                            var btn_text = 'Okay';
                                                            var msg = 'You have entered an invalid passcode'; 
                                                            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                                                        }
                                                    }
                                                });   
                                            }else{
                                                $rootScope.canQuip = true;
                                            }
                                        }
                                    }else{
                                        var status = "e";
                                        var ontap_callback = function(e){
                                            // console.log(e);
                                        }
                                        var title = 'Cannot Quip';
                                        var btn_text = 'Okay';
                                        var msg = 'You cannot quip because you\'re just a visitor'; 
                                        $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                                    }
                                })

                                // window.localStorage['cur_sphere_id'] = $stateParams.id;
                                // if($scope.currentsphere.everyone_may_quip=='Y'){
                                //     window.localStorage['sphere_'+$stateParams.id] = $scope.currentsphere.passcode;
                                // }
                            }
                            $scope.getSphereThreads();
                            API.sphereCollectionSlide({
                                limit : 5,
                                sphere_unique_id : $stateParams.id
                                },function(data){
                                    if(data.Result == 1){
                                        $scope.sphere_collection_array = data.Data;
                                        $ionicSlideBoxDelegate.$getByHandle('sphere-slider-collection-handle').update();
                                    }
                                },function(err){
                            });
                        }else{
                            $rootScope.goback();
                        }
                    },function(err){
                        $rootScope.goback();
                });

                $scope.openSpherePopover = function($event) {
                    $scope.spherepopover.show($event);
                };
                $scope.closeSpherePopover = function() {
                    console.log('close')
                    $scope.spherepopover.hide();
                };
                //Cleanup the popover when we're done with it!
                $scope.$on('$destroy', function() {
                    $scope.spherepopover.remove();
                });
                // Execute action on hide popover
                $scope.$on('spherepopover.hidden', function() {
                    // Execute action
                });
                // Execute action on remove popover
                $scope.$on('spherepopover.removed', function() {
                    // Execute action
                });
            }
        });
})
.controller('SphereaddcollectionCtrl', function($rootScope, $ionicLoading, $scope, $state, 
    $ionicModal, $timeout, $stateParams,
    $ionicPopover,API) { //ADD to kolek


        //console.log($stateParams.id);

        var sphereAddCollectionElement = document.querySelector("#sphere-add-collection");
        $scope.$on('$ionicView.beforeEnter', function() {
            sphereAddCollectionElement.addEventListener("click", sphereAddCollectionEvent, false);
        }); 

        $scope.$on('$ionicView.beforeLeave', function() {
            sphereAddCollectionElement.removeEventListener("click", sphereAddCollectionEvent, false);
        });

        $scope.$on('$ionicView.afterLeave', function() {
            $rootScope.canQuip = true;
        });


        $scope.currentsphere = {};
        $scope.newsfeed_spheres = [];
        $scope.sphere_collection_array = [];
        $scope.show_new_count = false;
        $scope.new_count = '';
        $scope.current_playing = '';
        var newsfeed_spheres_temp = [];
        $scope.sphere_last_played_id = "";
        var playedicon = 'img/newsfeed/quip_play_icon_1.png';
        var pausedicon = 'img/newsfeed/quip_pause_icon_1.png';
        var loadingicon = 'img/quip_loading_icon.gif';
        $rootScope.mediaPausedFlag = 0;
        $rootScope.currentMediaId = '';
        var mediaLoadedFlag = 0;
        var template = 
        '<ion-popover-view class="sphere-delete-quip" style="width:100px; text-align: center;">'+
        '<div>'+
        '<div class="profile-popover-li" on-tap="" >'+
        '<span>Delete</span><br>'+
        '</div>'+
        '</div>'+
        '</ion-popover-view>';
        var media = null;
        $scope.collection_list = [];
        function sphereAddCollectionEvent(e){
            if (e.target !== e.currentTarget) {
                var checktarget = e.target.classList;
                for(var i = 0; i < checktarget.length; i++){
                    splited = checktarget[i].split("_");
                    console.log(splited);
                    if(splited[0] == "sphere"){
                        switch(splited[1]){

                            case "sharequip":
                                var uid = splited[3];
                                console.log(uid);
                                window.plugins.socialsharing.share('Listen to this!', "Listen to this!", null, 'http://quipsphere.com/quip/quipshare.php?quipid=' + uid);
                                break;
                            case "viewoptions":
                                var template = 
                                '<ion-popover-view class="sphere-delete-quip" style="width:100px; text-align: center;">'+
                                '<div>'+
                                '<div class="profile-popover-li" on-tap="deleteQuip(\''+splited[2]+'\')" >'+
                                '<span>Delete</span><br>'+
                                '</div>'+
                                '</div>'+
                                '</ion-popover-view>';

                                $scope.spherePopover = $ionicPopover.fromTemplate(template, {
                                    scope: $scope
                                });
                                $scope.spherePopover.show(e);
                            break;
                            case "imgslider":
                                var imgs = $scope.newsfeed_spheres[splited[2]].quip_images;
                                $rootScope.showImages(imgs);
                            break;
                            case "viewquipper":
                                //console.log(splited[2]);
                                $rootScope.reRoute('go','view profile', 0, {id:splited[2], handler:$scope.currentsphere.handle});
                                $rootScope.goto('app.view-profile',{id:splited[2]});
                            break;
                            case "viewcollection":
                                //console.log(splited[2]);
                                $rootScope.reRoute('go','app.collectionitems', 0, {id:$stateParams.id,collectionid:splited[2], handler:$rootScope.routeParams.handler});
                                $rootScope.goto('app.collectionitems',{id:$stateParams.id,collectionid:splited[2]});
                            break;
                            case "quipmedia":
                                //stop autoplay
                                if($scope.current_playing != ''){
                                    $scope.current_playing.src = playedicon;
                                }

                                for(var i = 0; i < $scope.newsfeed_spheres.length; i++){
                                    if($scope.newsfeed_spheres[i].unique_id == splited[2]){
                                        var quip_media_class = 'auto_play_'+splited[2];
                                        var elems = document.querySelectorAll("."+quip_media_class);
                                        $scope.current_playing = '';

                                        if($scope.newsfeed_spheres[i].is_played == 0){
                                            $scope.quipHeard($scope.newsfeed_spheres[i].uniqid);
                                        }
                                        $scope.newsfeed_spheres[i].is_played = 1;
                                        for(var i = 0; i < elems.length; i++){
                                            e.target = elems[i];
                                        }
                                        if($rootScope.currentMediaId == splited[2]){
                                            if($rootScope.mediaPausedFlag == 0){
                                                e.target.src = playedicon;
                                                $rootScope.media.pause();
                                            }else{
                                                e.target.src = pausedicon;
                                                $rootScope.media.play();
                                            }
                                        }else{
                                            e.target.src = loadingicon;
                                            e.target.classList.remove('play_0');
                                            e.target.classList.add('play_1');
                                            $rootScope.currentMediaId = splited[2];
                                            $rootScope.media = document.getElementById('quip_audio_src');
                                            $rootScope.media.pause();
                                            $rootScope.media.src = e.target.name;
                                            $rootScope.media.load();
                                            $rootScope.quipPlayerItem = e.target;
                                            $rootScope.sphereQuipUniqueId = splited[2];
                                            $scope.sphere_last_played_id = splited[2];
                                            $scope.current_playing = e.target;
                                        }
                                        return;
                                    }
                                }
                            break;
                            case "thread":
                                $rootScope.reRoute('go','app.sphere-reply', 0, $rootScope.routeParams);
                                $rootScope.selectedtopics.handler = $scope.currentsphere.handle + " " +splited[4];
                                $rootScope.threadParentUniqueId = splited[2];
                                $rootScope.postBackRoute = 'app.sphere-reply';
                                $rootScope.routeParams.id = splited[3];
                                $rootScope.routeParams.handler = $scope.currentsphere.handle;
                                $rootScope.routeParams.quipper_handler = splited[4];
                                $rootScope.goto('app.sphere-reply',{sphere_id:$rootScope.routeParams.id, quip_id:splited[2]});
                            break;
                            case "replythread":
                                if($scope.currentsphere.enable_reply != 1){
                                    var status = "e";
                                    var ontap_callback = function(e){
                                        // console.log(e);
                                    }
                                    var title = 'Cannot Reply';
                                    var btn_text = 'Okay';
                                    var msg = 'Reply Option is disabled'; 
                                    $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                                    return;
                                }
                                if($rootScope.canQuip == false){
                                    $rootScope.CannotQuip();
                                }else{
                                    $rootScope.reRoute('go','recorder');
                                    $rootScope.selectedtopics.handler = $scope.currentsphere.handle + " " +splited[4];
                                    $rootScope.threadParentUniqueId = splited[2];
                                    $rootScope.postBackRoute = 'app.sphere-reply';
                                    $rootScope.routeParams.id = splited[3];
                                    $rootScope.routeParams.handler = $scope.currentsphere.handle;
                                    $rootScope.routeParams.quipper_handler = splited[4];
                                    $rootScope.openRecorderModal();
                                }
                            break;
                            default:
                            break;
                        }
                    }
                }

            }
        }
        function isInArray(value, array) {
            return array.indexOf(value) > -1;
        }
        var quipids_array = [];

        $scope.quipHeard = function(uniqid){
            API.sphereQuipPlayed({
                uniqid : uniqid
                },function(data){
                    console.log(data);
                },function(err){
            });
        }
        $scope.addCollection = function(collectionid){ 

            if( document.getElementById(collectionid).style.opacity == 1){
                document.getElementById(collectionid).style.opacity = 0;

                var selected_flag = isInArray(collectionid,quipids_array); 

                if(selected_flag === true){ // existing

                    // Find and remove item from an array
                    var i = quipids_array.indexOf(collectionid);
                    if(i != -1) {
                        quipids_array.splice(i, 1);
                    }
                    console.log(quipids_array);
                }

            }else{
                document.getElementById(collectionid).style.opacity = 1;

                var selected_flag = isInArray(collectionid,quipids_array); 

                if(selected_flag === false){ // add if not existing
                    quipids_array.push(collectionid);
                }

                console.log(quipids_array);
            }

        }

        $scope.getSphereThreads = function(){
            API.getSphereQuipsThread({
                unique_id : $stateParams.id
                },function(data){
                    console.log(data);
                    if(data.Result == 1){
                        $scope.newsfeed_spheres = data.Data;
                        //window.localStorage['newsfeed_sphere'] = JSON.stringify(data.Data);
                        //$scope.newsfeed_spheres = JSON.parse(window.localStorage['newsfeed_sphere']);
                    }else{
                    }
                },function(err){
            });
        }

        $scope.AddinSectedColl = function(colid){
            $scope.colid = colid;

            if($scope.quipids == ""){
                create_failed("Please select Quip");
            }else{
                var data = {
                    quipids_array: quipids_array.join("|"),
                    unique_id:$stateParams.id,
                    collectionid:colid
                };
                //console.log(data);
                API.AddinCollection(data, cb_success, cb_error);
                console.log(data);
            }
        }
        function cb_success(data){
            if(data.Result == 1 ){
                //success
                create_success(data.Message[0]);
            }else{
                //error
                var msg = data.Message.join("<br/>");
                console.log(data.Message)
                create_failed(msg);
            }
            // console.log(data);
        }
        function cb_error(data){
            
            // console.log("cb_error");
            // console.log(data);
            create_failed("Something went wrong please try again");
        }

        function create_failed(msg){
            var status = "e";
            var ontap_callback = function(e){
                // console.log(e);
            }
            title = 'Add Quip in Collection';
            btn_text = 'Try again';
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }

        function create_success(msg){
            var status = "s";
            var ontap_callback = function(e){
                //console.log(e);

                $rootScope.reRoute('go','app.collectionitems', 0, {id:$stateParams.id,collectionid:$scope.colid, handler:$rootScope.routeParams.handler});
                $rootScope.goto('app.collectionitems',{id:$stateParams.id,collectionid:$scope.colid});
            }
            title = 'Add Quip in Collection';
            btn_text = 'OK';
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }

        var template = '<ion-popover-view class="collectionpopover"></ion-popover-view>';

        $scope.collectionpopover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });
        $scope.noCollection = function () {
            var status = "e";
            var ontap_callback = function(e){
                // console.log(e);
            }
            var title = 'No Collection';
            var btn_text = 'OK';
            var msg = 'You have no collection'; 
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }
        //get Collectionlist
        $scope.getListofCollections = function(){ 
            API.getCollections({
                creatorquipperid:$rootScope.user_data.quipper_id,
                sphere_unid:$stateParams.id,
                },function(data){
                    console.log(data);
                    if(data.Result == 1){
                        var template = '<ion-popover-view class="collectionpopover">'+
                        '<div>';
                        for(var i = 0; i < data.Data.length; i++){
                            template = template + '<div class="collection-popover-li" on-tap="AddinSectedColl(\''+data.Data[i].collectionid+'\'); closeCollectionlistPopover()" >'+
                            '<span class="collectiontitle">'+data.Data[i].title+'</span><br>'+
                            '</div>';
                        }
                        template = template + '</div>'+
                        '</ion-popover-view>';
                        $scope.collection_list = data.Data;
                        $scope.collectionpopover = $ionicPopover.fromTemplate(template, {
                            scope: $scope
                        });

                    }
                },function(err){
            });
        }

        //$scope.getListofCollections();
        //$scope.getSphereThreads();


        $scope.showPopup3 = function(ontap_callback) {
          $scope.data = {}
        
          // Custom popup
          var myPopup = $ionicPopup.show({
             template: '<input type = "number" ng-model = "data.model" style="text-align:center; background-color:#eee;">',
             title: 'Enter Passcode',
             subTitle: '',
             scope: $scope,
                
             buttons: [
                { text: 'Cancel' }, {
                   text: '<b>Enter</b>',
                   type: 'button-positive',
                      onTap: function(e) {
                            
                         if (!$scope.data.model) {
                            //don't allow the user to close unless he enters model...
                               e.preventDefault();
                         } else {
                            return $scope.data.model;
                         }
                      }
                }
             ]
          });

          return myPopup;
        };
        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){
            if(toState.name == 'app.sphereaddcollection'){
                //get sphere
                API.getSphere({
                    unique_id : $stateParams.id
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            $scope.currentsphere =  data.Data;
                            $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                            $rootScope.routeParams.id = $stateParams.id;
                            $rootScope.routeParams.handler = $scope.currentsphere.handle;
                            $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            if(data.Data.member_type=='OWNER'){
                                // .fromTemplateUrl() method
                                $ionicPopover.fromTemplateUrl('sphere-popover-owner.html', {
                                    scope: $scope
                                }).then(function(popover) {
                                    $scope.spherepopover = popover;
                                });
                            }else if(data.Data.member_type=='MEMBER'){
                                $ionicPopover.fromTemplateUrl('sphere-popover-member.html', {
                                    scope: $scope
                                }).then(function(popover) {
                                    $scope.spherepopover = popover;
                                });
                            }else{

                                $rootScope.canQuip = false;
                                if(window.localStorage['sphere_'+$stateParams.id] == $scope.currentsphere.passcode){
                                    $rootScope.canQuip = true;
                                }
                                $ionicPopover.fromTemplateUrl('sphere-popover-follower.html', {
                                    scope: $scope
                                }).then(function(popover) {
                                    $scope.spherepopover = popover;
                                });
                                $scope.$on('checkCanQuip', function(){
                                    if(data.Data.member_type=='FOLLOWER'){
                                        if($scope.currentsphere.everyone_may_quip=='N'){
                                            var status = "e";
                                            var ontap_callback = function(e){
                                                // console.log(e);
                                            }
                                            var title = 'Cannot Quip';
                                            var btn_text = 'Okay';
                                            var msg = 'You cannot quip because you\'re just a follower'; 
                                            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                                        }else{
                                            if($scope.currentsphere.passcode != ""){
                                                $scope.showPopup3().then(function(res) {
                                                    console.log('Tapped!', res);
                                                    if(res != undefined){
                                                        if($scope.currentsphere.passcode == res){
                                                            window.localStorage['sphere_'+$stateParams.id] = res;
                                                            $rootScope.canQuip = true;
                                                            var status = "e";
                                                            var ontap_callback = function(e){
                                                                // console.log(e);
                                                                // setTimeout(function(){
                                                                //     $rootScope.reRoute('go','recorder');
                                                                //     $rootScope.openRecorderModal();
                                                                // },250)
                                                            }
                                                            var title = 'Passcode Valid!';
                                                            var btn_text = 'Okay';
                                                            var msg = 'You may now post quips to this sphere!'; 
                                                            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                                                        }else{
                                                            var status = "e";
                                                            var ontap_callback = function(e){
                                                                // console.log(e);
                                                            }
                                                            var title = 'Invalid Passcode';
                                                            var btn_text = 'Okay';
                                                            var msg = 'You have entered an invalid passcode'; 
                                                            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                                                        }
                                                    }
                                                });   
                                            }else{
                                                $rootScope.canQuip = true;
                                            }
                                        }
                                    }else{
                                        var status = "e";
                                        var ontap_callback = function(e){
                                            // console.log(e);
                                        }
                                        var title = 'Cannot Quip';
                                        var btn_text = 'Okay';
                                        var msg = 'You cannot quip because you\'re just a visitor'; 
                                        $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                                    }
                                })

                                // window.localStorage['cur_sphere_id'] = $stateParams.id;
                                // if($scope.currentsphere.everyone_may_quip=='Y'){
                                //     window.localStorage['sphere_'+$stateParams.id] = $scope.currentsphere.passcode;
                                // }
                            }
                        }
                    },function(err){
                });

                $scope.getListofCollections();
                $scope.getSphereThreads();
                $scope.openCollectionlistPopover = function($event) {
                    $scope.collectionpopover.show($event);
                };

                $scope.closeCollectionlistPopover = function($event) {
                    $scope.collectionpopover.hide($event);
                };

                // Execute action on hide popover
                $scope.$on('collectionpopover.hidden', function() {
                    // Execute action
                });
                // Execute action on remove popover
                $scope.$on('collectionpopover.removed', function() {
                    // Execute action
                });

            }
        });
})
.controller('SpherecollectionCtrl', function($rootScope, $scope, $state, $timeout, $stateParams,
    $ionicPopover,API,$ionicLoading) {
        //console.log($rootScope.user_data.quipper_id);

        $scope.createcollection = function(){
            console.log($rootScope.routeParams.handler);
            $rootScope.reRoute('go','app.sphereaddcollection', 0, {id:$stateParams.id,handler:$rootScope.routeParams.handler});
            $rootScope.goto('app.createcollections',{id:$stateParams.id});
        }
        $scope.previouspage = function(){
            $rootScope.goback();
        }

        var parentelement = document.getElementById('sphere-collection-parent');
        $scope.$on('$ionicView.beforeEnter', function() {
            parentelement.addEventListener('click', collectionEvent, false);
        }); 

        $scope.$on('$ionicView.beforeLeave', function() {
            var parentelement = document.getElementById('sphere-collection-parent');
            parentelement.removeEventListener('click', collectionEvent, false);
        });

        $scope.$on('$ionicView.afterLeave', function() {
            $rootScope.canQuip = true;
        });

        function collectionEvent(e) {

            if (e.target !== e.currentTarget) {
                var checktarget = e.target.className;
                console.log(checktarget);
                splited = checktarget.split("_");
                if(splited[0]=='collections'){
                    switch(splited[1]){
                        case "viewcollection":
                            $rootScope.reRoute('go','app.collectionitems', 0, {id:$stateParams.id,collectionid:splited[2], handler:$rootScope.routeParams.handler});
                            $rootScope.goto('app.collectionitems',{id:$stateParams.id,collectionid:splited[2]});
                            break;
                        default:break;
                    }
                }
            }
            e.stopPropagation();
        } 

        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){

            if(toState.name == 'app.spherecollections'){
                API.getSphere({
                    unique_id : $stateParams.id
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            $scope.currentsphere =  data.Data;
                            $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                            $rootScope.routeParams.id = $stateParams.id;
                            $rootScope.routeParams.handler = $scope.currentsphere.handle;
                            $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            if(data.Data.member_type=='OWNER'){
                            }else if(data.Data.member_type=='MEMBER'){
                            }else{
                                $rootScope.canQuip = false;
                            }
                        }
                        
                    },function(err){
                        
                });


                API.getCollections({
                    creatorquipperid:$rootScope.user_data.quipper_id,
                    sphere_unid:$stateParams.id
                    }, function(data){
                        
                        console.log(data);
                        if(data.Result == 1){
                            $scope.collectionlist = data.Data;
                        }      
                    }, function(err){
                    
                });

            }

        });
})
.controller('CollectionitemsCtrl', function($rootScope,  $ionicLoading, $scope, $state, $timeout,$stateParams,
    $ionicPopover,API) { //aytems


        var sphereCollectionItemsElement = document.querySelector("#sphere-collection-items");
        $scope.$on('$ionicView.beforeEnter', function() {
            sphereCollectionItemsElement.addEventListener("click", sphereCollectionItemsEvent, false);
        }); 

        $scope.$on('$ionicView.beforeLeave', function() {
            sphereCollectionItemsElement.removeEventListener("click", sphereCollectionItemsEvent, false);
        });

        $scope.$on('$ionicView.afterLeave', function() {
            $rootScope.canQuip = true;
        });

        var playedicon = 'img/newsfeed/quip_play_icon_1.png';
        var pausedicon = 'img/newsfeed/quip_pause_icon_1.png';
        var loadingicon = 'img/quip_loading_icon.gif';
        var media = null;
        $rootScope.mediaPausedFlag = 0;
        $rootScope.currentMediaId = '';
        var mediaLoadedFlag = 0;
        $scope.current_playing = '';
        function sphereCollectionItemsEvent(e){
            if (e.target !== e.currentTarget) {
                var checktarget = e.target.classList;
                for(var i = 0; i < checktarget.length; i++){
                    splited = checktarget[i].split("_");
                    console.log(splited);
                    if(splited[0] == "sphere"){
                        switch(splited[1]){

                            case "sharequip":
                                var uid = splited[3];
                                console.log(uid);
                                window.plugins.socialsharing.share('Listen to this!', "Listen to this!", null, 'http://quipsphere.com/quip/quipshare.php?quipid=' + uid);
                                break;
                            case "viewoptions":
                                var template = 
                                '<ion-popover-view class="sphere-delete-quip" style="width:100px; text-align: center;">'+
                                '<div>'+
                                '<div class="profile-popover-li" on-tap="deleteQuip(\''+splited[2]+'\')" >'+
                                '<span>Delete</span><br>'+
                                '</div>'+
                                '</div>'+
                                '</ion-popover-view>';

                                $scope.spherePopover = $ionicPopover.fromTemplate(template, {
                                    scope: $scope
                                });
                                $scope.spherePopover.show(e);
                            break;
                            case "imgslider":
                                var imgs = $scope.quipsincollection[splited[2]].quip_images;
                                $rootScope.showImages(imgs);
                            break;
                            case "viewquipper":
                                //console.log(splited[2]);
                                $rootScope.reRoute('go','view profile', 0, {id:splited[2], handler:$scope.currentsphere.handle});
                                $rootScope.goto('app.view-profile',{id:splited[2]});
                            break;
                            case "viewcollection":
                                //console.log(splited[2]);
                                $rootScope.reRoute('go','app.collectionitems', 0, {id:$stateParams.id,collectionid:splited[2], handler:$rootScope.routeParams.handler});
                                $rootScope.goto('app.collectionitems',{id:$stateParams.id,collectionid:splited[2]});
                            break;
                            case "quipmedia":
                                //stop autoplay
                                if($scope.current_playing != ''){
                                    $scope.current_playing.src = playedicon;
                                }

                                for(var i = 0; i < $scope.quipsincollection.length; i++){
                                    if($scope.quipsincollection[i].unique_id == splited[2]){
                                        var quip_media_class = 'auto_play_'+splited[2];
                                        var elems = document.querySelectorAll("."+quip_media_class);
                                        $scope.current_playing = '';

                                        if($scope.quipsincollection[i].is_played == 0){
                                            $scope.quipHeard($scope.quipsincollection[i].uniqid);
                                        }
                                        $scope.quipsincollection[i].is_played = 1;
                                        for(var i = 0; i < elems.length; i++){
                                            e.target = elems[i];
                                        }
                                        if($rootScope.currentMediaId == splited[2]){
                                            if($rootScope.mediaPausedFlag == 0){
                                                e.target.src = playedicon;
                                                $rootScope.media.pause();
                                            }else{
                                                e.target.src = pausedicon;
                                                $rootScope.media.play();
                                            }
                                        }else{
                                            e.target.src = loadingicon;
                                            e.target.classList.remove('play_0');
                                            e.target.classList.add('play_1');
                                            $rootScope.currentMediaId = splited[2];
                                            $rootScope.media = document.getElementById('quip_audio_src');
                                            $rootScope.media.pause();
                                            $rootScope.media.src = e.target.name;
                                            $rootScope.media.load();
                                            $rootScope.quipPlayerItem = e.target;
                                            $rootScope.sphereQuipUniqueId = splited[2];
                                            $scope.sphere_last_played_id = splited[2];
                                            $scope.current_playing = e.target;
                                        }
                                        return;
                                    }
                                }
                            break;
                            case "thread":
                                $rootScope.reRoute('go','app.sphere-reply', 0, $rootScope.routeParams);
                                $rootScope.selectedtopics.handler = $scope.currentsphere.handle + " " +splited[4];
                                $rootScope.threadParentUniqueId = splited[2];
                                $rootScope.postBackRoute = 'app.sphere-reply';
                                $rootScope.routeParams.id = splited[3];
                                $rootScope.routeParams.handler = $scope.currentsphere.handle;
                                $rootScope.routeParams.quipper_handler = splited[4];
                                $rootScope.goto('app.sphere-reply',{sphere_id:$rootScope.routeParams.id, quip_id:splited[2]});
                            break;
                            case "replythread":
                                if($scope.currentsphere.enable_reply != 1){
                                    var status = "e";
                                    var ontap_callback = function(e){
                                        // console.log(e);
                                    }
                                    var title = 'Cannot Reply';
                                    var btn_text = 'Okay';
                                    var msg = 'Reply Option is disabled'; 
                                    $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                                    return;
                                }
                                if($rootScope.canQuip == false){
                                    $rootScope.CannotQuip();
                                }else{
                                    $rootScope.reRoute('go','recorder');
                                    $rootScope.selectedtopics.handler = $scope.currentsphere.handle + " " +splited[4];
                                    $rootScope.threadParentUniqueId = splited[2];
                                    $rootScope.postBackRoute = 'app.sphere-reply';
                                    $rootScope.routeParams.id = splited[3];
                                    $rootScope.routeParams.handler = $scope.currentsphere.handle;
                                    $rootScope.routeParams.quipper_handler = splited[4];
                                    $rootScope.openRecorderModal();
                                }
                            break;
                            default:
                            break;
                        }
                    }
                }

            }
        }
        $scope.getCollecton = function(){
            
            API.getCollection({
                collectionid:$stateParams.collectionid,
                }, function(data){
                    
                    console.log(data);
                    if(data.Result == 1){
                        $scope.collection = data.Data;
                    }      
                }, function(err){
                    
            });
        }
        $scope.getQuipsincollections = function(){
            $ionicLoading.show();
            API.getQuipsincollection({
                collectionid:$stateParams.collectionid,
                }, function(data){
                    console.log(data);
                    if(data.Result == 1){
                        $scope.quipsincollection = data.Data;
                    }      
                    $ionicLoading.hide();
                }, function(err){
                    $ionicLoading.hide();
            });
        }
        $scope.deleteSphereCollection = function(){
            //console.log($stateParams.id);

              var collectionid  = $stateParams.collectionid;
              var creator_quipperid  = $rootScope.me_quipperid;
              var unique_id  = $stateParams.id;

            $ionicLoading.show();
             API.deletesphereCollection({
                 collectionid: collectionid,
                creator_quipperid : creator_quipperid
                },function(data){ 
                   $ionicLoading.hide();
                   
                    //$rootScope.reRoute('go','app.spherecollections', 0, {id:$stateParams.id, handler:$rootScope.routeParams.handler});
                   $rootScope.goto('app.spherecollections/'+unique_id);
                },function(err){
                    $ionicLoading.hide();
            })
        }
        $scope.editSphereCollection = function(){
            console.log('editcollection')
            console.log($stateParams);
            $rootScope.reRoute('go','app.editcollection', 0, {id:$stateParams.id,collectionid:$stateParams.collectionid, handler:$rootScope.routeParams.handler});
            $rootScope.goto('app.editcollection',{id:$stateParams.id,collectionid:$stateParams.collectionid});
        }
        $scope.deleteQuipCollectionitem = function(unique_id){
            $ionicLoading.show();
            document.getElementById("sphere-quip-"+unique_id).remove();
            var sphere_arr = [];
            for(var i = 0; i < $scope.quipsincollection.length; i++){
                if($scope.quipsincollection[i].unique_id == unique_id){

                }else{
                    sphere_arr.push($scope.quipsincollection[i]);
                }
            }
            //console.log($stateParams.id);
            $scope.quipsincollection = sphere_arr;
            API.deletequipCollectionitem({
                'collectionid': $stateParams.collectionid,
                'unique_id' : unique_id,                
                },function(data){
                    console.log(data)
                    // $ionicLoading.hide();
                },function(err){
                    //$ionicLoading.hide();


            });
            $scope.spherePopover.hide();
            $scope.collectionitemPopover.hide();
        }

       $ionicPopover.fromTemplateUrl('sphere-collection-popover.html', {
            scope: $scope
        }).then(function(popover) {
            $scope.collectionitemPopover = popover;
        });


        $scope.openCollectionitemPopover = function($event) {
            $scope.collectionitemPopover.show($event);
        };
        $scope.closeCollectionItemPopover = function() {
            //console.log('close')
            $scope.collectionitemPopover.hide();
        };

        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){

            if(toState.name == 'app.collectionitems'){

                $ionicLoading.show();
                API.getSphere({
                    unique_id : $stateParams.id
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            $scope.currentsphere =  data.Data;
                            $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                            $rootScope.routeParams.id = $stateParams.id;
                            $rootScope.routeParams.handler = $scope.currentsphere.handle;
                            $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            if(data.Data.member_type=='OWNER'){
                            }else if(data.Data.member_type=='MEMBER'){
                            }else{
                                $rootScope.canQuip = false;
                            }
                        }
                        $ionicLoading.hide();
                    },function(err){
                        $ionicLoading.hide();
                });
                $scope.getCollecton();
                $scope.getQuipsincollections();

            }
        });
})
.controller('CreatecollectionCtrl', function($scope, $rootScope, $ionicPopover, $stateParams, 
    $timeout, $ionicActionSheet, $ionicHistory, 
    $state, CameraService, API, $ionicLoading, $log, Constant, $cordovaFile, $cordovaFileTransfer, $timeout, $ionicModal,
    $ionicSlideBoxDelegate, $ionicScrollDelegate  ) {

        $scope.collection = {};     
        $scope.collection["b64"] = "img/no-banner.jpg";

        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){
            if(toState.name == 'app.createcollection'){

                $ionicLoading.show();
                API.getSphere({
                    unique_id : $stateParams.id
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            $scope.currentsphere =  data.Data;
                            $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                            $rootScope.routeParams.id = $stateParams.id;
                            $rootScope.routeParams.handler = $scope.currentsphere.handle;
                            $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            if(data.Data.member_type=='OWNER'){
                            }else if(data.Data.member_type=='MEMBER'){
                            }else{
                                $rootScope.canQuip = false;
                            }
                        }
                        $ionicLoading.hide();
                    },function(err){
                        $ionicLoading.hide();
                });
            }
        });


        $scope.saveCollection = function(){ //SAVING *
            //console.log($scope.collection.collection_title);

            var sphereBannerURL = '';
            if ($scope.collection.b64 != '' && $scope.collection.b64 != "img/no-banner.jpg"){
                    //upload file first
                    //sphereBannerURL = Constant.QUIPSHERE_API_HOST+ '/images/public/' + $scope.newQpFile ;
                    sphereBannerURL = Constant.S3URL_PUBLIC_PATH + $scope.newQpFile ;
                    console.log( sphereBannerURL );
                    $scope.sendSphereCollectionBanner($scope.imageLocalPath);
            }  
            if($scope.collection.collection_title === undefined || $scope.collection.collection_title === ""){
                create_failed("Title is required");
            }else if($scope.collection.collection_description === undefined || $scope.collection.collection_description === ""){
                create_failed("Description is required");
            }else{
                $ionicLoading.show();
                var data = {
                    title: $scope.collection.collection_title,
                    description: $scope.collection.collection_description,
                    url_banner:sphereBannerURL,
                    sphere_id:$stateParams.id,
                    creator_quipperid:$rootScope.user_data.quipper_id,
                };
                console.log(data);
                API.createCollection(data, cb_success, cb_error);
            }
        }
        function cb_success(data){
            $ionicLoading.hide();
            if(data.Result == 1 ){
                //success
                create_success(data.Message[0]);
            }else{
                //error
                var msg = data.Message.join("<br/>");
                console.log(data.Message)
                create_failed(msg);
            }
            // console.log(data);
        }
        function cb_error(data){
            $ionicLoading.hide();
            // console.log("cb_error");
            // console.log(data);
            create_failed("Something went wrong please try again");
        }
        function create_failed(msg){
            var status = "e";
            var ontap_callback = function(e){
                // console.log(e);
            }
            title = 'Create Collection';
            btn_text = 'Try again';
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }
        function create_success(msg){
            var status = "s";
            var ontap_callback = function(e){
                // console.log(e);
                $rootScope.goback();
            }
            title = 'Create Collection Success';
            btn_text = 'OK';
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }




        //Upload Logo Image
        $scope.createUploadBanner = function(){
            //$ionicLoading.show();
                
            navigator.camera.getPicture(onSuccessFromGallery, onFailFromGallery, {
                targetWidth: 720,
                targetHeight: 720,
                quality: 72,
                allowEdit: false,
                correctOrientation: true,
                saveToPhotoAlbum: true,
                destinationType: Camera.DestinationType.FILE_URI,
                sourceType: navigator.camera.PictureSourceType.SAVEDPHOTOALBUM
            });
        };

        $scope.newQpFile = ''; $scope.imageLocalPath = '';

        function onSuccessFromGallery(imageData) {
            // format url and filename
            var qp = imageData.split('/').pop(); var qpFile = qp.split('?'); // get the file
            var qpUrlArr = imageData.split('/'); 
            qpUrlArr.splice(-1,1); 
            var qpUrl = qpUrlArr.join('/')+'/'; // get the folder
            var newQpFile = 'sphere_collection_' + $rootScope.user_data.quipper_id + '_' + new Date().getTime()+'.jpg';
            $scope.newQpFile = newQpFile;
            
            // copy the file in quipsphere folder
            $cordovaFile.copyFile(qpUrl, qpFile[0], cordova.file.externalRootDirectory, newQpFile)
                .then(function (success) {
                    // display in form
                    var imageSource = cordova.file.externalRootDirectory + newQpFile;                                      
                    $scope.imageLocalPath =$scope.collection["b64"] = imageSource;


                }, function (error) {
                    console.log('error: '+ error);
                });
        }

        function onFailFromGallery(message) {
           // $ionicLoading.hide();            
        }

        $scope.sendSphereCollectionBanner = function(filePath){
            $timeout(function() {
                 var argsP = new Array();
                    argsP[0] = '';
                    argsP[1] = ".jpg";
                    argsP[2] = "fileUpload";
                    
                    var fileinput = filePath.replace("file:", "");
                    QuipsApi.fileUpload( fileinput, argsP,  uploadCallBack );

                    //Upload File
                    function uploadCallBack(result){
                          // $ionicLoading.hide();
                          //emit msg to end user
                    }                
            },500);
        }
})
.controller('EditSphereCollectionCtrl', function($scope, $rootScope, $ionicPopover, $stateParams, 
    $timeout, $ionicActionSheet, $ionicHistory, 
    $state, CameraService, API, $ionicLoading, $log, Constant, $cordovaFile, $cordovaFileTransfer, $timeout, $ionicModal,
    $ionicSlideBoxDelegate, $ionicScrollDelegate  ) {

        $scope.collection = {};     
        $scope.collection["b64"] = "img/no-banner.jpg";

        $scope.getCollecton = function(){
            $ionicLoading.show();
            API.getCollection({
                collectionid:$stateParams.collectionid,
                }, function(data){
                    $ionicLoading.hide();
                    console.log(data);
                    if(data.Result == 1){
                        $scope.collection = data.Data;
                        $scope.collection.temp_url = data.Data.b64;
                    }      
                }, function(err){
                    $ionicLoading.hide();

            });
        }

        $scope.saveCollection = function(){ 

            var sphereBannerURL = '';
            if($scope.collection.temp_url == $scope.collection.b64){
                sphereBannerURL = $scope.collection.temp_url;
            }else if ($scope.collection.b64 != '' && $scope.collection.b64 != "img/no-banner.jpg" ){
                    //upload file first
                    sphereBannerURL = Constant.QUIPSHERE_API_HOST+ '/images/public/' + $scope.newQpFile ;
                    console.log( sphereBannerURL );
                    $scope.sendSphereCollectionBanner($scope.imageLocalPath);
            }else{
                sphereBannerURL = '';
            }  
            if($scope.collection.title === undefined || $scope.collection.title === ""){
                create_failed("Title is required");
            }else if($scope.collection.description === undefined || $scope.collection.description === ""){
                create_failed("Description is required");
            }else{
                $ionicLoading.show();
                var data = {
                    title: $scope.collection.title,
                    description: $scope.collection.description,
                    url_banner:sphereBannerURL,
                    sphere_id:$stateParams.id,
                    collectionid:$stateParams.collectionid,
                    creator_quipperid:$rootScope.user_data.quipper_id,
                };
                console.log(data);
                API.editCollection(data, cb_success, cb_error);
            }
        }
        function cb_success(data){
            $ionicLoading.hide();
            if(data.Result == 1 ){
                //success
                create_success("Update Collection Success");
            }else{
                //error
                var msg = data.Message.join("<br/>");
                console.log(data.Message)
                create_failed(msg);
            }
            // console.log(data);
        }
        function cb_error(data){
            $ionicLoading.hide();
            // console.log("cb_error");
            // console.log(data);
            create_failed("Something went wrong please try again");
        }

        function create_failed(msg){
            var status = "e";
            var ontap_callback = function(e){
                // console.log(e);
            }
            title = 'Update Collection';
            btn_text = 'Try again';
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }
        function create_success(msg){
            var status = "s";
            var ontap_callback = function(e){
                // console.log(e);
                $rootScope.goback();
            }
            title = 'Update Collection Success';
            btn_text = 'OK';
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }

        //Upload Logo Image
        $scope.editUploadBanner = function(){
            //$ionicLoading.show();
                
            navigator.camera.getPicture(onSuccessFromGallery, onFailFromGallery, {
                targetWidth: 720,
                targetHeight: 720,
                quality: 72,
                allowEdit: false,
                correctOrientation: true,
                saveToPhotoAlbum: true,
                destinationType: Camera.DestinationType.FILE_URI,
                sourceType: navigator.camera.PictureSourceType.SAVEDPHOTOALBUM
            });
        };

        $scope.newQpFile = ''; $scope.imageLocalPath = '';

        function onSuccessFromGallery(imageData) {
            // format url and filename
            var qp = imageData.split('/').pop(); var qpFile = qp.split('?'); // get the file
            var qpUrlArr = imageData.split('/'); 
            qpUrlArr.splice(-1,1); 
            var qpUrl = qpUrlArr.join('/')+'/'; // get the folder
            var newQpFile = 'sphere_collection_' + $rootScope.user_data.quipper_id + '_' + new Date().getTime()+'.jpg';
            $scope.newQpFile = newQpFile;
            
            // copy the file in quipsphere folder
            $cordovaFile.copyFile(qpUrl, qpFile[0], cordova.file.externalRootDirectory, newQpFile)
                .then(function (success) {
                    // display in form
                    var imageSource = cordova.file.externalRootDirectory+newQpFile;                                      
                    $scope.imageLocalPath =$scope.collection["b64"] = imageSource;


                }, function (error) {
                    console.log('error: '+ error);
                });
        }

        function onFailFromGallery(message) {
           // $ionicLoading.hide();            
        }

        $scope.sendSphereCollectionBanner = function(filePath){
            $timeout(function() {
                 var argsP = new Array();
                    argsP[0] = '';
                    argsP[1] = ".jpg";
                    argsP[2] = "fileUpload";
                    
                    var fileinput = filePath.replace("file:", "");
                    QuipsApi.fileUpload( fileinput, argsP,  uploadCallBack );

                    //Upload File
                    function uploadCallBack(result){
                          // $ionicLoading.hide();
                          //emit msg to end user
                    }                
            },500);
        }

        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){ 
            if(toState.name == 'app.editcollection'){
                $ionicLoading.show();
                API.getSphere({
                    unique_id : $stateParams.id
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            $scope.currentsphere =  data.Data;
                            $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                            $rootScope.routeParams.id = $stateParams.id;
                            $rootScope.routeParams.handler = $scope.currentsphere.handle;
                            $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            if(data.Data.member_type=='OWNER'){
                            }else if(data.Data.member_type=='MEMBER'){
                            }else{
                                $rootScope.canQuip = false;
                            }
                        }
                        $ionicLoading.hide();
                    },function(err){
                        $ionicLoading.hide();
                });
                $scope.getCollecton();
            }
        });
})
.controller('CreateSphereCtrl', function($rootScope, $scope, $state, $cordovaDatePicker, $ionicHistory,
    $ionicLoading, DatePicker, TimePicker, API, $cordovaFile, $timeout, Constant) {
        $scope.ad_class = "hide";
        $scope.mysphere = {};

        $scope.mysphere["SphereHandle"] = "";  
        $scope.mysphere["Hashtags"] = "";   
        $scope.mysphere["Description"] = ""; 
        $scope.mysphere["ApplyDuration"] = 0;
        $scope.mysphere["StartDate"] = "";  
        $scope.mysphere["Duration"] = "Hours";   
        $scope.mysphere["Private"] = 'Public';  
        $scope.mysphere["EnableReply"] = 0;   
        $scope.mysphere["StartTime"] = "";
        $scope.mysphere["sphere_logo"] = "";
        $scope.mysphere["b64"] = "";
        //everyone may quip  
        $scope.mysphere["Everyone_may_quip"] = 'N';   
        $scope.mysphere["Passcode"] = '';    
        $scope.options = [];

        for(var i = 1; i <= 24; i++){
            $scope.options.push({"val":i});
        }

       /* $scope.fileNameChanged = function(){
            $ionicLoading.show();
            var f = document.getElementById("create-sphere-logo").files[0],
            r = new FileReader();
            r.onloadend = function(e) { //callback after files finish loading
                $scope.mysphere.b64 = e.target.result;
                $scope.$apply();
                $ionicLoading.hide();
                //here you can send data over your server as desired
            }
            r.readAsDataURL(f); //once defined all callbacks, begin reading the file
        }*/

       /* $scope.tapFile = function(){
            document.getElementById("create-sphere-logo").click();
        }*/
        $scope.log = function(x){
            console.log(x)
        }

        $scope.sliceValue = function(x){
            console.log(x);
            var x = ""+x;
            $scope.mysphere.Passcode = parseInt(x.substr(0, 4));
        }

        $scope.gen_passcode = function(x){
            // if(x == 'Y'){
            //     $scope.mysphere["Passcode"] = getRandomInt(1000, 10000) 
            // }else{
            //     $scope.mysphere["Passcode"] = '';
            // }
        }
        function getRandomInt(min, max) {
          return Math.floor(Math.random() * (max - min)) + min;
        }
        $scope.createShpere = function(){
             //validate
            if ($scope.mysphere.SphereHandle  == ''){
                title = 'Error on save';
                btn_text = 'Try again';
                msg = 'Handle is required';
                var status = "e";
                $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                return;
            }
            if ($scope.mysphere.Description  == ''){
                title = 'Error on save';
                btn_text = 'Try again';
                msg = 'Description is required';
                var status = "e";
                $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                return;
            }

            $ionicLoading.show();

            var sphereLogoURL = '';
            if ($scope.mysphere.b64 != ''){
                    //upload file first
                    sphereLogoURL = Constant.S3URL_SPHERELOGO_PATH + $scope.newQpFile ;
                    console.log( sphereLogoURL );
                    $scope.sendSphereLogo($scope.imageLocalPath);
            }            

            var data = {
                sphere_logo: sphereLogoURL,
                hashtags: $scope.mysphere.Hashtags,
                handle: $scope.mysphere.SphereHandle,
                description: $scope.mysphere.Description,
                privacy_type: $scope.mysphere.Private,
                everyone_may_quip: $scope.mysphere.Everyone_may_quip,
                enable_reply: $scope.mysphere.EnableReply,
                passcode: $scope.mysphere.Passcode
                //start_datetime: $scope.mysphere.StartDate + " " + $scope.mysphere.StartTime,
                //duration: $scope.mysphere.Duration,
                //apply_duration: $scope.mysphere.ApplyDuration,
                //enable_reply: $scope.mysphere.EnableReply,
            };

            API.createSphere(data, cb_success, cb_error);
        }

        function cb_success(data){
            $ionicLoading.hide();
            if(data.Result == 1 ){
                //success
                $scope.mysphere["SphereHandle"] = "";  
                $scope.mysphere["Hashtags"] = "";   
                $scope.mysphere["Description"] = ""; 
                $scope.mysphere["ApplyDuration"] = 0;
                $scope.mysphere["StartDate"] = "";  
                $scope.mysphere["Duration"] = "Hours";   
                $scope.mysphere["Private"] = 'Public';  
                $scope.mysphere["Everyone_may_quip"] = 'N';    
                $scope.mysphere["EnableReply"] = 0;   
                $scope.mysphere["StartTime"] = "";
                $scope.mysphere["sphere_logo"] = "";
                $scope.mysphere["b64"] = "img/no-image-available.png";
                document.getElementById("create-sphere-logo").value='';
                create_success(data.Message[0]);
            }else{
                //error
                var msg = data.Message.join("<br/>");
                create_failed(msg);
            }
            console.log(data);
        }
        function cb_error(data){
            $ionicLoading.hide();
            console.log("cb_error");
            console.log(data);
            create_failed("Something went wrong please try again");
        }
        function create_failed(msg){
            var status = "e";
            var ontap_callback = function(e){
                console.log(e);
            }
            title = 'Create Sphere Failed';
            btn_text = 'Try again';
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }
        function create_success(msg){
            var status = "s";
            var ontap_callback = function(e){
                console.log(e);
                console.log('getMySphereEvents');
                setTimeout(function(){
                    $rootScope.$broadcast('getMySphereEvents');
                },250);
                $rootScope.goback();
            }
            title = 'Create Sphere Success';
            btn_text = 'OK';
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }
        //Upload Logo Image
        $scope.uploadLogoImage = function(){
            //$ionicLoading.show();
                
            navigator.camera.getPicture(onSuccessFromGallery, onFailFromGallery, {
                targetWidth: 720,
                targetHeight: 720,
                quality: 72,
                allowEdit: false,
                correctOrientation: true,
                saveToPhotoAlbum: true,
                destinationType: Camera.DestinationType.FILE_URI,
                sourceType: navigator.camera.PictureSourceType.SAVEDPHOTOALBUM
            });
        };

        $scope.newQpFile = ''; $scope.imageLocalPath = '';

        function onSuccessFromGallery(imageData) {
            // format url and filename
            var qp = imageData.split('/').pop(); var qpFile = qp.split('?'); // get the file
            var qpUrlArr = imageData.split('/'); 
            qpUrlArr.splice(-1,1); 
            var qpUrl = qpUrlArr.join('/')+'/'; // get the folder
            var newQpFile = 'sphere_' + $rootScope.user_data.quipper_id + '_' + new Date().getTime()+'.jpg';
            $scope.newQpFile = newQpFile;
            
            // copy the file in quipsphere folder
            console.log("cordova.file.externalRootDirectory");
            console.log(cordova.file.externalRootDirectory);
            $cordovaFile.copyFile(qpUrl, qpFile[0], cordova.file.externalRootDirectory, newQpFile)
                .then(function (success) {
                    // display in form
                    var imageSource = cordova.file.externalRootDirectory+newQpFile;                                      
                    console.log(imageSource);
                    $scope.imageLocalPath =$scope.mysphere["b64"] = imageSource;


                }, function (error) {
                    console.log('error: '+ error);
                });
        }

        function onFailFromGallery(message) {
           // $ionicLoading.hide();            
        }

         $scope.sendSphereLogo = function(filePath){
            $timeout(function() {
                 var argsP = new Array();
                    argsP[0] = '';
                    argsP[1] = ".jpg";
                    
                    var fileinput = filePath.replace("file:", "");
                    QuipsApi.uploadSphereLogo( fileinput, argsP,  uploadCallBack );

                    //Upload File
                    function uploadCallBack(result){
                          // $ionicLoading.hide();
                          //emit msg to end user
                    }                
            },500);
        }
})
.controller('EditSphereCtrl', function($rootScope, $scope, $state, $stateParams, $cordovaDatePicker, $ionicHistory,
    $ionicLoading, DatePicker, TimePicker, API, $cordovaFile, $timeout, Constant) {
        $scope.ad_class = "hide";
        $scope.mysphere = {};
        $scope.editsphereloading = true;
        $scope.mysphere["SphereHandle"] = "";  
        $scope.mysphere["Hashtags"] = "";   
        $scope.mysphere["Description"] = ""; 
        $scope.mysphere["ApplyDuration"] = 0;
        $scope.mysphere["StartDate"] = "";  
        $scope.mysphere["Duration"] = "Hours";   
        $scope.mysphere["Private"] = 'Public';    
        $scope.mysphere["EnableReply"] = 0;   
        $scope.mysphere["StartTime"] = "";
        $scope.mysphere["sphere_logo"] = "";
        $scope.mysphere["b64"] = "img/no-image-available.png";
        //everyone may quip  
        $scope.mysphere["Everyone_may_quip"] = 'N';   
        $scope.mysphere["Passcode"] = '';    
        $scope.options = [];
        for(var i = 1; i <= 24; i++){
            $scope.options.push({"val":i});
        }


        $scope.sliceValue = function(x){
            console.log(x);
            var x = ""+x;
            $scope.mysphere.Passcode = parseInt(x.substr(0, 4));
        }
        $scope.getSphere = function(){
            $scope.editsphereloading = true;
            $ionicLoading.show();
            API.getSphere({
                unique_id : $stateParams.id 
                },function(data){
                    $ionicLoading.hide();
                    if(data.Result == 1){
                        $scope.editsphereloading = false;
                        $scope.mysphere["SphereHandle"] = data.Data.handle;  
                        $scope.mysphere["Hashtags"] = data.Data.hashtags; 
                        $scope.mysphere["Description"] = data.Data.description;
                        $scope.mysphere["Private"] = data.Data.privacy_type;   
                        $scope.mysphere["sphere_logo"] = data.Data.sphere_logo;
                        $scope.mysphere["EnableReply"] = data.Data.enable_reply;
                        $scope.mysphere["b64"] = data.Data.sphere_logo;
                        $scope.mysphere["Everyone_may_quip"] = data.Data.everyone_may_quip;
                        $scope.mysphere["Passcode"] = parseInt(data.Data.passcode);
                    }else{
                        $scope.editsphereloading = true;
                    }
                },function(err){
                    $ionicLoading.hide();
                    $scope.editsphereloading = true;
            })
        }

        $scope.$on('$ionicView.beforeEnter', function() {

        }); 

        $scope.$on('$ionicView.afterEnter', function() {
        }); 
        $scope.$on('$ionicView.beforeLeave', function() {
        });
        $scope.$on('$ionicView.afterLeave', function() {
            $rootScope.canQuip = true;
        });
        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){ 
            if(toState.name == 'app.edit-sphere'){
                $ionicLoading.show();
                API.getSphere({
                    unique_id : $stateParams.id
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            $scope.currentsphere =  data.Data;
                            $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                            $rootScope.routeParams.id = $stateParams.id;
                            $rootScope.routeParams.handler = $scope.currentsphere.handle;
                            $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            if(data.Data.member_type=='OWNER'){
                            }else if(data.Data.member_type=='MEMBER'){
                            }else{
                                $rootScope.canQuip = false;
                            }
                        }
                        $ionicLoading.hide();
                    },function(err){
                        $ionicLoading.hide();
                });
                $scope.getSphere();
            }
        });

        $scope.fileNameChanged = function(){
            $ionicLoading.show();
            var f = document.getElementById("edit-sphere-logo").files[0],
            r = new FileReader();
            r.onloadend = function(e) { //callback after files finish loading
                $scope.mysphere.b64 = e.target.result;
                $scope.$apply();
                $ionicLoading.hide();
                //here you can send data over your server as desired
            }
            r.readAsDataURL(f); //once defined all callbacks, begin reading the file
        }
        $scope.log = function(x){
            console.log(x)
        }

        $scope.gen_passcode = function(x){
            // if(x == 'Y'){
            //     $scope.mysphere["Passcode"] = getRandomInt(1000, 10000) 
            // }else{
            //     $scope.mysphere["Passcode"] = '';
            // }
        }
        function getRandomInt(min, max) {
          return Math.floor(Math.random() * (max - min)) + min;
        }

        $scope.tapFile = function(){
             navigator.camera.getPicture(onEsSuccessFromGallery, onEsFailFromGallery, {
                targetWidth: 720,
                targetHeight: 720,
                quality: 72,
                allowEdit: false,
                correctOrientation: true,
                saveToPhotoAlbum: true,
                destinationType: Camera.DestinationType.FILE_URI,
                sourceType: navigator.camera.PictureSourceType.SAVEDPHOTOALBUM
            });
        }

        $scope.es_newQpFile = ''; $scope.es_imageLocalPath = '';

        function onEsSuccessFromGallery(imageData) {
            // format url and filename
            var qp = imageData.split('/').pop(); var qpFile = qp.split('?'); // get the file
            var qpUrlArr = imageData.split('/'); 
            qpUrlArr.splice(-1,1); 
            var qpUrl = qpUrlArr.join('/')+'/'; // get the folder
            var newQpFile = 'sphere_' + $rootScope.user_data.quipper_id + '_' + new Date().getTime()+'.jpg';
            $scope.es_newQpFile = newQpFile;
            
            // copy the file in quipsphere folder
            $cordovaFile.copyFile(qpUrl, qpFile[0], cordova.file.externalRootDirectory, newQpFile)
                .then(function (success) {
                    // display in form
                    var imageSource = cordova.file.externalRootDirectory+newQpFile;                                      
                    $scope.es_imageLocalPath =$scope.mysphere["b64"] = imageSource;

                }, function (error) {
                    console.log('error: '+ error);
                });
        }

        function onEsFailFromGallery(message) {
           // $ionicLoading.hide();            
        }

        $scope.editShpere = function(){

            var ontap_callback = function(e){
                    console.log(e);
            }
            //validate
            if ($scope.mysphere.SphereHandle  == ''){
                title = 'Error on save';
                btn_text = 'Try again';
                msg = 'Handle is required';
                var status = "e";
                $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                return;
            }
            if ($scope.mysphere.Description  == ''){
                title = 'Error on save';
                btn_text = 'Try again';
                msg = 'Description is required';
                var status = "e";
                $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                return;

            }

            $ionicLoading.show();
            /*var file = document.getElementById("edit-sphere-logo");*/

            var sphereLogoURL = '';
            if ($scope.es_imageLocalPath != ''){
                    //upload file first
                    //sphereLogoURL = Constant.QUIPSHERE_API_HOST+ '/images/sphere_logo/' + $scope.es_newQpFile ;
                    sphereLogoURL = Constant.S3URL_SPHERELOGO_PATH + $scope.es_newQpFile ;
                    console.log( sphereLogoURL );
                    $scope.sendSphereLogo($scope.es_imageLocalPath);
            }            

            var data = {
                sphere_logo: sphereLogoURL,
                hashtags: $scope.mysphere.Hashtags,
                handle: $scope.mysphere.SphereHandle,
                description: $scope.mysphere.Description,
                privacy_type: $scope.mysphere.Private,
                unique_id: $stateParams.id,
                everyone_may_quip: $scope.mysphere.Everyone_may_quip,
                enable_reply: $scope.mysphere.EnableReply,
                passcode: $scope.mysphere.Passcode
                //start_datetime: $scope.mysphere.StartDate + " " + $scope.mysphere.StartTime,
                //duration: $scope.mysphere.Duration,
                //apply_duration: $scope.mysphere.ApplyDuration,
                //enable_reply: $scope.mysphere.EnableReply,
            };

            API.editSphere(data, cb_success, cb_error);
        }

        $scope.sendSphereLogo = function(filePath){
            $timeout(function() {
                 var argsP = new Array();
                    argsP[0] = '';
                    argsP[1] = ".jpg";
                    
                    var fileinput = filePath.replace("file:", "");
                    QuipsApi.uploadSphereLogo( fileinput, argsP,  uploadCallBack );

                    //Upload File
                    function uploadCallBack(result){
                          // $ionicLoading.hide();
                          //emit msg to end user
                    }                
            },500);
        }

        function cb_success(data){
            $ionicLoading.hide();
            if(data.Result == 1 ){
                //success
                edit_success(data.Message);
            }else{
                //error
                var msg = data.Message.join("<br/>");
                edit_failed(msg);
            }
            console.log(data);
        }
        function cb_error(data){
            $ionicLoading.hide();
            console.log("cb_error");
            console.log(data);
            edit_failed("Something went wrong please try again");
        }
        function edit_failed(msg){
            var status = "e";
            var ontap_callback = function(e){
                console.log(e);
            }
            title = 'Edit Sphere Failed';
            btn_text = 'Try again';
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }
        function edit_success(msg){
            var status = "s";
            var ontap_callback = function(e){
                console.log(e);
                $rootScope.goback();
            }
            title = 'Edit Sphere Success';
            btn_text = 'OK';
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }
})
.controller('SphereMembersCtrl', function($rootScope, $scope, $state,$ionicPopup, $state,
    $stateParams,$ionicPopover, API,$ionicLoading) {
        $scope.sphere = {};
        $scope.sphere.handle = "sphere members";
        $scope.sphere_members = {};
        $scope.paramId = $stateParams.id;
        $scope.member_name = '';
        $scope.mdoloadmore = false;

        var sphereMembersElement = document.querySelector("#sphere-members");
        $scope.$on('$ionicView.beforeEnter', function() {
            console.log("adding event listener sphereMemberEvent")
            sphereMembersElement.addEventListener("click", sphereMemberEvent, false);
        }); 
        $scope.$on('$ionicView.afterEnter', function() {
        }); 

        $scope.$on('$ionicView.beforeLeave', function() {
            console.log("removing event listener sphereMemberEvent")
            sphereMembersElement.removeEventListener("click", sphereMemberEvent, false);
        });

        $scope.$on('$ionicView.afterLeave', function() {
            $rootScope.canQuip = true;
        });

        $scope.popover = $ionicPopover.fromTemplate('', {
            scope: $scope
        });

        $scope.openPopover = function($event) {
            $scope.popover.show($event);
        };
        $scope.closePopover = function() {
            $scope.popover.hide();
        };

        function sphereMemberEvent(e){
            if (e.target !== e.currentTarget) {
                var checktarget = e.target.classList;
                //console.log(checktarget);
                for(var i = 0; i < checktarget.length; i++){
                    splited = checktarget[i].split("_");
                    if(splited[0] == "sm"){
                        switch(splited[1]){
                            case "options":      
                                var template = 
                                '<ion-popover-view class="sphere-popover"> '+
                                '<div>'+
                                '<div on-tap="deleteSphereMember(\''+splited[2]+'\');closePopover()" class="sphere-popover-li">Remove from Sphere</div>'+
                                '</div>'+
                                '</ion-popover-view>';
                                $scope.popover = $ionicPopover.fromTemplate(template, {
                                    scope: $scope
                                });
                                $scope.popover.show(e);
                                break;

                            case "viewquipper":
                                //console.log(splited[2]);
                                $rootScope.reRoute('go','view profile', 0, {id:splited[2], handler:$scope.currentsphere.handle});
                                $rootScope.goto('app.view-profile',{id:splited[2]});
                            break;
                            // case "viewquipper":
                            //     $rootScope.goto('app.view-profile',{id:splited[2]});
                            // break;
                            default:
                                break;
                        }
                    }
                }

            }
        }

        $scope.resetMemberName = function(){
            $scope.member_name = "";
            $scope.sphere_members = [];
            API.sphereMembers({
                unique_id : $stateParams.id
                },function(data){
                    if(data.Result == 1){
                        window.localStorage['sphere_members'] = JSON.stringify(data.Data);
                        $scope.sphere_members = JSON.parse(window.localStorage['sphere_members']);
                        $scope.mdoloadmore = true;
                    }else{
                        $scope.mdoloadmore = false;
                    }
                   //$ionicLoading.hide();
                },function(err){
                   // $ionicLoading.hide();
            });
        }
        $scope.searchMember = function(member_name){
            $scope.sphere_members = [];
            API.sphereMembers({
                unique_id : $stateParams.id,
                member_name: member_name
                },function(data){
                    if(data.Result == 1){
                        window.localStorage['sphere_members'] = JSON.stringify(data.Data);
                        $scope.sphere_members = JSON.parse(window.localStorage['sphere_members']);
                        $scope.mdoloadmore = true;
                    }else{
                        $scope.mdoloadmore = false;
                    }
                   // $ionicLoading.hide();
                },function(err){
                   // $ionicLoading.hide();
            });
        }
        $scope.deleteSphereMember = function(quipper_id){
            // var msg  = "Are you sure you want to remove this sphere member?";
            // var status = "e";     
            // var title = "Remove Sphere Member";   
            // $rootScope.popUp(msg, status, title,  function(e){
            API.deleteSphereMember({
                'unique_id' : $scope.paramId,
                'quipper_id' : quipper_id
                },function(data){ 
                    console.log(data); 
                },function(err){
            })
            var arr = [];
            for(var i = 0; i < $scope.sphere_members.length; i++){
                if(quipper_id != $scope.sphere_members[i].quipper_id){
                    var temp = {};
                    temp['fullname'] = $scope.sphere_members[i].fullname;
                    temp['handle'] = $scope.sphere_members[i].handle;
                    temp['member_type'] = $scope.sphere_members[i].member_type;
                    temp['quipper_id'] = $scope.sphere_members[i].quipper_id;
                    temp['quipper_img'] = $scope.sphere_members[i].quipper_img;
                    arr.push(temp);
                }
            }
            $scope.sphere_members = arr;
            //$scope.$apply();
            //});
        }
        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){ 
            if(toState.name == 'app.sphere-members'){
                $scope.paramId = $stateParams.id;
                $ionicLoading.show();
                API.getSphere({
                    unique_id : $stateParams.id
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            $scope.currentsphere =  data.Data;
                            $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                            $rootScope.routeParams.id = $stateParams.id;
                            $rootScope.routeParams.handler = $scope.currentsphere.handle;
                            $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            if(data.Data.member_type=='OWNER'){
                            }else if(data.Data.member_type=='MEMBER'){
                            }else{
                                $rootScope.canQuip = false;
                            }
                        }
                        $ionicLoading.hide();
                    },function(err){
                        $ionicLoading.hide();
                });
                $ionicLoading.show();
                // API.getSphere({
                //     unique_id : $stateParams.id 
                // },function(data){
                //     if(data.Result == 1){
                //         $scope.sphere.handle = data.Data.handle;
                //     }else{

                //     }
                // },function(err){
                // })
                API.sphereMembers({
                    unique_id : $stateParams.id 
                    },function(data){
                        if(data.Result == 1){
                            window.localStorage['sphere_members'] = JSON.stringify(data.Data);
                            $scope.sphere_members = JSON.parse(window.localStorage['sphere_members']);
                            $scope.mdoloadmore = true;
                        }else{
                            $scope.mdoloadmore = false;
                        }
                        $ionicLoading.hide();
                    },function(err){
                        $ionicLoading.hide();
                })
            }
        });

        $scope.loadmoremembers = function(){
            if($scope.mdoloadmore == true){
                $scope.mdoloadmore = false;
                var offsetid = $scope.sphere_members.length;
                API.sphereMembers({
                    unique_id : $stateParams.id,
                    offset:offsetid,
                    limit:20,
                    member_name: $scope.member_name 
                    },function(data){
                        if(data.Result == 1){
                            for(var i = 0; i < data.Data.length; i++){
                                $scope.sphere_members.push(data.Data[i]);
                            }
                            window.localStorage['sphere_members'] = JSON.stringify($scope.sphere_members);
                        }else{
                        }
                        
                    },function(err){
                })
            }
        }
})
.controller('InviteSphereMembersCtrl', function($rootScope, $scope, $state,$ionicPopup, $state,
    $stateParams,$ionicPopover, API, $ionicLoading) {

        var inviteSphereMembersElement = document.querySelector("#invite-sphere-members");
        var removedMembers =[];
        var addedMembers =[];
        $scope.paramId = $stateParams.id;
        $scope.member_name = "";
        $scope.followerList = [];
        $scope.memberList = [];

        $scope.$on('$ionicView.beforeEnter', function() {
            console.log("adding event listener inviteSphereMemberEvent")
            inviteSphereMembersElement.addEventListener("click", inviteSphereMemberEvent, false);
        }); 

        $scope.$on('$ionicView.afterEnter', function() {
        }); 
        $scope.$on('$ionicView.beforeLeave', function() {
            console.log("removing event listener inviteSphereMemberEvent")
            inviteSphereMembersElement.removeEventListener("click", inviteSphereMemberEvent, false);
        });
        $scope.$on('$ionicView.afterLeave', function() {
            $rootScope.canQuip = true;
        });

        function inviteSphereMemberEvent(e){
            if (e.target !== e.currentTarget) {
                var checktarget = e.target.classList;
                //console.log(checktarget);
                for(var i = 0; i < checktarget.length; i++){
                    splited = checktarget[i].split("_");
                    if(splited[0] == "ism"){
                        switch(splited[1]){
                            case "removemember":
                                //console.log(splited[2]);
                                var ml = [];
                                for(var i =0; i < $scope.memberList.length; i++){
                                    if($scope.memberList[i].quipper_id != splited[2]){
                                        var q = {};
                                        q['handle'] = $scope.memberList[i].handle;
                                        q['fullname'] = $scope.memberList[i].fullname;
                                        q['quipper_id'] = $scope.memberList[i].quipper_id;
                                        q['isMember'] = $scope.memberList[i].isMember;
                                        ml.push(q);
                                    }else{
                                        if(removedMembers.indexOf(splited[2]) == -1){
                                            removedMembers.push(splited[2]);
                                            addedMembers.splice(addedMembers.indexOf(splited[2]),1);
                                        }
                                    }
                                }
                                for(var i = 0; i < $scope.followerList.length; i++){
                                    if(removedMembers.indexOf($scope.followerList[i].quipper_id) != -1){
                                        $scope.followerList[i].isMember = false;
                                    }
                                }
                                $scope.memberList = ml;
                                $scope.$apply();
                                break;
                            case "addmember":
                                for(var i =0; i < $scope.followerList.length; i++){
                                    if($scope.followerList[i].quipper_id == splited[2]){
                                        $scope.followerList[i].isMember = true;
                                        var q = {};
                                        q['handle'] = $scope.followerList[i].handle;
                                        q['fullname'] = $scope.followerList[i].fullname;
                                        q['quipper_id'] = $scope.followerList[i].quipper_id;
                                        q['isMember'] = $scope.followerList[i].isMember;
                                        $scope.memberList.push(q);
                                        removedMembers.splice(removedMembers.indexOf(splited[2]),1);
                                        if(addedMembers.indexOf(splited[2]) == -1){
                                            addedMembers.push(splited[2]);
                                        }
                                    }
                                }
                                $scope.$apply();
                                break;

                            case "viewquipper":
                                //console.log(splited[2]);
                                $rootScope.reRoute('go','view profile', 0, {id:splited[2], handler:$scope.currentsphere.handle});
                                $rootScope.goto('app.view-profile',{id:splited[2]});
                            break;
                            default:
                                break;
                        }
                    }
                }

            }
        }

        $scope.manageMembers = function(){
            if($scope.memberList.length != 0 ){
                $ionicLoading.show();
                var members = [];
                for(var i = 0; i < $scope.memberList.length; i++){
                    members.push($scope.memberList[i].quipper_id);
                }
                members_string = members.join(',');
                var s = ( 1 != $scope.memberList.length )?"s":"";
                API.sphereInviteMembers({
                    members: members_string,
                    unique_id : $stateParams.id
                    },function(data){
                        $ionicLoading.hide();
                        if(data.Result==1){
                            var status = "e";
                            var ontap_callback = function(e){
                                $rootScope.goback();
                            }
                            title = 'Manage Members';
                            btn_text = 'Okay';
                            msg = "You have added "+$scope.memberList.length+ " New Member"+s;
                            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                        }else{

                        }
                    },function(err){
                        $ionicLoading.hide();
                })
            }
        }
        $scope.resetMemberName = function(){
            $scope.member_name = "";
            $ionicLoading.show();
            API.sphereFollowerList({
                unique_id : $stateParams.id
                },function(data){
                    $ionicLoading.hide();
                    if(data.Result == 1){
                        $scope.followerList = data.Data;
                        if(removedMembers.length != 0){
                            for(var i = 0; i < $scope.followerList.length; i++){
                                if(removedMembers.indexOf($scope.followerList[i].quipper_id) != -1){
                                    $scope.followerList[i].isMember = false;
                                }
                            }
                        }
                        if(addedMembers.length != 0){
                            for(var i = 0; i < $scope.followerList.length; i++){
                                if(addedMembers.indexOf($scope.followerList[i].quipper_id) != -1){
                                    $scope.followerList[i].isMember = true;
                                }
                            }
                        }
                    }else{

                    }
                },function(err){
                    $ionicLoading.hide();
            });
        }
        $scope.searchMember = function(member_name){
            $ionicLoading.show();
            API.sphereFollowerList({
                unique_id : $stateParams.id,
                member_name: member_name
                },function(data){
                    $ionicLoading.hide();
                    if(data.Result == 1){
                        $scope.followerList = data.Data;
                        if(removedMembers.length != 0){
                            for(var i = 0; i < $scope.followerList.length; i++){
                                if(removedMembers.indexOf($scope.followerList[i].quipper_id) != -1){
                                    $scope.followerList[i].isMember = false;
                                }
                            }
                        }
                        if(addedMembers.length != 0){
                            for(var i = 0; i < $scope.followerList.length; i++){
                                if(addedMembers.indexOf($scope.followerList[i].quipper_id) != -1){
                                    $scope.followerList[i].isMember = true;
                                }
                            }
                        }
                    }else{

                    }
                },function(err){
                    $ionicLoading.hide();
            });
        }
        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){ 
            if(toState.name == 'app.invite-sphere-members'){
                $scope.paramId = $stateParams.id;
                $ionicLoading.show();
                API.getSphere({
                    unique_id : $stateParams.id
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            $scope.currentsphere =  data.Data;
                            $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                            $rootScope.routeParams.id = $stateParams.id;
                            $rootScope.routeParams.handler = $scope.currentsphere.handle;
                            $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            if(data.Data.member_type=='OWNER'){
                            }else if(data.Data.member_type=='MEMBER'){
                            }else{
                                $rootScope.canQuip = false;
                            }
                        }
                        $ionicLoading.hide();
                    },function(err){
                        $ionicLoading.hide();
                });
                //get sphere
                // API.getSphere({
                //     unique_id : $stateParams.id
                // },function(data){

                // },function(err){
                // });

                // API.sphereMemberList({
                //     unique_id : $stateParams.id,
                // },function(data){
                //     if(data.Result == 1){
                //         $scope.memberList = data.Data;
                //     }else{

                //     }
                // },function(err){
                // });
                $ionicLoading.show();
                API.sphereFollowerList({
                    unique_id : $stateParams.id,
                    },function(data){
                        $ionicLoading.hide();
                        if(data.Result == 1){
                            $scope.followerList = data.Data;
                            // if(removedMembers.length != 0){
                            //     for(var i = 0; i < $scope.followerList.length; i++){
                            //         if(removedMembers.indexOf($scope.followerList[i].quipper_id) != -1){
                            //             $scope.followerList[i].isMember = false;
                            //         }
                            //     }
                            // }
                            // if(addedMembers.length != 0){
                            //     for(var i = 0; i < $scope.followerList.length; i++){
                            //         if(addedMembers.indexOf($scope.followerList[i].quipper_id) != -1){
                            //             $scope.followerList[i].isMember = true;
                            //         }
                            //     }
                            // }
                        }else{

                        }
                    },function(err){
                        $ionicLoading.hide();
                });

            }

        });
})
.controller('SphereFollowersCtrl', function($rootScope, $scope, $state,$ionicPopup, $state,
    $stateParams,$ionicPopover, API,$ionicLoading) {
        $scope.sphere = {};
        $scope.sphere.handle = "sphere members";
        $scope.sphere_followers = {};
        $scope.paramId = $stateParams.id;
        $scope.member_name = '';
        $scope.doloadmore = false;

        var sphereFollowersElement = document.querySelector("#sphere-followers");
        $scope.$on('$ionicView.beforeEnter', function() {
            console.log("adding event listener sphereFollowerEvent")
            sphereFollowersElement.addEventListener("click", sphereFollowerEvent, false);
        }); 
        $scope.$on('$ionicView.afterEnter', function() {
        }); 

        $scope.$on('$ionicView.beforeLeave', function() {
            console.log("removing event listener sphereFollowerEvent")
            sphereFollowersElement.removeEventListener("click", sphereFollowerEvent, false);
        });

        $scope.$on('$ionicView.afterLeave', function() {
            $rootScope.canQuip = true;
        });

        $scope.popover = $ionicPopover.fromTemplate('', {
            scope: $scope
        });

        $scope.openPopover = function($event) {
            $scope.popover.show($event);
        };
        $scope.closePopover = function() {
            $scope.popover.hide();
        };

        function sphereFollowerEvent(e){
            if (e.target !== e.currentTarget) {
                var checktarget = e.target.classList;
                //console.log(checktarget);
                for(var i = 0; i < checktarget.length; i++){
                    splited = checktarget[i].split("_");
                    if(splited[0] == "sf"){
                        switch(splited[1]){
                            case "options":      
                                var template = 
                                '<ion-popover-view class="sphere-popover"> '+
                                '<div>'+
                                '<div on-tap="deleteSphereFollower(\''+splited[2]+'\');closePopover()" class="sphere-popover-li">Remove from Sphere</div>'+
                                '</div>'+
                                '</ion-popover-view>';
                                $scope.popover = $ionicPopover.fromTemplate(template, {
                                    scope: $scope
                                });
                                $scope.popover.show(e);
                                break;
                                
                            case "viewquipper":
                                //console.log(splited[2]);
                                $rootScope.reRoute('go','view profile', 0, {id:splited[2], handler:$scope.currentsphere.handle});
                                $rootScope.goto('app.view-profile',{id:splited[2]});
                            break;
                            // case "viewquipper":
                            //     $rootScope.goto('app.view-profile',{id:splited[2]});
                            // break;
                            default:
                                break;
                        }
                    }
                }

            }
        }

        $scope.resetMemberName = function(){
            $scope.sphere_followers = [];
            $scope.member_name = "";
            //$ionicLoading.show();
            API.sphereFollowers({
                unique_id : $stateParams.id
                },function(data){
                    if(data.Result == 1){
                        window.localStorage['sphere_followers'] = JSON.stringify(data.Data);
                        $scope.sphere_followers = JSON.parse(window.localStorage['sphere_followers']);
                        $scope.doloadmore = true;
                    }else{
                        $scope.doloadmore = false;
                    }
                    //$ionicLoading.hide();
                },function(err){
                    //$ionicLoading.hide();
            });
        }
        $scope.searchMember = function(member_name){
            //$ionicLoading.show();
            $scope.sphere_followers = [];
            API.sphereFollowers({
                unique_id : $stateParams.id,
                member_name: member_name
                },function(data){
                    if(data.Result == 1){
                        //window.localStorage['sphere_followers'] = JSON.stringify(data.Data);
                        $scope.sphere_followers = data.Data; //JSON.parse(window.localStorage['sphere_followers']);
                        $scope.mdoloadmore = true;
                    }else{
                        $scope.mdoloadmore = false;
                    }
                    //$ionicLoading.hide();
                },function(err){
                    //$ionicLoading.hide();
            });
        }
        $scope.deleteSphereFollower = function(quipper_id){
            // var msg  = "Are you sure you want to remove this sphere member?";
            // var status = "e";     
            // var title = "Remove Sphere Member";   
            // $rootScope.popUp(msg, status, title,  function(e){
            API.deleteSphereMember({
                'unique_id' : $scope.paramId,
                'quipper_id' : quipper_id
                },function(data){ 
                    console.log(data); 
                },function(err){
            })
            var arr = [];
            for(var i = 0; i < $scope.sphere_followers.length; i++){
                if(quipper_id != $scope.sphere_followers[i].quipper_id){
                    var temp = {};
                    temp['fullname'] = $scope.sphere_followers[i].fullname;
                    temp['handle'] = $scope.sphere_followers[i].handle;
                    temp['member_type'] = $scope.sphere_followers[i].member_type;
                    temp['quipper_id'] = $scope.sphere_followers[i].quipper_id;
                    temp['quipper_img'] = $scope.sphere_followers[i].quipper_img;
                    arr.push(temp);
                }
            }
            $scope.sphere_followers = arr;
            //$scope.$apply();
            //});
        }
        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){ 
            if(toState.name == 'app.sphere-followers'){
                $scope.paramId = $stateParams.id;
                $ionicLoading.show();
                API.getSphere({
                    unique_id : $stateParams.id
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            $scope.currentsphere =  data.Data;
                            $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                            $rootScope.routeParams.id = $stateParams.id;
                            $rootScope.routeParams.handler = $scope.currentsphere.handle;
                            $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            if(data.Data.member_type=='OWNER'){
                            }else if(data.Data.member_type=='MEMBER'){
                            }else{
                                $rootScope.canQuip = false;
                            }
                        }
                        $ionicLoading.hide();
                    },function(err){
                        $ionicLoading.hide();
                });
                $ionicLoading.show();
                // API.getSphere({
                //     unique_id : $stateParams.id 
                // },function(data){
                //     if(data.Result == 1){
                //         $scope.sphere.handle = data.Data.handle;
                //     }else{

                //     }
                // },function(err){
                // })
                API.sphereFollowers({
                    unique_id : $stateParams.id,
                    offset:0 
                    },function(data){
                        if(data.Result == 1){
                            window.localStorage['sphere_followers'] = JSON.stringify(data.Data);
                            $scope.sphere_followers = JSON.parse(window.localStorage['sphere_followers']);
                            $scope.doloadmore = true;
                        }else{
                            $scope.doloadmore = false;
                        }
                        $ionicLoading.hide();
                    },function(err){
                        $ionicLoading.hide();
                })
            }
        });


    $scope.loadmorefollowers = function(){
        if($scope.doloadmore == true){
            $scope.doloadmore = false;
            var offsetid = $scope.sphere_followers.length;
            API.sphereFollowers({
                unique_id : $stateParams.id,
                offset:offsetid,
                limit:20,
                member_name: $scope.member_name
                },function(data){
                    if(data.Result == 1){
                        for(var i = 0; i < data.Data.length; i++){
                            $scope.sphere_followers.push(data.Data[i]);
                        }
                        window.localStorage['sphere_followers'] = JSON.stringify($scope.sphere_followers);
                        $scope.doloadmore = true;
                    }else{
                        $scope.doloadmore = false;
                    }
                },function(err){
            })
        }
    }
})
.controller('SphereEventsCtrl', function($scope, $rootScope, $ionicHistory, $stateParams,$ionicLoading, API, $ionicPopover) {
    $scope.currentsphere = {};
    $scope.sphere_unique_id = $stateParams.id;
    $scope.AddSphereEvent = function(){
        $rootScope.reRoute('go','app.add-sphere-event', 0, {id:$stateParams.id, handler:$rootScope.routeParams.handler});
        $rootScope.goto('app.add-sphere-event',{id:$stateParams.id});
    }

    $scope.editSphereEvent = function(val){
        console.log($scope.currentsphere);
        $rootScope.reRoute('go','app.edit-sphere-event', 0, {id:$stateParams.id, handler:$rootScope.routeParams.handler});
        console.log($rootScope.routeParams);
        $rootScope.goto('app.edit-sphere-event',{id:val});
    };

    $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){

        if(toState.name == 'app.sphere-events'){
            //get sphere
            $ionicLoading.show();
            API.getSphere({
                unique_id : $stateParams.id
                },function(data){
                    console.log(data);
                    if(data.Result == 1){
                        $scope.currentsphere =  data.Data;
                        $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                        $rootScope.routeParams.id = $stateParams.id;
                        $rootScope.routeParams.handler = $scope.currentsphere.handle;
                        $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                        $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                        if(data.Data.member_type=='OWNER'){
                        }else if(data.Data.member_type=='MEMBER'){
                        }else{
                            $rootScope.canQuip = false;
                        }
                    }
                    $ionicLoading.hide();
                },function(err){
                    $ionicLoading.hide();
            });
            API.viewsphereevents({id:$stateParams.id }, function(data){
                $ionicLoading.hide();
                if(data.Result == 1){
                    $scope.eventlist = data.Data;
                }      
                }, function(err){
                    $ionicLoading.hide();

            });

        }

    });
})
.controller('AddSphereEventCtrl', function($scope, $rootScope, $cordovaDatePicker, 
    $ionicHistory, DatePicker, TimePicker,  $http, $ionicLoading, Constant, API, $timeout,
    deviceType, $stateParams, $cordovaFile 
    , Timezones
    ) {
    //alert();
    $scope.sphere_event = {};
    $scope.sphere_event.sphereid = "";
    $scope.sphere_event.title = "";
    $scope.sphere_event.description = "";
    $scope.sphere_event.event_date = "";
    $scope.sphere_event.event_time_from = "";
    $scope.sphere_event.event_time_from_ampm = "";
    $scope.sphere_event.event_time_to = "";
    $scope.sphere_event.event_time_to_ampm = "";
    $scope.sphere_event.time_zone = "";
    $scope.sphere_event.b64 ="img/no-banner.jpg";

    var dp = new DatePicker();
    dp.datepickerObject.from = new Date("January 1, 1907");
    dp.datepickerObject.callback = function (val) {
        if (typeof(val) === 'undefined') {
            // console.log('No date selected');
        } else {
            $scope.datepickerObject.inputDate = val;
            // console.log('Selected date is : ', val)
            $scope.sphere_event.event_date = dp.dateFormat(val);
        }
    }; 
    $scope.datepickerObject = dp.datepickerObject;

    var tp_start = new TimePicker();
    tp_start.timePickerObject.callback= function(val) {
        if (typeof (val) === 'undefined') {
            console.log('Time not selected');
        } else {
            var selectedTime = new Date(val * 1000);
            $scope.sphere_event.event_time_from = tp_start.ampm(selectedTime);
            //console.log('Selected epoch is : ', val, 'and the time is ', selectedTime.getUTCHours(), ':', selectedTime.getUTCMinutes(), 'in UTC');
        }
    }
    $scope.timePickerObject_start = tp_start.timePickerObject;

    var tp_end = new TimePicker();
    tp_end.timePickerObject.callback= function(val) {
        if (typeof (val) === 'undefined') {
            console.log('Time not selected');
        } else {
            var selectedTime = new Date(val * 1000);
            $scope.sphere_event.event_time_to = tp_end.ampm(selectedTime);
            //console.log('Selected epoch is : ', val, 'and the time is ', selectedTime.getUTCHours(), ':', selectedTime.getUTCMinutes(), 'in UTC');
        }
    }
    $scope.timePickerObject_end = tp_end.timePickerObject;

    function create_failed(msg){
        var status = "e";
        var ontap_callback = function(e){
            // console.log(e);
        }
        title = 'Create Collection';
        btn_text = 'Try again';
        $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
    }
    function create_success(msg){
        var status = "s";
        var ontap_callback = function(e){
            // console.log(e);
            $rootScope.goback();
        }
        title = 'Create Collection Success';
        btn_text = 'OK';
        $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
    }

    $scope.addSphereEvent = function(){

            var sphereBannerURL = '';
            if ($scope.sphere_event.b64 != '' && $scope.sphere_event.b64 != "img/no-banner.jpg"){
                    //upload file first
                    //sphereBannerURL = Constant.QUIPSHERE_API_HOST+ '/images/public/' + $scope.newQpFile ;
                    sphereBannerURL = Constant.S3URL_PUBLIC_PATH + $scope.newQpFile ;
                    console.log( sphereBannerURL );
                    $scope.sendSphereEventBanner($scope.imageLocalPath);
            }  
            if($scope.sphere_event.title === undefined || $scope.sphere_event.title === ""){
                create_failed("Title is required");
            }else if($scope.sphere_event.description === undefined || $scope.sphere_event.description === ""){
                create_failed("Description is required");
            }else{
                var event_data = {
                    banner_url:sphereBannerURL,
                    unique_id: $stateParams.id,
                    title: $scope.sphere_event.title, 
                    description: $scope.sphere_event.description,
                    event_date: $scope.sphere_event.event_date,
                    event_time_from: $scope.sphere_event.event_time_from,
                    event_time_from_ampm: $scope.sphere_event.event_time_from_ampm,
                    event_time_to: $scope.sphere_event.event_time_to,
                    event_time_to_ampm: $scope.sphere_event.event_time_to_ampm,
                    time_zone: $scope.sphere_event.time_zone
                };
                $ionicLoading.show();
                API.createsphereevent(event_data, function(data){
                    $ionicLoading.hide();
                    if(data.Result == 1) {
                        $rootScope.popAlert(
                            'Sphere Event Successfully Published',
                            'success', 
                            'Alert',
                            'OK',
                            function() {
                                $rootScope.goback();
                        });
                    } else {
                        $rootScope.popAlert(
                            'Sphere Event Published Failed!', 
                            'OK',
                            function() {
                        });
                    }
                    },function(err){
                        $ionicLoading.hide();
                        $rootScope.popAlert(
                            'Sphere Event Published Failed!', 
                            'OK',
                            function() {
                        });
                });
            }
    }



    //Upload Logo Image
    $scope.createUploadBanner = function(){
        //$ionicLoading.show();
            
        navigator.camera.getPicture(onSuccessFromGallery, onFailFromGallery, {
            targetWidth: 720,
            targetHeight: 720,
            quality: 72,
            allowEdit: false,
            correctOrientation: true,
            saveToPhotoAlbum: true,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: navigator.camera.PictureSourceType.SAVEDPHOTOALBUM
        });
    };

    $scope.newQpFile = ''; $scope.imageLocalPath = '';

    function onSuccessFromGallery(imageData) {
        // format url and filename
        var qp = imageData.split('/').pop(); var qpFile = qp.split('?'); // get the file
        var qpUrlArr = imageData.split('/'); 
        qpUrlArr.splice(-1,1); 
        var qpUrl = qpUrlArr.join('/')+'/'; // get the folder
        var newQpFile = 'sphere_event_' + $rootScope.user_data.quipper_id + '_' + new Date().getTime()+'.jpg';
        $scope.newQpFile = newQpFile;
        
        // copy the file in quipsphere folder
        $cordovaFile.copyFile(qpUrl, qpFile[0], cordova.file.externalRootDirectory, newQpFile)
            .then(function (success) {
                // display in form
                var imageSource = cordova.file.externalRootDirectory+newQpFile;                                      
                $scope.imageLocalPath =$scope.sphere_event["b64"] = imageSource;


            }, function (error) {
                console.log('error: '+ error);
            });
    }

    function onFailFromGallery(message) {
       // $ionicLoading.hide();            
    }

    $scope.sendSphereEventBanner = function(filePath){
        $timeout(function() {
             var argsP = new Array();
                argsP[0] = '';
                argsP[1] = ".jpg";
                argsP[2] = "fileUpload";
                
                var fileinput = filePath.replace("file:", "");
                QuipsApi.fileUpload( fileinput, argsP,  uploadCallBack );

                //Upload File
                function uploadCallBack(result){
                      // $ionicLoading.hide();
                      //emit msg to end user
                }                
        },500);
    }
    setTimeout(function(){
        $scope.timezones = Timezones.list;
        $scope.$apply();
    },250);
    $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){

        if(toState.name == 'app.add-sphere-event'){
            $ionicLoading.show();
            API.getSphere({
                unique_id : $stateParams.id
                },function(data){
                    console.log(data);
                    if(data.Result == 1){
                        $scope.currentsphere =  data.Data;
                        $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                        $rootScope.routeParams.id = $stateParams.id;
                        $rootScope.routeParams.handler = $scope.currentsphere.handle;
                        $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                        $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                        if(data.Data.member_type=='OWNER'){
                        }else if(data.Data.member_type=='MEMBER'){
                        }else{
                            $rootScope.canQuip = false;
                        }
                    }
                    $ionicLoading.hide();
                },function(err){
                    $ionicLoading.hide();
            });
        }
    });
})
.controller('EditSphereEventCtrl', function($scope, $rootScope, $cordovaDatePicker, $ionicLoading, $cordovaFile, 
    $ionicHistory, DatePicker, TimePicker,  $http, $timeout, $ionicLoading, Constant, API, deviceType, $stateParams, Timezones) {
    $scope.sphere_event = {};
    $scope.sphere_event.sphereid = "";
    $scope.sphere_event.title = "";
    $scope.sphere_event.description = "";
    $scope.sphere_event.event_date = "";
    $scope.sphere_event.event_time_from = "";
    $scope.sphere_event.event_time_from_ampm = "";
    $scope.sphere_event.event_time_to = "";
    $scope.sphere_event.event_time_to_ampm = "";
    $scope.sphere_event.time_zone = "";
    $scope.sphere_event.b64 ="img/no-banner.jpg";

    setTimeout(function(){
        $scope.timezones = Timezones.list;
    },100)
    $scope.$on('$ionicView.beforeEnter', function() {
    }); 
    var dp = new DatePicker();
    dp.datepickerObject.from = new Date("January 1, 1907");
    dp.datepickerObject.callback = function (val) {
        if (typeof(val) === 'undefined') {
            // console.log('No date selected');
        } else {
            $scope.datepickerObject.inputDate = val;
            // console.log('Selected date is : ', val)
            $scope.sphere_event.event_date = dp.dateFormat(val);
        }
    }; 
    $scope.datepickerObject = dp.datepickerObject;

    var tp_start = new TimePicker();
    tp_start.timePickerObject.callback= function(val) {
        if (typeof (val) === 'undefined') {
            console.log('Time not selected');
        } else {
            var selectedTime = new Date(val * 1000);
            $scope.sphere_event.event_time_from = tp_start.ampm(selectedTime);
            //console.log('Selected epoch is : ', val, 'and the time is ', selectedTime.getUTCHours(), ':', selectedTime.getUTCMinutes(), 'in UTC');
        }
    }
    $scope.timePickerObject_start = tp_start.timePickerObject;

    var tp_end = new TimePicker();
    tp_end.timePickerObject.callback= function(val) {
        if (typeof (val) === 'undefined') {
            console.log('Time not selected');
        } else {
            var selectedTime = new Date(val * 1000);
            $scope.sphere_event.event_time_to = tp_end.ampm(selectedTime);
            //console.log('Selected epoch is : ', val, 'and the time is ', selectedTime.getUTCHours(), ':', selectedTime.getUTCMinutes(), 'in UTC');
        }
    }
    $scope.timePickerObject_end = tp_end.timePickerObject;

    $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){ 
        if(toState.name == 'app.edit-sphere-event'){ 

            $ionicLoading.show();
            API.getSphere({
                unique_id : $stateParams.id
                },function(data){
                    console.log(data);
                    if(data.Result == 1){
                        $scope.currentsphere =  data.Data;
                        $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                        $rootScope.routeParams.id = $stateParams.id;
                        $rootScope.routeParams.handler = $scope.currentsphere.handle;
                        $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                        $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                        if(data.Data.member_type=='OWNER'){
                        }else if(data.Data.member_type=='MEMBER'){
                        }else{
                            $rootScope.canQuip = false;
                        }
                    }
                    $ionicLoading.hide();
                },function(err){
                    $ionicLoading.hide();
            });
            $scope.sphere_event = {}; 
            $scope.sphere_event["title"] = "";  
            $scope.sphere_event["description"] = "";  
            $scope.sphere_event["event_date"] = ""; 
            $scope.sphere_event["event_time_from"] = "";
            $scope.sphere_event["event_time_from_ampm"] = "";
            $scope.sphere_event["event_time_to"] = "";
            $scope.sphere_event["event_time_to_ampm"] = "";
            $scope.sphere_event["time_zone"] = "";     
            $scope.sphere_event["banner_url"] = "img/no-banner.jpg";
            $scope.sphere_event["b64"] = "img/no-banner.jpg";

            $scope.viewEvent();    
        }
    });

    $scope.viewEvent = function(){ 
        var dataview = {id:$stateParams.id};

        console.log(dataview);
        $ionicLoading.show();
        API.vieweditevent(dataview, function(data){
            $ionicLoading.hide();
            if(data.Result == 1 ){
                console.log(data.Data);
                $scope.sphere_event["title"] = data.Data.title;  
                $scope.sphere_event["description"] = data.Data.description;  
                $scope.sphere_event["event_date"] = data.Data.event_date; 
                $scope.sphere_event["event_time_from"] = data.Data.event_time_from; 
                $scope.sphere_event["event_time_from_ampm"] = data.Data.event_time_from_ampm; 
                $scope.sphere_event["event_time_to"] = data.Data.event_time_to; 
                $scope.sphere_event["event_time_to_ampm"] = data.Data.event_time_to_ampm; 
                $scope.sphere_event["banner_url"] = data.Data.banner_url; 
                $scope.sphere_event["b64"] = data.Data.banner_url;
                $scope.sphere_event["time_zone"] = data.Data.time_zone;   
                $scope.sphere_event["temp_url"] = data.Data.banner_url;
                setTimeout(function(){
                    $scope.sphere_event["time_zone"] = data.Data.time_zone; 
                    $scope.$apply();   
                },250);
                console.log($scope.sphere_event);
            }else{
                console.log("Error!");
            }
            },function(err){

                $ionicLoading.hide();
        });
    }

    $scope.updateSphereEvent = function(){ 
        var sphereBannerURL = '';
        if($scope.sphere_event.temp_url == $scope.sphere_event.b64){
            sphereBannerURL = $scope.sphere_event.temp_url;
        }else if ($scope.sphere_event.b64 != '' && $scope.sphere_event.b64 != "img/no-banner.jpg"){
            //upload file first
             //sphereBannerURL = Constant.QUIPSHERE_API_HOST+ '/images/public/' + $scope.newQpFile ;
             sphereBannerURL = Constant.S3URL_PUBLIC_PATH + $scope.newQpFile ;
            console.log( sphereBannerURL );
            $scope.sendSphereEventBanner($scope.imageLocalPath);
        }  
        if($scope.sphere_event.title === undefined || $scope.sphere_event.title === ""){
            create_failed("Title is required");
        }else if($scope.sphere_event.description === undefined || $scope.sphere_event.description === ""){
            create_failed("Description is required");
        }else{
            var data = {
                banner_url:sphereBannerURL,
                event_id: $stateParams.id,
                title: $scope.sphere_event.title,
                description: $scope.sphere_event.description,
                event_date: $scope.sphere_event.event_date,
                event_time_from: $scope.sphere_event.event_time_from,
                event_time_from_ampm: $scope.sphere_event.event_time_from_ampm,
                event_time_to: $scope.sphere_event.event_time_to,
                event_time_to_ampm: $scope.sphere_event.event_time_to_ampm,
                time_zone:  $scope.sphere_event.time_zone
            };
            console.log(data);
            $ionicLoading.show();
            API.editsphereevent(data, cb_success, cb_error);
        }
    }
    function cb_success(data){
        $ionicLoading.hide();
        if(data.Result == 1 ){
            //success
            create_success(data.Message[0]);
        }else{
            //error
            var msg = data.Message.join("<br/>");
            console.log(data.Message)
            create_failed(msg);
        }
        // console.log(data);
    }
    function cb_error(data){
        console.log(data);
        $ionicLoading.hide();
        // console.log("cb_error");
        // console.log(data);
        create_failed("Something went wrong please try again");
    }

    function create_failed(msg){
        var status = "e";
        var ontap_callback = function(e){
            // console.log(e);
        }
        title = 'Updated Event';
        btn_text = 'Try again';
        $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
    }
    function create_success(msg){
        var status = "s";
        var ontap_callback = function(e){
            // console.log(e);
            $rootScope.goback();  
        }
        title = 'Updated Event';
        btn_text = 'OK';
        $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
    }


    //Upload Logo Image
    $scope.createUploadBanner = function(){
        //$ionicLoading.show();
            
        navigator.camera.getPicture(onSuccessFromGallery, onFailFromGallery, {
            targetWidth: 720,
            targetHeight: 720,
            quality: 72,
            allowEdit: false,
            correctOrientation: true,
            saveToPhotoAlbum: true,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: navigator.camera.PictureSourceType.SAVEDPHOTOALBUM
        });
    };

    $scope.newQpFile = ''; $scope.imageLocalPath = '';

    function onSuccessFromGallery(imageData) {
        // format url and filename
        var qp = imageData.split('/').pop(); var qpFile = qp.split('?'); // get the file
        var qpUrlArr = imageData.split('/'); 
        qpUrlArr.splice(-1,1); 
        var qpUrl = qpUrlArr.join('/')+'/'; // get the folder
        var newQpFile = 'sphere_event_' + $rootScope.user_data.quipper_id + '_' + new Date().getTime()+'.jpg';
        $scope.newQpFile = newQpFile;
        
        // copy the file in quipsphere folder
        $cordovaFile.copyFile(qpUrl, qpFile[0], cordova.file.externalRootDirectory, newQpFile)
            .then(function (success) {
                // display in form
                var imageSource = cordova.file.externalRootDirectory+newQpFile;                                      
                $scope.imageLocalPath =$scope.sphere_event["b64"] = imageSource;


            }, function (error) {
                console.log('error: '+ error);
            });
    }

    function onFailFromGallery(message) {
       // $ionicLoading.hide();            
    }

    $scope.sendSphereEventBanner = function(filePath){
        $timeout(function() {
             var argsP = new Array();
                argsP[0] = '';
                argsP[1] = ".jpg";
                argsP[2] = "fileUpload";
                
                var fileinput = filePath.replace("file:", "");
                QuipsApi.fileUpload( fileinput, argsP,  uploadCallBack );

                //Upload File
                function uploadCallBack(result){
                      // $ionicLoading.hide();
                      //emit msg to end user
                }                
        },500);
    }
})
.controller('SphereReplyCtrl', function($rootScope, $scope, $state, ClockSrv, $ionicScrollDelegate, 
    $ionicSlideBoxDelegate,$ionicLoading,$ionicPopup,
    $stateParams,$ionicPopover, API) {
        $scope.currentsphere = {};
        $scope.parentquip = {};
        $scope.sphere_threads = [];
        $scope.current_playing = '';
        var playedicon = 'img/newsfeed/quip_play_icon_1.png';
        var pausedicon = 'img/newsfeed/quip_pause_icon_1.png';
        var loadingicon = 'img/quip_loading_icon.gif';
        var sphereReplyElement = document.querySelector("#sphere-reply");

        var template = 
        '<ion-popover-view class="sphere-delete-quip" style="width:100px; text-align: center;">'+
        '<div>'+
        '<div class="profile-popover-li" on-tap="" >'+
        '<span>Delete</span><br>'+
        '</div>'+
        '</div>'+
        '</ion-popover-view>';
        $scope.deleteQuip = function(unique_id){
            document.getElementById("sphere-quip-"+unique_id).remove();
            var sphere_arr = [];
            for(var i = 0; i < $scope.sphere_threads.length; i++){
                if($scope.sphere_threads[i].unique_id == unique_id){

                }else{
                    sphere_arr.push($scope.sphere_threads[i]);
                }
            }
            $scope.sphere_threads = sphere_arr;
            API.deleteQuip({
                unique_id : unique_id
                },function(data){
                    console.log(data)
                },function(err){

            });
            $scope.spherePopover.hide();
        }
        function getSphereData(){
            return new Promise( function( resolve, reject ) {
                if (true) {
                    resolve();
                    document.querySelector("#sp-container").style.display = 'none';
                    API.getSphereThreads({
                        sphere_id : $stateParams.sphere_id,
                        quip_id : $stateParams.quip_id,
                        action : 'get_parent',
                        limit:10,
                    },function(data){
                        if(data.Result == 1){
                            window.localStorage['sphere_threads'] = JSON.stringify(data.Data);
                            $scope.sphere_threads = JSON.parse(window.localStorage['sphere_threads']);
                            $scope.stoploadingsphere = false;
                        }
                        console.log('getSphereData');
                        console.log($scope.sphere_threads);
                        setTimeout(function(){
                            document.querySelector("#sp-container").style.display = 'block';
                        },1000)
                    },function(err){
                        console.log(err);
                        setTimeout(function(){
                            document.querySelector("#sp-container").style.display = 'block';
                        },1000)
                    });
                } else {
                    reject();
                }
            } );
        }

        function sphereReplyEvent(e){
            if (e.target !== e.currentTarget) {

                var checktarget = e.target.classList;
                for(var i = 0; i < checktarget.length; i++){
                    splited = checktarget[i].split("_");
                    console.log(splited);
                    if(splited[0] == "sphere"){
                        switch(splited[1]){
                            case "sharequip":
                                var uid = splited[3];
                                console.log(uid);
                                window.plugins.socialsharing.share('Listen to this!', "Listen to this!", null, 'http://quipsphere.com/quip/quipshare.php?quipid=' + uid);
                                break;
                            case "viewoptions":
                                var template = 
                                '<ion-popover-view class="sphere-delete-quip" style="width:100px; text-align: center;">'+
                                '<div>'+
                                '<div class="profile-popover-li" on-tap="deleteQuip(\''+splited[2]+'\')" >'+
                                '<span>Delete</span><br>'+
                                '</div>'+
                                '</div>'+
                                '</ion-popover-view>';

                                $scope.spherePopover = $ionicPopover.fromTemplate(template, {
                                    scope: $scope
                                });
                                $scope.spherePopover.show(e);
                            break;
                            case "imgslider":
                                var imgs = $scope.sphere_threads[splited[2]].quip_images;
                                $rootScope.showImages(imgs);
                            break;
                            case "viewquipper":
                                //console.log(splited[2]);
                                $rootScope.reRoute('go','view profile', 0, {id:splited[2], handler:$scope.currentsphere.handle});
                                $rootScope.goto('app.view-profile',{id:splited[2]});
                            break;
                            case "viewcollection":
                                //console.log(splited[2]);
                                $rootScope.reRoute('go','app.collectionitems', 0, {id:$stateParams.id,collectionid:splited[2], handler:$rootScope.routeParams.handler});
                                $rootScope.goto('app.collectionitems',{id:$stateParams.id,collectionid:splited[2]});
                            break;
                            case "quipmedia":
                                //stop autoplay
                                if($scope.current_playing != ''){
                                    $scope.current_playing.src = playedicon;
                                }

                                for(var i = 0; i < $scope.sphere_threads.length; i++){
                                    if($scope.sphere_threads[i].unique_id == splited[2]){
                                        var quip_media_class = 'auto_play_'+splited[2];
                                        var elems = document.querySelectorAll("."+quip_media_class);
                                        $scope.current_playing = '';

                                        if($scope.sphere_threads[i].is_played == 0){
                                            $scope.quipHeard($scope.sphere_threads[i].uniqid);
                                        }
                                        $scope.sphere_threads[i].is_played = 1;
                                        for(var i = 0; i < elems.length; i++){
                                            e.target = elems[i];
                                        }
                                        if($rootScope.currentMediaId == splited[2]){
                                            if($rootScope.mediaPausedFlag == 0){
                                                e.target.src = playedicon;
                                                $rootScope.media.pause();
                                            }else{
                                                e.target.src = pausedicon;
                                                $rootScope.media.play();
                                            }
                                        }else{
                                            e.target.src = loadingicon;

                                            e.target.classList.remove('play_0');
                                            e.target.classList.add('play_1');
                                            setTimeout(function(){
                                                if($rootScope.currentMediaId != '' && $rootScope.currentMediaId != null){
                                                    e.target.setAttribute('src',playedicon);
                                                }
                                                $rootScope.currentMediaId = splited[2];
                                                $rootScope.media = document.getElementById('quip_audio_src');
                                                $rootScope.media.pause();
                                                $rootScope.media.src = e.target.name;
                                                $rootScope.media.load();
                                                //e.target.src = pausedicon;
                                                $rootScope.quipPlayerItem = e.target; // assign the object to play
                                                // update
                                                $rootScope.sphereQuipUniqueId = splited[2];
                                                $scope.sphere_last_played_id = splited[2];
                                                $scope.current_playing = e.target;
                                                //$scope.reScroll();
                                            },250);
                                        }
                                        return;
                                    }
                                }
                            break;
                            case "thread":
                                $rootScope.reRoute('go','app.sphere-reply', 0, $rootScope.routeParams);
                                $rootScope.selectedtopics.handler = $scope.currentsphere.handle + " " +splited[4];
                                $rootScope.threadParentUniqueId = splited[2];
                                $rootScope.postBackRoute = 'app.sphere-reply';
                                $rootScope.routeParams.id = splited[3];
                                $rootScope.routeParams.handler = $scope.currentsphere.handle;
                                $rootScope.routeParams.quipper_handler = splited[4];
                                $rootScope.goto('app.sphere-reply',{sphere_id:$rootScope.routeParams.id, quip_id:splited[2]});
                            break;
                            case "replythread":
                                if($scope.currentsphere.enable_reply != 1){
                                    var status = "e";
                                    var ontap_callback = function(e){
                                        // console.log(e);
                                    }
                                    var title = 'Cannot Reply';
                                    var btn_text = 'Okay';
                                    var msg = 'Reply Option is disabled'; 
                                    $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                                    return;
                                }
                                if($rootScope.canQuip == false){
                                    $rootScope.CannotQuip();
                                }else{
                                    $rootScope.reRoute('go','recorder');
                                    $rootScope.selectedtopics.handler = $scope.currentsphere.handle + " " +splited[4];
                                    $rootScope.threadParentUniqueId = splited[2];
                                    $rootScope.postBackRoute = 'app.sphere-reply';
                                    $rootScope.routeParams.id = splited[3];
                                    $rootScope.routeParams.handler = $scope.currentsphere.handle;
                                    $rootScope.routeParams.quipper_handler = splited[4];
                                    $rootScope.openRecorderModal();
                                }
                            break;
                            default:
                            break;
                        }
                    }
                    if(splited[0] == "global"){
                        switch(splited[1]){
                            case "viewtopic":
                                    $rootScope.goto('app.home-topics',{id:splited[2]});
                                    break;
                            case 'viewprofile':
                                    $rootScope.goto('app.view-profile',{id:splited[2]});
                                    break;
                            case "viewsphere":
                                    $rootScope.goto('app.sphere',{id:splited[2]});
                                    break;
                            default:break;
                        }
                    }
                    if(splited[0] == 'viewlink'){
                        var a = checktarget[i];
                        var b = a.replace("viewlink_","");
                        window.open(b, '_system', 'location=yes');
                    }
                }

            }
        }

        $scope.quipHeard = function(uniqid){
            // API.sphereQuipPlayed({
            //     uniqid : uniqid
            //     },function(data){
            //         console.log(data);
            //     },function(err){
            // });
        }
        $scope.loadmoreSphereReply = function(){
            console.log('loadmoreSphereReply');
            if($scope.stoploadingsphere === false){
                $scope.stoploadingsphere = true;
                if($scope.sphere_threads.length){
                    document.getElementById("sphereloading").style.display = "block";
                    API.getSphereThreads({
                        sphere_id : $stateParams.sphere_id,
                        quip_id : $stateParams.quip_id,
                        action : 'showmore',
                        limit: 10,
                        end : $scope.sphere_threads[$scope.sphere_threads.length-1].unique_id,
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            if(data.Data.length > 0){
                                for(i = 0; i < data.Data.length; i++){
                                    $scope.sphere_threads.push(data.Data[i]);
                                    $scope.stoploadingsphere = false;
                                }
                            }
                        }
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        document.getElementById("sphereloading").style.display = "none"
                    },function(err){
                        console.log(err);
                        $scope.stoploadingsphere = false;
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        document.getElementById("sphereloading").style.display = "none"
                    });
                    var loadinginficon = document.getElementsByClassName("loading-inf");
                    loadinginficon[0].innerHTML = '<div class="ptrloading" style="display:block"><span id="l1"></span><span id="l2"></span><span id="l3"></span></div>';
                }else{
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    document.getElementById("sphereloading").style.display = "none"
                }
            }
        }

        $scope.$on('getSphereThreads', function(){
            API.getSphereThreads({
                sphere_id : $stateParams.sphere_id,
                quip_id : $stateParams.quip_id,
                action : 'get_parent',
                limit: 10,
            },function(data){
                console.log(data);
                if(data.Result == 1){
                    window.localStorage['sphere_threads'] = JSON.stringify(data.Data);
                    $scope.sphere_threads = JSON.parse(window.localStorage['sphere_threads']);
                    $scope.stoploadingsphere = false;
                }
                PullToRefresh.init({
                    contentEl:"sp-content",
                    ptrEl:"sp-ptr",
                    limittrigger:'sp-container',
                    bodyId:'sp-bodycontainer',
                    loadingFunction: getSphereData,
                    limitscroll: 0
                });
            },function(err){
                console.log(err);
                PullToRefresh.init({
                    contentEl:"sp-content",
                    ptrEl:"sp-ptr",
                    limittrigger:'sp-container',
                    bodyId:'sp-bodycontainer',
                    loadingFunction: getSphereData,
                    limitscroll: 0
                });
            });
        })

        $scope.showPopup3 = function(ontap_callback) {
          $scope.data = {}
        
          // Custom popup
          var myPopup = $ionicPopup.show({
             template: '<input type = "number" ng-model = "data.model" style="text-align:center; background-color:#eee;">',
             title: 'Enter Passcode',
             subTitle: '',
             scope: $scope,
                
             buttons: [
                { text: 'Cancel' }, {
                   text: '<b>Enter</b>',
                   type: 'button-positive',
                      onTap: function(e) {
                            
                         if (!$scope.data.model) {
                            //don't allow the user to close unless he enters model...
                               e.preventDefault();
                         } else {
                            return $scope.data.model;
                         }
                      }
                }
             ]
          });

          return myPopup;
        };
        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){ 
            if(toState.name == 'app.sphere-reply'){
                $scope.sphere_rating = 5;
                $scope.sphere = {};
                $scope.sphere.sphere_id = $stateParams.sphere_id;

                $scope.sphere_threads = [];

                //get sphere
                API.getSphere({
                    unique_id : $stateParams.sphere_id
                },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            $scope.currentsphere =  data.Data;
                            $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                            //$rootScope.routeParams.id = $stateParams.sphere_id;
                            //$rootScope.routeParams.handler = $scope.currentsphere.handle;
                            //$rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            //$rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            if(data.Data.member_type=='OWNER'){
                                // .fromTemplateUrl() method
                                $ionicPopover.fromTemplateUrl('sphere-popover-owner.html', {
                                    scope: $scope
                                }).then(function(popover) {
                                    $scope.spherepopover = popover;
                                });
                            }else if(data.Data.member_type=='MEMBER'){
                                $ionicPopover.fromTemplateUrl('sphere-popover-member.html', {
                                    scope: $scope
                                }).then(function(popover) {
                                    $scope.spherepopover = popover;
                                });
                            }else{

                                $rootScope.canQuip = false;
                                if(window.localStorage['sphere_'+$stateParams.sphere_id] == $scope.currentsphere.passcode){
                                    $rootScope.canQuip = true;
                                }
                                $ionicPopover.fromTemplateUrl('sphere-popover-follower.html', {
                                    scope: $scope
                                }).then(function(popover) {
                                    $scope.spherepopover = popover;
                                });
                                $scope.$on('checkCanQuip', function(){
                                    if(data.Data.member_type=='FOLLOWER'){
                                        if($scope.currentsphere.everyone_may_quip=='N'){
                                            var status = "e";
                                            var ontap_callback = function(e){

                                            }
                                            var title = 'Cannot Quip';
                                            var btn_text = 'Okay';
                                            var msg = 'You cannot quip because you\'re just a follower'; 
                                            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                                        }else{
                                            if($scope.currentsphere.passcode != ""){
                                                $scope.showPopup3().then(function(res) {
                                                    console.log('Tapped!', res);
                                                    if(res != undefined){
                                                        if($scope.currentsphere.passcode == res){
                                                            window.localStorage['sphere_'+$stateParams.id] = res;
                                                            $rootScope.canQuip = true;
                                                            var status = "e";
                                                            var ontap_callback = function(e){
                                                            }
                                                            var title = 'Passcode Valid!';
                                                            var btn_text = 'Okay';
                                                            var msg = 'You may now post quips to this sphere!'; 
                                                            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                                                        }else{
                                                            var status = "e";
                                                            var ontap_callback = function(e){
                                                                // console.log(e);
                                                            }
                                                            var title = 'Invalid Passcode';
                                                            var btn_text = 'Okay';
                                                            var msg = 'You have entered an invalid passcode'; 
                                                            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                                                        }
                                                    }
                                                });   
                                            }else{
                                                $rootScope.canQuip = true;
                                            }
                                        }
                                    }else{
                                        var status = "e";
                                        var ontap_callback = function(e){
                                        }
                                        var title = 'Cannot Quip';
                                        var btn_text = 'Okay';
                                        var msg = 'You cannot quip because you\'re just a visitor'; 
                                        $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                                    }
                                })

                            }

                        }else{
                            $rootScope.goback();  
                        }
                        $ionicLoading.hide();
                },function(err){
                        $rootScope.goback();  
                        $ionicLoading.hide();
                });

                API.getSphereThreads({
                    sphere_id : $stateParams.sphere_id,
                    quip_id : $stateParams.quip_id,
                    action : 'get_parent',
                    limit: 10,
                },function(data){
                    console.log(data);
                    if(data.Result == 1){
                        window.localStorage['sphere_threads'] = JSON.stringify(data.Data);
                        $scope.sphere_threads = JSON.parse(window.localStorage['sphere_threads']);
                        $scope.stoploadingsphere = false;
                    }
                    PullToRefresh.init({
                        contentEl:"sp-content",
                        ptrEl:"sp-ptr",
                        limittrigger:'sp-container',
                        bodyId:'sp-bodycontainer',
                        loadingFunction: getSphereData,
                        limitscroll: 0
                    });
                },function(err){
                    console.log(err);
                    PullToRefresh.init({
                        contentEl:"sp-content",
                        ptrEl:"sp-ptr",
                        limittrigger:'sp-container',
                        bodyId:'sp-bodycontainer',
                        loadingFunction: getSphereData,
                        limitscroll: 0
                    });
                });

            }
        });
        $scope.$on('$ionicView.beforeEnter', function() {
            console.log("adding event listener sphereEvent")
            sphereReplyElement.addEventListener("click", sphereReplyEvent, false);
        }); 
        $scope.$on('$ionicView.afterEnter', function() {

        }); 
        $scope.$on('$ionicView.beforeLeave', function() {
            console.log("adding event listener sphereEvent")
            sphereReplyElement.removeEventListener("click", sphereReplyEvent, false);
        });
        $scope.$on('$ionicView.afterLeave', function() {
            $rootScope.canQuip = true;
        });
})
