angular.module('quipsphere.sphere.controllers', [])
.controller('MysphereCtrl', function($rootScope, $scope, $state, $ionicModal, $timeout,
    $ionicSlideBoxDelegate, $ionicPopover,API, $ionicLoading) {
        var mysphereElement = document.querySelector("#mysphere");
        $scope.$on('$ionicView.beforeEnter', function() {
            console.log("adding event listener mySphereEvent")
            mysphereElement.addEventListener("click", mySphereEvent, false);
            $rootScope.selectedtopics.handler = "";
            $rootScope.threadParentUniqueId = "";
        }); 

        $scope.$on('$ionicView.beforeLeave', function() {
            console.log("removing event listener mySphereEvent")
            mysphereElement.removeEventListener("click", mySphereEvent, false);
        });
        $scope.$on('$ionicView.afterLeave', function() {
            $rootScope.canQuip = true;
        });

        function mySphereEvent(e){
            if (e.target !== e.currentTarget) {
                var checktarget = e.target.classList;
                console.log(checktarget);
                for(var i = 0; i < checktarget.length; i++){
                    splited = checktarget[i].split("_");
                    if(splited[0] == "mysphere"){
                        switch(splited[1]){
                            case "view":
                                $rootScope.threadParentUniqueId = splited[2];
                                $rootScope.reRoute('go','app.sphere', 0, {id:splited[2], handler: splited[3]});
                                $rootScope.goto('app.sphere',{id:splited[2]});
                                break;
                            case "viewevents":
                                $rootScope.threadParentUniqueId = splited[2];
                                $rootScope.reRoute('go','app.sphere-events', 0, {id:splited[2], handler: splited[3]});
                                $rootScope.goto('app.sphere-events',{id:splited[2]});
                                break;
                            default:
                                break;
                        }
                    }
                }

            }
        }


        $scope.myspheres = [];
        $scope.mysphere_array = [];
        $scope.mysphere_events = [];
        $scope.mysphere_events_array = [];
        $scope.h = window.innerHeight;
        $scope.w = window.innerWidth;
        $scope.show_mysphere_slider = false;
        $scope.show_mysphere_events_slider = false;
        $scope.getMysphere = function(){
            $scope.mysphere_array = [];
            $ionicLoading.show();
            API.getSpheres({limit:100},
                function(data){
                    if(data.Result == 1){
                        window.localStorage['myspheres'] = JSON.stringify(data.Data);
                        $scope.myspheres = JSON.parse(window.localStorage['myspheres']);
                        //console.log($scope.myspheres.length);
                        var x = 0;
                        var y = [];
                        for(var i = 0; i < data.Data.length; i++){
                            x++;
                            y.push(data.Data[i]);
                            if(x == 9){
                                $scope.mysphere_array.push(y);
                                x = 0;
                                y = [];
                            }else{
                                if(i+1 == data.Data.length){
                                    $scope.mysphere_array.push(y);
                                    x = 0;
                                    y = [];
                                }
                            }
                            //console.log(i);
                        }
                        //console.log($scope.mysphere_array);
                        $ionicSlideBoxDelegate.$getByHandle('mysphere-slide').update();
                        if($scope.mysphere_array.length != 0){
                            $scope.show_mysphere_slider = true;
                        }
                    }
                        $ionicLoading.hide();
                        setTimeout(function(){
                            $scope.$broadcast('getMySphereEvents');
                        },250)
                },function(err){
                    $ionicLoading.hide();
                    setTimeout(function(){
                        $scope.$broadcast('getMySphereEvents');
                    },250)
            }); 
        }
        $scope.getMysphereEvents = function(){
            $ionicLoading.show();
            $scope.mysphere_events_array = [];
            API.sphereEvents({limit:100},
                function(data){
                    $ionicLoading.hide();
                    //console.log(data);
                    if(data.Result == 1){
                        window.localStorage['myspheres_events'] = JSON.stringify(data.Data);
                        $scope.mysphere_events = JSON.parse(window.localStorage['myspheres_events']);
                        //console.log($scope.mysphere_events.length);
                        var x = 0;
                        var y = [];
                        for(var i = 0; i < data.Data.length; i++){
                            x++;
                            y.push(data.Data[i]);
                            if(x == 3){
                                $scope.mysphere_events_array.push(y);
                                x = 0;
                                y = [];
                            }else{
                                if(i+1 == data.Data.length){
                                    $scope.mysphere_events_array.push(y);
                                    x = 0;
                                    y = [];
                                }
                            }
                            //console.log(i);
                        }
                        $ionicSlideBoxDelegate.$getByHandle('sphere-event-slide').update();
                        if($scope.mysphere_events_array.length != 0){
                            $scope.show_mysphere_events_slider = true;
                        }
                    }
                },function(err){
                    $ionicLoading.hide();
            }); 
        }
        $scope.$on('getMySphere', function(){
            $scope.getMysphere();
        })
        $scope.$on('getMySphereEvents', function(){
            $scope.getMysphereEvents();
        })

        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){
            if(toState.name == 'app.mysphere'){
                $scope.$broadcast('getMySphere');
            }
        });

        // .fromTemplateUrl() method
        $ionicPopover.fromTemplateUrl('mysphere-popover.html', {
            scope: $scope
        }).then(function(popover) {
            $scope.myspherepopover = popover;
        });

        $scope.openMyspherePopover = function($event) {
            $scope.myspherepopover.show($event);
        };
        $scope.closeMyspherePopover = function() {
            $scope.myspherepopover.hide();
        };
        //Cleanup the popover when we're done with it!
        $scope.$on('$destroy', function() {
            $scope.myspherepopover.remove();
        });
        // Execute action on hide popover
        $scope.$on('myspherepopover.hidden', function() {
            // Execute action
        });
        // Execute action on remove popover
        $scope.$on('myspherepopover.removed', function() {
            // Execute action
        });
})
.controller('SphereCtrl', function($rootScope, $scope, $state, ClockSrv, $ionicScrollDelegate, 
    $ionicSlideBoxDelegate,$ionicLoading,
    $stateParams,$ionicPopover, API) {
        $scope.currentsphere = {};
        $scope.sphere = {};
        $scope.sphere.sphere_id = $stateParams.id;
        $scope.newsfeed_spheres = [];
        $scope.sphere_collection_array = [];
        $scope.show_new_count = false;
        $scope.new_count = '';
        var sphereElement = document.querySelector("#sphere");
        var sphere_puller = new ClockSrv();
        var newsfeed_spheres_temp = [];
        $scope.$on('$ionicView.beforeEnter', function() {
            console.log("adding event listener sphereEvent")
            sphereElement.addEventListener("click", sphereEvent, false);
        }); 
        $scope.$on('$ionicView.afterEnter', function() {
            console.log('start clock for fetching');
            sphere_puller.startClock(function(){
                console.log('fetching');
                if($scope.newsfeed_spheres.length != 0){
                    API.getSphereQuipsThread({
                        unique_id : $stateParams.id,
                        limit:100,
                        action:'pull',
                        end: $scope.newsfeed_spheres[0].uniqid
                        },function(data){
                            console.log(data);
                            if(data.Result == 1){

                                if(data.Data.length != 0){
                                    $scope.new_count = (data.Data.length <= 1)?data.Data.length+" new quip":data.Data.length+" new quips";
                                    if($ionicScrollDelegate.$getByHandle('sphereScroll').getScrollPosition().top <= 0){
                                        window.localStorage['newsfeed_sphere'] = JSON.stringify(data.Data.concat($scope.newsfeed_spheres));
                                        $scope.newsfeed_spheres = JSON.parse(window.localStorage['newsfeed_sphere']);
                                    }else{
                                        document.querySelector("#show_sphere_new_quips").style.display="block";
                                        document.querySelector("#show_sphere_new_quips").classList.remove("animate-slide-down");
                                        document.querySelector("#show_sphere_new_quips").classList.add("animate-slide-down");
                                    }
                                }
                            }else{
                            }
                        },function(err){
                    });
                }else{
                    API.getSphereQuipsThread({
                        unique_id : $stateParams.id
                        },function(data){
                            console.log(data);
                            if(data.Result == 1){
                                if(data.Data.length != 0){
                                    $scope.new_count = (data.Data.length <= 1)?data.Data.length+" new quip":data.Data.length+" new quips";
                                    if($ionicScrollDelegate.$getByHandle('sphereScroll').getScrollPosition().top <= 0){
                                        window.localStorage['newsfeed_sphere'] = JSON.stringify(data.Data.concat($scope.newsfeed_spheres));
                                        $scope.newsfeed_spheres = JSON.parse(window.localStorage['newsfeed_sphere']);
                                    }else{
                                        document.querySelector("#show_sphere_new_quips").style.display="block";
                                        document.querySelector("#show_sphere_new_quips").classList.remove("animate-slide-down");
                                        document.querySelector("#show_sphere_new_quips").classList.add("animate-slide-down");
                                    }
                                }
                            }else{
                            }
                        },function(err){
                    });
                }
                },5000);
        }); 
        $scope.$on('$ionicView.beforeLeave', function() {
            console.log('stop clock for fetching');
            sphere_puller.stopClock();

            console.log("adding event listener sphereEvent")
            sphereElement.removeEventListener("click", sphereEvent, false);
        });
        $scope.$on('$ionicView.afterLeave', function() {
            $rootScope.canQuip = true;
        });

        $scope.$on('getSphereThreads', function(){
            console.log('on getSphereThreads');
            $scope.sphereScrollToTop();
        })

        var playedicon = 'img/newsfeed/quip_play_icon_1.png';
        var pausedicon = 'img/newsfeed/quip_pause_icon_1.png';
        var loadingicon = 'img/quip_loading_icon.gif';
        var media = null;
        $rootScope.mediaPausedFlag = 0;
        $rootScope.currentMediaId = '';
        var mediaLoadedFlag = 0;
        var template = 
        '<ion-popover-view class="sphere-delete-quip" style="width:100px; text-align: center;">'+
        '<div>'+
        '<div class="profile-popover-li" on-tap="" >'+
        '<span>Delete</span><br>'+
        '</div>'+
        '</div>'+
        '</ion-popover-view>';

        $scope.spherePopover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });
        console.log('$rootScope.routeStack');
        console.log($rootScope.routeStack);
        function sphereEvent(e){
            if (e.target !== e.currentTarget) {
                var checktarget = e.target.classList;
                for(var i = 0; i < checktarget.length; i++){
                    splited = checktarget[i].split("_");
                    console.log(splited);
                    if(splited[0] == "sphere"){
                        switch(splited[1]){
                            case "viewoptions":
                                var template = 
                                '<ion-popover-view class="sphere-delete-quip" style="width:100px; text-align: center;">'+
                                '<div>'+
                                '<div class="profile-popover-li" on-tap="deleteQuip(\''+splited[2]+'\')" >'+
                                '<span>Delete</span><br>'+
                                '</div>'+
                                '</div>'+
                                '</ion-popover-view>';

                                $scope.spherePopover = $ionicPopover.fromTemplate(template, {
                                    scope: $scope
                                });
                                $scope.spherePopover.show(e);
                                break;

                            case "imgslider":
                                var imgs = $scope.newsfeed_spheres[splited[2]].quip_images;
                                $rootScope.showImages(imgs);
                                break;
                            case "viewquipper":
                                //console.log(splited[2]);
                                $rootScope.reRoute('go','view profile', 0, {id:splited[2], handler:$scope.currentsphere.handle});
                                $rootScope.goto('app.view-profile',{id:splited[2]});
                            break;
                            case "viewcollection":
                                //console.log(splited[2]);
                                $rootScope.reRoute('go','app.collectionitems', 0, {id:$stateParams.id,collectionid:splited[2], handler:$rootScope.routeParams.handler});
                                $rootScope.goto('app.collectionitems',{id:$stateParams.id,collectionid:splited[2]});
                                break;
                            case "quipmedia":
                                if($rootScope.currentMediaId == splited[2]){
                                    if($rootScope.mediaPausedFlag == 0){
                                        e.target.src = playedicon;
                                        media.pause();
                                    }else{
                                        e.target.src = pausedicon;
                                        media.play();
                                    }
                                }else{
                                    if($rootScope.currentMediaId == '' || $rootScope.currentMediaId == null){
                                    }else{
                                        console.log("."+$rootScope.currentMediaId);
                                        var currentPlayerImage = document.querySelectorAll("."+$rootScope.currentMediaId);
                                        for(var i=0;i<currentPlayerImage.length;i++){
                                            currentPlayerImage[i].setAttribute('src',playedicon);
                                        }
                                        e.target.src = loadingicon;
                                    }
                                    $rootScope.currentMediaId = splited[2];
                                    media = document.getElementById('quip_audio_src');
                                    media.pause();
                                    media.src = ''
                                    for(var i = 0; i < $scope.newsfeed_spheres.length; i++){
                                        if($scope.newsfeed_spheres[i].unique_id == splited[2]){
                                            $rootScope.sphereQuipUniqueId = splited[2];
                                            media.src = $scope.newsfeed_spheres[i].quip;
                                            if($scope.newsfeed_spheres[i].is_played == 0){
                                                $scope.newsfeed_spheres[i].is_played = 1;
                                                $scope.quipHeard($scope.newsfeed_spheres[i].uniqid);
                                                $scope.newsfeed_spheres[i].quip_played_count =$scope.newsfeed_spheres[i].quip_played_count + 1;
                                                $scope.newsfeed_spheres[i].quip_played = $scope.newsfeed_spheres[i].quip_played_count + ' heard this quip';
                                            }
                                        }
                                    }
                                    media.load();
                                    e.target.src = pausedicon;
                                }
                                break;
                            case "create":
                                break;
                            default:
                                break;
                        }
                    }
                }

            }
        }
        function mysphereDelete(){
            var msg  = "Are you sure you want to delete this Sphere?";
            var status = "e";     
            var title = "Delete this Sphere";   
            $rootScope.popUp(msg, status, title,  function(e){
                console.log("Delete");
                API.deleteSphere({
                    'unique_id' : $scope.sphere.sphere_id
                    },function(data){
                        if(data.Result == 1){
                            $rootScope.goback();
                        }else{
                            $rootScope.popAlert(
                                'Failed to delete sphere', 
                                'OK',
                                function() {
                            });
                        }   
                    },function(err){
                        $rootScope.popAlert(
                            'Failed to delete sphere', 
                            'OK',
                            function() {
                        });
                })
            });
        }
        function mysphereLeave(){
            var msg  = "Are you sure you want to leave this Sphere?";
            var status = "e";
            var title = "Leave this Sphere";
            $rootScope.popUp(msg, status, title,  function(e){
                console.log("Leave");
            })
        }
        $scope.deleteQuip = function(unique_id){
            document.getElementById("sphere-quip-"+unique_id).remove();
            var sphere_arr = [];
            for(var i = 0; i < $scope.newsfeed_spheres.length; i++){
                if($scope.newsfeed_spheres[i].unique_id == unique_id){

                }else{
                    sphere_arr.push($scope.newsfeed_spheres[i]);
                }
            }
            $scope.newsfeed_spheres = sphere_arr;
            API.deleteQuip({
                unique_id : unique_id
                },function(data){
                    console.log(data)
                },function(err){

            });
            $scope.spherePopover.hide();
        }
        $scope.quipHeard = function(uniqid){
            API.sphereQuipPlayed({
                uniqid : uniqid
                },function(data){
                    console.log(data);
                },function(err){
            });
        }
        $scope.sphereScrollToTop = function(){
            $ionicScrollDelegate.$getByHandle('sphereScroll').scrollTop(true);
            $scope.getLatestSphereThreads();
        }
        $scope.sphereScrollPosition = function(){
            var ssp = $ionicScrollDelegate.$getByHandle('sphereScroll').getScrollPosition().top;
            if(ssp <= 0){
                document.querySelector("#show_sphere_new_quips").style.display="none";
                //$scope.getLatestSphereThreads();
            }else{
                if(newsfeed_spheres_temp.length != 0){
                    document.querySelector("#show_sphere_new_quips").style.display="block";
                    document.querySelector("#show_sphere_new_quips").classList.remove("animate-slide-down");
                    document.querySelector("#show_sphere_new_quips").classList.add("animate-slide-down");
                }
            }
        }
        $scope.pressSphereAction = function(action){
            console.log(action);
            if(action == "DELETE"){
                mysphereDelete();
            }else{
                mysphereLeave();
            }
        }
        $scope.followSphere = function(){
            $scope.currentsphere.followers = parseInt($scope.currentsphere.followers) + 1;
            API.sphereFollowSphere({
                unique_id : $scope.sphere.sphere_id
                },function(data){},function(err){});
            $scope.currentsphere.member_type = 'FOLLOWER';
        }
        $scope.unfollowSphere = function(){
            $scope.currentsphere.followers = parseInt($scope.currentsphere.followers) - 1;
            API.sphereUnfollowSphere({
                unique_id : $scope.sphere.sphere_id
                },function(data){},function(err){});
            $scope.currentsphere.member_type = '';
        }
        $scope.leaveSphere = function(){
            $ionicLoading.show();
            API.sphereUnfollowSphere({
                unique_id : $scope.sphere.sphere_id
                },function(data){
                    $ionicLoading.hide();
                    $rootScope.goback();
                },function(err){
                    $ionicLoading.hide();
                    $rootScope.goback();
            });
        }
        $scope.getSphereThreads = function(){
            $ionicLoading.show();
            API.getSphereQuipsThread({
                unique_id : $stateParams.id
                },function(data){
                    $ionicLoading.hide();
                    console.log(data);
                    if(data.Result == 1){
                        window.localStorage['newsfeed_sphere'] = JSON.stringify(data.Data);
                        $scope.newsfeed_spheres = JSON.parse(window.localStorage['newsfeed_sphere']);
                    }else{
                    }
                },function(err){
                    $ionicLoading.hide();
            });
        }
        $scope.selectsphere = function(){
            console.log($stateParams.id);
            $rootScope.reRoute('go','app.sphereaddcollection', 0, {id:$stateParams.id,collectionid:splited[2], handler:$rootScope.routeParams.handler});
            $rootScope.goto('app.sphereaddcollection',{id:$stateParams.id});
        }
        $scope.getLatestSphereThreads =function(){
            if($scope.newsfeed_spheres.length != 0){
                $ionicLoading.show();
                API.getSphereQuipsThread({
                    unique_id : $stateParams.id,
                    limit:100,
                    action:'pull',
                    end: $scope.newsfeed_spheres[0].uniqid
                    },function(data){
                        $ionicLoading.hide();
                        console.log(data);
                        if(data.Result == 1){
                            if(data.Data.length != 0){
                                window.localStorage['newsfeed_sphere'] = JSON.stringify(data.Data.concat($scope.newsfeed_spheres));
                                $scope.newsfeed_spheres = JSON.parse(window.localStorage['newsfeed_sphere']);
                            }
                        }
                    },function(err){
                        $ionicLoading.hide();
                });
            }else{
                $scope.getSphereThreads();
            }
        }

        function getSphereData(){
            return new Promise( function( resolve, reject ) {
                if (true) {
                    resolve();
                    
                } else {
                    reject();
                }
            } );
        }

        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){ 
            if(toState.name == 'app.sphere'){
                $scope.sphere_rating = 5;
                $scope.sphere = {};
                $scope.sphere.sphere_id = $stateParams.id;

                $scope.newsfeed_spheres = [];

                $ionicLoading.show();

                 PullToRefresh.init({
                    contentEl:"sp-content",
                    ptrEl:"sp-ptr",
                    limittrigger:'sp-container',
                    bodyId:'sp-bodycontainer',
                    loadingFunction: getSphereData,
                    limitscroll: 0
                });
                 
                //get sphere
                API.getSphere({
                    unique_id : $stateParams.id
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            $scope.currentsphere =  data.Data;
                            $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                            $rootScope.routeParams.id = $stateParams.id;
                            $rootScope.routeParams.handler = $scope.currentsphere.handle;
                            $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            if(data.Data.member_type=='OWNER'){
                                // .fromTemplateUrl() method
                                $ionicPopover.fromTemplateUrl('sphere-popover-owner.html', {
                                    scope: $scope
                                }).then(function(popover) {
                                    $scope.spherepopover = popover;
                                });
                            }else if(data.Data.member_type=='MEMBER'){
                                $ionicPopover.fromTemplateUrl('sphere-popover-member.html', {
                                    scope: $scope
                                }).then(function(popover) {
                                    $scope.spherepopover = popover;
                                });
                            }else{
                                $rootScope.canQuip = false;
                                $ionicPopover.fromTemplateUrl('sphere-popover-follower.html', {
                                    scope: $scope
                                }).then(function(popover) {
                                    $scope.spherepopover = popover;
                                });
                            }
                        }
                        $ionicLoading.hide();
                    },function(err){
                        $ionicLoading.hide();
                });

                $scope.getSphereThreads();

                API.sphereCollectionSlide({
                    sphere_unique_id : $stateParams.id
                    },function(data){
                        $ionicLoading.hide();
                        if(data.Result == 1){
                            $scope.sphere_collection_array = data.Data;
                            $ionicSlideBoxDelegate.$getByHandle('sphere-slider-collection-handle').update();
                        }
                    },function(err){
                        $ionicLoading.hide();
                });

                $scope.openSpherePopover = function($event) {
                    $scope.spherepopover.show($event);
                };
                $scope.closeSpherePopover = function() {
                    console.log('close')
                    $scope.spherepopover.hide();
                };
                //Cleanup the popover when we're done with it!
                $scope.$on('$destroy', function() {
                    $scope.spherepopover.remove();
                });
                // Execute action on hide popover
                $scope.$on('spherepopover.hidden', function() {
                    // Execute action
                });
                // Execute action on remove popover
                $scope.$on('spherepopover.removed', function() {
                    // Execute action
                });
            }
        });
})
.controller('SphereaddcollectionCtrl', function($rootScope, $ionicLoading, $scope, $state, 
    $ionicModal, $timeout, $stateParams,
    $ionicPopover,API) { //ADD to kolek


        //console.log($stateParams.id);

        var sphereAddCollectionElement = document.querySelector("#sphere-add-collection");
        $scope.$on('$ionicView.beforeEnter', function() {
            sphereAddCollectionElement.addEventListener("click", sphereAddCollectionEvent, false);
        }); 

        $scope.$on('$ionicView.beforeLeave', function() {
            sphereAddCollectionElement.removeEventListener("click", sphereAddCollectionEvent, false);
        });

        $scope.$on('$ionicView.afterLeave', function() {
            $rootScope.canQuip = true;
        });

        var playedicon = 'img/newsfeed/quip_play_icon_1.png';
        var pausedicon = 'img/newsfeed/quip_pause_icon_1.png';
        var loadingicon = 'img/quip_loading_icon.gif';
        var media = null;
        $scope.collection_list = [];
        $rootScope.mediaPausedFlag = 0;
        $rootScope.currentMediaId = '';
        var mediaLoadedFlag = 0;
        function sphereAddCollectionEvent(e){
            if (e.target !== e.currentTarget) {
                var checktarget = e.target.classList;
                for(var i = 0; i < checktarget.length; i++){
                    splited = checktarget[i].split("_");
                    if(splited[0] == "sphere"){
                        switch(splited[1]){
                            case "viewoptions":
                                var template = 
                                '<ion-popover-view class="sphere-delete-quip" style="width:100px; text-align: center;">'+
                                '<div>'+
                                '<div class="profile-popover-li" on-tap="deleteQuip(\''+splited[2]+'\')" >'+
                                '<span>Delete</span><br>'+
                                '</div>'+
                                '</div>'+
                                '</ion-popover-view>';

                                $scope.spherePopover = $ionicPopover.fromTemplate(template, {
                                    scope: $scope
                                });
                                $scope.spherePopover.show(e);
                                break;

                            case "viewcollection":
                                $rootScope.reRoute('go','app.collectionitems', 0, {id:$stateParams.id,collectionid:splited[2], handler:$rootScope.routeParams.handler});
                                $rootScope.goto('app.collectionitems',{id:$stateParams.id,collectionid:splited[2]});
                                break;
                            case "quipmedia":
                                if($rootScope.currentMediaId == splited[2]){
                                    if($rootScope.mediaPausedFlag == 0){
                                        e.target.src = playedicon;
                                        media.pause();
                                    }else{
                                        e.target.src = pausedicon;
                                        media.play();
                                    }
                                }else{
                                    if($rootScope.currentMediaId == '' || $rootScope.currentMediaId == null){
                                    }else{
                                        console.log("."+$rootScope.currentMediaId);
                                        var currentPlayerImage = document.querySelectorAll("."+$rootScope.currentMediaId);
                                        for(var i=0;i<currentPlayerImage.length;i++){
                                            currentPlayerImage[i].setAttribute('src',playedicon);
                                        }
                                        e.target.src = loadingicon;
                                    }
                                    $rootScope.currentMediaId = splited[2];
                                    media = document.getElementById('quip_audio_src');
                                    media.pause();
                                    media.src = ''
                                    for(var i = 0; i < $scope.newsfeed_spheres.length; i++){
                                        if($scope.newsfeed_spheres[i].unique_id == splited[2]){
                                            $rootScope.sphereQuipUniqueId = splited[2];
                                            media.src = $scope.newsfeed_spheres[i].quip;
                                            if($scope.newsfeed_spheres[i].is_played == 0){
                                                $scope.newsfeed_spheres[i].is_played = 1;
                                                $scope.quipHeard($scope.newsfeed_spheres[i].uniqid);
                                                $scope.newsfeed_spheres[i].quip_played_count =$scope.newsfeed_spheres[i].quip_played_count + 1;
                                                $scope.newsfeed_spheres[i].quip_played = $scope.newsfeed_spheres[i].quip_played_count + ' heard this quip';
                                            }
                                        }
                                    }
                                    media.load();
                                    e.target.src = pausedicon;
                                }
                                break;
                            case "create":
                                break;
                            default:
                                break;
                        }
                    }
                }

            }
        }
        function isInArray(value, array) {
            return array.indexOf(value) > -1;
        }
        var quipids_array = [];

        $scope.quipHeard = function(uniqid){
            API.sphereQuipPlayed({
                uniqid : uniqid
                },function(data){
                    console.log(data);
                },function(err){
            });
        }
        $scope.addCollection = function(collectionid){ 

            if( document.getElementById(collectionid).style.opacity == 1){
                document.getElementById(collectionid).style.opacity = 0;

                var selected_flag = isInArray(collectionid,quipids_array); 

                if(selected_flag === true){ // existing

                    // Find and remove item from an array
                    var i = quipids_array.indexOf(collectionid);
                    if(i != -1) {
                        quipids_array.splice(i, 1);
                    }
                    console.log(quipids_array);
                }

            }else{
                document.getElementById(collectionid).style.opacity = 1;

                var selected_flag = isInArray(collectionid,quipids_array); 

                if(selected_flag === false){ // add if not existing
                    quipids_array.push(collectionid);
                }

                console.log(quipids_array);
            }

        }

        $scope.getSphereThreads = function(){
            $ionicLoading.show();
            API.getSphereQuipsThread({
                unique_id : $stateParams.id
                },function(data){
                    $ionicLoading.hide();
                    console.log(data);
                    if(data.Result == 1){
                        $scope.newsfeed_spheres = data.Data;
                        //window.localStorage['newsfeed_sphere'] = JSON.stringify(data.Data);
                        //$scope.newsfeed_spheres = JSON.parse(window.localStorage['newsfeed_sphere']);
                    }else{
                    }
                },function(err){
                    $ionicLoading.hide();
            });
        }

        $scope.AddinSectedColl = function(colid){
            $scope.colid = colid;

            if($scope.quipids == ""){
                create_failed("Please select Quip");
            }else{
                $ionicLoading.show();
                var data = {
                    quipids_array: quipids_array.join("|"),
                    unique_id:$stateParams.id,
                    collectionid:colid
                };
                //console.log(data);
                $ionicLoading.show();
                API.AddinCollection(data, cb_success, cb_error);
                console.log(data);
            }
        }
        function cb_success(data){
            $ionicLoading.hide();
            if(data.Result == 1 ){
                //success
                create_success(data.Message[0]);
            }else{
                //error
                var msg = data.Message.join("<br/>");
                console.log(data.Message)
                create_failed(msg);
            }
            // console.log(data);
        }
        function cb_error(data){
            $ionicLoading.hide();
            // console.log("cb_error");
            // console.log(data);
            create_failed("Something went wrong please try again");
        }

        function create_failed(msg){
            var status = "e";
            var ontap_callback = function(e){
                // console.log(e);
            }
            title = 'Add Quip in Collection';
            btn_text = 'Try again';
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }

        function create_success(msg){
            var status = "s";
            var ontap_callback = function(e){
                //console.log(e);

                $rootScope.reRoute('go','app.collectionitems', 0, {id:$stateParams.id,collectionid:$scope.colid, handler:$rootScope.routeParams.handler});
                $rootScope.goto('app.collectionitems',{id:$stateParams.id,collectionid:$scope.colid});
            }
            title = 'Add Quip in Collection';
            btn_text = 'OK';
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }

        var template = '<ion-popover-view class="collectionpopover"></ion-popover-view>';

        $scope.collectionpopover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });
        $scope.noCollection = function () {
            var status = "e";
            var ontap_callback = function(e){
                // console.log(e);
            }
            var title = 'No Collection';
            var btn_text = 'OK';
            var msg = 'You have no collection'; 
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }
        //get Collectionlist
        $scope.getListofCollections = function(){ 
            $ionicLoading.show();
            API.getCollections({
                creatorquipperid:$rootScope.user_data.quipper_id,
                sphere_unid:$stateParams.id,
                },function(data){
                    $ionicLoading.hide();
                    console.log(data);
                    if(data.Result == 1){
                        var template = '<ion-popover-view class="collectionpopover">'+
                        '<div>';
                        for(var i = 0; i < data.Data.length; i++){
                            template = template + '<div class="collection-popover-li" on-tap="AddinSectedColl(\''+data.Data[i].collectionid+'\'); closeCollectionlistPopover()" >'+
                            '<span class="collectiontitle">'+data.Data[i].title+'</span><br>'+
                            '</div>';
                        }
                        template = template + '</div>'+
                        '</ion-popover-view>';
                        $scope.collection_list = data.Data;
                        $scope.collectionpopover = $ionicPopover.fromTemplate(template, {
                            scope: $scope
                        });

                    }
                },function(err){
                    $ionicLoading.hide();
            });
        }

        //$scope.getListofCollections();
        //$scope.getSphereThreads();


        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){
            if(toState.name == 'app.sphereaddcollection'){

                //console.log($scope.getSphereThreads());
                $ionicLoading.show();
                API.getSphere({
                    unique_id : $stateParams.id
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            $scope.currentsphere =  data.Data;
                            $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                            $rootScope.routeParams.id = $stateParams.id;
                            $rootScope.routeParams.handler = $scope.currentsphere.handle;
                            $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            if(data.Data.member_type=='OWNER'){
                            }else if(data.Data.member_type=='MEMBER'){
                            }else{
                                $rootScope.canQuip = false;
                            }
                        }
                        $ionicLoading.hide();
                    },function(err){
                        $ionicLoading.hide();
                });

                $scope.getListofCollections();
                $scope.getSphereThreads();
                $scope.openCollectionlistPopover = function($event) {
                    $scope.collectionpopover.show($event);
                };

                $scope.closeCollectionlistPopover = function($event) {
                    $scope.collectionpopover.hide($event);
                };

                // Execute action on hide popover
                $scope.$on('collectionpopover.hidden', function() {
                    // Execute action
                });
                // Execute action on remove popover
                $scope.$on('collectionpopover.removed', function() {
                    // Execute action
                });

            }
        });
})
.controller('SpherecollectionCtrl', function($rootScope, $scope, $state, $timeout, $stateParams,
    $ionicPopover,API,$ionicLoading) {
        //console.log($rootScope.user_data.quipper_id);

        $scope.createcollection = function(){
            console.log($rootScope.routeParams.handler);
            $rootScope.reRoute('go','app.sphereaddcollection', 0, {id:$stateParams.id,handler:$rootScope.routeParams.handler});
            $rootScope.goto('app.createcollections',{id:$stateParams.id});
        }
        $scope.previouspage = function(){
            $rootScope.goback();
        }

        var parentelement = document.getElementById('sphere-collection-parent');
        $scope.$on('$ionicView.beforeEnter', function() {
            parentelement.addEventListener('click', collectionEvent, false);
        }); 

        $scope.$on('$ionicView.beforeLeave', function() {
            var parentelement = document.getElementById('sphere-collection-parent');
            parentelement.removeEventListener('click', collectionEvent, false);
        });

        $scope.$on('$ionicView.afterLeave', function() {
            $rootScope.canQuip = true;
        });

        function collectionEvent(e) {

            if (e.target !== e.currentTarget) {
                var checktarget = e.target.className;
                console.log(checktarget);
                splited = checktarget.split("_");
                if(splited[0]=='collections'){
                    switch(splited[1]){
                        case "viewcollection":
                            $rootScope.reRoute('go','app.collectionitems', 0, {id:$stateParams.id,collectionid:splited[2], handler:$rootScope.routeParams.handler});
                            $rootScope.goto('app.collectionitems',{id:$stateParams.id,collectionid:splited[2]});
                            break;
                        default:break;
                    }
                }
            }
            e.stopPropagation();
        } 

        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){

            if(toState.name == 'app.spherecollections'){
                $ionicLoading.show();
                API.getSphere({
                    unique_id : $stateParams.id
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            $scope.currentsphere =  data.Data;
                            $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                            $rootScope.routeParams.id = $stateParams.id;
                            $rootScope.routeParams.handler = $scope.currentsphere.handle;
                            $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            if(data.Data.member_type=='OWNER'){
                            }else if(data.Data.member_type=='MEMBER'){
                            }else{
                                $rootScope.canQuip = false;
                            }
                        }
                        $ionicLoading.hide();
                    },function(err){
                        $ionicLoading.hide();
                });


                API.getCollections({
                    creatorquipperid:$rootScope.user_data.quipper_id,
                    sphere_unid:$stateParams.id
                    }, function(data){
                        $ionicLoading.hide();
                        console.log(data);
                        if(data.Result == 1){
                            $scope.collectionlist = data.Data;
                        }      
                    }, function(err){
                        $ionicLoading.hide();
                });

            }

        });
})
.controller('CollectionitemsCtrl', function($rootScope,  $ionicLoading, $scope, $state, $timeout,$stateParams,
    $ionicPopover,API) { //aytems


        var sphereCollectionItemsElement = document.querySelector("#sphere-collection-items");
        $scope.$on('$ionicView.beforeEnter', function() {
            sphereCollectionItemsElement.addEventListener("click", sphereCollectionItemsEvent, false);
        }); 

        $scope.$on('$ionicView.beforeLeave', function() {
            sphereCollectionItemsElement.removeEventListener("click", sphereCollectionItemsEvent, false);
        });

        $scope.$on('$ionicView.afterLeave', function() {
            $rootScope.canQuip = true;
        });

        var playedicon = 'img/newsfeed/quip_play_icon_1.png';
        var pausedicon = 'img/newsfeed/quip_pause_icon_1.png';
        var loadingicon = 'img/quip_loading_icon.gif';
        var media = null;
        $rootScope.mediaPausedFlag = 0;
        $rootScope.currentMediaId = '';
        var mediaLoadedFlag = 0;
        function sphereCollectionItemsEvent(e){
            if (e.target !== e.currentTarget) {
                var checktarget = e.target.classList;
                for(var i = 0; i < checktarget.length; i++){
                    splited = checktarget[i].split("_");
                    if(splited[0] == "sphere"){
                        switch(splited[1]){
                            case "viewoptions":
                                var template = 
                                '<ion-popover-view class="sphere-delete-quip" style="width:100px; text-align: center;">'+
                                '<div>'+
                                '<div class="profile-popover-li" on-tap="deleteQuip(\''+splited[2]+'\')" >'+
                                '<span>Delete</span><br>'+
                                '</div>'+
                                '</div>'+
                                '</ion-popover-view>';

                                $scope.spherePopover = $ionicPopover.fromTemplate(template, {
                                    scope: $scope
                                });
                                $scope.spherePopover.show(e);
                                break;
                            case "viewcollection":
                                $rootScope.reRoute('go','app.collectionitems', 0, {id:$stateParams.id,collectionid:splited[2], handler:$rootScope.routeParams.handler});
                                $rootScope.goto('app.collectionitems',{id:$stateParams.id,collectionid:splited[2]});
                                break;
                            case "quipmedia":
                                if($rootScope.currentMediaId == splited[2]){
                                    if($rootScope.mediaPausedFlag == 0){
                                        e.target.src = playedicon;
                                        media.pause();
                                    }else{
                                        e.target.src = pausedicon;
                                        media.play();
                                    }
                                }else{
                                    if($rootScope.currentMediaId == '' || $rootScope.currentMediaId == null){
                                    }else{
                                        console.log("."+$rootScope.currentMediaId);
                                        var currentPlayerImage = document.querySelectorAll("."+$rootScope.currentMediaId);
                                        for(var i=0;i<currentPlayerImage.length;i++){
                                            currentPlayerImage[i].setAttribute('src',playedicon);
                                        }
                                        e.target.src = loadingicon;
                                    }
                                    $rootScope.currentMediaId = splited[2];
                                    media = document.getElementById('quip_audio_src');
                                    media.pause();
                                    media.src = ''
                                    for(var i = 0; i < $scope.quipsincollection.length; i++){
                                        if($scope.quipsincollection[i].unique_id == splited[2]){
                                            $rootScope.sphereQuipUniqueId = splited[2];
                                            media.src = $scope.quipsincollection[i].quip;
                                            if($scope.quipsincollection[i].is_played == 0){
                                                $scope.quipsincollection[i].is_played = 1;
                                                $scope.quipHeard($scope.quipsincollection[i].uniqid);
                                                $scope.quipsincollection[i].quip_played_count =$scope.quipsincollection[i].quip_played_count + 1;
                                                $scope.quipsincollection[i].quip_played = $scope.quipsincollection[i].quip_played_count + ' heard this quip';
                                            }
                                        }
                                    }
                                    media.load();
                                    e.target.src = pausedicon;
                                }
                                break;
                            case "create":
                                break;
                            default:
                                break;
                        }
                    }
                }

            }
        }

        //console.log($stateParams.collectionid);
        $scope.getCollecton = function(){
            $ionicLoading.show();
            API.getCollection({
                collectionid:$stateParams.collectionid,
                }, function(data){
                    $ionicLoading.hide();
                    console.log(data);
                    if(data.Result == 1){
                        $scope.collection = data.Data;
                    }      
                }, function(err){
                    $ionicLoading.hide();

            });
        }

        $scope.getQuipsincollections = function(){
            $ionicLoading.show();
            API.getQuipsincollection({
                collectionid:$stateParams.collectionid,
                }, function(data){
                    console.log(data);
                    if(data.Result == 1){
                        $scope.quipsincollection = data.Data;
                    }      
                    $ionicLoading.hide();
                }, function(err){
                    $ionicLoading.hide();
            });

        }
        $scope.deleteSphereCollection = function(){
            //console.log($stateParams.id);

              var collectionid  = $stateParams.collectionid;
              var creator_quipperid  = $rootScope.me_quipperid;
              var unique_id  = $stateParams.id;

            $ionicLoading.show();
             API.deletesphereCollection({
                 collectionid: collectionid,
                creator_quipperid : creator_quipperid
                },function(data){ 
                   $ionicLoading.hide();
                   
                    //$rootScope.reRoute('go','app.spherecollections', 0, {id:$stateParams.id, handler:$rootScope.routeParams.handler});
                   $rootScope.goto('app.spherecollections/'+unique_id);
                },function(err){
                    $ionicLoading.hide();
            })


        }

        $scope.deleteQuipCollectionitem = function(unique_id){
             $ionicLoading.show();
            document.getElementById("sphere-quip-"+unique_id).remove();
            var sphere_arr = [];
            for(var i = 0; i < $scope.quipsincollection.length; i++){
                if($scope.quipsincollection[i].unique_id == unique_id){

                }else{
                    sphere_arr.push($scope.quipsincollection[i]);
                }
            }
            //console.log($stateParams.id);
            $scope.newsfeed_spheres = sphere_arr;
            API.deletequipCollectionitem({
                'collectionid': $stateParams.collectionid,
                'unique_id' : unique_id,                
                },function(data){
                    console.log(data)
                    // $ionicLoading.hide();
                },function(err){
                    //$ionicLoading.hide();


            });
            $scope.spherePopover.hide();
            $scope.collectionitemPopover.hide();
        }


       $ionicPopover.fromTemplateUrl('sphere-collection-popover.html', {
            scope: $scope
        }).then(function(popover) {
            $scope.collectionitemPopover = popover;
        });


        $scope.openCollectionitemPopover = function($event) {
            $scope.collectionitemPopover.show($event);
        };
        $scope.closeCollectionItemPopover = function() {
            //console.log('close')
            $scope.collectionitemPopover.hide();
        };
        //Cleanup the popover when we're done with it!
        $scope.$on('$destroy', function() {
            $scope.spherepopover.remove();
        });
        // Execute action on hide popover
        $scope.$on('spherepopover.hidden', function() {
        // Execute action
        });
        // Execute action on remove popover
        $scope.$on('spherepopover.removed', function() {
        // Execute action
        });

        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){

            if(toState.name == 'app.collectionitems'){

                $ionicLoading.show();
                API.getSphere({
                    unique_id : $stateParams.id
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            $scope.currentsphere =  data.Data;
                            $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                            $rootScope.routeParams.id = $stateParams.id;
                            $rootScope.routeParams.handler = $scope.currentsphere.handle;
                            $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            if(data.Data.member_type=='OWNER'){
                            }else if(data.Data.member_type=='MEMBER'){
                            }else{
                                $rootScope.canQuip = false;
                            }
                        }
                        $ionicLoading.hide();
                    },function(err){
                        $ionicLoading.hide();
                });
                $scope.getCollecton();
                $scope.getQuipsincollections();

            }
        });
})
.controller('CreatecollectionCtrl', function($scope, $rootScope, $ionicPopover, $stateParams, 
    $timeout, $ionicActionSheet, $ionicHistory, 
    $state, CameraService, API, $ionicLoading, $log, Constant, $cordovaFile, $cordovaFileTransfer, $timeout, $ionicModal,
    $ionicSlideBoxDelegate, $ionicScrollDelegate  ) {

        $scope.collection = {};     
        $scope.collection["b64"] = "img/no-banner.jpg";

        $scope.fileNameChanged = function(){
            $ionicLoading.show();
            var f = document.getElementById("create-sphere-collection-banner").files[0],
            r = new FileReader();
            r.onloadend = function(e) { //callback after files finish loading
                $scope.collection.b64 = e.target.result;
                $scope.$apply();
                $ionicLoading.hide();
                //here you can send data over your server as desired
            }
            r.readAsDataURL(f); //once defined all callbacks, begin reading the file
        }

        $scope.tapFile = function(){
            document.getElementById("create-sphere-collection-banner").click();
        }

        function ImageExist(url) 
        {
            var img = new Image();
            img.src = url;
            return img.height != 0;
        }


        $scope.banner_picture = 'img/banner.jpg?'+ new Date().getTime();
        console.log($scope.banner_picture);
        // if (window.localStorage['collection_banner']){
        //     imageURI =  window.localStorage['collection_banner'];
        //     var image = document.getElementById('collection-banner');    

        //     if (ImageExist(imageURI)){                
        //         $scope.banner_picture = imageURI;
        //         image.src = $scope.banner_picture;
        //     }else{
        //         $scope.banner_picture = 'http://api.quipsphere.com/GetImagebanner.php?pictype=collection&file='+$rootScope.user_data.quipper_id+'.jpg?'+ new Date().getTime();
        //         image.src = $scope.banner_picture;
        //     }
        // }

        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){
            if(toState.name == 'app.createcollection'){

                $ionicLoading.show();
                API.getSphere({
                    unique_id : $stateParams.id
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            $scope.currentsphere =  data.Data;
                            $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                            $rootScope.routeParams.id = $stateParams.id;
                            $rootScope.routeParams.handler = $scope.currentsphere.handle;
                            $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            if(data.Data.member_type=='OWNER'){
                            }else if(data.Data.member_type=='MEMBER'){
                            }else{
                                $rootScope.canQuip = false;
                            }
                        }
                        $ionicLoading.hide();
                    },function(err){
                        $ionicLoading.hide();
                });
                /*imageURI =  window.localStorage['collection_banner'];
                var image = document.getElementById('collection-banner');    
                $scope.banner_picture = 'img/banner.jpg?'+ new Date().getTime();
                image.src = $scope.banner_picture;
                if (ImageExist(imageURI)){                        
                //$scope.profile_picture = 'file:///storage/sdcard0/quipsphere/'+$rootScope.user_data.quipper_id+'.jpg';
                $scope.banner_picture = imageURI;
                image.src = $scope.banner_picture;
                }else{
                $scope.banner_picture = 'http://api.quipsphere.com/GetImagebanner.php?pictype=collection&file='+$rootScope.user_data.quipper_id+'.jpg?'+ new Date().getTime();
                image.src = $scope.banner_picture;
                }
                //$scope.profile_picture = Constant.QUIPSHERE_API_HOST+'/uploads/profilepic/'+$rootScope.user_data.quipper_id+'.jpg?'+new Date().getTime();
                submitbtn = document.getElementById('avatar-submit-container');
                submitbtn.style.display = "none";*/
            }
        });

        $scope.addBanner = function(){   
            if(quipDebug == 0){
                if($scope.quipPhotosTempArr.length > 2 ){
                    $rootScope.popAlert(
                        'You can only add maximum of three(3) photos.', null,'Quip Capture Photo', 'OK',function() {}
                    );
                }else{
                    navigator.camera.getPicture(onSuccessUploadBanner, onFailUploadBanner, {
                        targetWidth: 720,
                        targetHeight: 720,
                        quality: 72,
                        allowEdit: false,
                        correctOrientation: true,
                        saveToPhotoAlbum: true,
                        destinationType: Camera.DestinationType.FILE_URI,
                        sourceType: navigator.camera.PictureSourceType.SAVEDPHOTOALBUM
                    });
                }
            }else{
                if($scope.quipPhotosTempArr.length == 2){ successUploadPhoto('img/bg2.jpg'); }
                if($scope.quipPhotosTempArr.length == 1){ successUploadPhoto('img/bg-img.jpg'); }
                if($scope.quipPhotosTempArr.length == 0){ successUploadPhoto('img/c1.jpg'); }
            } 
        }

        var successUploadPhoto = function (imageURI) {
            var qp = imageURI.split('/').pop();
            $scope.quipPhotosTempArr.push(imageURI);
            var imageIndex = $scope.quipPhotosTempArr.length-1;

            var qpPhotoSrc = '<div class="qppd_'+(imageIndex)+'"><img src="'+imageURI+'" class="qpp_'+imageIndex+'" ></div>';
            $scope.quipPhotoContainer = $scope.quipPhotoContainer + qpPhotoSrc;
            $scope.quipPhotoContainerDiv = $scope.quipPhotoContainer;
            $scope.addQuipPhotos(imageURI,imageIndex);
        }

        // format photo display
        $scope.addQuipPhotos = function(imageURI,imageIndex){
            $timeout(function() {
                xht = $('.qpp_'+imageIndex).height();
                xwd = $('.qpp_'+imageIndex).width();
                if(xht <= xwd){
                    $rootScope.quipPhotoContainerArrHgt.push('100%');
                    $rootScope.quipPhotoContainerArrWdt.push('auto');
                }else{
                    $rootScope.quipPhotoContainerArrHgt.push('auto');
                    $rootScope.quipPhotoContainerArrWdt.push('100%');
                }
                $rootScope.quipPhotoContainerArrSrc.push(imageURI);
                $('#quip_photo_box_out').html('');
                ctr = 0;
                $rootScope.quipPhotoContainerArrSrc.forEach(function(entry){
                    var qpPhotoSrc = '<div class="qppd_'+(ctr)+'" title="'+ctr+'"><img src="'+entry+'" class="qpp_'+ctr+'" style="width:'+$rootScope.quipPhotoContainerArrWdt[ctr]+';height:'+$rootScope.quipPhotoContainerArrHgt[ctr]+';" title="'+ctr+'"></div>';
                    $('#quip_photo_box_out').append(qpPhotoSrc);
                    ctr++;
                });
                $ionicLoading.hide();
                },300);
        }

        function onSuccessUploadBanner(imageData) {
            var qp = imageData.split('/').pop(); var qpFile = qp.split('?'); // get the file
            var qpUrlArr = imageData.split('/'); qpUrlArr.splice(-1,1); var qpUrl = qpUrlArr.join('/')+'/'; // get the folder
            var newQpFile = "avatar_"+new Date().getTime()+'.jpg';
            // copy the file in quipsphere folder
            $cordovaFile.copyFile(qpUrl, qpFile[0], cordova.file.externalRootDirectory+'Quipsphere/', newQpFile)
            .then(function (success) {
                var imageSource = cordova.file.externalRootDirectory+'Quipsphere/'+newQpFile;
                $scope.banner_picture = imageSource;
                window.localStorage['collection_banner'] = imageSource;

                $timeout(function(){
                    $ionicLoading.hide();
                    },700);
                }, function (error) {
                    $log.error('error: '+error);
                    $ionicLoading.hide();
            });
        }

        function onFailUploadBanner(message) {
            $ionicLoading.hide();
            $log.error('Failed because: ' + message);
        }

        $scope.submitPhoto = function(){
            var imgEl = document.getElementById('collection-banner');
            fileURL = imgEl.src;
            var fileinput = fileURL.replace("file:", "");

            function uploadCallBack(result){
                var imgEl = document.getElementById('collection-banner');
                fileURL = imgEl.src;
                window.localStorage['collection_banner']  = fileURL;

                $rootScope.goto('app.createcollection',{});
            }

            var args = new Array();
            args[0] = window.localStorage['quipper_id'] ;
            args[1] = ".jpg";

            QuipsApi.uploadFile(fileinput, args, uploadCallBack);
        };


        // photo slide show
        $scope.showBannerSlide = function(index) {
            $rootScope.slideIndex = index;
            $ionicSlideBoxDelegate.slide(0);
            $scope.photoModal.show();
            $timeout(function() {
                $ionicSlideBoxDelegate.slide(index);
                $timeout(function() {
                    },500);
                },300);
        }
        $scope.slideChanged = function($index) {
            $rootScope.slideIndex = $index;
        };
        // photo slide show
        // photo modal
        $scope.createPhotoModal = function() {
            $ionicModal.fromTemplateUrl('views/record/modal-photo.html', {
                scope: $scope,
                animation: 'slide-in-up',
                controller: 'CreatecollectionCtrl'
            }).then(function(modal) {
                $scope.photoModal = modal;
            });
        };
        $scope.openPhotoModal = function() {
            $scope.photoModal.show();
        };
        $scope.closePhotoModal = function() {
            event.preventDefault();
            $scope.photoModal.hide();
            $scope.photoModal.remove();
            $scope.createPhotoModal();
        };
        $scope.createPhotoModal();
        $scope.formatPhotoModal = function(index) {
            phtHgt = $('.qpp_'+index).height();
            phtWdt = $('.qpp_'+index).width();
            hgtPftn = (phtHgt/phtWdt)*$(window).width();
            wdtPftn = (phtWdt/phtHgt)*$(window).height();
            if(phtWdt >= phtHgt){
                $('#qpphoto-scroll div div').css('width',$(window).width()+'px');
                $('#qpphoto-scroll div div').css('height',hgtPftn+'px');
                $('#qpphoto-scroll div div img').css('width',$(window).width()+'px');
                $('#qpphoto-scroll div div img').css('height',hgtPftn+'px');
            }else{
                $('#qpphoto-scroll div div').css('width',wdtPftn+'px');
                $('#qpphoto-scroll div div').css('height',$(window).height()+'px');
                $('#qpphoto-scroll div div img').css('width',wdtPftn+'px');
                $('#qpphoto-scroll div div img').css('height',$(window).height()+'px');
                $('#qpphoto-scroll div div').css('margin','0 auto');
            }

            $('#qpphoto-scroll .scroll').attr('style','');
        }

        $scope.updatePhoto= function(index) {
            var zoomFactor = $ionicScrollDelegate.$getByHandle('scrollHandleimg'+index).getScrollPosition().zoom;
            if (zoomFactor == 1) {
                $ionicSlideBoxDelegate.$getByHandle("imghandle").enableSlide(true);
            } else {
                $ionicSlideBoxDelegate.$getByHandle("imghandle").enableSlide(false);
            }
        }
        // photo modal

        $("#quip_photo_box_out").click(function(e) {
            if($scope.quipPhotosTempArr.toString() != ''){
                $scope.showQpPhoto(e.target.title);
                $rootScope.slideIndex = e.target.title;
            }
        });


        $scope.saveCollection = function(){ //SAVING *
            //console.log($scope.collection.collection_title);
            if($scope.collection.collection_title === undefined || $scope.collection.collection_title === ""){
                create_failed("Title is required");
            }else{
                $ionicLoading.show();
                var file = document.getElementById("create-sphere-collection-banner");
                var data = {
                    collection_banner_url: file.files[0],
                    title: $scope.collection.collection_title,
                    description: $scope.collection.collection_description,
                    url_banner:'',
                    sphere_id:$stateParams.id,
                    creator_quipperid:$rootScope.user_data.quipper_id,
                };
                console.log(data);
                API.createCollection(data, cb_success, cb_error);
            }
        }
        function cb_success(data){
            $ionicLoading.hide();
            if(data.Result == 1 ){
                //success
                create_success(data.Message[0]);
            }else{
                //error
                var msg = data.Message.join("<br/>");
                console.log(data.Message)
                create_failed(msg);
            }
            // console.log(data);
        }
        function cb_error(data){
            $ionicLoading.hide();
            // console.log("cb_error");
            // console.log(data);
            create_failed("Something went wrong please try again");
        }

        function create_failed(msg){
            var status = "e";
            var ontap_callback = function(e){
                // console.log(e);
            }
            title = 'Create Collection';
            btn_text = 'Try again';
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }
        function create_success(msg){
            var status = "s";
            var ontap_callback = function(e){
                // console.log(e);
                $rootScope.goback();
            }
            title = 'Create Collection Success';
            btn_text = 'OK';
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }
})
.controller('CreateSphereCtrl', function($rootScope, $scope, $state, $cordovaDatePicker, $ionicHistory,
    $ionicLoading, DatePicker, TimePicker, API, $cordovaFile, $timeout, Constant) {
        $scope.ad_class = "hide";
        $scope.mysphere = {};

        $scope.mysphere["SphereHandle"] = "";  
        $scope.mysphere["Hashtags"] = "";   
        $scope.mysphere["Description"] = ""; 
        $scope.mysphere["ApplyDuration"] = 0;
        $scope.mysphere["StartDate"] = "";  
        $scope.mysphere["Duration"] = "Hours";   
        $scope.mysphere["Private"] = 'Public';    
        $scope.mysphere["EnableReply"] = 1;   
        $scope.mysphere["StartTime"] = "";
        $scope.mysphere["sphere_logo"] = "";
        $scope.mysphere["b64"] = "";
        $scope.options = [];

        for(var i = 1; i <= 24; i++){
            $scope.options.push({"val":i});
        }

       /* $scope.fileNameChanged = function(){
            $ionicLoading.show();
            var f = document.getElementById("create-sphere-logo").files[0],
            r = new FileReader();
            r.onloadend = function(e) { //callback after files finish loading
                $scope.mysphere.b64 = e.target.result;
                $scope.$apply();
                $ionicLoading.hide();
                //here you can send data over your server as desired
            }
            r.readAsDataURL(f); //once defined all callbacks, begin reading the file
        }*/

       /* $scope.tapFile = function(){
            document.getElementById("create-sphere-logo").click();
        }*/

        $scope.createShpere = function(){
            $ionicLoading.show();

            var ontap_callback = function(e){
                    console.log(e);
            }
            //validate
            if ($scope.mysphere.SphereHandle  == ''){
                title = 'Error on save';
                btn_text = 'Try again';
                msg = 'Handle is required';
                var status = "e";
                $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                return;
            }
            if ($scope.mysphere.Description  == ''){
                title = 'Error on save';
                btn_text = 'Try again';
                msg = 'Description is required';
                var status = "e";
                $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                return;

            }


            var sphereLogoURL = '';
            if ($scope.mysphere.b64 != ''){
                    //upload file first
                    sphereLogoURL = Constant.QUIPSHERE_API_HOST+ '/images/sphere_logo/' + $scope.newQpFile ;
                    console.log( sphereLogoURL );
                    $scope.sendSphereLogo($scope.imageLocalPath);
            }            

            var data = {
                sphere_logo: sphereLogoURL,
                hashtags: $scope.mysphere.Hashtags,
                handle: $scope.mysphere.SphereHandle,
                description: $scope.mysphere.Description,
                privacy_type: $scope.mysphere.Private,
                //start_datetime: $scope.mysphere.StartDate + " " + $scope.mysphere.StartTime,
                //duration: $scope.mysphere.Duration,
                //apply_duration: $scope.mysphere.ApplyDuration,
                //enable_reply: $scope.mysphere.EnableReply,
            };

            API.createSphere(data, cb_success, cb_error);
        }
        function cb_success(data){
            $ionicLoading.hide();
            if(data.Result == 1 ){
                //success
                $scope.mysphere["SphereHandle"] = "";  
                $scope.mysphere["Hashtags"] = "";   
                $scope.mysphere["Description"] = ""; 
                $scope.mysphere["ApplyDuration"] = 0;
                $scope.mysphere["StartDate"] = "";  
                $scope.mysphere["Duration"] = "Hours";   
                $scope.mysphere["Private"] = 'Public';    
                $scope.mysphere["EnableReply"] = 1;   
                $scope.mysphere["StartTime"] = "";
                $scope.mysphere["sphere_logo"] = "";
                $scope.mysphere["b64"] = "img/no-image-available.png";
                document.getElementById("create-sphere-logo").value='';
                create_success(data.Message[0]);
            }else{
                //error
                var msg = data.Message.join("<br/>");
                create_failed(msg);
            }
            console.log(data);
        }
        function cb_error(data){
            $ionicLoading.hide();
            console.log("cb_error");
            console.log(data);
            create_failed("Something went wrong please try again");
        }
        function create_failed(msg){
            var status = "e";
            var ontap_callback = function(e){
                console.log(e);
            }
            title = 'Create Sphere Failed';
            btn_text = 'Try again';
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }
        function create_success(msg){
            var status = "s";
            var ontap_callback = function(e){
                console.log(e);
                $rootScope.goback();
            }
            title = 'Create Sphere Success';
            btn_text = 'OK';
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }

        //Upload Logo Image
        $scope.uploadLogoImage = function(){
            //$ionicLoading.show();
                
            navigator.camera.getPicture(onSuccessFromGallery, onFailFromGallery, {
                targetWidth: 720,
                targetHeight: 720,
                quality: 72,
                allowEdit: false,
                correctOrientation: true,
                saveToPhotoAlbum: true,
                destinationType: Camera.DestinationType.FILE_URI,
                sourceType: navigator.camera.PictureSourceType.SAVEDPHOTOALBUM
            });

        };

        $scope.newQpFile = ''; $scope.imageLocalPath = '';

        function onSuccessFromGallery(imageData) {
            // format url and filename
            var qp = imageData.split('/').pop(); var qpFile = qp.split('?'); // get the file
            var qpUrlArr = imageData.split('/'); 
            qpUrlArr.splice(-1,1); 
            var qpUrl = qpUrlArr.join('/')+'/'; // get the folder
            var newQpFile = 'sphere_' + $rootScope.user_data.quipper_id + '_' + new Date().getTime()+'.jpg';
            $scope.newQpFile = newQpFile;
            
            // copy the file in quipsphere folder
            $cordovaFile.copyFile(qpUrl, qpFile[0], cordova.file.externalRootDirectory+'quipsphere/', newQpFile)
                .then(function (success) {
                    // display in form
                    var imageSource = cordova.file.externalRootDirectory+'quipsphere/'+newQpFile;                                      
                    $scope.imageLocalPath =$scope.mysphere["b64"] = imageSource;


                }, function (error) {
                    console.log('error: '+ error);
                });
        }

        function onFailFromGallery(message) {
           // $ionicLoading.hide();            
        }

        $scope.sendSphereLogo = function(filePath){
            $timeout(function() {
                 var argsP = new Array();
                    argsP[0] = '';
                    argsP[1] = ".jpg";
                    
                    var fileinput = filePath.replace("file:", "");
                    QuipsApi.uploadSphereLogo( fileinput, argsP,  uploadCallBack );

                    //Upload File
                    function uploadCallBack(result){
                          // $ionicLoading.hide();
                          //emit msg to end user
                    }                
            },500);
        }

        /*
        $scope.applyDuration = function(ad){
        //reset value
        if(ad == 0){
        $scope.mysphere["StartDate"] = "";  
        $scope.mysphere["Duration"] = "Hours";   
        $scope.mysphere["Private"] = 'Public';    
        $scope.mysphere["EnableReply"] = 1;  
        $scope.ad_class = "hide";
        }else{
        $scope.ad_class = "";
        }

        }
        function showNativeDatePicker(){
        var options = {
        date: new Date(),
        mode: 'time', // or 'time'
        minDate: new Date() - 10000,
        allowOldDates: true,
        allowFutureDates: false,
        doneButtonLabel: 'DONE',
        doneButtonColor: '#F2F3F4',
        cancelButtonLabel: 'CANCEL',
        cancelButtonColor: '#000000'
        };

        $cordovaDatePicker.show(options).then(function(date){
        alert(date);
        });
        }

        var dp = new DatePicker();
        console.log(dp.datepickerObject);
        dp.datepickerObject.callback = function (val) {
        if (typeof(val) === 'undefined') {
        console.log('No date selected');
        } else {
        $scope.datepickerObject.inputDate = val;
        console.log('Selected date is : ', val)
        $scope.mysphere.StartDate = dp.dateFormat(val);
        }
        }; 
        $scope.datepickerObject = dp.datepickerObject;

        //Time Picker
        var tp = new TimePicker();
        tp.timePickerObject.callback= function(val) {
        if (typeof (val) === 'undefined') {
        console.log('Time not selected');
        } else {
        var selectedTime = new Date(val * 1000);
        $scope.mysphere.StartTime = tp.ampm(selectedTime);
        console.log('Selected epoch is : ', val, 'and the time is ', selectedTime.getUTCHours(), ':', selectedTime.getUTCMinutes(), 'in UTC');
        }
        }
        $scope.timePickerObject = tp.timePickerObject;
        */
})
.controller('EditSphereCtrl', function($rootScope, $scope, $state, $stateParams, $cordovaDatePicker, $ionicHistory,
    $ionicLoading, DatePicker, TimePicker, API) {
        $scope.ad_class = "hide";
        $scope.mysphere = {};
        $scope.editsphereloading = true;
        $scope.mysphere["SphereHandle"] = "";  
        $scope.mysphere["Hashtags"] = "";   
        $scope.mysphere["Description"] = ""; 
        $scope.mysphere["ApplyDuration"] = 0;
        $scope.mysphere["StartDate"] = "";  
        $scope.mysphere["Duration"] = "Hours";   
        $scope.mysphere["Private"] = 'Public';    
        $scope.mysphere["EnableReply"] = 1;   
        $scope.mysphere["StartTime"] = "";
        $scope.mysphere["sphere_logo"] = "";
        $scope.mysphere["b64"] = "img/no-image-available.png";
        $scope.options = [];
        for(var i = 1; i <= 24; i++){
            $scope.options.push({"val":i});
        }

        $scope.getSphere = function(){
            $scope.editsphereloading = true;
            $ionicLoading.show();
            API.getSphere({
                unique_id : $stateParams.id 
                },function(data){
                    $ionicLoading.hide();
                    if(data.Result == 1){
                        $scope.editsphereloading = false;
                        $scope.mysphere["SphereHandle"] = data.Data.handle;  
                        $scope.mysphere["Hashtags"] = data.Data.hashtags; 
                        $scope.mysphere["Description"] = data.Data.description;
                        $scope.mysphere["Private"] = data.Data.privacy_type;   
                        $scope.mysphere["sphere_logo"] = data.Data.sphere_logo;
                        $scope.mysphere["b64"] = data.Data.sphere_logo;
                    }else{
                        $scope.editsphereloading = true;
                    }
                },function(err){
                    $ionicLoading.hide();
                    $scope.editsphereloading = true;
            })
        }

        $scope.$on('$ionicView.beforeEnter', function() {

        }); 

        $scope.$on('$ionicView.afterEnter', function() {
        }); 
        $scope.$on('$ionicView.beforeLeave', function() {
        });
        $scope.$on('$ionicView.afterLeave', function() {
            $rootScope.canQuip = true;
        });
        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){ 
            if(toState.name == 'app.edit-sphere'){
                $ionicLoading.show();
                API.getSphere({
                    unique_id : $stateParams.id
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            $scope.currentsphere =  data.Data;
                            $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                            $rootScope.routeParams.id = $stateParams.id;
                            $rootScope.routeParams.handler = $scope.currentsphere.handle;
                            $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            if(data.Data.member_type=='OWNER'){
                            }else if(data.Data.member_type=='MEMBER'){
                            }else{
                                $rootScope.canQuip = false;
                            }
                        }
                        $ionicLoading.hide();
                    },function(err){
                        $ionicLoading.hide();
                });
                $scope.getSphere();
            }
        });

        $scope.fileNameChanged = function(){
            $ionicLoading.show();
            var f = document.getElementById("edit-sphere-logo").files[0],
            r = new FileReader();
            r.onloadend = function(e) { //callback after files finish loading
                $scope.mysphere.b64 = e.target.result;
                $scope.$apply();
                $ionicLoading.hide();
                //here you can send data over your server as desired
            }
            r.readAsDataURL(f); //once defined all callbacks, begin reading the file
        }

        $scope.tapFile = function(){
            document.getElementById("edit-sphere-logo").click();
        }

        $scope.editShpere = function(){
            $ionicLoading.show();
            var file = document.getElementById("edit-sphere-logo");
            var data = {
                sphere_logo:file.files[0],
                hashtags: $scope.mysphere.Hashtags,
                handle: $scope.mysphere.SphereHandle,
                description: $scope.mysphere.Description,
                privacy_type: $scope.mysphere.Private,
                unique_id: $stateParams.id,
                //start_datetime: $scope.mysphere.StartDate + " " + $scope.mysphere.StartTime,
                //duration: $scope.mysphere.Duration,
                //apply_duration: $scope.mysphere.ApplyDuration,
                //enable_reply: $scope.mysphere.EnableReply,
            };

            API.editSphere(data, cb_success, cb_error);
        }
        function cb_success(data){
            $ionicLoading.hide();
            if(data.Result == 1 ){
                //success
                edit_success(data.Message);
            }else{
                //error
                var msg = data.Message.join("<br/>");
                edit_failed(msg);
            }
            console.log(data);
        }
        function cb_error(data){
            $ionicLoading.hide();
            console.log("cb_error");
            console.log(data);
            edit_failed("Something went wrong please try again");
        }
        function edit_failed(msg){
            var status = "e";
            var ontap_callback = function(e){
                console.log(e);
            }
            title = 'Edit Sphere Failed';
            btn_text = 'Try again';
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }
        function edit_success(msg){
            var status = "s";
            var ontap_callback = function(e){
                console.log(e);
                $rootScope.goback();
            }
            title = 'Edit Sphere Success';
            btn_text = 'OK';
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }
})
.controller('SphereMembersCtrl', function($rootScope, $scope, $state,$ionicPopup, $state,
    $stateParams,$ionicPopover, API,$ionicLoading) {
        $scope.sphere = {};
        $scope.sphere.handle = "sphere members";
        $scope.sphere_members = {};
        $scope.paramId = $stateParams.id;
        $scope.member_name = '';

        var sphereMembersElement = document.querySelector("#sphere-members");
        $scope.$on('$ionicView.beforeEnter', function() {
            console.log("adding event listener sphereMemberEvent")
            sphereMembersElement.addEventListener("click", sphereMemberEvent, false);
        }); 
        $scope.$on('$ionicView.afterEnter', function() {
        }); 

        $scope.$on('$ionicView.beforeLeave', function() {
            console.log("removing event listener sphereMemberEvent")
            sphereMembersElement.removeEventListener("click", sphereMemberEvent, false);
        });

        $scope.$on('$ionicView.afterLeave', function() {
            $rootScope.canQuip = true;
        });

        $scope.popover = $ionicPopover.fromTemplate('', {
            scope: $scope
        });

        $scope.openPopover = function($event) {
            $scope.popover.show($event);
        };
        $scope.closePopover = function() {
            $scope.popover.hide();
        };

        function sphereMemberEvent(e){
            if (e.target !== e.currentTarget) {
                var checktarget = e.target.classList;
                //console.log(checktarget);
                for(var i = 0; i < checktarget.length; i++){
                    splited = checktarget[i].split("_");
                    if(splited[0] == "sm"){
                        switch(splited[1]){
                            case "options":      
                                var template = 
                                '<ion-popover-view class="sphere-popover"> '+
                                '<div>'+
                                '<div on-tap="deleteSphereMember(\''+splited[2]+'\');closePopover()" class="sphere-popover-li">Remove from Sphere</div>'+
                                '</div>'+
                                '</ion-popover-view>';
                                $scope.popover = $ionicPopover.fromTemplate(template, {
                                    scope: $scope
                                });
                                $scope.popover.show(e);
                                break;

                            case "viewquipper":
                                //console.log(splited[2]);
                                $rootScope.reRoute('go','view profile', 0, {id:splited[2], handler:$scope.currentsphere.handle});
                                $rootScope.goto('app.view-profile',{id:splited[2]});
                            break;
                            // case "viewquipper":
                            //     $rootScope.goto('app.view-profile',{id:splited[2]});
                            // break;
                            default:
                                break;
                        }
                    }
                }

            }
        }

        $scope.resetMemberName = function(){
            $scope.member_name = "";
            $ionicLoading.show();
            API.sphereMembers({
                unique_id : $stateParams.id
                },function(data){
                    if(data.Result == 1){
                        window.localStorage['sphere_members'] = JSON.stringify(data.Data);
                        $scope.sphere_members = JSON.parse(window.localStorage['sphere_members']);
                    }else{
                    }
                    $ionicLoading.hide();
                },function(err){
                    $ionicLoading.hide();
            });
        }
        $scope.searchMember = function(member_name){
            $ionicLoading.show();
            API.sphereMembers({
                unique_id : $stateParams.id,
                member_name: member_name
                },function(data){
                    if(data.Result == 1){
                        window.localStorage['sphere_members'] = JSON.stringify(data.Data);
                        $scope.sphere_members = JSON.parse(window.localStorage['sphere_members']);
                    }else{
                    }
                    $ionicLoading.hide();
                },function(err){
                    $ionicLoading.hide();
            });
        }
        $scope.deleteSphereMember = function(quipper_id){
            // var msg  = "Are you sure you want to remove this sphere member?";
            // var status = "e";     
            // var title = "Remove Sphere Member";   
            // $rootScope.popUp(msg, status, title,  function(e){
            API.deleteSphereMember({
                'unique_id' : $scope.paramId,
                'quipper_id' : quipper_id
                },function(data){ 
                    console.log(data); 
                },function(err){
            })
            var arr = [];
            for(var i = 0; i < $scope.sphere_members.length; i++){
                if(quipper_id != $scope.sphere_members[i].quipper_id){
                    var temp = {};
                    temp['fullname'] = $scope.sphere_members[i].fullname;
                    temp['handle'] = $scope.sphere_members[i].handle;
                    temp['member_type'] = $scope.sphere_members[i].member_type;
                    temp['quipper_id'] = $scope.sphere_members[i].quipper_id;
                    temp['quipper_img'] = $scope.sphere_members[i].quipper_img;
                    arr.push(temp);
                }
            }
            $scope.sphere_members = arr;
            //$scope.$apply();
            //});
        }
        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){ 
            if(toState.name == 'app.sphere-members'){
                $scope.paramId = $stateParams.id;
                $ionicLoading.show();
                API.getSphere({
                    unique_id : $stateParams.id
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            $scope.currentsphere =  data.Data;
                            $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                            $rootScope.routeParams.id = $stateParams.id;
                            $rootScope.routeParams.handler = $scope.currentsphere.handle;
                            $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            if(data.Data.member_type=='OWNER'){
                            }else if(data.Data.member_type=='MEMBER'){
                            }else{
                                $rootScope.canQuip = false;
                            }
                        }
                        $ionicLoading.hide();
                    },function(err){
                        $ionicLoading.hide();
                });
                $ionicLoading.show();
                // API.getSphere({
                //     unique_id : $stateParams.id 
                // },function(data){
                //     if(data.Result == 1){
                //         $scope.sphere.handle = data.Data.handle;
                //     }else{

                //     }
                // },function(err){
                // })
                API.sphereMembers({
                    unique_id : $stateParams.id 
                    },function(data){
                        if(data.Result == 1){
                            window.localStorage['sphere_members'] = JSON.stringify(data.Data);
                            $scope.sphere_members = JSON.parse(window.localStorage['sphere_members']);
                        }else{
                        }
                        $ionicLoading.hide();
                    },function(err){
                        $ionicLoading.hide();
                })
            }
        });
})
.controller('InviteSphereMembersCtrl', function($rootScope, $scope, $state,$ionicPopup, $state,
    $stateParams,$ionicPopover, API, $ionicLoading) {

        var inviteSphereMembersElement = document.querySelector("#invite-sphere-members");
        var removedMembers =[];
        var addedMembers =[];
        $scope.paramId = $stateParams.id;
        $scope.member_name = "";
        $scope.followerList = [];
        $scope.memberList = [];

        $scope.$on('$ionicView.beforeEnter', function() {
            console.log("adding event listener inviteSphereMemberEvent")
            inviteSphereMembersElement.addEventListener("click", inviteSphereMemberEvent, false);
        }); 

        $scope.$on('$ionicView.afterEnter', function() {
        }); 
        $scope.$on('$ionicView.beforeLeave', function() {
            console.log("removing event listener inviteSphereMemberEvent")
            inviteSphereMembersElement.removeEventListener("click", inviteSphereMemberEvent, false);
        });
        $scope.$on('$ionicView.afterLeave', function() {
            $rootScope.canQuip = true;
        });

        function inviteSphereMemberEvent(e){
            if (e.target !== e.currentTarget) {
                var checktarget = e.target.classList;
                //console.log(checktarget);
                for(var i = 0; i < checktarget.length; i++){
                    splited = checktarget[i].split("_");
                    if(splited[0] == "ism"){
                        switch(splited[1]){
                            case "removemember":
                                //console.log(splited[2]);
                                var ml = [];
                                for(var i =0; i < $scope.memberList.length; i++){
                                    if($scope.memberList[i].quipper_id != splited[2]){
                                        var q = {};
                                        q['handle'] = $scope.memberList[i].handle;
                                        q['fullname'] = $scope.memberList[i].fullname;
                                        q['quipper_id'] = $scope.memberList[i].quipper_id;
                                        q['isMember'] = $scope.memberList[i].isMember;
                                        ml.push(q);
                                    }else{
                                        if(removedMembers.indexOf(splited[2]) == -1){
                                            removedMembers.push(splited[2]);
                                            addedMembers.splice(addedMembers.indexOf(splited[2]),1);
                                        }
                                    }
                                }
                                for(var i = 0; i < $scope.followerList.length; i++){
                                    if(removedMembers.indexOf($scope.followerList[i].quipper_id) != -1){
                                        $scope.followerList[i].isMember = false;
                                    }
                                }
                                $scope.memberList = ml;
                                $scope.$apply();
                                break;
                            case "addmember":
                                for(var i =0; i < $scope.followerList.length; i++){
                                    if($scope.followerList[i].quipper_id == splited[2]){
                                        $scope.followerList[i].isMember = true;
                                        var q = {};
                                        q['handle'] = $scope.followerList[i].handle;
                                        q['fullname'] = $scope.followerList[i].fullname;
                                        q['quipper_id'] = $scope.followerList[i].quipper_id;
                                        q['isMember'] = $scope.followerList[i].isMember;
                                        $scope.memberList.push(q);
                                        removedMembers.splice(removedMembers.indexOf(splited[2]),1);
                                        if(addedMembers.indexOf(splited[2]) == -1){
                                            addedMembers.push(splited[2]);
                                        }
                                    }
                                }
                                $scope.$apply();
                                break;

                            case "viewquipper":
                                //console.log(splited[2]);
                                $rootScope.reRoute('go','view profile', 0, {id:splited[2], handler:$scope.currentsphere.handle});
                                $rootScope.goto('app.view-profile',{id:splited[2]});
                            break;
                            default:
                                break;
                        }
                    }
                }

            }
        }

        $scope.manageMembers = function(){
            if($scope.memberList.length != 0 ){
                $ionicLoading.show();
                var members = [];
                for(var i = 0; i < $scope.memberList.length; i++){
                    members.push($scope.memberList[i].quipper_id);
                }
                members_string = members.join(',');
                var s = ( 1 != $scope.memberList.length )?"s":"";
                API.sphereInviteMembers({
                    members: members_string,
                    unique_id : $stateParams.id
                    },function(data){
                        $ionicLoading.hide();
                        if(data.Result==1){
                            var status = "e";
                            var ontap_callback = function(e){
                                $rootScope.goback();
                            }
                            title = 'Manage Members';
                            btn_text = 'Okay';
                            msg = "You have added "+$scope.memberList.length+ " New Member"+s;
                            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                        }else{

                        }
                    },function(err){
                        $ionicLoading.hide();
                })
            }
        }
        $scope.resetMemberName = function(){
            $scope.member_name = "";
            $ionicLoading.show();
            API.sphereFollowerList({
                unique_id : $stateParams.id
                },function(data){
                    $ionicLoading.hide();
                    if(data.Result == 1){
                        $scope.followerList = data.Data;
                        if(removedMembers.length != 0){
                            for(var i = 0; i < $scope.followerList.length; i++){
                                if(removedMembers.indexOf($scope.followerList[i].quipper_id) != -1){
                                    $scope.followerList[i].isMember = false;
                                }
                            }
                        }
                        if(addedMembers.length != 0){
                            for(var i = 0; i < $scope.followerList.length; i++){
                                if(addedMembers.indexOf($scope.followerList[i].quipper_id) != -1){
                                    $scope.followerList[i].isMember = true;
                                }
                            }
                        }
                    }else{

                    }
                },function(err){
                    $ionicLoading.hide();
            });
        }
        $scope.searchMember = function(member_name){
            $ionicLoading.show();
            API.sphereFollowerList({
                unique_id : $stateParams.id,
                member_name: member_name
                },function(data){
                    $ionicLoading.hide();
                    if(data.Result == 1){
                        $scope.followerList = data.Data;
                        if(removedMembers.length != 0){
                            for(var i = 0; i < $scope.followerList.length; i++){
                                if(removedMembers.indexOf($scope.followerList[i].quipper_id) != -1){
                                    $scope.followerList[i].isMember = false;
                                }
                            }
                        }
                        if(addedMembers.length != 0){
                            for(var i = 0; i < $scope.followerList.length; i++){
                                if(addedMembers.indexOf($scope.followerList[i].quipper_id) != -1){
                                    $scope.followerList[i].isMember = true;
                                }
                            }
                        }
                    }else{

                    }
                },function(err){
                    $ionicLoading.hide();
            });
        }
        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){ 
            if(toState.name == 'app.invite-sphere-members'){
                $scope.paramId = $stateParams.id;
                $ionicLoading.show();
                API.getSphere({
                    unique_id : $stateParams.id
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            $scope.currentsphere =  data.Data;
                            $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                            $rootScope.routeParams.id = $stateParams.id;
                            $rootScope.routeParams.handler = $scope.currentsphere.handle;
                            $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            if(data.Data.member_type=='OWNER'){
                            }else if(data.Data.member_type=='MEMBER'){
                            }else{
                                $rootScope.canQuip = false;
                            }
                        }
                        $ionicLoading.hide();
                    },function(err){
                        $ionicLoading.hide();
                });
                //get sphere
                // API.getSphere({
                //     unique_id : $stateParams.id
                // },function(data){

                // },function(err){
                // });

                // API.sphereMemberList({
                //     unique_id : $stateParams.id,
                // },function(data){
                //     if(data.Result == 1){
                //         $scope.memberList = data.Data;
                //     }else{

                //     }
                // },function(err){
                // });
                $ionicLoading.show();
                API.sphereFollowerList({
                    unique_id : $stateParams.id,
                    },function(data){
                        $ionicLoading.hide();
                        if(data.Result == 1){
                            $scope.followerList = data.Data;
                            // if(removedMembers.length != 0){
                            //     for(var i = 0; i < $scope.followerList.length; i++){
                            //         if(removedMembers.indexOf($scope.followerList[i].quipper_id) != -1){
                            //             $scope.followerList[i].isMember = false;
                            //         }
                            //     }
                            // }
                            // if(addedMembers.length != 0){
                            //     for(var i = 0; i < $scope.followerList.length; i++){
                            //         if(addedMembers.indexOf($scope.followerList[i].quipper_id) != -1){
                            //             $scope.followerList[i].isMember = true;
                            //         }
                            //     }
                            // }
                        }else{

                        }
                    },function(err){
                        $ionicLoading.hide();
                });

            }

        });
})
.controller('SphereFollowersCtrl', function($rootScope, $scope, $state,$ionicPopup, $state,
    $stateParams,$ionicPopover, API,$ionicLoading) {
        $scope.sphere = {};
        $scope.sphere.handle = "sphere members";
        $scope.sphere_followers = {};
        $scope.paramId = $stateParams.id;
        $scope.member_name = '';

        var sphereFollowersElement = document.querySelector("#sphere-followers");
        $scope.$on('$ionicView.beforeEnter', function() {
            console.log("adding event listener sphereFollowerEvent")
            sphereFollowersElement.addEventListener("click", sphereFollowerEvent, false);
        }); 
        $scope.$on('$ionicView.afterEnter', function() {
        }); 

        $scope.$on('$ionicView.beforeLeave', function() {
            console.log("removing event listener sphereFollowerEvent")
            sphereFollowersElement.removeEventListener("click", sphereFollowerEvent, false);
        });

        $scope.$on('$ionicView.afterLeave', function() {
            $rootScope.canQuip = true;
        });

        $scope.popover = $ionicPopover.fromTemplate('', {
            scope: $scope
        });

        $scope.openPopover = function($event) {
            $scope.popover.show($event);
        };
        $scope.closePopover = function() {
            $scope.popover.hide();
        };

        function sphereFollowerEvent(e){
            if (e.target !== e.currentTarget) {
                var checktarget = e.target.classList;
                //console.log(checktarget);
                for(var i = 0; i < checktarget.length; i++){
                    splited = checktarget[i].split("_");
                    if(splited[0] == "sf"){
                        switch(splited[1]){
                            case "options":      
                                var template = 
                                '<ion-popover-view class="sphere-popover"> '+
                                '<div>'+
                                '<div on-tap="deleteSphereFollower(\''+splited[2]+'\');closePopover()" class="sphere-popover-li">Remove from Sphere</div>'+
                                '</div>'+
                                '</ion-popover-view>';
                                $scope.popover = $ionicPopover.fromTemplate(template, {
                                    scope: $scope
                                });
                                $scope.popover.show(e);
                                break;
                                
                            case "viewquipper":
                                //console.log(splited[2]);
                                $rootScope.reRoute('go','view profile', 0, {id:splited[2], handler:$scope.currentsphere.handle});
                                $rootScope.goto('app.view-profile',{id:splited[2]});
                            break;
                            // case "viewquipper":
                            //     $rootScope.goto('app.view-profile',{id:splited[2]});
                            // break;
                            default:
                                break;
                        }
                    }
                }

            }
        }

        $scope.resetMemberName = function(){
            $scope.member_name = "";
            $ionicLoading.show();
            API.sphereMembers({
                unique_id : $stateParams.id
                },function(data){
                    if(data.Result == 1){
                        window.localStorage['sphere_followers'] = JSON.stringify(data.Data);
                        $scope.sphere_followers = JSON.parse(window.localStorage['sphere_followers']);
                    }else{
                    }
                    $ionicLoading.hide();
                },function(err){
                    $ionicLoading.hide();
            });
        }
        $scope.searchMember = function(member_name){
            $ionicLoading.show();
            API.sphereFollowers({
                unique_id : $stateParams.id,
                member_name: member_name
                },function(data){
                    if(data.Result == 1){
                        window.localStorage['sphere_followers'] = JSON.stringify(data.Data);
                        $scope.sphere_followers = JSON.parse(window.localStorage['sphere_followers']);
                    }else{
                    }
                    $ionicLoading.hide();
                },function(err){
                    $ionicLoading.hide();
            });
        }
        $scope.deleteSphereFollower = function(quipper_id){
            // var msg  = "Are you sure you want to remove this sphere member?";
            // var status = "e";     
            // var title = "Remove Sphere Member";   
            // $rootScope.popUp(msg, status, title,  function(e){
            API.deleteSphereMember({
                'unique_id' : $scope.paramId,
                'quipper_id' : quipper_id
                },function(data){ 
                    console.log(data); 
                },function(err){
            })
            var arr = [];
            for(var i = 0; i < $scope.sphere_followers.length; i++){
                if(quipper_id != $scope.sphere_followers[i].quipper_id){
                    var temp = {};
                    temp['fullname'] = $scope.sphere_followers[i].fullname;
                    temp['handle'] = $scope.sphere_followers[i].handle;
                    temp['member_type'] = $scope.sphere_followers[i].member_type;
                    temp['quipper_id'] = $scope.sphere_followers[i].quipper_id;
                    temp['quipper_img'] = $scope.sphere_followers[i].quipper_img;
                    arr.push(temp);
                }
            }
            $scope.sphere_followers = arr;
            //$scope.$apply();
            //});
        }
        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){ 
            if(toState.name == 'app.sphere-followers'){
                $scope.paramId = $stateParams.id;
                $ionicLoading.show();
                API.getSphere({
                    unique_id : $stateParams.id
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            $scope.currentsphere =  data.Data;
                            $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                            $rootScope.routeParams.id = $stateParams.id;
                            $rootScope.routeParams.handler = $scope.currentsphere.handle;
                            $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            if(data.Data.member_type=='OWNER'){
                            }else if(data.Data.member_type=='MEMBER'){
                            }else{
                                $rootScope.canQuip = false;
                            }
                        }
                        $ionicLoading.hide();
                    },function(err){
                        $ionicLoading.hide();
                });
                $ionicLoading.show();
                // API.getSphere({
                //     unique_id : $stateParams.id 
                // },function(data){
                //     if(data.Result == 1){
                //         $scope.sphere.handle = data.Data.handle;
                //     }else{

                //     }
                // },function(err){
                // })
                API.sphereFollowers({
                    unique_id : $stateParams.id 
                    },function(data){
                        if(data.Result == 1){
                            window.localStorage['sphere_followers'] = JSON.stringify(data.Data);
                            $scope.sphere_followers = JSON.parse(window.localStorage['sphere_followers']);
                        }else{
                        }
                        $ionicLoading.hide();
                    },function(err){
                        $ionicLoading.hide();
                })
            }
        });
})
.controller('SphereEventsCtrl', function($scope, $rootScope, $ionicHistory, $stateParams,$ionicLoading, API, $ionicPopover) {
    $scope.currentsphere = {};
    $scope.sphere_unique_id = $stateParams.id;
    $scope.AddSphereEvent = function(){
        $rootScope.reRoute('go','app.add-sphere-event', 0, {id:$stateParams.id, handler:$rootScope.routeParams.handler});
        $rootScope.goto('app.add-sphere-event',{id:$stateParams.id});
    }

    $scope.editSphereEvent = function(val){
        console.log($scope.currentsphere);
        $rootScope.reRoute('go','app.edit-sphere-event', 0, {id:$stateParams.id, handler:$rootScope.routeParams.handler});
        console.log($rootScope.routeParams);
        $rootScope.goto('app.edit-sphere-event',{id:val});
    };

    $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){

        if(toState.name == 'app.sphere-events'){
            //get sphere
            $ionicLoading.show();
            API.getSphere({
                unique_id : $stateParams.id
                },function(data){
                    console.log(data);
                    if(data.Result == 1){
                        $scope.currentsphere =  data.Data;
                        $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                        $rootScope.routeParams.id = $stateParams.id;
                        $rootScope.routeParams.handler = $scope.currentsphere.handle;
                        $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                        $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                        if(data.Data.member_type=='OWNER'){
                        }else if(data.Data.member_type=='MEMBER'){
                        }else{
                            $rootScope.canQuip = false;
                        }
                    }
                    $ionicLoading.hide();
                },function(err){
                    $ionicLoading.hide();
            });
            API.viewsphereevents({id:$stateParams.id }, function(data){
                $ionicLoading.hide();
                if(data.Result == 1){
                    $scope.eventlist = data.Data;
                }      
                }, function(err){
                    $ionicLoading.hide();

            });

        }

    });
})
.controller('AddSphereEventCtrl', function($scope, $rootScope, $cordovaDatePicker, 
    $ionicHistory, DatePicker, TimePicker,  $http, $ionicLoading, Constant, API, 
    deviceType, $stateParams
    , Timezones
    ) {
    //alert();
    $scope.sphere_event = {};
    $scope.sphere_event.sphereid = "";
    $scope.sphere_event.title = "";
    $scope.sphere_event.description = "";
    $scope.sphere_event.event_date = "";
    $scope.sphere_event.event_time_from = "";
    $scope.sphere_event.event_time_from_ampm = "";
    $scope.sphere_event.event_time_to = "";
    $scope.sphere_event.event_time_to_ampm = "";
    $scope.sphere_event.time_zone = "";
    $scope.sphere_event.b64 ="img/no-banner.jpg";

    $scope.fileNameChanged = function(){
        $ionicLoading.show();
        var f = document.getElementById("create-sphere-event-banner").files[0],
        r = new FileReader();
        r.onloadend = function(e) { //callback after files finish loading
            $scope.sphere_event.b64 = e.target.result;
            $scope.$apply();
            $ionicLoading.hide();
            //here you can send data over your server as desired
        }
        r.readAsDataURL(f); //once defined all callbacks, begin reading the file
    }

    $scope.tapFile = function(){
        document.getElementById("create-sphere-event-banner").click();
    }
    var dp = new DatePicker();
    dp.datepickerObject.from = new Date("January 1, 1907");
    dp.datepickerObject.callback = function (val) {
        if (typeof(val) === 'undefined') {
            // console.log('No date selected');
        } else {
            $scope.datepickerObject.inputDate = val;
            // console.log('Selected date is : ', val)
            $scope.sphere_event.event_date = dp.dateFormat(val);
        }
    }; 
    $scope.datepickerObject = dp.datepickerObject;

    var tp_start = new TimePicker();
    tp_start.timePickerObject.callback= function(val) {
        if (typeof (val) === 'undefined') {
            console.log('Time not selected');
        } else {
            var selectedTime = new Date(val * 1000);
            $scope.sphere_event.event_time_from = tp_start.ampm(selectedTime);
            //console.log('Selected epoch is : ', val, 'and the time is ', selectedTime.getUTCHours(), ':', selectedTime.getUTCMinutes(), 'in UTC');
        }
    }
    $scope.timePickerObject_start = tp_start.timePickerObject;

    var tp_end = new TimePicker();
    tp_end.timePickerObject.callback= function(val) {
        if (typeof (val) === 'undefined') {
            console.log('Time not selected');
        } else {
            var selectedTime = new Date(val * 1000);
            $scope.sphere_event.event_time_to = tp_end.ampm(selectedTime);
            //console.log('Selected epoch is : ', val, 'and the time is ', selectedTime.getUTCHours(), ':', selectedTime.getUTCMinutes(), 'in UTC');
        }
    }
    $scope.timePickerObject_end = tp_end.timePickerObject;

    $scope.addSphereEvent = function(){
        /*var spinner = document.getElementById("signup-spinner-container");
        var btn = document.getElementById("signup-btn-container");
        spinner.style.display = "block";
        btn.style.display = "none";*/

        var file = document.getElementById("create-sphere-event-banner");
        var event_data = {
            banner_url:file.files[0],
            unique_id: $stateParams.id,
            title: $scope.sphere_event.title, 
            description: $scope.sphere_event.description,
            event_date: $scope.sphere_event.event_date,
            event_time_from: $scope.sphere_event.event_time_from,
            event_time_from_ampm: $scope.sphere_event.event_time_from_ampm,
            event_time_to: $scope.sphere_event.event_time_to,
            event_time_to_ampm: $scope.sphere_event.event_time_to_ampm,
            time_zone: $scope.sphere_event.time_zone
        };
        $ionicLoading.show();
        API.createsphereevent(event_data, function(data){
            $ionicLoading.hide();
            if(data.Result == 1) {
                $rootScope.popAlert(
                    'Sphere Event Successfully Published',
                    'success', 
                    'Alert',
                    'OK',
                    function() {
                        $rootScope.goback();
                });
            } else {
                $rootScope.popAlert(
                    'Sphere Event Published Failed!', 
                    'OK',
                    function() {
                });
            }
            },function(err){
                $ionicLoading.hide();
                $rootScope.popAlert(
                    'Sphere Event Published Failed!', 
                    'OK',
                    function() {
                });
        });
    }
    setTimeout(function(){
    $ionicLoading.show();
    API.getSphere({
        unique_id : $stateParams.id
        },function(data){
            console.log(data);
            if(data.Result == 1){
                $scope.currentsphere =  data.Data;
                $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                $rootScope.routeParams.id = $stateParams.id;
                $rootScope.routeParams.handler = $scope.currentsphere.handle;
                $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                if(data.Data.member_type=='OWNER'){
                }else if(data.Data.member_type=='MEMBER'){
                }else{
                    $rootScope.canQuip = false;
                }
            }
            $ionicLoading.hide();
        },function(err){
            $ionicLoading.hide();
    });
        $scope.timezones = Timezones.list;
        $scope.$apply();
    },100)
    // $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){

    //     if(toState.name == 'app.add-sphere-event'){
    //     }

    // });

    
})
.controller('EditSphereEventCtrl', function($scope, $rootScope, $cordovaDatePicker, $ionicLoading,
    $ionicHistory, DatePicker, TimePicker,  $http, $ionicLoading, Constant, API, deviceType, $stateParams, Timezones) {
    $scope.sphere_event = {};
    $scope.sphere_event.sphereid = "";
    $scope.sphere_event.title = "";
    $scope.sphere_event.description = "";
    $scope.sphere_event.event_date = "";
    $scope.sphere_event.event_time_from = "";
    $scope.sphere_event.event_time_from_ampm = "";
    $scope.sphere_event.event_time_to = "";
    $scope.sphere_event.event_time_to_ampm = "";
    $scope.sphere_event.time_zone = "";
    $scope.sphere_event.b64 ="img/no-banner.jpg";

        setTimeout(function(){
            $scope.timezones = Timezones.list;
        },100)
        $scope.$on('$ionicView.beforeEnter', function() {
        }); 
    $scope.fileNameChanged = function(){
        $ionicLoading.show();
        var f = document.getElementById("edit-sphere-event-banner").files[0],
        r = new FileReader();
        r.onloadend = function(e) { //callback after files finish loading
            $scope.sphere_event.b64 = e.target.result;
            $scope.$apply();
            $ionicLoading.hide();
            //here you can send data over your server as desired
        }
        r.readAsDataURL(f); //once defined all callbacks, begin reading the file
    }

    $scope.tapFile = function(){
        document.getElementById("edit-sphere-event-banner").click();
    }
    var dp = new DatePicker();
    dp.datepickerObject.from = new Date("January 1, 1907");
    dp.datepickerObject.callback = function (val) {
        if (typeof(val) === 'undefined') {
            // console.log('No date selected');
        } else {
            $scope.datepickerObject.inputDate = val;
            // console.log('Selected date is : ', val)
            $scope.sphere_event.event_date = dp.dateFormat(val);
        }
    }; 
    $scope.datepickerObject = dp.datepickerObject;

    var tp_start = new TimePicker();
    tp_start.timePickerObject.callback= function(val) {
        if (typeof (val) === 'undefined') {
            console.log('Time not selected');
        } else {
            var selectedTime = new Date(val * 1000);
            $scope.sphere_event.event_time_from = tp_start.ampm(selectedTime);
            //console.log('Selected epoch is : ', val, 'and the time is ', selectedTime.getUTCHours(), ':', selectedTime.getUTCMinutes(), 'in UTC');
        }
    }
    $scope.timePickerObject_start = tp_start.timePickerObject;

    var tp_end = new TimePicker();
    tp_end.timePickerObject.callback= function(val) {
        if (typeof (val) === 'undefined') {
            console.log('Time not selected');
        } else {
            var selectedTime = new Date(val * 1000);
            $scope.sphere_event.event_time_to = tp_end.ampm(selectedTime);
            //console.log('Selected epoch is : ', val, 'and the time is ', selectedTime.getUTCHours(), ':', selectedTime.getUTCMinutes(), 'in UTC');
        }
    }
    $scope.timePickerObject_end = tp_end.timePickerObject;

    $scope.$on('$stateChangeSuccess', function(event, toState, API, cb_success2){
        if(toState.name == 'app.edit-sphere-event'){ 

            $ionicLoading.show();
            API.getSphere({
                unique_id : $stateParams.id
                },function(data){
                    console.log(data);
                    if(data.Result == 1){
                        $scope.currentsphere =  data.Data;
                        $scope.sphere_rating = parseInt(data.Data.sphere_rating);
                        $rootScope.routeParams.id = $stateParams.id;
                        $rootScope.routeParams.handler = $scope.currentsphere.handle;
                        $rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                        $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                        if(data.Data.member_type=='OWNER'){
                        }else if(data.Data.member_type=='MEMBER'){
                        }else{
                            $rootScope.canQuip = false;
                        }
                    }
                    $ionicLoading.hide();
                },function(err){
                    $ionicLoading.hide();
            });
            $scope.sphere_event = {}; 
            $scope.sphere_event["title"] = "";  
            $scope.sphere_event["description"] = "";  
            $scope.sphere_event["event_date"] = ""; 
            $scope.sphere_event["event_time_from"] = "";
            $scope.sphere_event["event_time_from_ampm"] = "";
            $scope.sphere_event["event_time_to"] = "";
            $scope.sphere_event["event_time_to_ampm"] = "";
            $scope.sphere_event["time_zone"] = "";     
            $scope.sphere_event["banner_url"] = "img/no-banner.jpg";
            $scope.sphere_event["b64"] = "img/no-banner.jpg";

            $scope.viewEvent();    
        }
    });

    $scope.viewEvent = function(){ 
        var dataview = {id:$stateParams.id};

        console.log(dataview);
        $ionicLoading.show();
        API.vieweditevent(dataview, function(data){
            $ionicLoading.hide();
            if(data.Result == 1 ){
                console.log(data.Data);
                $scope.sphere_event["title"] = data.Data.title;  
                $scope.sphere_event["description"] = data.Data.description;  
                $scope.sphere_event["event_date"] = data.Data.event_date; 
                $scope.sphere_event["event_time_from"] = data.Data.event_time_from; 
                $scope.sphere_event["event_time_from_ampm"] = data.Data.event_time_from_ampm; 
                $scope.sphere_event["event_time_to"] = data.Data.event_time_to; 
                $scope.sphere_event["event_time_to_ampm"] = data.Data.event_time_to_ampm; 
                $scope.sphere_event["banner_url"] = data.Data.banner_url; 
                $scope.sphere_event["b64"] = data.Data.banner_url;
                $scope.sphere_event["time_zone"] = data.Data.time_zone;   
                setTimeout(function(){
                    $scope.sphere_event["time_zone"] = data.Data.time_zone; 
                    $scope.$apply();   
                },250);
                console.log($scope.sphere_event);
            }else{
                console.log("Error!");
            }
            },function(err){

                $ionicLoading.hide();
        });
    }

    $scope.updateSphereEvent = function(){ //SAVING *


        var file = document.getElementById("edit-sphere-event-banner");
        console.log(file.files[0]);
        var data = {
            banner_url:file.files[0],
            event_id: $stateParams.id,
            title: $scope.sphere_event.title,
            description: $scope.sphere_event.description,
            event_date: $scope.sphere_event.event_date,
            event_time_from: $scope.sphere_event.event_time_from,
            event_time_from_ampm: $scope.sphere_event.event_time_from_ampm,
            event_time_to: $scope.sphere_event.event_time_to,
            event_time_to_ampm: $scope.sphere_event.event_time_to_ampm,
            time_zone:  $scope.sphere_event.time_zone
        };
        console.log(data);
        $ionicLoading.show();
        API.editsphereevent(data, cb_success, cb_error);
    }
    function cb_success(data){
        $ionicLoading.hide();
        if(data.Result == 1 ){
            //success
            create_success(data.Message[0]);
        }else{
            //error
            var msg = data.Message.join("<br/>");
            console.log(data.Message)
            create_failed(msg);
        }
        // console.log(data);
    }
    function cb_error(data){
        console.log(data);
        $ionicLoading.hide();
        // console.log("cb_error");
        // console.log(data);
        create_failed("Something went wrong please try again");
    }

    function create_failed(msg){
        var status = "e";
        var ontap_callback = function(e){
            // console.log(e);
        }
        title = 'Updated Event';
        btn_text = 'Try again';
        $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
    }
    function create_success(msg){
        var status = "s";
        var ontap_callback = function(e){
            // console.log(e);
            $rootScope.goback();  
        }
        title = 'Updated Event';
        btn_text = 'OK';
        $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
    }

})
