angular.module('quipsphere.factories', [])


.factory('socket',function(socketFactory, Constant){
        //Create socket and connect to http://chat.socket.io 
         //var myIoSocket = io.connect('http://192.168.7.117:3007');  
         var myIoSocket = io.connect(Constant.SOCKETSERVER);  
         //var myIoSocket = io.connect(Constant.SOCKETSERVER);  

         if (myIoSocket){
            mySocket = socketFactory({
              ioSocket: myIoSocket
            });
            return mySocket;
         }
         
    })

.factory('SecuredPopups', [
    '$ionicPopup',
    '$q',
    function ($ionicPopup, $q) {

        var firstDeferred = $q.defer();
        firstDeferred.resolve();

        var lastPopupPromise = firstDeferred.promise;

        // Change this var to true if you want that popups will automaticly close before opening another
        var closeAndOpen = false;

        return {
            'show': function (method, object) {
                var deferred = $q.defer();
                var closeMethod = null;
                deferred.promise.isOpen = false;
                deferred.promise.close = function () {
                    if (deferred.promise.isOpen && angular.isFunction(closeMethod)) {
                        closeMethod();
                    }
                };

                if (closeAndOpen && lastPopupPromise.isOpen) {
                    lastPopupPromise.close();
                }

                lastPopupPromise.then(function () {
                    deferred.promise.isOpen = true;
                    var popupInstance = $ionicPopup[method](object);

                    closeMethod = popupInstance.close;
                    popupInstance.then(function (res) {
                        deferred.promise.isOpen = false;
                        deferred.resolve(res);
                    });
                });

                lastPopupPromise = deferred.promise;

                return deferred.promise;
            }
        };
    }
])
.factory('FeedLoader', function ($resource){
  return $resource('http://ajax.googleapis.com/ajax/services/feed/load', {}, {
    fetch: { method: 'JSONP', params: {v: '1.0', callback: 'JSON_CALLBACK'} }
  });
})

.factory('CameraService', function($cordovaCamera){
  return function(){
    this.options = {
      // quality: 100,
      destinationType: Camera.DestinationType.DATA_URL,
      sourceType: Camera.PictureSourceType.CAMERA,
      allowEdit: true,
      encodingType: Camera.EncodingType.JPEG,
      // targetWidth: 100,
      // targetHeight: 100,
      popoverOptions: CameraPopoverOptions,
      saveToPhotoAlbum: false,
      correctOrientation:true
    };
    // this.options = {
    //   destinationType: Camera.DestinationType.FILE_URI,
    //   sourceType: Camera.PictureSourceType.CAMERA,
    //   targetWidth: 100,
    //   targetHeight: 100,
    // };
    this.start = function(cb_success, cb_error){
      $cordovaCamera.getPicture(this.options).then(function(imageData) {
        cb_success(imageData);
      }, function(err) {
        // error
        cb_error(err);
      });
    }

    
  }
})

.factory('DatePicker', function(){
  return function(){
    this.disabledDates = [
      new Date(1437719836326),
      new Date(),
      new Date(2015, 7, 10), //months are 0-based, this is August, 10th!
      new Date('Wednesday, August 12, 2015'), //Works with any valid Date formats like long format
      new Date("08-14-2015"), //Short format
      new Date(1439676000000) //UNIX format
    ]; 
    this.datePickerCallback = function(val){
      console.log(val);
    }
    this.numberToMonth = function(x){
        var month = new Array();
        month[0] = "January";
        month[1] = "February";
        month[2] = "March";
        month[3] = "April";
        month[4] = "May";
        month[5] = "June";
        month[6] = "July";
        month[7] = "August";
        month[8] = "September";
        month[9] = "October";
        month[10] = "November";
        month[11] = "December";
        return month[x];
    }

    this.dateFormat = function(date){
        return this.numberToMonth(date.getMonth())+" " +date.getDate()+", "+date.getFullYear();
    }
    this.weekDaysList = ["Sun", "Mon", "Tue", "Wed", "thu", "Fri", "Sat"];
    this.monthList = ["Jan", "Feb", "March", "April", "May", "June", "July", "Aug", "Sept", "Oct", "Nov", "Dec"];
    this.datepickerObject = {
      titleLabel: 'Select Date',  //Optional
      todayLabel: 'Today',  //Optional
      closeLabel: 'Close',  //Optional
      setLabel: 'Set',  //Optional
      //setButtonType : 'button-assertive',  //Optional
      //todayButtonType : 'button-assertive',  //Optional
      //closeButtonType : 'button-assertive',  //Optional
      inputDate: new Date(),  //Optional
      mondayFirst: true,  //Optional
      disabledDates: this.disabledDates, //Optional
      weekDaysList: this.weekDaysList, //Optional
      monthList: this.monthList, //Optional
      templateType: 'modal', //Optional or PopUp
      showTodayButton: 'true', //Optional
      //modalHeaderColor: 'bar-positive', //Optional
      //modalFooterColor: 'bar-positive', //Optional
      from: new Date(2012, 8, 2), //Optional
      to: new Date(2018, 8, 25),  //Optional
      callback: this.datePickerCallback,
      dateFormat: 'MMMM dd, yyyy', //Optional
      closeOnSelect: false, //Optional
    };
  }
})
.factory('TimePicker', function(){
  return function(){
    this.timePickerCallback = function(val){
      var selectedTime = new Date(val * 1000);
      console.log(selectedTime);
    }
    this.addZero = function(x){
        if(x < 10){
            x = "0"+x;
        }
        return x;
    }
    this.ampm = function(time){
        var hours = time.getUTCHours();
        var minutes = time.getUTCMinutes();
        var ampm = "AM";
        if(hours > 12){
            hours = hours - 12;
            ampm = "PM";
        }
        hours = this.addZero(hours);
        minutes = this.addZero(minutes);
        return hours + ":" + minutes +" "+ ampm;
    }
    this.timePickerObject = {
      inputEpochTime: ((new Date()).getHours() * 60 * 60),  //Optional
      step: 15,  //Optional
      format: 12,  //Optional
      titleLabel: 'Select Time',  //Optional
      setLabel: 'Set',  //Optional
      closeLabel: 'Close',  //Optional
      setButtonType: 'button-white-black',  //Optional
      closeButtonType: 'button-white-black',  //Optional
      callback: this.timePickerCallback,
    };
  }
})

// Factory for node-pushserver (running locally in this case), if you are using other push notifications server you need to change this
.factory('NodePushServer', function ($http){
  // Configure push notifications server address
  //    - If you are running a local push notifications server you can test this by setting the local IP (on mac run: ipconfig getifaddr en1)
  var push_server_address = "http://192.168.1.102:8000";

  return {
    // Stores the device token in a db using node-pushserver
    // type:  Platform type (ios, android etc)
    storeDeviceToken: function(type, regId) {
      // Create a random userid to store with it
      var user = {
        user: 'user' + Math.floor((Math.random() * 10000000) + 1),
        type: type,
        token: regId
      };
      console.log("Post token for registered device with data " + JSON.stringify(user));

      $http.post(push_server_address+'/subscribe', JSON.stringify(user))
      .success(function (data, status) {
        console.log("Token stored, device is successfully subscribed to receive push notifications.");
      })
      .error(function (data, status) {
        console.log("Error storing device token." + data + " " + status);
      });
    },
    // CURRENTLY NOT USED!
    // Removes the device token from the db via node-pushserver API unsubscribe (running locally in this case).
    // If you registered the same device with different userids, *ALL* will be removed. (It's recommended to register each
    // time the app opens which this currently does. However in many cases you will always receive the same device token as
    // previously so multiple userids will be created with the same token unless you add code to check).
    removeDeviceToken: function(token) {
      var tkn = {"token": token};
      $http.post(push_server_address+'/unsubscribe', JSON.stringify(tkn))
      .success(function (data, status) {
        console.log("Token removed, device is successfully unsubscribed and will not receive push notifications.");
      })
      .error(function (data, status) {
        console.log("Error removing device token." + data + " " + status);
      });
    }
  };
})


.factory('AdMob', function ($window){
  var admob = $window.AdMob;

  if(admob)
  {
    // Register AdMob events
    // new events, with variable to differentiate: adNetwork, adType, adEvent
    document.addEventListener('onAdFailLoad', function(data){
      console.log('error: ' + data.error +
      ', reason: ' + data.reason +
      ', adNetwork:' + data.adNetwork +
      ', adType:' + data.adType +
      ', adEvent:' + data.adEvent); // adType: 'banner' or 'interstitial'
    });
    document.addEventListener('onAdLoaded', function(data){
      console.log('onAdLoaded: ' + data);
    });
    document.addEventListener('onAdPresent', function(data){
      console.log('onAdPresent: ' + data);
    });
    document.addEventListener('onAdLeaveApp', function(data){
      console.log('onAdLeaveApp: ' + data);
    });
    document.addEventListener('onAdDismiss', function(data){
      console.log('onAdDismiss: ' + data);
    });

    var defaultOptions = {
      // bannerId: admobid.banner,
      // interstitialId: admobid.interstitial,
      // adSize: 'SMART_BANNER',
      // width: integer, // valid when set adSize 'CUSTOM'
      // height: integer, // valid when set adSize 'CUSTOM'
      position: admob.AD_POSITION.BOTTOM_CENTER,
      // offsetTopBar: false, // avoid overlapped by status bar, for iOS7+
      bgColor: 'black', // color name, or '#RRGGBB'
      // x: integer,    // valid when set position to 0 / POS_XY
      // y: integer,    // valid when set position to 0 / POS_XY
      isTesting: true // set to true, to receiving test ad for testing purpose
      // autoShow: true // auto show interstitial ad when loaded, set to false if prepare/show
    };
    var admobid = {};

    if(ionic.Platform.isAndroid())
    {
      admobid = { // for Android
        banner: 'ca-app-pub-6869992474017983/9375997553',
        interstitial: 'ca-app-pub-6869992474017983/1657046752'
      };
    }

    if(ionic.Platform.isIOS())
    {
      admobid = { // for iOS
        banner: 'ca-app-pub-6869992474017983/4806197152',
        interstitial: 'ca-app-pub-6869992474017983/7563979554'
      };
    }

    admob.setOptions(defaultOptions);

    // Prepare the ad before showing it
    //    - (for example at the beginning of a game level)
    admob.prepareInterstitial({
      adId: admobid.interstitial,
      autoShow: false,
      success: function(){
        console.log('interstitial prepared');
      },
      error: function(){
        console.log('failed to prepare interstitial');
      }
    });
  }
  else
  {
    console.log("No AdMob?");
  }

  return {
    showBanner: function() {
      if(admob)
      {
        admob.createBanner({
          adId:admobid.banner,
          position:admob.AD_POSITION.BOTTOM_CENTER,
          autoShow:true,
          success: function(){
            console.log('banner created');
          },
          error: function(){
            console.log('failed to create banner');
          }
        });
      }
    },
    showInterstitial: function() {
      if(admob)
      {
        // If you didn't prepare it before, you can show it like this
        // admob.prepareInterstitial({adId:admobid.interstitial, autoShow:autoshow});

        // If you did prepare it before, then show it like this
        //    - (for example: check and show it at end of a game level)
        admob.showInterstitial();
      }
    },
    removeAds: function() {
      if(admob)
      {
        admob.removeBanner();
      }
    }
  };
})

.factory('iAd', function ($window){
  var iAd = $window.iAd;

  // preppare and load ad resource in background, e.g. at begining of game level
  if(iAd) {
    iAd.prepareInterstitial( { autoShow:false } );
  }
  else
  {
    console.log("No iAd?");
  }

  return {
    showBanner: function() {
      if(iAd)
      {
        // show a default banner at bottom
        iAd.createBanner({
          position:iAd.AD_POSITION.BOTTOM_CENTER,
          autoShow:true
        });
      }
    },
    showInterstitial: function() {
      // ** Notice: iAd interstitial Ad only supports iPad.
      if(iAd)
      {
        // If you did prepare it before, then show it like this
        //    - (for example: check and show it at end of a game level)
        iAd.showInterstitial();
      }
    },
    removeAds: function() {
      if(iAd)
      {
        iAd.removeBanner();
      }
    }
  };
})


.factory('xxDn', function ($window){
    alert('x');
})

.factory('ClockSrv', function($interval){
  return function(){
    //this.clock = "test";
    this.clock = null;
    this.startClock = function(fn, seconds){
      if(this.clock === null){
        this.clock = $interval(fn, seconds);
      }
    }
    this.stopClock =  function(){
      if(this.clock !== null){
        $interval.cancel(this.clock);
        this.clock = null;
      }
    }
  }
})

.factory('Arc', function(){
  return function(){
    this.x = 0;
    this.y = 0;
    this.r = 0;
    this.sAngle = 0;
    this.eAngle = 0;
    this.counterclockwise = false;

    var degToRad = function(degree){
        var factor = Math.PI/180;
        return degree * factor;
    }
    this.startingAngle = function(){
      return degToRad(this.sAngle);
    }
    this.endingAngle = function(){
      return degToRad(this.eAngle);
    }

  }
})
.factory('FillText', function(){
  return function(){
    this.text = "";
    this.x = 0;
    this.y = 0;
    this.font = "12px Arial";
    this.maxWidth = null;
  }
})

// services
.factory('MockService', ['$http', '$q',
    function($http, $q) {
        var me = {};

        me.getUserMessages = function(d) {
            /*
             var endpoint =
             'http://www.mocky.io/v2/547cf341501c337f0c9a63fd?callback=JSON_CALLBACK';
             return $http.jsonp(endpoint).then(function(response) {
             return response.data;
             }, function(err) {
             console.log('get user messages error, err: ' + JSON.stringify(
             err, null, 2));
             });
             */
            var deferred = $q.defer();

            setTimeout(function() {
                deferred.resolve(getMockMessages());
            }, 1500);

            return deferred.promise;
        };

        me.getMockMessage = function() {
            return {
                userId: '534b8e5aaa5e7afc1b23e69b',
                date: new Date(),
                text: 'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.'
            };
        }

        return me;
    }
])

.factory('$ImageCacheFactory', ['$q', function($q) {
    return {
        Cache: function(urls) {
            if (!(urls instanceof Array))
                return $q.reject('Input is not an array');

            var promises = [];
            
            for (var i = 0; i < urls.length; i++) {
                var deferred = $q.defer();
                var img = new Image();

                img.onload = (function(deferred) {
                    return function(){
                        deferred.resolve();
                    }
                })(deferred);
                
                img.onerror = (function(deferred,url) {
                    return function(){
                        deferred.reject(url);
                    }
                })(deferred,urls[i]);

                promises.push(deferred.promise);
                img.src = urls[i];
            }
            
            return $q.all(promises);
        }
    }
}])

.factory('FlightDataService', function($q, $timeout) {
    var searchAirlines = function(searchFilter) {
        console.log('Searching airlines for ' + searchFilter);
        var deferred = $q.defer();
        var matches = airlines.filter( function(airline) {
            if(airline.tag.toLowerCase().indexOf(searchFilter.toLowerCase()) !== -1 ) return true;
        })
        $timeout( function(){
            deferred.resolve( matches );
        }, 100);
        console.log(matches);
        return deferred.promise;
    };
    return {
        searchAirlines : searchAirlines
    }
})

.factory('NewsfeedService', function($q, $cordovaSQLite, $rootScope) {
    var worker = new Worker('jsworker/work.newsfeeds.js');
    var defer = $q.defer();
    worker.addEventListener('message', function(e) {
      //console.log('Worker said: ', e.data);

      
      window.localStorage['newsf_data'] = e.data;

      /*var tempArr newsf_datae.data.split('|');
      var nfItem = {id: tempArr[0] , content : tempArr[1]};
      var newsfeedItem = [nfItem.id, nfItem.content];
      var parameters = newsfeedItem || [];*/

      /* if(window.cordova) {
            // App syntax
            var db = $cordovaSQLite.openDB("quips.db");
        } else {
            // Ionic serve syntax
            var db = window.openDatabase("quips.db", "1.0", "Quips app", -1);
        }

        $cordovaSQLite.execute(db, "CREATE TABLE IF NOT EXISTS newsfeeds (nfid integer primary key, feed text)");

      var result =  $cordovaSQLite.execute(db, "INSERT INTO newsfeeds (nfid, feed) VALUES (?,?)", parameters);
      console.log(result);*/

      defer.resolve(e.data);

    }, false);

    return {
        doWork : function(params){
            defer = $q.defer();
            worker.postMessage(params); // Send data to our worker. 
            return defer.promise;
        }
    };
})

.factory('SphereService', function($q, $cordovaSQLite, $rootScope, Constant) {
    var worker;var defer;
    var apiUrl = Constant.QUIPSHERE_API_HOST + "/sphere/getunreadcount";
    var callParams = {
        'get': 'true', 
        'quipper_id': '' , 
        'root_country_code' : '', 
        'root_quipper_id' : '' 
    };
    var callHeaders = {
        'devtoken': Constant.DEVTOKEN, 
        'userlang' : '',
        'cachecontrol' : 'no-cache'            
    }

    if (window.localStorage['user_data']!= 'undefined' 
        && window.localStorage['user_data']!= undefined 
        && window.localStorage['user_data']!= '' 
        && window.localStorage['user_data']!= 'null'){    
      var user_data = JSON.parse(window.localStorage['user_data']);
      callParams.quipper_id = user_data.quipper_id;
      callParams.root_quipper_id = user_data.quipper_id;
    }
    var mssParams = {apiUrl : apiUrl, callParams: callParams, callHeaders: callHeaders };
    return function(){
        this.params = mssParams;
        this.doWork = function(params){
          if(mssParams.callParams.root_quipper_id){
            console.log("worker started");

            if(typeof(Worker) !== "undefined") {
              if(typeof(worker) == "undefined") {
                  worker = new Worker('jsworker/work.sphere.js');
              }
              defer = $q.defer();
              worker.addEventListener('message', function(e) {
                console.log('Worker said: ', e.data);
                var data = JSON.parse(e.data);
                for(var i = 0; i < document.querySelectorAll(".mysphere-badge").length; i++){
                  if(data.Data.unread_count == 1){
                    document.querySelectorAll(".mysphere-badge")[i].style.visibility = "visible";
                  }else{
                    document.querySelectorAll(".mysphere-badge")[i].style.visibility = "hidden";
                  }
                }
                //window.localStorage['sphere_service'] = JSON.stringify(data.Data);
                //$rootScope.$broadcast('checkUnheard');
                defer.resolve(e.data);
              }, false);
              defer = $q.defer();
              worker.postMessage(params); // Send data to our worker. 
              return defer.promise;
            } else {
                console.log("Sorry, your browser does not support Web Workers...");
            }
          }else{
            console.log("web service error, incomplete param");
          }
        }
        this.worker = function(){
            return worker;//.terminate();
            //worker = undefined;
        }
        this.stopWorker = function(){
            console.log("worker terminated");
            if (worker){
              worker.terminate();
              worker = undefined;
              return worker;  
            }
            
        }
    };
})
.factory('MysphereService', function($q, $cordovaSQLite, $rootScope, Constant) {
    var worker;var defer;
    var apiUrl = Constant.QUIPSHERE_API_HOST + "/sphere/getunreadcountbysphereid";
    var callParams = {
        'get': 'true', 
        'quipper_id': '' , 
        'root_country_code' : '', 
        'root_quipper_id' : '' 
    };
    var callHeaders = {
        'devtoken': Constant.DEVTOKEN, 
        'userlang' : '',
        'cachecontrol' : 'no-cache'            
    }

    if (window.localStorage['user_data']!= 'undefined' 
        && window.localStorage['user_data']!= undefined 
        && window.localStorage['user_data']!= '' 
        && window.localStorage['user_data']!= 'null'){    
      var user_data = JSON.parse(window.localStorage['user_data']);
      callParams.quipper_id = user_data.quipper_id;
      callParams.root_quipper_id = user_data.quipper_id;
    }
    var mssParams = {apiUrl : apiUrl, callParams: callParams, callHeaders: callHeaders };
    return function(){
        this.params = mssParams;
        this.doWork = function(params){
          if(mssParams.callParams.root_quipper_id){
            console.log("worker started");

            if(typeof(Worker) !== "undefined") {
              if(typeof(worker) == "undefined") {
                  worker = new Worker('jsworker/work.sphere.js');
              }
              defer = $q.defer();
              worker.addEventListener('message', function(e) {
                console.log('Worker said: ', e.data);
                var data = JSON.parse(e.data);
                window.localStorage['mysphere_service'] = JSON.stringify(data.Data);
                //$rootScope.$broadcast('checkUnheard');
                defer.resolve(e.data);
              }, false);
              defer = $q.defer();
              worker.postMessage(params); // Send data to our worker. 
              return defer.promise;
            } else {
                console.log("Sorry, your browser does not support Web Workers...");
            }
          }else{
            console.log("web service error, incomplete param");
          }
        }
        this.worker = function(){
            return worker;//.terminate();
            //worker = undefined;
        }
        this.stopWorker = function(){
            console.log("worker terminated")
            worker.terminate();
            worker = undefined;
            return worker;
        }
    };
})


.factory('WebWorkerFactory', function($q, $cordovaSQLite, $rootScope, Constant) {
    var worker = new Worker('jsworker/work.factory.js');
    var defer = $q.defer();
    worker.addEventListener('message', function(e) {
      console.log('Worker said: ', e.data);

      console.log(e);
      //window.localStorage['newsf_data'] = e.data;

      /*var tempArr newsf_datae.data.split('|');
      var nfItem = {id: tempArr[0] , content : tempArr[1]};
      var newsfeedItem = [nfItem.id, nfItem.content];
      var parameters = newsfeedItem || [];*/

      /* if(window.cordova) {
            // App syntax
            var db = $cordovaSQLite.openDB("quips.db");
        } else {
            // Ionic serve syntax
            var db = window.openDatabase("quips.db", "1.0", "Quips app", -1);
        }

        $cordovaSQLite.execute(db, "CREATE TABLE IF NOT EXISTS newsfeeds (nfid integer primary key, feed text)");

      var result =  $cordovaSQLite.execute(db, "INSERT INTO newsfeeds (nfid, feed) VALUES (?,?)", parameters);
      console.log(result);*/

      defer.resolve(e.data);

    }, false);

    var apiUrl = Constant.QUIPSHERE_API_HOST + "/sphere/getunreadcountbysphereid";
    var callParams = {
        'get': 'true', 
        'quipper_id': '' , 
        'root_country_code' : '', 
        'root_quipper_id' : '' 
    };
    var callHeaders = {
        'devtoken': Constant.DEVTOKEN, 
        'userlang' : '',
        'cachecontrol' : 'no-cache'            
    }

    if (window.localStorage['user_data']!= 'undefined' 
        && window.localStorage['user_data']!= undefined 
        && window.localStorage['user_data']!= '' 
        && window.localStorage['user_data']!= 'null'){    
      var user_data = JSON.parse(window.localStorage['user_data']);
      console.log(user_data);
      callParams.quipper_id = user_data.quipper_id;
      callParams.root_quipper_id = user_data.quipper_id;
    }
    var mssParams = {apiUrl : apiUrl, callParams: callParams, callHeaders: callHeaders };
    return function(){
        this.params = mssParams;
        this.doWork = function(params){
          if(mssParams.callParams.root_quipper_id){
            console.log("worker started");
            defer = $q.defer();
            worker.postMessage(params); // Send data to our worker. 
            return defer.promise;
          }else{
            console.log("web service error, incomplete param");
          }
        }
        this.worker = function(){
            return worker;//.terminate();
            //worker = undefined;
        }
        this.stopWorker = function(){
            console.log("worker terminated")
            worker.terminate();
            worker = undefined;
            return worker;
        }
    };
})

.factory('PrvService', function($q, $cordovaSQLite, $rootScope, Constant) {
    var worker;
    var defer;
    var callParams = {
        'get': 'true', 
        'quipper_id': '' , 
        'root_country_code' : '', 
        'root_quipper_id' : '' 
    };
    var apiUrl = Constant.QUIPSHERE_API_HOST + "/privatequip/getunplayed";
    if (window.localStorage['user_data']!= 'undefined' 
        && window.localStorage['user_data']!= undefined 
        && window.localStorage['user_data']!= '' 
        && window.localStorage['user_data']!= 'null'){    
      var user_data = JSON.parse(window.localStorage['user_data']);
      callParams = {'root_quipper_id' :user_data.quipper_id};
    }
    var callHeaders = {
        'devtoken': Constant.DEVTOKEN, 
        'userlang' : 'en',
        'cachecontrol' : 'no-cache'            
    }
    var prvParams = {apiUrl : apiUrl, callParams: callParams, callHeaders: callHeaders };
    return function(){
        this.params = prvParams;
        this.doWork = function(params){
          if(params.callParams.root_quipper_id){
            if(typeof(Worker) !== "undefined") {
              if(typeof(worker) == "undefined") {
                  worker = new Worker('jsworker/work.prv.js');
              }
              defer = $q.defer();
              worker.addEventListener('message', function(e) {
                var a = JSON.parse(e.data);
                $rootScope.prvcount = a.Data.count;
                $rootScope.$apply();
                defer.resolve(e.data);
              }, false);
              defer = $q.defer();
              worker.postMessage(params); // Send data to our worker. 
              return defer.promise;
            } else {
                console.log("Sorry, your browser does not support Web Workers...");
            }
          }else{
            console.log("web service error, incomplete param");
          }
        }
        this.worker = function(){
            return worker;//.terminate();
            //worker = undefined;
        }
        this.stopWorker = function(){
            console.log("worker terminated");
            if (worker){
              worker.terminate();
              worker = undefined;
              return worker;  
            }
            
        }
    };
})
;
