
angular.module('quipsphere.services.api', [])

.service('Constant', function($rootScope, QUIPSHERE_API_HOST, QUIPSHERE_GET_API, DEVTOKEN, GCM_SENDER_ID,DEVELOPER_MODE, SOCKETSERVER, 
        S3URL_SPHERELOGO_PATH, S3URL_PUBLIC_PATH, S3URL_CHATPICS){
    this.QUIPSHERE_API_HOST = QUIPSHERE_API_HOST;
    this.QUIPSHERE_GET_API = QUIPSHERE_GET_API;
    this.DEVTOKEN = DEVTOKEN;
    this.GCM_SENDER_ID = GCM_SENDER_ID;
    this.DEVELOPER_MODE = DEVELOPER_MODE;
    this.SOCKETSERVER = SOCKETSERVER;
    this.S3URL_SPHERELOGO_PATH = S3URL_SPHERELOGO_PATH;
    this.S3URL_PUBLIC_PATH = S3URL_PUBLIC_PATH;
    this.S3URL_CHATPICS = S3URL_CHATPICS;
})

.service('HTTP', function ($rootScope, Constant, $http){
    this.get = function(url, data, config, cb_success,cb_error) {
        data['root_country_code'] = $rootScope.user_data.country;
        data['root_quipper_id'] = $rootScope.user_data.quipper_id;
        var params = '';
        var arr = [];
        arr.push("get=true")
        for(key in data){
           arr.push(key+"="+ data[key]);
        }
        params += arr.join("&");
        if(url.indexOf("?")==-1){
            url += "?"+params;
        }else{
            url += "&"+params;
        }
        config.headers['cache-control'] = 'no-cache';
        config.transformRequest = angular.identity;
        //config.timeout = 3000;//3seconds before cancelling the request
        $http.get(url, config)
        .success(function(result){
            cb_success(result);
        })
        .error(function(result){
            cb_error(result);
        });
    };
    // url(string) - API URL
    // data(object) - params
    // headers(object) - headers
    // cb_success(function) - callback function for on success
    // cb_error(function) - callback function for on error 
    this.post = function(url, data, headers, cb_success,cb_error){
        data['root_country_code'] = $rootScope.user_data.country;
        data['root_quipper_id'] = $rootScope.user_data.quipper_id;
        var form = new FormData();
        headers['Content-Type'] = undefined;
        for(key in data){
            form.append(key, data[key]);
        }
        $http.post(url, form, {
            transformRequest: angular.identity,
            headers: headers,
            cache:false
        })
        .success(function(result){
            cb_success(result);
        })
        .error(function(result){
            cb_error(result);
            //console.log(result);
        });
    }
})
.service('API',function($rootScope, Constant, HTTP){

    this.login = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang,
                'cache-control' : 'no-cache'            
            }
        var url = Constant.QUIPSHERE_API_HOST+'/quipper/login';
        console.log(data);
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    };

    this.fbloginsuccess = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang,
                'cache-control' : 'no-cache'            
            }
        var url = Constant.QUIPSHERE_API_HOST+'/quipper/fbloginsuccess';
        console.log(data);
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    };

    this.firstLogin = function(data, cb_success, cb_error){
        var headers = {
            'devtoken': $rootScope.global.devtoken, 
            'userlang' : $rootScope.global.userlang,
            'cache-control' : 'no-cache'            
        }
        var url = Constant.QUIPSHERE_API_HOST+'/quipper/firstlogin';
        console.log(data);
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    };

    this.checkfbid = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang,
                'cache-control' : 'no-cache'            
            }
        var url = Constant.QUIPSHERE_API_HOST+'/quipper/checkfbid';
        console.log(data);
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    };

    this.checkemail = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang,
                'cache-control' : 'no-cache'            
            }
        var url = Constant.QUIPSHERE_API_HOST+'/quipper/checkemail';
        console.log(data);
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    };
    
    this.fbsignup = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+'/quipper/fbsignup';
        console.log(data);
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    };

    this.savefbid = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang': $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+'/quipper/savefbid';
        console.log(data);
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    };

    this.forgotPassword = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang,
                'cache-control' : 'no-cache'            
            }
        var url = Constant.QUIPSHERE_API_HOST+'/quipper/forgotpassword';
        
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    };

    this.signup = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+'/quipper/signup';
        console.log(data);
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    };

    this.createSphere = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+'/sphere/create';
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.editSphere = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+'/sphere/update';
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }
    this.getSpheres = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }

        var url = Constant.QUIPSHERE_GET_API+'/sphere/get';
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }
    this.getSphereQuipsThread= function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+'/sphere/spherequipsthread';
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }
    this.getSphereThreads= function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+'/sphere/spherethreads';
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }
    this.getSphere = function(data, cb_success, cb_error){

        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+'/sphere/sphere';
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.createCollection = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+'/sphere/createcollection';
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.editCollection = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+'/sphere/editcollection';
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.getCollections = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+'/sphere/getcollections';
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.getCollection = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+'/sphere/getcollection';
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.getQuipsincollection = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+'/sphere/getquipsincollection';
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.AddinCollection = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+'/sphere/addincollection';
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.updateProfile = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang': $rootScope.global.userlang 
            }
        // var url = Constant.QUIPSHERE_API_HOST+"/quipper/updateprofile";
        var url = Constant.QUIPSHERE_API_HOST+"/quipper/update_profile";
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }


    this.changePassword = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang': $rootScope.global.userlang 
            }
        // var url = Constant.QUIPSHERE_API_HOST+"/quipper/updateprofile";
        var url = Constant.QUIPSHERE_API_HOST+"/quipper/change_password?quipper_id="+$rootScope.user_data.quipper_id;
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }


    this.myProfile = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        // var url = Constant.QUIPSHERE_API_HOST+"/quipper/updateprofile";
        var url = Constant.QUIPSHERE_API_HOST+"/quipper/my_profile";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }



    this.quipperAchievements = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        // var url = Constant.QUIPSHERE_API_HOST+"/quipper/updateprofile";
        var url = Constant.QUIPSHERE_API_HOST+"/quipper/quipperachievements";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }


    this.Myachievements = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        // var url = Constant.QUIPSHERE_API_HOST+"/quipper/updateprofile";
        var url = Constant.QUIPSHERE_API_HOST+"/quipper/myachievements";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }


    this.changeBadge = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang': $rootScope.global.userlang 
            }
        // var url = Constant.QUIPSHERE_API_HOST+"/quipper/updateprofile";
        var url = Constant.QUIPSHERE_API_HOST+"/quipper/changebadge";
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }


    this.myQuips = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/quip/threadbyquipid";
        HTTP.get(url, data, config, function(result){
             cb_success(result);
        }, function(result){
             cb_error(result);
        })
    }
    
    this.changePhoto = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang': $rootScope.global.userlang 
            }
        // var url = Constant.QUIPSHERE_API_HOST+"/quipper/updateprofile";
        var url = Constant.QUIPSHERE_API_HOST+"/quipper/changephoto";
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    // this.getQuippers = function(data, cb_success, cb_error){
    //     var headers = {
    //             'devtoken': $rootScope.global.devtoken, 
    //             'userlang': $rootScope.global.userlang 
    //         }
    //     var url = Constant.QUIPSHERE_API_HOST+"/quipper/getquippers";
    //     HTTP.get(url, data, headers, function(result){
    //         cb_success(result);
    //     }, function(result){
    //         cb_error(result);
    //     })
    // }

    this.getTrendingQuippers = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/trending/quippers";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.getTrendingTopics = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/trending/topics";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.getTrendingSpheres = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/trending/spheres";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.viewProfille = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+"/quipper/view_profile";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.followQuipper = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang': $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+"/follow/quipper";
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.unfollowQuipper = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang': $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+"/follow/unfollow";
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.registerDevice = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang': $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+"/quipper/registerdeviceuuid";
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.postQuip = function(data, cb_success, cb_error){
        var headers = {
            'devtoken': $rootScope.global.devtoken,
            'userlang': $rootScope.global.userlang
        }
        var url = Constant.QUIPSHERE_API_HOST+'/quip/post_quip';
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }


    this.postprvQuip = function(data, cb_success, cb_error){
        var headers = {
            'devtoken': $rootScope.global.devtoken,
            'userlang': $rootScope.global.userlang
        }
        var url = Constant.QUIPSHERE_API_HOST+'/quip/sendprv_quip';
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.readNotification = function(data, cb_success, cb_error){
        var headers = {
            'devtoken': $rootScope.global.devtoken,
            'userlang': $rootScope.global.userlang
        }
        var url = Constant.QUIPSHERE_API_HOST+'/notify/read';
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.getNewsfeeds = function(data, cb_success, cb_error, timeoutparam){
        var config = {};
        config.headers = {
            'devtoken': $rootScope.global.devtoken, 
            'userlang' : $rootScope.global.userlang 
        }
        if(timeoutparam){
            config.timeout = timeoutparam;
        }
        var url = Constant.QUIPSHERE_GET_API+"/newsfeed/get";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.rateQuip = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+"/newsfeed/rate";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.userRate = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/quipper/userrate";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.updateNewsfeedPlay = function(data, cb_success, cb_error){
        var headers = {
            'devtoken': $rootScope.global.devtoken,
            'userlang': $rootScope.global.userlang
        }
        var url = Constant.QUIPSHERE_API_HOST+"/newsfeed/tagplayed";
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }
    
    this.updatePrivPlay = function(data, cb_success, cb_error){
            var headers = {
                'devtoken': $rootScope.global.devtoken,
                'userlang': $rootScope.global.userlang
            }
            var url = Constant.QUIPSHERE_API_HOST+"/privatequip/tagplayed";
            HTTP.post(url, data, headers, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
        }

    this.updateHeared = function(data, cb_success, cb_error){
        var headers = {
            'devtoken': $rootScope.global.devtoken,
            'userlang': $rootScope.global.userlang
        }
        var url = Constant.QUIPSHERE_API_HOST+"/quip/tagheared";
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.getStars = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/follow/get_stars";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }


    this.getFollowers = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/follow/get_allfollowers";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.getFollowings = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/follow/get_allfollowing";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }
    this.searchHash = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/search/topic";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }
    this.searchTopics = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/search/topics";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }
    this.searchTopic = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/search/searchtopic";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

     this.getFollowersByName = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/follow/get_followers_byname";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }
    
    this.searchQuippers = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/search/quippers";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }
    this.searchQuipper = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/search/searchquipper";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }
    this.searchSpheres = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/search/spheres";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }
    this.searchSphere = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/search/sphere";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }
    this.getNotification = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/notify/my_new";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }
    this.getQuipperByHandle = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/quipper/getquipperbyhandle";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }
    this.getThreadParent = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/quip/threadparent";
            HTTP.get(url, data, config, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
    }
    this.getThreadChild = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/quip/threadchild";
            HTTP.get(url, data, config, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
    }
    this.getThread = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/quip/thread";
            HTTP.get(url, data, config, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
    }
    this.Requip = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang': $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+"/quip/requip";
            HTTP.post(url, data, headers, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
    }
    this.UndoRequip = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang': $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+"/quip/undorequip";
            HTTP.post(url, data, headers, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
    }
    this.deleteQuip = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang': $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+"/quip/remove_quip";
            HTTP.post(url, data, headers, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
    }
    this.deletequipCollectionitem = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang': $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+"/sphere/removeitem";
            HTTP.post(url, data, headers, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
    }
    this.deletesphereCollection = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang': $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+"/sphere/removecollection";
            HTTP.post(url, data, headers, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
    }
    this.deleteSphere = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang': $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+"/sphere/delete";
            HTTP.post(url, data, headers, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
    }
    this.deleteSphereMember = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang': $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+"/sphere/deletespheremember";
            HTTP.post(url, data, headers, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
    }
    this.sphereMembers = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/sphere/getspheremembers";
            HTTP.get(url, data, config, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
    }
    this.sphereFollowers = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/sphere/getspherefollowers";
            HTTP.get(url, data, config, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
    }
    this.sphereFollowerList = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/sphere/followerlist";
            HTTP.get(url, data, config, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
    }
    this.sphereMemberList = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/sphere/memberlist";
            HTTP.get(url, data, config, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
    }
    this.sphereInviteMembers = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang': $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+"/sphere/invitemembers";
            HTTP.post(url, data, headers, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
    }
    this.sphereFollowSphere = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang': $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+"/sphere/followsphere";
            HTTP.post(url, data, headers, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
    }
    this.sphereUnfollowSphere = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang': $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+"/sphere/unfollowsphere";
            HTTP.post(url, data, headers, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
    }
    this.sphereQuipPlayed = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang': $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+"/sphere/quipplayed";
            HTTP.post(url, data, headers, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
    }
    this.prvquips = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/privatequip/viewprvquips";
            HTTP.get(url, data, config, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
    }
    this.prvquipsthread = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/privatequip/prvquipthread";
            HTTP.get(url, data, config, function(result){
                cb_success(result);
            }, function(result){
                cb_error(result);
            })
    }

    this.createsphereevent = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+'/sphereevents/createsphereevent';
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.editsphereevent = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+'/sphereevents/editsphereevent';
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.viewsphereevents = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+'/sphereevents/viewsphereevents';
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.vieweditevent = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+"/sphereevents/vieweditevent";
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.sphereEvents = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+'/sphere/sphereevents';
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.sphereCollectionSlide = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+'/sphere/spherecollectionslide';
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }
    this.privatequipSearchQuipper = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+'/privatequip/searchquipper';
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }
    this.privatequipGetquipper = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+'/privatequip/prvgetquipper';
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.privatequipGetunplayed = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+'/privatequip/getunplayed';
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }

    this.getLatestQuip = function(data, cb_success, cb_error){
        var config = {};
        config.headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_GET_API+'/quip/getlatestquips';
        HTTP.get(url, data, config, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }
    this.submitquipreport = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+'/quip/report';
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }
    this.submitblock = function(data, cb_success, cb_error){
        var headers = {
                'devtoken': $rootScope.global.devtoken, 
                'userlang' : $rootScope.global.userlang 
            }
        var url = Constant.QUIPSHERE_API_HOST+'/quip/block';
        HTTP.post(url, data, headers, function(result){
            cb_success(result);
        }, function(result){
            cb_error(result);
        })
    }
})
.service('HomeInit', function($rootScope, Constant, $http){
        

        this.getTrendingTopicsData = function() {
                    return [
                                                                            
                        ]
        };

        this.getTrendingQuippersData = function() {
                    return [
                                                
                            ]
        }

         this.getTrendingSpheresData = function() {
                return [
                        
                    ];
        }
})

.service('GetData', function($rootScope, Constant, $http){
        this.Topics = function(val) {
            var data = {
                
            };
            
            return data[val];
        };

        this.Quippers = function(val) {
            var data = {
                
            }
            return data[val];
        };

        this.Spheres = function(val) {
            var data = {
                
            }
            return data[val];
        };

})