angular.module('quipsphere.services', [])

.service('deviceType', function(Constant){
   	this.isWindows = function() {
            return /IEMobile/i.test(navigator.userAgent);
        },
    this.isAndroid = function() {
        return /Android/i.test(navigator.userAgent);
    }
    this.isBlackBerry= function() {
        return /BlackBerry/i.test(navigator.userAgent);
    }
    this.isIOS= function() {
        return /iPhone|iPad|iPod/i.test(navigator.userAgent);
    }
    this.isAny= function() {
    	if(Constant.DEVELOPER_MODE !== false){
	    	return false;
	    }else{
	        return (this.isAndroid() || this.isBlackBerry() || this.isIOS() || this.isWindows());
	    }
    }
})

.service('quipDB', function(deviceType){
	this._name = "quip.db";
	this._version = "1.0";
	this._description = "Quip Database";
	this._size = 50000000;
    this.openDatabase = function(name, version, description, size) {
	    if (!deviceType.isAny()) {
	    	//console.log('WebSQL');
	        return window.openDatabase(name, version, description, size);
	    } else {
	    	//console.log('appSQL');
	        return sqlitePlugin.openDatabase(name, version, description, size);
	    }
    }

    this.execute = function(query){
    	var db = this.openDatabase(this._name, this._version, this._description, this._size);
    	db.transaction(function(tx) {
        	tx.executeSql(query);
    	});
    }

    this.executeSql = function(query, param, cb_success, cb_error){
    	var db = this.openDatabase(this._name, this._version, this._description, this._size);
    	db.transaction(function(tx) {
        	tx.executeSql(query, param, function(tx, res) {
	          cb_success(tx, res);
	        },function(err){
	           cb_error(err)
	        });
    	});
    }
})

.service('Country', function ($rootScope){
	this.list = [{'country_code':'','country_name':'Global'},{'country_code':'AF','country_name':'Afghanistan'},{'country_code':'AL','country_name':'Albania'},{'country_code':'DZ','country_name':'Algeria'},{'country_code':'AS','country_name':'American Samoa'},{'country_code':'AD','country_name':'Andorra'},{'country_code':'AO','country_name':'Angola'},{'country_code':'AI','country_name':'Anguilla'},{'country_code':'AQ','country_name':'Antarctica'},{'country_code':'AG','country_name':'Antigua and Barbuda'},{'country_code':'AR','country_name':'Argentina'},{'country_code':'AM','country_name':'Armenia'},{'country_code':'AW','country_name':'Aruba'},{'country_code':'AU','country_name':'Australia'},{'country_code':'AT','country_name':'Austria'},{'country_code':'AZ','country_name':'Azerbaijan'},{'country_code':'BS','country_name':'Bahamas'},{'country_code':'BH','country_name':'Bahrain'},{'country_code':'BD','country_name':'Bangladesh'},{'country_code':'BB','country_name':'Barbados'},{'country_code':'BY','country_name':'Belarus'},{'country_code':'BE','country_name':'Belgium'},{'country_code':'BZ','country_name':'Belize'},{'country_code':'BJ','country_name':'Benin'},{'country_code':'BM','country_name':'Bermuda'},{'country_code':'BT','country_name':'Bhutan'},{'country_code':'BO','country_name':'Bolivia'},{'country_code':'BA','country_name':'Bosnia and Herzegovina'},{'country_code':'BW','country_name':'Botswana'},{'country_code':'BR','country_name':'Brazil'},{'country_code':'IO','country_name':'British Indian Ocean Territory'},{'country_code':'VG','country_name':'British Virgin Islands'},{'country_code':'BN','country_name':'Brunei'},{'country_code':'BG','country_name':'Bulgaria'},{'country_code':'BF','country_name':'Burkina Faso'},{'country_code':'BI','country_name':'Burundi'},{'country_code':'KH','country_name':'Cambodia'},{'country_code':'CM','country_name':'Cameroon'},{'country_code':'CA','country_name':'Canada'},{'country_code':'CV','country_name':'Cape Verde'},{'country_code':'KY','country_name':'Cayman Islands'},{'country_code':'CF','country_name':'Central African Republic'},{'country_code':'TD','country_name':'Chad'},{'country_code':'CL','country_name':'Chile'},{'country_code':'CN','country_name':'China'},{'country_code':'CX','country_name':'Christmas Island'},{'country_code':'CC','country_name':'Cocos Islands'},{'country_code':'CO','country_name':'Colombia'},{'country_code':'KM','country_name':'Comoros'},{'country_code':'CK','country_name':'Cook Islands'},{'country_code':'CR','country_name':'Costa Rica'},{'country_code':'HR','country_name':'Croatia'},{'country_code':'CU','country_name':'Cuba'},{'country_code':'CW','country_name':'Curacao'},{'country_code':'CY','country_name':'Cyprus'},{'country_code':'CZ','country_name':'Czech Republic'},{'country_code':'CD','country_name':'Democratic Republic of the Congo'},{'country_code':'DK','country_name':'Denmark'},{'country_code':'DJ','country_name':'Djibouti'},{'country_code':'DM','country_name':'Dominica'},{'country_code':'DO','country_name':'Dominican Republic'},{'country_code':'TL','country_name':'East Timor'},{'country_code':'EC','country_name':'Ecuador'},{'country_code':'EG','country_name':'Egypt'},{'country_code':'SV','country_name':'El Salvador'},{'country_code':'GQ','country_name':'Equatorial Guinea'},{'country_code':'ER','country_name':'Eritrea'},{'country_code':'EE','country_name':'Estonia'},{'country_code':'ET','country_name':'Ethiopia'},{'country_code':'FK','country_name':'Falkland Islands'},{'country_code':'FO','country_name':'Faroe Islands'},{'country_code':'FJ','country_name':'Fiji'},{'country_code':'FI','country_name':'Finland'},{'country_code':'FR','country_name':'France'},{'country_code':'PF','country_name':'French Polynesia'},{'country_code':'GA','country_name':'Gabon'},{'country_code':'GM','country_name':'Gambia'},{'country_code':'GE','country_name':'Georgia'},{'country_code':'DE','country_name':'Germany'},{'country_code':'GH','country_name':'Ghana'},{'country_code':'GI','country_name':'Gibraltar'},{'country_code':'GR','country_name':'Greece'},{'country_code':'GL','country_name':'Greenland'},{'country_code':'GD','country_name':'Grenada'},{'country_code':'GU','country_name':'Guam'},{'country_code':'GT','country_name':'Guatemala'},{'country_code':'GG','country_name':'Guernsey'},{'country_code':'GN','country_name':'Guinea'},{'country_code':'GW','country_name':'Guinea-Bissau'},{'country_code':'GY','country_name':'Guyana'},{'country_code':'HT','country_name':'Haiti'},{'country_code':'HN','country_name':'Honduras'},{'country_code':'HK','country_name':'Hong Kong'},{'country_code':'HU','country_name':'Hungary'},{'country_code':'IS','country_name':'Iceland'},{'country_code':'IN','country_name':'India'},{'country_code':'ID','country_name':'Indonesia'},{'country_code':'IR','country_name':'Iran'},{'country_code':'IQ','country_name':'Iraq'},{'country_code':'IE','country_name':'Ireland'},{'country_code':'IM','country_name':'Isle of Man'},{'country_code':'IL','country_name':'Israel'},{'country_code':'IT','country_name':'Italy'},{'country_code':'CI','country_name':'Ivory Coast'},{'country_code':'JM','country_name':'Jamaica'},{'country_code':'JP','country_name':'Japan'},{'country_code':'JE','country_name':'Jersey'},{'country_code':'JO','country_name':'Jordan'},{'country_code':'KZ','country_name':'Kazakhstan'},{'country_code':'KE','country_name':'Kenya'},{'country_code':'KI','country_name':'Kiribati'},{'country_code':'XK','country_name':'Kosovo'},{'country_code':'KW','country_name':'Kuwait'},{'country_code':'KG','country_name':'Kyrgyzstan'},{'country_code':'LA','country_name':'Laos'},{'country_code':'LV','country_name':'Latvia'},{'country_code':'LB','country_name':'Lebanon'},{'country_code':'LS','country_name':'Lesotho'},{'country_code':'LR','country_name':'Liberia'},{'country_code':'LY','country_name':'Libya'},{'country_code':'LI','country_name':'Liechtenstein'},{'country_code':'LT','country_name':'Lithuania'},{'country_code':'LU','country_name':'Luxembourg'},{'country_code':'MO','country_name':'Macao'},{'country_code':'MK','country_name':'Macedonia'},{'country_code':'MG','country_name':'Madagascar'},{'country_code':'MW','country_name':'Malawi'},{'country_code':'MY','country_name':'Malaysia'},{'country_code':'MV','country_name':'Maldives'},{'country_code':'ML','country_name':'Mali'},{'country_code':'MT','country_name':'Malta'},{'country_code':'MH','country_name':'Marshall Islands'},{'country_code':'MR','country_name':'Mauritania'},{'country_code':'MU','country_name':'Mauritius'},{'country_code':'YT','country_name':'Mayotte'},{'country_code':'MX','country_name':'Mexico'},{'country_code':'FM','country_name':'Micronesia'},{'country_code':'MD','country_name':'Moldova'},{'country_code':'MC','country_name':'Monaco'},{'country_code':'MN','country_name':'Mongolia'},{'country_code':'ME','country_name':'Montenegro'},{'country_code':'MS','country_name':'Montserrat'},{'country_code':'MA','country_name':'Morocco'},{'country_code':'MZ','country_name':'Mozambique'},{'country_code':'MM','country_name':'Myanmar'},{'country_code':'NA','country_name':'Namibia'},{'country_code':'NR','country_name':'Nauru'},{'country_code':'NP','country_name':'Nepal'},{'country_code':'NL','country_name':'Netherlands'},{'country_code':'AN','country_name':'Netherlands Antilles'},{'country_code':'NC','country_name':'New Caledonia'},{'country_code':'NZ','country_name':'New Zealand'},{'country_code':'NI','country_name':'Nicaragua'},{'country_code':'NE','country_name':'Niger'},{'country_code':'NG','country_name':'Nigeria'},{'country_code':'NU','country_name':'Niue'},{'country_code':'KP','country_name':'North Korea'},{'country_code':'MP','country_name':'Northern Mariana Islands'},{'country_code':'NO','country_name':'Norway'},{'country_code':'OM','country_name':'Oman'},{'country_code':'PK','country_name':'Pakistan'},{'country_code':'PW','country_name':'Palau'},{'country_code':'PS','country_name':'Palestine'},{'country_code':'PA','country_name':'Panama'},{'country_code':'PG','country_name':'Papua New Guinea'},{'country_code':'PY','country_name':'Paraguay'},{'country_code':'PE','country_name':'Peru'},{'country_code':'PH','country_name':'Philippines'},{'country_code':'PN','country_name':'Pitcairn'},{'country_code':'PL','country_name':'Poland'},{'country_code':'PT','country_name':'Portugal'},{'country_code':'PR','country_name':'Puerto Rico'},{'country_code':'QA','country_name':'Qatar'},{'country_code':'CG','country_name':'Republic of the Congo'},{'country_code':'RE','country_name':'Reunion'},{'country_code':'RO','country_name':'Romania'},{'country_code':'RU','country_name':'Russia'},{'country_code':'RW','country_name':'Rwanda'},{'country_code':'BL','country_name':'Saint Barthelemy'},{'country_code':'SH','country_name':'Saint Helena'},{'country_code':'KN','country_name':'Saint Kitts and Nevis'},{'country_code':'LC','country_name':'Saint Lucia'},{'country_code':'MF','country_name':'Saint Martin'},{'country_code':'PM','country_name':'Saint Pierre and Miquelon'},{'country_code':'VC','country_name':'Saint Vincent and the Grenadines'},{'country_code':'WS','country_name':'Samoa'},{'country_code':'SM','country_name':'San Marino'},{'country_code':'ST','country_name':'Sao Tome and Principe'},{'country_code':'SA','country_name':'Saudi Arabia'},{'country_code':'SN','country_name':'Senegal'},{'country_code':'RS','country_name':'Serbia'},{'country_code':'SC','country_name':'Seychelles'},{'country_code':'SL','country_name':'Sierra Leone'},{'country_code':'SG','country_name':'Singapore'},{'country_code':'SX','country_name':'Sint Maarten'},{'country_code':'SK','country_name':'Slovakia'},{'country_code':'SI','country_name':'Slovenia'},{'country_code':'SB','country_name':'Solomon Islands'},{'country_code':'SO','country_name':'Somalia'},{'country_code':'ZA','country_name':'South Africa'},{'country_code':'KR','country_name':'South Korea'},{'country_code':'SS','country_name':'South Sudan'},{'country_code':'ES','country_name':'Spain'},{'country_code':'LK','country_name':'Sri Lanka'},{'country_code':'SD','country_name':'Sudan'},{'country_code':'SR','country_name':'Suriname'},{'country_code':'SJ','country_name':'Svalbard and Jan Mayen'},{'country_code':'SZ','country_name':'Swaziland'},{'country_code':'SE','country_name':'Sweden'},{'country_code':'CH','country_name':'Switzerland'},{'country_code':'SY','country_name':'Syria'},{'country_code':'TW','country_name':'Taiwan'},{'country_code':'TJ','country_name':'Tajikistan'},{'country_code':'TZ','country_name':'Tanzania'},{'country_code':'TH','country_name':'Thailand'},{'country_code':'TG','country_name':'Togo'},{'country_code':'TK','country_name':'Tokelau'},{'country_code':'TO','country_name':'Tonga'},{'country_code':'TT','country_name':'Trinidad and Tobago'},{'country_code':'TN','country_name':'Tunisia'},{'country_code':'TR','country_name':'Turkey'},{'country_code':'TM','country_name':'Turkmenistan'},{'country_code':'TC','country_name':'Turks and Caicos Islands'},{'country_code':'TV','country_name':'Tuvalu'},{'country_code':'VI','country_name':'U.S. Virgin Islands'},{'country_code':'UG','country_name':'Uganda'},{'country_code':'UA','country_name':'Ukraine'},{'country_code':'AE','country_name':'United Arab Emirates'},{'country_code':'GB','country_name':'United Kingdom'},{'country_code':'US','country_name':'United States'},{'country_code':'UY','country_name':'Uruguay'},{'country_code':'UZ','country_name':'Uzbekistan'},{'country_code':'VU','country_name':'Vanuatu'},{'country_code':'VA','country_name':'Vatican'},{'country_code':'VE','country_name':'Venezuela'},{'country_code':'VN','country_name':'Vietnam'},{'country_code':'WF','country_name':'Wallis and Futuna'},{'country_code':'EH','country_name':'Western Sahara'},{'country_code':'YE','country_name':'Yemen'},{'country_code':'ZM','country_name':'Zambia'},{'country_code':'ZW','country_name':'Zimbabwe'}];

	this.getName = function(countryCode) {
		for(var l=0 in this.list){
			if(this.list[l].country_code == countryCode){
				return this.list[l].country_name;
			}
		}
	};

	this.getCode = function(countryName) {
		for(var l=0 in this.list){
			if(this.list[l].country_name == countryName){
				return this.list[l].country_code;
			}
		}
	};

})
.service('Timezones', function ($rootScope){
	this.list = [{title:'A', content:'Alpha Time Zone(A)' },{title:'ACDT', content:'Australian Central Daylight Time(ACDT)' },{title:'ACST', content:'Australian Central Standard Time(ACST)' },{title:'ACT', content:'Acre Time(ACT)' },{title:'ACT', content:'Australian Central Time(ACT)' },{title:'ACWST', content:'Australian Central Western Standard Time(ACWST)' },{title:'ADT', content:'Arabia Daylight Time(ADT)' },{title:'ADT', content:'Atlantic Daylight Time(ADT)' },{title:'AEDT', content:'Australian Eastern Daylight Time(AEDT)' },{title:'AEST', content:'Australian Eastern Standard Time(AEST)' },{title:'AET', content:'Australian Eastern Time(AET)' },{title:'AFT', content:'Afghanistan Time(AFT)' },{title:'AKDT', content:'Alaska Daylight Time(AKDT)' },{title:'AKST', content:'Alaska Standard Time(AKST)' },{title:'ALMT', content:'Alma-Ata Time(ALMT)' },{title:'AMST', content:'Amazon Summer Time(AMST)' },{title:'AMST', content:'Armenia Summer Time(AMST)' },{title:'AMT', content:'Amazon Time(AMT)' },{title:'AMT', content:'Armenia Time(AMT)' },{title:'ANAST', content:'Anadyr Summer Time(ANAST)' },{title:'ANAT', content:'Anadyr Time(ANAT)' },{title:'AQTT', content:'Aqtobe Time(AQTT)' },{title:'ART', content:'Argentina Time(ART)' },{title:'AST', content:'Arabia Standard Time(AST)' },{title:'AST', content:'Atlantic Standard Time(AST)' },{title:'AT', content:'Atlantic Time(AT)' },{title:'AWDT', content:'Australian Western Daylight Time(AWDT)' },{title:'AWST', content:'Australian Western Standard Time(AWST)' },{title:'AZOST', content:'Azores Summer Time(AZOST)' },{title:'AZOT', content:'Azores Time(AZOT)' },{title:'AZST', content:'Azerbaijan Summer Time(AZST)' },{title:'AZT', content:'Azerbaijan Time(AZT)' },{title:'AoE', content:'Anywhere on Earth(AoE)' },{title:'B', content:'Bravo Time Zone(B)' },{title:'BNT', content:'Brunei Darussalam Time(BNT)' },{title:'BOT', content:'Bolivia Time(BOT)' },{title:'BRST', content:'Brasília Summer Time(BRST)' },{title:'BRT', content:'Brasília Time(BRT)' },{title:'BST', content:'Bangladesh Standard Time(BST)' },{title:'BST', content:'Bougainville Standard Time(BST)' },{title:'BST', content:'British Summer Time(BST)' },{title:'BTT', content:'Bhutan Time(BTT)' },{title:'C', content:'Charlie Time Time(C)' },{title:'CAST', content:'Casey Time(CAST)' },{title:'CAT', content:'Central Africa Time(CAT)' },{title:'CCT', content:'Cocos Islands Time(CCT)' },{title:'CDT', content:'Central Daylight Time(CDT)' },{title:'CDT', content:'Cuba Daylight Time(CDT)' },{title:'CEST', content:'Central European Summer Time(CEST)' },{title:'CET', content:'Central European Time(CET)' },{title:'CHADT', content:'Chatham Island Daylight Time(CHADT)' },{title:'CHAST', content:'Chatham Island Standard Time(CHAST)' },{title:'CHOST', content:'Choibalsan Summer Time(CHOST)' },{title:'CHOST', content:'Choibalsan Summer Time(CHOST)' },{title:'CHOT', content:'Choibalsan Time(CHOT)' },{title:'CHUT', content:'Chuuk Time(CHUT)' },{title:'CIDST', content:'Cayman Islands Daylight Saving Time(CIDST)' },{title:'CIST', content:'Cayman Islands Standard Time(CIST)' },{title:'CKT', content:'Cook Island Time(CKT)' },{title:'CLST', content:'Chile Summer Time(CLST)' },{title:'CLT', content:'Chile Standard Time(CLT)' },{title:'COT', content:'Colombia Time(COT)' },{title:'CST', content:'Central Standard Time(CST)' },{title:'CST', content:'China Standard Time(CST)' },{title:'CST', content:'Cuba Standard Time(CST)' },{title:'CT', content:'Central Time(CT)' },{title:'CVT', content:'Cape Verde Time(CVT)' },{title:'CXT', content:'Christmas Island Time(CXT)' },{title:'ChST', content:'Chamorro Standard Time(ChST)' },{title:'D', content:'Delta Time Time(D)' },{title:'DAVT', content:'Davis Time(DAVT)' },{title:'DDUT', content:'Dumont-d\'Urville Time(DDUT)' },{title:'E', content:'Echo Time Time(E)' },{title:'EASST', content:'Easter Island Summer Time(EASST)' },{title:'EAST', content:'Easter Island Standard Time(EAST)' },{title:'EAT', content:'Eastern Africa Time(EAT)' },{title:'ECT', content:'Ecuador Time(ECT)' },{title:'EDT', content:'Eastern Daylight Time(EDT)' },{title:'EEST', content:'Eastern European Summer Time(EEST)' },{title:'EET', content:'Eastern European Time(EET)' },{title:'EGST', content:'Eastern Greenland Summer Time(EGST)' },{title:'EGT', content:'East Greenland Time(EGT)' },{title:'EST', content:'Eastern Standard Time(EST)' },{title:'ET', content:'Eastern Time(ET)' },{title:'F', content:'Foxtrot Time Time(F)' },{title:'FET', content:'Further-Eastern European Time(FET)' },{title:'FJST', content:'Fiji Summer Time(FJST)' },{title:'FJT', content:'Fiji Time(FJT)' },{title:'FKST', content:'Falkland Islands Summer Time(FKST)' },{title:'FKT', content:'Falkland Island Time(FKT)' },{title:'FNT', content:'Fernando de Noronha Time(FNT)' },{title:'G', content:'Golf Time Time(G)' },{title:'GALT', content:'Galapagos Time(GALT)' },{title:'GAMT', content:'Gambier Time(GAMT)' },{title:'GET', content:'Georgia Standard Time(GET)' },{title:'GFT', content:'French Guiana Time(GFT)' },{title:'GILT', content:'Gilbert Island Time(GILT)' },{title:'GMT', content:'Greenwich Mean Time(GMT)' },{title:'GST', content:'Gulf Standard Time(GST)' },{title:'GST', content:'South Georgia Time(GST)' },{title:'GYT', content:'Guyana Time(GYT)' },{title:'H', content:'Hotel Time Time(H)' },{title:'HADT', content:'Hawaii-Aleutian Daylight Time(HADT)' },{title:'HAST', content:'Hawaii-Aleutian Standard Time(HAST)' },{title:'HKT', content:'Hong Kong Time(HKT)' },{title:'HOVST', content:'Hovd Summer Time(HOVST)' },{title:'HOVT', content:'Hovd Time(HOVT)' },{title:'I', content:'India Time Zone(I)' },{title:'ICT', content:'Indochina Time(ICT)' },{title:'IDT', content:'Israel Daylight Time(IDT)' },{title:'IOT', content:'Indian Chagos Time(IOT)' },{title:'IRDT', content:'Iran Daylight Time(IRDT)' },{title:'IRKST', content:'Irkutsk Summer Time(IRKST)' },{title:'IRKT', content:'Irkutsk Time(IRKT)' },{title:'IRST', content:'Iran Standard Time(IRST)' },{title:'IST', content:'India Standard Time(IST)' },{title:'IST', content:'Irish Standard Time(IST)' },{title:'IST', content:'Israel Standard Time(IST)' },{title:'JST', content:'Japan Standard Time(JST)' },{title:'K', content:'Kilo Time Time(K)' },{title:'KGT', content:'Kyrgyzstan Time(KGT)' },{title:'KOST', content:'Kosrae Time(KOST)' },{title:'KRAST', content:'Krasnoyarsk Summer Time(KRAST)' },{title:'KRAT', content:'Krasnoyarsk Time(KRAT)' },{title:'KST', content:'Korea Standard Time(KST)' },{title:'KUYT', content:'Kuybyshev Time(KUYT)' },{title:'L', content:'Lima Time Time(L)' },{title:'LHDT', content:'Lord Howe Daylight Time(LHDT)' },{title:'LHST', content:'Lord Howe Standard Time(LHST)' },{title:'LINT', content:'Line Islands Time(LINT)' },{title:'M', content:'Mike Time Zone(M)' },{title:'MAGST', content:'Magadan Summer Time(MAGST)' },{title:'MAGT', content:'Magadan Time(MAGT)' },{title:'MART', content:'Marquesas Time(MART)' },{title:'MAWT', content:'Mawson Time(MAWT)' },{title:'MDT', content:'Mountain Daylight Time(MDT)' },{title:'MHT', content:'AcreMarshall Islands Time(MHT)' },{title:'MMT', content:'Myanmar Time(MMT)' },{title:'MSD', content:'Moscow Daylight Time(MSD)' },{title:'MSK', content:'Moscow Standard Time(MSK)' },{title:'MST', content:'Mountain Standard Time(MST)' },{title:'MT', content:'Mountain Time(MT)' },{title:'MUT', content:'Mauritius Time(MUT)' },{title:'MVT', content:'Maldives Time(MVT)' },{title:'MYT', content:'Malaysia Time(MYT)' },{title:'N', content:'November Time Time(N)' },{title:'NCT', content:'New Caledonia Time(NCT)' },{title:'NDT', content:'Newfoundland Daylight Time(NDT)' },{title:'NFT', content:'Norfolk Time(NFT)' },{title:'NOVST', content:'Novosibirsk Summer Time(NOVST)' },{title:'NOVT', content:'Novosibirsk Time(NOVT)' },{title:'NPT', content:'Nepal Time(NPT)' },{title:'NRT', content:'Nauru Time(NRT)' },{title:'NST', content:'Newfoundland Standard Time(NST)' },{title:'NUT', content:'Niue Time(NUT)' },{title:'NZDT', content:'New Zealand Daylight Time(NZDT)' },{title:'NZST', content:'New Zealand Standard Time(NZST)' },{title:'O', content:'Oscar Time Time(O)' },{title:'OMSST ', content:'Omsk Summer Time(OMSST   )' },{title:'OMST', content:'Omsk Standard Time(OMST)' },{title:'ORAT', content:'Oral Time(ORAT)' },{title:'P', content:'Papa Time Zone(P)' },{title:'PDT', content:'Pacific Daylight Time(PDT)' },{title:'PET', content:'Peru Time(PET)' },{title:'PETST', content:'Kamchatka Summer Time(PETST)' },{title:'PETT', content:'Kamchatka Time(PETT)' },{title:'PGT', content:'Papua New Guinea Time(PGT)' },{title:'PHOT', content:'Phoenix Island Time(PHOT)' },{title:'PHT', content:'Philippine Time(PHT)' },{title:'PKT', content:'Pakistan Standard Time(PKT)' },{title:'PMDT', content:'Pierre &amp; Miquelon Daylight Time(PMDT)' },{title:'PMST', content:'Pierre &amp; Miquelon Standard Time(PMST)' },{title:'PONT', content:'Pohnpei Standard Time(PONT)' },{title:'PST', content:'Pacific Standard Time(PST)' },{title:'PST', content:'Pitcairn Standard Time(PST)' },{title:'PT', content:'Pacific Time(PT)' },{title:'PWT', content:'Palau Time(PWT)' },{title:'PYST', content:'Paraguay Summer Time(PYST)' },{title:'PYT', content:'Paraguay Time(PYT)' },{title:'PYT', content:'Pyongyang Time(PYT)' },{title:'Q', content:'Quebec Time Zone(Q)' },{title:'QYZT', content:'Qyzylorda Time(QYZT)' },{title:'R', content:'Romeo Time Zone(R)' },{title:'RET', content:'Reunion Time(RET)' },{title:'ROTT', content:'Rothera Time(ROTT)' },{title:'S', content:'Sierra Time Zone(S)' },{title:'SAKT', content:'Sakhalin Time(SAKT)' },{title:'SAMT', content:'Samara Time(SAMT)' },{title:'SAST', content:'South Africa Standard Time(SAST)' },{title:'SBT', content:'Solomon Islands Time(SBT)' },{title:'SCT', content:'Seychelles Time(SCT)' },{title:'SGT', content:'Singapore Time(SGT)' },{title:'SRET', content:'Srednekolymsk Time(SRET)' },{title:'SRT', content:'Suriname Time(SRT)' },{title:'SST', content:'Samoa Standard Time(SST)' },{title:'SYOT', content:'Syowa Time(SYOT)' },{title:'T', content:'Tango Time Zone(T)' },{title:'TAHT', content:'Tahiti Time(TAHT)' },{title:'TFT', content:'French Southern and Antarctic Time(TFT)' },{title:'TJT', content:'Tajikistan Time(TJT)' },{title:'TKT', content:'Tokelau Time(TKT)' },{title:'TLT', content:'East Timor Time(TLT)' },{title:'TMT', content:'Turkmenistan Time(TMT)' },{title:'TOT', content:'Tonga Time(TOT)' },{title:'TVT', content:'Tuvalu Time(TVT)' },{title:'U', content:'Uniform Time Zone(U)' },{title:'ULAST', content:'Ulaanbaatar Summer Time(ULAST)' },{title:'ULAT', content:'Ulaanbaatar Time(ULAT)' },{title:'UTC', content:'Coordinated Universal Time(UTC)' },{title:'UYST', content:'Uruguay Summer Time(UYST)' },{title:'UYT', content:'Uruguay Time(UYT)' },{title:'UZT', content:'Uzbekistan Time(UZT)' },{title:'V', content:'Victor Time Zone(V)' },{title:'VET', content:'Venezuelan Standard Time(VET)' },{title:'VLAST', content:'Vladivostok Summer Time(VLAST)' },{title:'VLAT', content:'Vladivostok Time(VLAT)' },{title:'VOST', content:'Vostok Time(VOST)' },{title:'VUT', content:'Vanuatu Time(VUT)' },{title:'W', content:'Whiskey Time Zone(W)' },{title:'WAKT', content:'Wake Time(WAKT)' },{title:'WARST', content:'Western Argentine Summer Time(WARST)' },{title:'WAST', content:'West Africa Summer Time(WAST)' },{title:'WAT', content:'West Africa Time(WAT)' },{title:'WEST', content:'Western European Summer Time(WEST)' },{title:'WET', content:'Western European Time(WET)' },{title:'WFT', content:'Wallis and Futuna Time(WFT)' },{title:'WGST', content:'Western Greenland Summer Time(WGST)' },{title:'WGT', content:'West Greenland Time(WGT)' },{title:'WIB', content:'Western Indonesian Time(WIB)' },{title:'WIT', content:'Eastern Indonesian Time(WIT)' },{title:'WITA', content:'Central Indonesian Time(WITA)' },{title:'WST', content:'West Samoa Time(WST)' },{title:'WST', content:'Western Sahara Summer Time(WST)' },{title:'WT', content:'Western Sahara Standard Time(WT)' },{title:'X', content:'X-ray Time Zone(X)' },{title:'Y', content:'Yankee Time Zone(Y)' },{title:'YAKST', content:'Yakutsk Summer Time(YAKST)' },{title:'YAKT', content:'Yakutsk Time(YAKT)' },{title:'YAPT', content:'Yap Time(YAPT)' },{title:'YEKST', content:'Yekaterinburg Summer Time(YEKST)' },{title:'YEKT', content:'Yekaterinburg Time(YEKT)' },{title:'Z', content:'Zulu Time Zone Time(Z)' }];
	this.getTimezoneByTitle = function(title) {
		for(var l=0 in this.list){
			if(this.list[l].title == title){
				return this.list[l].content;
			}
		}
	};
})

.service('FeedList', function ($rootScope, FeedLoader, $q){
	this.get = function(feedSourceUrl) {
		var response = $q.defer();
		//num is the number of results to pull form the source
		FeedLoader.fetch({q: feedSourceUrl, num: 20}, {}, function (data){
			response.resolve(data.responseData);
		});
		return response.promise;
	};
})
.service('Toast', function($cordovaToast){
	//Param		Type	Detail
	//message	String	Message of the spinner dialog. Leave blank for no message
	//duration	String	Duration of time to display the toast. Options : 'short', 'long'
	//position	String	Location of the toast. Options : 'top', 'center', 'bottom'
	this.show = function(msg, duration, position, posY, cb_success, cb_error){

        window.plugins.toast.showWithOptions(
            {
                message: msg,
                duration: duration,
                position: position,
                addPixelsY: posY // added a negative value to move it up a bit (default 0)
            },
            function(success){
                cb_success(success);
            }, // optional
            function(err){
                cb_error(err);
            }    // optional
        );
//		$cordovaToast
//	    .show(msg, duration, position, pixelY)
//	    .then(function(success) {
//	      // success
//	      cb_success(success);
//	    }, function (error) {
//	      // error
//	      cb_error(error)
//	    }
//        );
	}
})


// PUSH NOTIFICATIONS
.service('PushNotificationsService', function ($rootScope, $cordovaPush, API, Constant, Toast){
	/* Apple recommends you register your application for push notifications on the device every time it’s run since tokens can change. The documentation says: ‘By requesting the device token and passing it to the provider every time your application launches, you help to ensure that the provider has the current token for the device. If a user restores a backup to a device other than the one that the backup was created for (for example, the user migrates data to a new device), he or she must launch the application at least once for it to receive notifications again. If the user restores backup data to a new device or reinstalls the operating system, the device token changes. Moreover, never cache a device token and give that to your provider; always get the token from the system whenever you need it.’ */
	this.register = function() {
		var config = {};

		// ANDROID PUSH NOTIFICATIONS
		if(ionic.Platform.isAndroid()){
			config = {
				"senderID": Constant.GCM_SENDER_ID
			};

			$cordovaPush.register(config).then(function(result) {
				// Success
				console.log("$cordovaPush.register Success");
				console.log(result);
			}, function(err) {
				// Error
				console.log("$cordovaPush.register Error");
				console.log(err);
			});

			// $rootScope.$on('$cordovaPush:notificationReceived', function(event, notification) {
			// 	console.log(JSON.stringify([notification]));
			// 	switch(notification.event)
			// 	{
			// 		case 'registered':
			// 			if (notification.regid.length > 0 ) {
			// 				console.log('registration ID = ' + notification.regid);
			// 				console.log('device id length = ' + notification.regid.length);

			// 				API.registerDevice({
			// 					'device':'android', 
			// 					'device_id': notification.regid,
			// 					'quipper_id': $rootScope.user_data.quipper_id,
			// 				},function(data){
			// 					console.log("registered!")
			// 				}, function(err){
			// 					console.log("failed to registered!")
			// 				})
			// 				//NodePushServer.storeDeviceToken("android", notification.regid);
			// 			}
			// 			break;

			// 		case 'message':
			// 			if(notification.foreground == "1")
			// 			{
			// 				console.log(notification);
			// 				console.log("Notification received when app was opened (foreground = true)");
			// 				if(notification.message != window.localStorage['notification_message']){
			// 					window.localStorage['notification_message'] = notification.message;
			// 					switch(notification.payload.quip_page){
			// 						case 'app.notification':
			// 						    var audio = new Audio('sounds/fireworks.mp3');
			// 						    audio.play();
									     
			// 						    if(notification.payload.badge_image != ""){
			// 						    		$rootScope.openModalBadge(notification.payload.badge_image, notification.payload.badge_message);
			// 						    }
								        	

			// 							title = 'Notification';
			// 					        btn_text = 'OK';
			// 					        $rootScope.popAlert(notification.message, status, title, btn_text, function(){
								        	
			// 					        });
			// 						break;
			// 						case 'app.sphere':
			// 						    var audio = new Audio('sounds/checkout_beep.mp3');
			// 						    audio.play();
			// 						    if(notification.payload.sphere_command == 'INVITE'){
			// 								title = notification.payload.title;
			// 						        $rootScope.popUp(notification.message, status, title, function(){
			// 	                                $rootScope.threadParentUniqueId = notification.payload.quip_params.sphere_unique_id;
			// 	                                $rootScope.reRoute('go','app.sphere', 0, {id:notification.payload.quip_params.sphere_unique_id, handler: notification.payload.quip_params.sphere_handle});
			// 	                                $rootScope.goto('app.sphere',{id:notification.payload.quip_params.sphere_unique_id});
			// 						        });
			// 					        }
			// 						break;
			// 						case 'app.privatequipitem':

			// 						    if(Constant.DEVELOPER_MODE == false){   
			// 						    var toastVerticalPosition = -150;               
			// 			                   Toast.show(notification.message,"short","bottom",
			// 			                           toastVerticalPosition,function(success){
			// 			                       },function(error){});     
						                   
			// 			               }
			// 						break;
			// 						default:
			// 						break;
			// 					}
			// 				}else{
			// 					switch(notification.payload.quip_page){
			// 						case 'app.notification':
			// 						    var audio = new Audio('sounds/fireworks.mp3');
			// 						    audio.play();
									     	
			// 						    if(notification.payload.badge_image != ""){
			// 						    		$rootScope.openModalBadge(notification.payload.badge_image, notification.payload.badge_message);
			// 						    }
								        	
			// 							title = 'Notification';
			// 					        btn_text = 'OK';
			// 					        $rootScope.popAlert(notification.message, status, title, btn_text, function(){
								       
			// 					        });
			// 						break;
			// 						case 'app.privatequipitem':
			// 						    if(Constant.DEVELOPER_MODE == false){   
			// 						    	var toastVerticalPosition = -150;                 
			// 				                   Toast.show(notification.message,"short","bottom",
			// 				                           toastVerticalPosition,function(success){
			// 				                       },function(error){});     
							                   
			// 				               }
			// 						break;
			// 						case 'app.sphere':
			// 						    var audio = new Audio('sounds/checkout_beep.mp3');
			// 						    audio.play();
			// 						    if(notification.payload.sphere_command == 'INVITE'){
			// 								title = notification.payload.title;
			// 						        $rootScope.popUp(notification.message+"<br/>Goto to "+notification.payload.quip_params.sphere_handle, status, title, function(){
			// 	                                $rootScope.threadParentUniqueId = notification.payload.quip_params.sphere_unique_id;
			// 	                                $rootScope.reRoute('go','app.sphere', 0, {id:notification.payload.quip_params.sphere_unique_id, 
			// 	                                	handler: notification.payload.quip_params.sphere_handle});
			// 	                                $rootScope.goto('app.sphere',{id:notification.payload.quip_params.sphere_unique_id});
			// 						        });
			// 					        }
			// 						break;
			// 						default:
			// 						break;
			// 					}
			// 				}
							
			// 			}
			// 			else
			// 			{
			// 				if(notification.coldstart == "1")
			// 				{
			// 					switch(notification.payload.quip_page){
			// 						case 'app.notification':
			// 							$rootScope.goto('app.newsfeed', {});
			// 							setTimeout(function(){
			// 								title = 'Notification';
			// 					        	btn_text = 'OK';
			// 					        	$rootScope.popAlert(notification.message, status, title, btn_text, function(){
								        		
			// 					        	});
			// 							},1000);
			// 						break;
			// 						case 'app.privatequipitem':
			// 							$rootScope.goto('app.privatequipitem', {id:notification.payload.prvquipid});
			// 							setTimeout(function(){
			// 								title = 'Notification';
			// 					        	btn_text = 'OK';
			// 					        	$rootScope.popAlert(notification.message, status, title, btn_text, function(){
								        		
			// 					        	});
			// 							},1000);
			// 						break;
			// 						case 'app.sphere':
			// 						    var audio = new Audio('sounds/checkout_beep.mp3');
			// 						    audio.play();
			// 						    if(notification.payload.sphere_command == 'INVITE'){
			// 								title = notification.payload.title;
			// 						        $rootScope.popUp(notification.message+"<br/>Goto to "+notification.payload.quip_params.sphere_handle, status, title, function(){
			// 	                                $rootScope.threadParentUniqueId = notification.payload.quip_params.sphere_unique_id;
			// 	                                $rootScope.reRoute('go','app.sphere', 0, {id:notification.payload.quip_params.sphere_unique_id, 
			// 	                                	handler: notification.payload.quip_params.sphere_handle});
			// 	                                $rootScope.goto('app.sphere',{id:notification.payload.quip_params.sphere_unique_id});
			// 						        });
			// 					        }
			// 						break;
			// 						default:
			// 							$rootScope.goto(notification.payload.quip_page, notification.payload.params);
			// 						break;
			// 					}
			// 					console.log("Notification received when app was closed (not even in background, foreground = false, coldstart = true)");
			// 				}
			// 				else
			// 				{
			// 					switch(notification.payload.quip_page){
			// 						case 'app.notification':
			// 							$rootScope.goto('app.newsfeed', {});
			// 							setTimeout(function(){
			// 								title = 'Notification';
			// 					        	btn_text = 'OK';
			// 					        	$rootScope.popAlert(notification.message, status, title, btn_text, function(){
								        		
			// 					        	});
			// 							},1000);
			// 							break;

			// 						case 'app.privatequipitem':
			// 							$rootScope.goto('app.privatequipitem', {id:notification.payload.prvquipid});
			// 							setTimeout(function(){
			// 								title = 'Notification';
			// 					        	btn_text = 'OK';
			// 					        	$rootScope.popAlert(notification.message, status, title, btn_text, function(){
								        		
			// 					        	});
			// 							},1000);
			// 						break;
			// 						case 'app.sphere':
			// 						    var audio = new Audio('sounds/checkout_beep.mp3');
			// 						    audio.play();
			// 						    if(notification.payload.sphere_command == 'INVITE'){
			// 								title = notification.payload.title;
			// 						        $rootScope.popUp(notification.message+"<br/>Goto to "+notification.payload.quip_params.sphere_handle, status, title, function(){
			// 	                                $rootScope.threadParentUniqueId = notification.payload.quip_params.sphere_unique_id;
			// 	                                $rootScope.reRoute('go','app.sphere', 0, {id:notification.payload.quip_params.sphere_unique_id, 
			// 	                                	handler: notification.payload.quip_params.sphere_handle});
			// 	                                $rootScope.goto('app.sphere',{id:notification.payload.quip_params.sphere_unique_id});
			// 						        });
			// 					        }
			// 						break;									default:
			// 							$rootScope.goto(notification.payload.quip_page, notification.payload.params);
			// 						break;
			// 					}
			// 					console.log("Notification received when app was in background (started but not focused, foreground = false, coldstart = false)");
			// 				}
			// 			}
			// 			console.log(notification.payload);
			// 			console.log(notification.payload.quip_page);
			// 			// this is the actual push notification. its format depends on the data model from the push server
			// 			console.log('message = ' + notification.message);
			// 			break;

			// 		case 'error':
			// 			console.log('GCM error = ' + notification.msg);
			// 			break;

			// 		default:
			// 			console.log('An unknown GCM event has occurred');
			// 			break;
			// 	}
			// });

			// WARNING: dangerous to unregister (results in loss of tokenID)
			// $cordovaPush.unregister(options).then(function(result) {
			//   // Success!
			// }, function(err) {
			//   // Error
			// });
		}
		
		if(ionic.Platform.isIOS()){
			config = {
				"badge": true,
				"sound": true,
				"alert": true
			};

			$cordovaPush.register(config).then(function(result) {
				// Success -- send deviceToken to server, and store for future use
				console.log("result: " + result);
				//NodePushServer.storeDeviceToken("ios", result);
			}, function(err) {
				console.log("Registration error: " + err);
			});

			$rootScope.$on('$cordovaPush:notificationReceived', function(event, notification) {
				console.log(JSON.stringify([notification]));
				switch(notification.event)
				{
					case 'registered':
						if (notification.regid.length > 0 ) {
							console.log('registration ID = ' + notification.regid);
							console.log('device id length = ' + notification.regid.length);

							API.registerDevice({
								'device':'android', 
								'device_id': notification.regid,
								'quipper_id': $rootScope.user_data.quipper_id,
							},function(data){
								console.log("registered!")
							}, function(err){
								console.log("failed to registered!")
							})
							//NodePushServer.storeDeviceToken("android", notification.regid);
						}
						break;

					case 'message':
						if(notification.foreground == "1")
						{
							console.log("Notification received when app was opened (foreground = true)");
							if(notification.message != window.localStorage['notification_message']){
								window.localStorage['notification_message'] = notification.message;
								switch(notification.payload.quip_page){
									case 'app.notification':
											var toastVerticalPosition = -150;               
						                   Toast.show(notification.message,"short","bottom",
			 			                           toastVerticalPosition,function(success){
			 			                    },function(error){});     

										//$rootScope.goto('app.notification', {});
										//$rootScope.$broadcast('getNotify');
									   /* var audio = new Audio('sounds/fireworks.wav');
									    audio.play();*/
										/*title = 'Notification';
								        btn_text = 'OK';
								        $rootScope.popAlert(notification.message, status, title, btn_text, function(){
								        	
								        });*/
									break;
									default:
									break;
								}
							}
							
						}
						else
						{
							if(notification.coldstart == "1")
							{
								switch(notification.payload.quip_page){
									case 'app.notification':
										//$rootScope.goto('app.newsfeed', {});
										setTimeout(function(){
											/*title = 'Notification';
								        	btn_text = 'OK';
								        	$rootScope.popAlert(notification.message, status, title, btn_text, function(){
								        		
								        	});*/
											if(Constant.DEVELOPER_MODE == false){   
	                                            var toastVerticalPosition = -150;               
	                                           Toast.show(notification.message,"short","bottom",
	                                                   toastVerticalPosition,function(success){
	                                               },function(error){});     
	                                           
	                                        } 
										},1000);
									break;
									default:
									break;
								}
								console.log("Notification received when app was closed (not even in background, foreground = false, coldstart = true)");
							}
							else
							{
								switch(notification.payload.quip_page){
									case 'app.notification':
										//$rootScope.goto('app.newsfeed', {});
										setTimeout(function(){
											/*title = 'Notification';
								        	btn_text = 'OK';
								        	$rootScope.popAlert(notification.message, status, title, btn_text, function(){
								        		
								        	});*/
											if(Constant.DEVELOPER_MODE == false){   
	                                            var toastVerticalPosition = -150;               
	                                            Toast.show(notification.message,"short","bottom",
	                                                   toastVerticalPosition,function(success){
	                                               },function(error){});     
	                                           
	                                        } 
										},1000);
										break;
									default:
									break;
								}
								console.log("Notification received when app was in background (started but not focused, foreground = false, coldstart = false)");
							}
						}
						console.log(notification.payload);
						console.log(notification.payload.quip_page);
						// this is the actual push notification. its format depends on the data model from the push server
						console.log('message = ' + notification.message);
						break;

					case 'error':
						console.log('GCM error = ' + notification.msg);
						break;

					default:
						console.log('An unknown GCM event has occurred');
						break;
				}
			});
		}
		
	};
})


// BOOKMARKS FUNCTIONS
.service('BookMarkService', function (_, $rootScope){

	this.bookmarkFeedPost = function(bookmark_post){

		var user_bookmarks = !_.isUndefined(window.localStorage.ionFullApp_feed_bookmarks) ?
														JSON.parse(window.localStorage.ionFullApp_feed_bookmarks) : [];

		//check if this post is already saved

		var existing_post = _.find(user_bookmarks, function(post){ return post.link == bookmark_post.link; });

		if(!existing_post){
			user_bookmarks.push({
				link: bookmark_post.link,
				title : bookmark_post.title,
				date: bookmark_post.publishedDate,
				excerpt: bookmark_post.contentSnippet
			});
		}

		window.localStorage.ionFullApp_feed_bookmarks = JSON.stringify(user_bookmarks);
		$rootScope.$broadcast("new-bookmark");
	};

	this.bookmarkWordpressPost = function(bookmark_post){

		var user_bookmarks = !_.isUndefined(window.localStorage.ionFullApp_wordpress_bookmarks) ?
														JSON.parse(window.localStorage.ionFullApp_wordpress_bookmarks) : [];

		//check if this post is already saved

		var existing_post = _.find(user_bookmarks, function(post){ return post.id == bookmark_post.id; });

		if(!existing_post){
			user_bookmarks.push({
				id: bookmark_post.id,
				title : bookmark_post.title,
				date: bookmark_post.date,
				excerpt: bookmark_post.excerpt
			});
		}

		window.localStorage.ionFullApp_wordpress_bookmarks = JSON.stringify(user_bookmarks);
		$rootScope.$broadcast("new-bookmark");
	};

	this.getBookmarks = function(){
		return {
			feeds : JSON.parse(window.localStorage.ionFullApp_feed_bookmarks || '[]'),
			wordpress: JSON.parse(window.localStorage.ionFullApp_wordpress_bookmarks || '[]')
		};
	};
})


// WP POSTS RELATED FUNCTIONS
.service('PostService', function ($rootScope, $http, $q, WORDPRESS_API_URL){

	this.getRecentPosts = function(page) {
		var deferred = $q.defer();

		$http.jsonp(WORDPRESS_API_URL + 'get_recent_posts/' +
		'?page='+ page +
		'&callback=JSON_CALLBACK')
		.success(function(data) {
			deferred.resolve(data);
		})
		.error(function(data) {
			deferred.reject(data);
		});

		return deferred.promise;
	};


	this.getPost = function(postId) {
		var deferred = $q.defer();

		$http.jsonp(WORDPRESS_API_URL + 'get_post/' +
		'?post_id='+ postId +
		'&callback=JSON_CALLBACK')
		.success(function(data) {
			deferred.resolve(data);
		})
		.error(function(data) {
			deferred.reject(data);
		});

		return deferred.promise;
	};

	this.shortenPosts = function(posts) {
		//we will shorten the post
		//define the max length (characters) of your post content
		var maxLength = 500;
		return _.map(posts, function(post){
			if(post.content.length > maxLength){
				//trim the string to the maximum length
				var trimmedString = post.content.substr(0, maxLength);
				//re-trim if we are in the middle of a word
				trimmedString = trimmedString.substr(0, Math.min(trimmedString.length, trimmedString.lastIndexOf("</p>")));
				post.content = trimmedString;
			}
			return post;
		});
	};

	this.sharePost = function(link){
		window.plugins.socialsharing.share('Check this post here: ', null, null, link);
	};

})


// WP POSTS RELATED FUNCTIONS
.service('PostService', function ($rootScope, $http, $q, WORDPRESS_API_URL){

	this.getRecentPosts = function(page) {
		var deferred = $q.defer();

		$http.jsonp(WORDPRESS_API_URL + 'get_recent_posts/' +
		'?page='+ page +
		'&callback=JSON_CALLBACK')
		.success(function(data) {
			deferred.resolve(data);
		})
		.error(function(data) {
			deferred.reject(data);
		});

		return deferred.promise;
	};


	this.getPost = function(postId) {
		var deferred = $q.defer();

		$http.jsonp(WORDPRESS_API_URL + 'get_post/' +
		'?post_id='+ postId +
		'&callback=JSON_CALLBACK')
		.success(function(data) {
			deferred.resolve(data);
		})
		.error(function(data) {
			deferred.reject(data);
		});

		return deferred.promise;
	};

	this.shortenPosts = function(posts) {
		//we will shorten the post
		//define the max length (characters) of your post content
		var maxLength = 500;
		return _.map(posts, function(post){
			if(post.content.length > maxLength){
				//trim the string to the maximum length
				var trimmedString = post.content.substr(0, maxLength);
				//re-trim if we are in the middle of a word
				trimmedString = trimmedString.substr(0, Math.min(trimmedString.length, trimmedString.lastIndexOf("</p>")));
				post.content = trimmedString;
			}
			return post;
		});
	};

	this.sharePost = function(link){
		window.plugins.socialsharing.share('Check this post here: ', null, null, link);
	};

})

.service('UserService', function() {
  // For the purpose of this example I will store user data on ionic local storage but you should save it on a database
  var setUser = function(user_data) {
    window.localStorage.starter_facebook_user = JSON.stringify(user_data);
  };

  var getUser = function(){
    return JSON.parse(window.localStorage.starter_facebook_user || '{}');
  };

  return {
    getUser: getUser,
    setUser: setUser
  };
});