angular.module('quipsphere.services.player', [])

.factory('AudioPlayer', function() {

   var AudioPlayer = function (playerIndex, audioUrl) {
        
        var playerindex = playerIndex;

        var player = {
           btnPlay: document.getElementById('playerC__' + 1 + '__play'),
           //btnStop: document.getElementById('playerC__' + 1 + '__stop'),
           timeElapsed: document.getElementById('playerC__' + 1 + '__time-elapsed'),
           //timeTotal: document.getElementById('playerC__' + 1 + '__time-total'),
           seekSlide: document.getElementById('playerC__' + 1 + '__seekSlide'),
           audioLoading: document.getElementById('playerC__' + 1 + '__loading')
        };
        
         this['audio' + playerIndex]  = null;  

        var audio = null;

        soundManager.setup({
           useFastPolling: true,
           useHighPerformance: true,
           onready: function() {
                 audio = soundManager.createSound({
                 id: 'audio' + playerIndex,
                 //url: 'http://freshly-ground.com/data/audio/mpc/20090119%20-%20Untitled%20Groove.mp3',
                 url: audioUrl,
                 whileloading: function() {
                    //player.timeTotal.textContent = formatMilliseconds(audio.durationEstimate);
                    //player.audioLoading.style.display = 'block';    
                 },
                 whileplaying: function() {                    
                    player.timeElapsed.textContent = formatMilliseconds(audio.position);
                    progress = (audio.position / audio.durationEstimate) * 100 ;
                    progress = progress.toFixed(2);
                    //player.seekLoad.style.width = String(progress) + '%';
                    player.seekSlide.value = progress;   
                    //player.audioLoading.style.display = 'none';                     
                 },
                 onload: function() {
                    //player.timeTotal.textContent = formatMilliseconds(audio.duration);  
                    //player.audioLoading.style.display = 'none';                  
                    
                 },
                 onstop: function() {
                     spinners = document.querySelectorAll('player__spinner');
                     [].forEach.call(spinners, function(spinner) {
                        // do whatever
                        spinner.style.display = "none";
                     }); 
                     
                     player.btnPlay.classList.remove('is-playing');
                     //player.seekLoad.style.width = '0%';
                     player.seekSlide.value = 0;
                     player.timeElapsed.textContent = formatMilliseconds(0);
                     //player.audioLoading.style.display = 'none';
                 },    
                 onfinish: function() {
                    var event;
                    try {
                       // Internet Explorer doesn't like this statement
                       event = new Event('click');
                    } catch (ex) {
                       event = document.createEvent('MouseEvent');
                       event.initEvent('click', true, false);
                    }
                    //player.btnStop.dispatchEvent(event);
                    /*player.btnPlay.classList.remove('is-playing');*/
                    player.btnPlay.classList.remove('ion-pause');
                    player.btnPlay.classList.add('ion-play');
                    player.seekSlide.value = 0;
                 }
              });
           }
        });

        function formatMilliseconds(milliseconds) {
           var hours = Math.floor(milliseconds / 3600000);
           milliseconds = milliseconds % 3600000;
           var minutes = Math.floor(milliseconds / 60000);
           milliseconds = milliseconds % 60000;
           var seconds = Math.floor(milliseconds / 1000);
           milliseconds = Math.floor(milliseconds % 1000);
           var ms = Math.floor(milliseconds);

           qDuration = (seconds < 10 ? '0' : '') + seconds + '.' + (ms < 10 ? '0' : '') + ms;
           qDurationStatus = Math.round((qDuration*0.1) * 100) / 10;
           return qDurationStatus.toFixed(2) ;
        }

        player.btnPlay.addEventListener('click', function() {
           if (audio === null) {
             return;
           }

           //player.audioLoading.style.display = 'block';

           //check first if fully loaded
           if (audio.readyState < 3){
              //console.log("Audio not yet ready");
              
           }else{
              player.audioLoading.style.display = 'none';
           }
           
           if (audio.playState === 0 || audio.paused === true) {
             audio.play();
             player.btnPlay.classList.add('is-playing');
             player.btnPlay.classList.remove('ion-play');
             player.btnPlay.classList.add('ion-pause');
           } else {
             audio.pause();
             player.btnPlay.classList.remove('is-playing');
             player.btnPlay.classList.add('ion-play');
             player.btnPlay.classList.remove('ion-pause');
           }
        });

        /*player.btnStop.addEventListener('click', function() {
           if (audio === null) {
             return;
           }
           
           audio.stop();           

        });*/

        //Range Slider
        player.seekSlide.addEventListener('change', function () {
            if (audio === null) {
              //console.log('Audio not loaded');
              return;
            }
            //pause first
            audio.pause();          
            barPercent = parseInt(player.seekSlide.value);

            //seek
            seekPosition = audio.durationEstimate * (barPercent / 100);
            audio.setPosition(seekPosition) ;

            //Resume Playing
            audio.play();
            player.btnPlay.classList.remove('ion-play');
             player.btnPlay.classList.add('ion-pause');
        }, false);


        
        return {
            audio:audio,

            init: function() {
                //console.log(audio);
            },
            play: function() {
                
            },
            stop: function(){
               audio.stop();
               audio.setPosition(0);
            }           
           
        }    
    };

    return AudioPlayer;


});